# -*- coding: utf-8 -*-
from numpy import array, hstack, linspace, pi
from numpy import zeros, cos, sin, arange, around
from scipy.integrate import odeint
from matplotlib import pyplot as plt
from matplotlib import animation
from matplotlib.patches import Rectangle
from sympy import symbols
from sympy.physics.mechanics import *
from numpy import array, hstack, zeros, linspace, pi, ones
import os
import math
import decimal
import numpy as np
from pyNN.utility.plotting import Figure, Panel

from nealCoverClass import NealCoverFunctions
import nealParams as nealParameters

#import system



if (nealParameters.simulator=="spinnaker"):
    import pyNN.spiNNaker as sim
elif (nealParameters.simulator=="nest"):
    #import pyNN.nest as sim
    import cPickle as pickle

#COMMENTS=WE ARE ROUNDING EVERY VALUE TO THE NEAREST WHOLE VALUE, INCLUDING THE NUMBER OF CELLS FOR EACH X, ECELLS, AND K, AND WHEN WE INITIALISE THE NETWORK CELLS


class ControlClass:

    ##here it would be, eg var1
    ## elsewhere it would be ControlClass.var1
    ##put variables here that are the same for each instance of the class
    
    def __init__(self, sim, numd, addtime, network, test, dtinput, record, useforce, neuralcontrol):
        ##put variables here that are different for each instance of the class

        self.force=useforce
        self.recording=record
        self.dt=dtinput
        self.test=test
        self.network=network
        self.addtime=addtime
        self.numSets=4           #how many of each population
        #numNeuronsInEachXPop=np.zeros((numSets), dtype=np.int)
        ##INITIALISE ARRAYS THAT HOLD THE NUMBER OF NEURONS IN EACH POPULATION
        self.numNeuronsInEachXPop=[[] for k in range(self.numSets)]
        self.numNeuronsInEachEPop=[[] for k in range(self.numSets)]
        self.numNeuronsInEachKPop=[[] for k in range(self.numSets)]
        self.numNeuronsInEachEMinusXPop=[[] for k in range(self.numSets)]
        self.numNeuronsInEachEMinusXMultKPop=[[] for k in range(self.numSets)]
        self.numNeuronsInRoundEXKPopCells=[[] for k in range(self.numSets)]

        self.EMinusXMultKPops=[[] for k in range(self.numSets)]
        self.RoundEXKPopCells=[[] for k in range(self.numSets)]

        self.EMinusXPops=[[] for k in range(self.numSets)]
        self.EXInterOutSubCells=[[] for k in range(self.numSets)]
    
        self.numNeuronsInFPop=[0,0]
        self.numNeuronsInCosPop=[]
        self.numNeuronsInSinPop=[]
        self.numNeuronsInSinCosPop=[]
        self.numNeuronsInMultCosSinPop=[]
        self.numNeuronsInCosSinDivPop=[]
        self.useNeuralController=neuralcontrol


    
#numNeuronsInFPop=np.zeros(1, dtype=np.int)

#[X1, X2, X3, X4, E1.., K1..., EminusX1..., EminusX*K1...... F]
###RESOLUTION OF THE POPULATIONS
        self.MainRes=0.01         #resolution of all the populations
        self.MultRes2=(self.MainRes*self.MainRes)
        self.AngRes=0.05
        self.RoundMultRes=0.05        #should be 0.05*0.05=0.0025
        self.MultRes=self.AngRes*self.AngRes
        self.varResX=np.ones(self.numSets)*self.MainRes  # output resolution of neurons in each populatoin
    #varResX=np.ones(numSets)*AngRes
        self.varResE=np.ones(self.numSets)*self.MainRes
        self.varResK=np.ones(self.numSets)*self.MainRes
        self.varResEminusX=np.ones(self.numSets)*self.MainRes
        self.varResEminusXmK=np.ones(self.numSets)*self.MainRes
        self.varResF=0.03
        self.dtincrement=0.001
        self.varCos=self.AngRes
        self.varSin=self.AngRes

        self.varCosSin=self.RoundMultRes
        self.varMultCosSin=self.MultRes

        self.varMultCosSinSum=self.AngRes
        self.varMultCosSinSub=self.AngRes

        self.varCosSinDiv=self.AngRes

        self.EXKSum01increments=self.MainRes
        self.EXKSum23increments=self.MainRes

        self.M0=0.01 #mass of the cart
        self.M1=0.01 #mass of the pole
        self.g=9.75  #gravitational constant
        self.l=1.0   #length of the pendulum
        self.oneDivl=1.0/self.l 
        self.M1Multg=self.M1*self.g   #g= 9.75 in the gpop due to rounding error so we keep 9.75 here too.
        self.M1Multl=self.M1*self.l
    

    #EXKSum01increments=MultRes
   #EXKSum23increments=MultRes


    

    #varResDX=np.ones(numSets)*MainRes

        self.vaValues=[]
        self.minmaxvalues=[]

    #varValues=self.extractVariables("ForceVariables.txt")
    #minmaxvalues=self.extractMinMaxVals(varValues)
    #Xincrements=varResX
        self.Xincrements=self.varResX
        self.EXKincrements=np.ones(self.numSets)*self.MultRes2
        #self.Fincrements=self.varResF
    #Fincrements=MultRes2
        self.Eincrements=self.varResE
        self.Kincrements=self.varResK
        self.EXincrements=self.varResEminusX
        self.COSincrements=self.varCos
        self.SINincrements=self.varSin
        
        
    #DXincrements=varResDX
        self.CosSinSumincrements=self.varMultCosSinSum
        self.CosSinSubincrements=self.varMultCosSinSub
        self.CosSinDivincrements=self.varCosSinDiv
        self.RoundEXKincrements=self.varResEminusXmK
    #RoundEXKincrements=np.ones(numSets)*MultRes
    #RoundEXKincrements=
        self.DivPopIncr=0.01#needs to be lower, e.g. 0.001 if a more accurate result (i.e. to how many decimal places) is required.  eg for input1 and input2 with 0.05 increments, each set of neurons attached to each neuron in input 1, will need to represent at least 4 decimal places, (e.g. 0.05/0.8=0.0625)/0.01<-(increment for div cells) =6 cells need to be on attached to each neuron in input 1, then times this by how many input 2 neurons (sets) there are, (for example, 6.25, is 6 neurons=6*20*0.01=1.2.  The actual answer of 1/0.8 should be 1.25 so the div increment would 
    
        self.RoundOutDivIncrements=0.1
        self.RoundOutDtIncrements=0.0001



    
    
        self.minXarray=[]
        self.maxXarray=[]
        self.Earray=[]
        self.minEminusXarray=[]
        self.maxEminusXarray=[]
        self.Karray=[]
        self.minEminusXMultKarray=[]
        self.maxEminusXMultKarray=[]
        self.minF=[]
        #minF=-5
        self.maxF=[]
        self.minCosArray=[]
        self.maxCosArray=[]
        self.minSinArray=[]
        self.maxSinArray=[]

    
        self.minCosSinArray=[]
        self.maxCosSinArray=[]

        self.minMultCosSinArray=[]
        self.maxMultCosSinArray=[]

        self.minDivCosSinArray=[]
        self.maxDivCosSinArray=[]
    #RoundEXKPopCells=[]
    
    
    #minDXarray=[]
    #maxDXarray=[]

    ########for summation
    #numNeuronsInFPop=[0,0]
    #numNeuronsInFPopNeg=[0,0]
        self.KneuronsPerEXneuron=[0,0,0,0]


    ####################
    ##create the neurons in each population
    #numNeurons=[row[0] for row in numNeuronsInEachXPop]         #acquire the first element from all of the lists in numNeuronsInEachXPop
        self.XPopsInpCells=[[] for k in range(self.numSets)] #numNeuronsInEachXPop[0] holds the total neuron num, [1] holds the positive num, [2] holds the negative

    #numNeurons=[row[0] for row in self.numNeuronsInEachEPop]         #acquire the first element from all of the lists in numNeuronsInEachXPop
        self.EPopsInpCells=[]

    #numNeurons=[row[0] for row in self.numNeuronsInEachKPop]         #acquire the first element from all of the lists in numNeuronsInEachXPop
        self.KPopsInpCells=[]

    #numNeurons=[row[0] for row in self.numNeuronsInEachEMinusXPop]         #acquire the first element from all of the lists in numNeuronsInEachXPop
    #EMinusXPops=[]

    #numNeurons=[row[0] for row in numNeuronsInEachEMinusXMultKPop]         #acquire the first element from all of the lists in numNeuronsInEachXPop
    #EMinusXMultKPops=[]

    #numNeurons=[row[0] for row in numNeuronsInEachXPop]         #acquire the first element from all of the lists in numNeuronsInEachXPop
    #FPops=createNeurons([numNeuronsInFPop[0]]) #createNeurons needs an array of numbers
        self.FOutCells=[]
 
    #DXPopsCells=[]   #DXPopsCells[0]=XPopsInpCells[2], DXPopsCells[1]=XPopsInpCells[3], DXPopsCells[2]=calculation using theta, which is the previous dx[1], and is therefore, the input at the beginning, and dtheta which is the previous dx[3].   dx[1] (theta) and dx[3] (dtheta) are inputs in the next time step, i.e. x[1] and x[3].  DXPopsCells[3]= a calculation using theta (dx[1], i.e. x[1])

        self.CosPopCells=[]
        self.SinPopCells=[]

        self.PulseCellPop=[]

        self.CosSinPopCells=[]

        self.MultCosSinPopCells=[]

        self.PosOrNegCosSinPop=[]
        self.CosSinSubCells=[]
        self.CosSinSumCells=[]
        self.CosSinDivCells=[]

        self.testinputcells=[]
        self.testoutputcells=[]

        self.copycell=[]

        self.CosPopInterSumCells=[]
        self.SinPopInterSumCells=[]

        self.CosSinPopInterOutSumCells=[]
        self.CosSinPopInterOutSubCells=[]

    #EXInterOutSubCells=[]

        self.EXKSum01Cells=[]
        self.EXKSum23Cells=[]
        self.EXKPopInterOutSum01Cells=[]
        self.EXKPopInterOutSum23Cells=[] 
        self.FInterSumCells=[]
   # EMinusXBufPops=[]
   # KPopsInpCellsBuf=[]

    #CosPopBufCells=[]
    #SinPopBufCells=[]     
    
        self.d=0
    #numdepths=22

        self.dtcell=[]
        self.dtresultpopCos=[]

        self.dtcosincrement=self.dtincrement*self.AngRes

        self.SinPopCells1=[]
        self.SinPopCells2=[]
        self.SinPopCells3=[]

        self.rounddtcospop=[]

        self.sinsqpop=[]


        
        #global FOutCells
        #self.init()
        self.numdepths=numd
        self.sim=sim
        self.varValues=self.extractVariables("ForceVariables2.txt")
        self.minmaxvalues=self.extractMinMaxVals(self.varValues)

        self.minXarray=self.minmaxvalues[0]
        self.maxXarray=self.minmaxvalues[1]
        print (self.minmaxvalues[0])
        print (self.minmaxvalues[1])
        self.Earray=self.minmaxvalues[2]
        self.minEminusXarray=self.minmaxvalues[3]
        self.maxEminusXarray=self.minmaxvalues[4]
        self.Karray=self.minmaxvalues[5]
        self.minEminusXMultKarray=self.minmaxvalues[6]
        self.maxEminusXMultKarray=self.minmaxvalues[7]
        
        self.minF=self.minmaxvalues[8]
        #minF=-5
        self.maxF=self.minmaxvalues[9]

        #print self.minF
        #print self.maxF
#        adfa
        
        self.minCosArray=-1
        self.maxCosArray=1
        self.minSinArray=-1
        self.maxSinArray=1


        """
        self.minXarray=[-1,0,-2,-3]
        self.maxXarray=[1,30,2,4]
        """
        ###WE NEED SIN TO START AT 0 AND COS AT 1 FOR IT TO WORK.  THEREFORE, WE NEED TO RANGE X1 accordingly, i.e. at -6.28
        #WITHOUT FORCE
       
        ########################################
        #self.minXarray=[-0.4,0.0,-6.0,0.0]  ##2 sec
        #self.maxXarray=[1.5,8.0,2.0,10.0]    ##2 sec    
        #####################
        #WITH FORCE
        if(self.force==1):
            self.minXarray=[-18.5,-6.28,-13.0,-3.5]  ##2 sec
            self.maxXarray=[0.5,0.9,0.8,1.5]    ##2 sec
        else:
            #self.minXarray=[0.0,0.0,-2.2,-0.2]  ##4 sec
            #self.maxXarray=[5.3,32.0,5.0,9.3]    ##4 sec ##2.5
            self.minXarray=[-0.5,0.0,-5.5,0.0]  ##4 sec
            self.maxXarray=[2.91,20.0,3.0,10.1]    ##4 sec             
        ##############
        #self.minXarray=[0.0,0.0,-1.67,0.0]  ##2 sec
        #self.maxXarray=[1.5,8.0,1.1,7.8]    ##2 sec 
            
        self.minCosSinArray=-1
        self.maxCosSinArray=1

        self.minMultCosSinArray=-1
        self.maxMultCosSinArray=1

        self.minCosSinSumArray=-2
        self.maxCosSinSumArray=2

        self.minCosSinSubArray=-2
        self.maxCosSinSubArray=2

        self.minDivCosSinArray=-1*(1/self.CosSinDivincrements)
        self.maxDivCosSinArray=1/self.CosSinDivincrements

        print self.minDivCosSinArray
        print self.maxDivCosSinArray

        #self.minDXarray=self.minXarray
        #self.maxDXarray=self.maxXarray

        #self.minXarray=[-10,-1,-1,-1]
        #self.maxXarray=[9,1,1,1]

        print self.Earray
        print self.Karray
        ###self.pause()

        #self.Earray=[2.0,1.57,-2.0, 1.0]  #put these in for the min
        #self.Earray=[2.0,1.57,-2.0, 1.0]  #put these in for the min
        self.Karray=[ -1.0, 2.0, -2.0, 2.0]                    #these results cause a -4 force output
        #print self.minXarray
        #print self.maxXarray
        #adfad
        addMinusToF=0.01
        addSinsqM1ToM0=0.01
        addSingToDX2Cos=0.05
        self.SinM1M0increments=addSinsqM1ToM0

        #########################MULTIPLICATION
        self.connectionnum=1 #CHANGED 2  #how many of the input to connect to each multiplication pop
        ##NEED TO CHECK THAT ALL ADD AND SUBSTRACT VALUES ARE THE SAME FROM THE MULTIPLICATION
        ####
        self.MultCosSinincrements=self.COSincrements*(self.SINincrements*(self.connectionnum*1.0))#0.005          #self.varMultCosSin
        self.CosSinincrements=0.01     #0.05 CHANGED
        self.MmultGincrements=self.M1Multg
        self.connectionnum3=1
        self.MultM1gCosSinincrements=self.MmultGincrements*(self.CosSinincrements*(self.connectionnum3*1.0)) #0.0975*0.05=0.004875
        self.RoundM1gCosSinincrements=addMinusToF        
        ####
        self.MultSinSinincrements=self.SINincrements*(self.SINincrements*(self.connectionnum*1.0))#0.005
        self.RoundSinSinincrements=self.RoundMultRes                                                #0.05
        self.M1increments=self.M1                                                                   #0.01
        self.MultSinM1increments=self.M1increments*(self.RoundSinSinincrements*(self.connectionnum*1.0)) #0.01*0.1=0.001
        #addM0toSinSqMultM1=0.005
        self.M0increments=addSinsqM1ToM0        
        self.RoundSinM1increments=self.M0increments #needs to be the same as M0 to add  CURRENTLY  0.005
        ####
        self.gincrements=0.25
        self.MultSinGincrements=self.gincrements*(self.SINincrements*(self.connectionnum*1.0)) #0.25*0.1=0.025
        self.RoundSinGincrements=0.05 #needs to be the same as M0 to add
        ####
        self.connectionnum2=150 #250
        self.MultX3X3increments=self.Xincrements[3]*(self.Xincrements[3]*(self.connectionnum2*1.0))  #0.01 #needed a larger number to connect with otherwise we would be getting 180,000+ neurons
        self.RoundX3X3increments=0.05
        self.MmultLincrements=0.01
        self.MultX3sqM1Lincrements=self.MmultLincrements*(self.RoundX3X3increments*(self.connectionnum*1.0)) #0.1*0.01=0.001
        self.RoundX3sqM1Lincrements=0.01 #
        self.connectionnum8=10 #CHANGED 20
        self.MultSinX3sqM1Lincrements=self.SINincrements*(self.RoundX3sqM1Lincrements*(self.connectionnum8*1.0)) #0.05*0.002=0.0001
        self.RoundSinX3sqM1Lincrements=addMinusToF #needs to be the same as M0 to add
        ####
        #Fincrements = 0.005
        #M1gCosSinMinusSinX3sqM1Lincrements=0.005
        #when adding together we merge them both into 0.03
        self.M1gCosSinMinusSinX3sqM1LPlusFincrements=0.01  #CHANGED 0.03
        self.RoundonedivSinsqM1M0Increments=0.75
        self.onedivSinsqM1M0Incr=0.05
        self.connectionnum7=2  ##CHANGED 3
        self.DX2increments=self.RoundonedivSinsqM1M0Increments*(self.M1gCosSinMinusSinX3sqM1LPlusFincrements*(self.connectionnum7*1.0)) #0.5*0.06=0.03
        self.RoundDX2increments=0.5 ##CHANGED 1.0
        ###
        self.connectionnum6=1
        self.MultDX2Cosinincrements=self.RoundDX2increments*(self.COSincrements*(self.connectionnum6*1.0)) #0.5*0.1=0.05
        self.RoundDX2Cosincrements=addSingToDX2Cos #needs to be the same as M0 to add        
        ###
        self.connectionnum4=1
        self.onedivlincrements=self.oneDivl     #1.0
        self.DX2CosPlusSingGincrements=addSingToDX2Cos
        self.DX3increments=self.DX2CosPlusSingGincrements*self.onedivlincrements #0.05*1.0=0.05
        self.RoundDX3increments=0.1        
        ###
        self.dt3increment=self.dt ##45ms
        self.DX3dtincrements=self.dt3increment*(self.RoundDX3increments*(self.connectionnum*1.0))#0.01*0.2=0.002
        self.RoundDX3dtincrements=0.01
        ###
        self.dt2increment=self.dt ##45ms
        self.DX2dtincrements=self.dt2increment*(self.RoundDX2increments*(self.connectionnum*1.0))#0.05*0.5=0.025
        self.RoundDX2dtincrements=0.01        
        ###
        self.dt0increment=self.dt ##45ms, 0.045
        self.DX0dtincrements=self.dt0increment*(self.Xincrements[2]*(self.connectionnum*1.0))#0.05*0.5=0.025
        self.RoundDX0dtincrements=0.01
        ###
        self.dt1increment=self.dt##45ms  
        self.DX1dtincrements=self.dt1increment*(self.Xincrements[3]*(self.connectionnum*1.0))#0.05*0.5=0.025
        self.RoundDX1dtincrements=0.01        
        ###
        if(self.force==1):
            self.Fmin=-1.0
            self.Fmax=0.24
        else:
            self.Fmin=0.0
            self.Fmax=0.01            
#        self.minXarray=[0.0,0.0,-1.67,0.0]  ##2 sec
#        self.maxXarray=[1.5,8.0,1.1,7.8]    ##2 sec             
        #self.Fmin=-18.0
        #self.Fmax=18.0
        #self.Fmin=-5.0
        #self.Fmax=5.0        
        self.Fincrements=addMinusToF
        ###
        self.M1gCosSinMinusSinX3sqM1Lincrements=addMinusToF


        ############################
              
        """                     
        for i in range(0,self.numSets):
#            print "calculating number of neurons for X %s" %i
            self.numNeuronsInEachXPop[i]=self.CalculateNeuronNumEachPop(self.minXarray[i], self.maxXarray[i], self.varResX[i])
            #numNeuronsInEachXPop[i]=CalculateNeuronNumEachPop(-7.9, 4, 1.19)
            #numNeuronsInEachXPop[i]=numNeuronsInEachPop
#            print "calculating number of neurons for E %s" %i
            
            self.numNeuronsInEachEPop[i]=self.CalculateNeuronNumEachPop(self.Earray[i], self.Earray[i], self.varResE[i])    #E has one constant number so the min and max is the same
#            print "calculating number of neurons for K %s" %i
            self.numNeuronsInEachKPop[i]=self.CalculateNeuronNumEachPop(self.Karray[i], self.Karray[i],self.varResK[i])    #K has one constant number so the min and max is the same
 #           print "calculating number of neurons for EminusX %s" %i
            self.numNeuronsInEachEMinusXPop[i]=self.CalculateNeuronNumEachPop(self.minEminusXarray[i], self.maxEminusXarray[i], self.varResEminusX[i])
#            print "calculating number of neurons for EminusXmultK %s" %i
            self.numNeuronsInEachEMinusXMultKPop[i]=self.CalculateNeuronNumEachPop(self.minEminusXMultKarray[i], self.maxEminusXMultKarray[i], self.varResEminusXmK[i])
        """
        ####################
        
#        "print e1"
#        print self.numNeuronsInEachEPop
#        hggjhgj
        ##########THIS BYPASSES THE ABOVE NEURON NUMBER CALCULATION...FOR NOW

        self.numNeuronsInSinPop=self.CalculateNeuronNumEachPop(self.minSinArray, self.maxSinArray,self.varSin)
        self.numNeuronsInCosPop=self.CalculateNeuronNumEachPop(self.minCosArray, self.maxCosArray,self.varCos)
        #self.numNeuronsInSinCosPop=self.CalculateNeuronNumEachPop(self.minCosSinArray, self.maxCosSinArray,self.varCosSin)
        #self.numNeuronsInMultCosSinPop=self.CalculateNeuronNumEachPop(self.minMultCosSinArray, self.maxMultCosSinArray,self.varMultCosSin)
        self.numNeuronsInCosSinSumPop=self.CalculateNeuronNumEachPop(self.minCosSinSumArray, self.maxCosSinSumArray,self.varMultCosSinSum)
        self.numNeuronsInCosSinSubPop=self.CalculateNeuronNumEachPop(self.minCosSinSubArray, self.maxCosSinSubArray,self.varMultCosSinSub)
        self.numNeuronsInCosSinDivPop=self.CalculateNeuronNumEachPop(self.minDivCosSinArray, self.maxDivCosSinArray,self.varCosSinDiv)

        #div inputs and output need to be the same, apart from the rounded value



        #self.numDivPops=self.calculatedivnumber(self.numNeuronsIn1DivPop, self.numNeuronsInCosPop, self.DivPopIncr)
        #divattributes=self.calculatedivnumber(self.numNeuronsInSinPop, self.numNeuronsInCosPop, self.DivPopIncr, self.RoundOutDivIncrements)

        #self.numDivPops=divattributes[0]
        #self.DivPops=divattributes[1]
        #self.numNeuronsDivRoundOutPop=divattributes[2]
        #self.DivRoundoutputPops=divattributes[3]
        #print self.DivRoundoutputPops
        #fasdf






#        print self.numDivPops
#        print self.numNeuronsDivRoundOutPop
#        print self.numNeuronsIn1DivPop
#        print self.numNeuronsInCosPop
        #adfadf


#        self.numNeuronsInSinCosPop

#        self.CosPopBufCells, self.SinPopBufCells, self.numNeuronsInCosPop
 

        multattributes=self.numneuronsformult(self.numNeuronsInCosPop,self.numNeuronsInSinPop, self.MultCosSinincrements, self.CosSinincrements,0, self.COSincrements, self.SINincrements)

        self.numNeuronsInMultCosSinPop=multattributes[0]
        self.MultCosSinPopCells=multattributes[1]
        self.numNeuronsInSinCosPop=multattributes[2]
        self.CosSinPopCells=multattributes[3]
        

#self.MultCosSinPopCells, self.numNeuronsInMultCosSinPop, self.MultCosSinincrements

        
        #self.numNeuronsInSinCosPop=[int(round((self.numNeuronsInMultCosSinPop[0]*self.MultRes)/self.CosSinincrements)),int(round((self.numNeuronsInMultCosSinPop[1]*self.MultRes)/self.CosSinincrements))]

        print self.numNeuronsInMultCosSinPop
        print self.numNeuronsInSinCosPop
        #fsdfgs
        #print self.minXarray
        #print self.maxXarray
        #adfadf
        for i in range(0,self.numSets):
            #input
            #self.numNeuronsInEachXPop[i]=[10,0]
            #self.numNeuronsInEachKPop[i]=self.CalculateNeuronNumEachPop(self.Karray[i], self.Karray[i],self.varResK[i])    #K has one constant number so the min and max is the same
            self.numNeuronsInEachXPop[i]=self.CalculateNeuronNumEachPop(self.minXarray[i], self.maxXarray[i], self.varResX[i])
            
            numXneurons=self.numNeuronsInEachXPop[i]
            Ecells=abs(int(round(self.Earray[i]/self.Eincrements[i])))
            Kcells=abs(int(round(self.Karray[i]/self.Kincrements[i])))
            #Ecells=self.numNeuronsInEachEPop[i]
#            print "Ecells"
#            print Ecells
#            print self.Earray[i]
            if(Ecells==0):
                self.numNeuronsInEachEPop[i]=[1,1]
                #if xarray is pos -> neg neurons or if xarray is neg-> pos neurons
                #self.numNeuronsInEachEMinusXPop[i]=[numXneurons[0], numXneurons[0]-numXneurons[1]]
            else:    
                if(self.Earray[i]<0):#1 neuron
                    #print "neg"
                    self.numNeuronsInEachEPop[i]=[Ecells,Ecells]  #total, neg num
                    #E-X)-> if Earray is neg or xarray is pos -> neg neurons
                    #self.numNeuronsInEachEMinusXPop[i]=[Ecells+numXneurons[0],(numXneurons[0]-numXneurons[1])+Ecells]
                else:
                    #print "pos"
                    self.numNeuronsInEachEPop[i]=[Ecells,0]
                    #E-X -> if Earray is pos or xarray is neg -> pos neurons
                    #self.numNeuronsInEachEMinusXPop[i]=[Ecells+numXneurons[0],numXneurons[0]-numXneurons[1]]


            if(Kcells==0):
                self.numNeuronsInEachKPop[i]=[1,1]
                #if xarray is pos -> neg neurons or if xarray is neg-> pos neurons
                #self.numNeuronsInEachEMinusXPop[i]=[numXneurons[0], numXneurons[0]-numXneurons[1]]
            else:    
                if(self.Karray[i]<0):#1 neuron
                    #print "neg"
                    self.numNeuronsInEachKPop[i]=[Kcells,Kcells]  #total, neg num
                    #E-X)-> if Earray is neg or xarray is pos -> neg neurons
                    #self.numNeuronsInEachEMinusXPop[i]=[Ecells+numXneurons[0],(numXneurons[0]-numXneurons[1])+Ecells]
                else:
                    #print "pos"
                    self.numNeuronsInEachKPop[i]=[Kcells,0]
                    #E-X -> if Earray is pos or xarray is neg -> pos neurons
                    #self.numNeuronsInEachEMinusXPop[i]=[Ecells+numXneurons[0],numXneurons[0]-numXneurons[1]]


            #print "I"
            #print i
            #print self.numNeuronsInEachEMinusXPop[i]
            #print Ecells
            #print numXneurons[0]



            
           
            #self.numNeuronsInEachEPop[i]*self.Eincrements[i]

            #self.numNeuronsInEachXPop[i]*self.varResX[i]

           
            
            
            """
            subattributes=self.CalculateNumForSubtractionPop(self.numNeuronsInEachEPop[i], self.numNeuronsInEachXPop[i], self.Eincrements[i], self.varResX[i], self.varResEminusX[i])


            self.numNeuronsInEachEMinusXPop[i]=subattributes[0]
            self.EMinusXPops[i]=subattributes[1]
            self.EXInterOutSubCells[i]=subattributes[2]
            """

            
#            print "calculating number of neurons for EminusXmultK %s" %i
            
            #self.numNeuronsInEachEMinusXMultKPop[i]=self.CalculateNeuronNumEachPop(minexvalue*minKvalue, maxexvalue*minKvalue, self.EXKincrements[i])

            #numn=self.numNeuronsInEachEMinusXMultKPop[i]
            """
            multattributes=self.numneuronsformult(self.numNeuronsInEachEMinusXPop[i],self.numNeuronsInEachKPop[i], self.MultRes2, self.RoundEXKincrements[i],0, self.EXincrements[i],self.Kincrements[i])

            self.numNeuronsInEachEMinusXMultKPop[i]=multattributes[0]
            self.EMinusXMultKPops[i]=multattributes[1]
            self.numNeuronsInRoundEXKPopCells[i]=multattributes[2]
            self.RoundEXKPopCells[i]=multattributes[3]
            """
            #self.numNeuronsInFPop[0]+=numEXKCells[0]
            #self.numNeuronsInFPop[1]+=numEXKCells[1]
            
            #value=

           

            #numEXneurons=self.numNeuronsInEachEMinusXPop[i]

            #self.KneuronsPerEXneuron[i]=int(round((self.EXincrements[i]*abs(self.Karray[i]))/self.EXKincrements[i]))
            #totalEXKCells=numEXneurons[0]*self.KneuronsPerEXneuron[i]
#            print "totalEXK"
#            print totalEXKCells
#            print "numexneur"
#            print numEXneurons[0]
#            print self.KneuronsPerEXneuron
#            print "EXKincrements"
#            print self.EXKincrements
#            print "EXincrements"
#            print self.EXincrements
#            print "karray"
#            print self.Karray
            #d=(self.EXincrements[i]*self.Karray[i])/self.EXKincrements[i]
            #adfafd
#            print d
            
            #if(self.Karray[i]<0):#1 neuron
                #if k is negative, pos and k is neg, so pos need to be changed to neg neuron
            #    self.numNeuronsInEachEMinusXMultKPop[i]=[totalEXKCells,(numEXneurons[0]-numEXneurons[1])*self.KneuronsPerEXneuron[i]]
            #else:
                #if k is positive, neg inputs lead to neg outputs and pos inputs lead to pos outputs
            #    self.numNeuronsInEachEMinusXMultKPop[i]=[totalEXKCells,numEXneurons[1]*self.KneuronsPerEXneuron[i]]        



  #          self.numNeuronsInEachEPop[i]+         
            """
            #numEneurons=self.numNeuronsInEachEPop[i]
            #print(numEneurons)
            #self.Eincrements[i]=self.Earray[i]/float(numEneurons[0])
            #self.EXincrements[i]=self.Eincrements[i]-self.Xincrements[i]
            
            #self.numNeuronsInEachEPop[i]=self.numNeuronsInEachXPop[i]               #3 neurons
            inputs=[self.numNeuronsInEachXPop[i],self.numNeuronsInEachEPop[1]]
            ##subsraction
            self.numNeuronsInEachEMinusXPop[i]=self.CalculateOutPopForSubOrSum(inputs, 0, 0)

           
            #input
            self.Kincrements[i]=self.Karray[i]/float(numXneurons[0])
            print self.Kincrements[i]
            print numXneurons[0]
            ####self.pause()
            if(self.Karray[i]<0):                       #1 neuron
                self.numNeuronsInEachKPop[i]=[numXneurons[0],numXneurons[0]]
            else:
                self.numNeuronsInEachKPop[i]=[numXneurons[0],0]

            #multiplication
            self.EXKincrements[i]=self.Kincrements[i]*self.EXincrements[i]
            self.numNeuronsInEachEMinusXMultKPop[i]=self.numNeuronsInEachEMinusXPop[i]
            """
            #numEXKCells=self.numNeuronsInEachEMinusXMultKPop[i]
            #self.numNeuronsInFPop[0]+=numEXKCells[0]
            #self.numNeuronsInFPop[1]+=numEXKCells[1]
            #subtraction
         
        #print self.numNeuronsInRoundEXKPopCells
        #adfa
        #summation
        #print "e4"
        #print self.numNeuronsInEachEPop
        #print self.EPopsInpCells
        #hggjhgj       
            
        #self.numNeuronsInFPop=self.CalculateOutPopForSubOrSum(self.numNeuronsInEachEMinusXMultKPop, 1, 1)
        ########################
       # print self.Xincrements
       # print self.EXKincrements
       # print self.Fincrements
        #print self.Eincrements
        #print self.Kincrements
        #print self.EXincrements
#        print self.Karray
#        print self.Earray
        #print numXneurons
        #print self.EXKincrements[1]
        #adfadf



        #self.numNeuronsInFPop=self.CalculateNeuronNumEachPop(self.minF, self.maxF, self.Fincrements)
        #self.numNeuronsInEXKSum01Pop=self.CalculateNeuronNumEachPop(self.minEminusXMultKarray[0]+self.minEminusXMultKarray[1], self.maxEminusXMultKarray[0]+self.maxEminusXMultKarray[1], self.EXKSum01increments)
        #self.numNeuronsInEXKSum23Pop=self.CalculateNeuronNumEachPop(self.minEminusXMultKarray[2]+self.minEminusXMultKarray[3], self.maxEminusXMultKarray[2]+self.maxEminusXMultKarray[3], self.EXKSum23increments)

        """
        sumattributes=self.calculatenumforadditionpop(self.numNeuronsInRoundEXKPopCells[0], self.numNeuronsInRoundEXKPopCells[1]) 

        self.numNeuronsInEXKSum01Pop=sumattributes[0]
        self.EXKSum01Cells=sumattributes[1]
        self.EXKPopInterOutSum01Cells=sumattributes[2]

        sumattributes=self.calculatenumforadditionpop(self.numNeuronsInRoundEXKPopCells[2], self.numNeuronsInRoundEXKPopCells[3]) 

        self.numNeuronsInEXKSum23Pop=sumattributes[0]
        self.EXKSum23Cells=sumattributes[1]
        self.EXKPopInterOutSum23Cells=sumattributes[2]                                                 
        

        sumattributes=self.calculatenumforadditionpop(self.numNeuronsInEXKSum01Pop, self.numNeuronsInEXKSum23Pop) 

        self.numNeuronsInFPop=sumattributes[0]
        self.FOutCells=sumattributes[1]
        self.FInterSumCells=sumattributes[2]

        sumattributes=self.calculatenumforadditionpop(self.numNeuronsInEXKSum01Pop, self.numNeuronsInEXKSum23Pop) 

        self.numNeuronsInFPop=sumattributes[0]
        self.FOutCells=sumattributes[1]
        self.FInterSumCells=sumattributes[2]
        """
        ##########take out controller for the minute

        Fneg=int(round(abs(self.Fmin)/self.Fincrements))
        Fpos=int(round(abs(self.Fmax)/self.Fincrements))
        self.numNeuronsInFPop=[Fneg+Fpos,Fneg]
        #self.numNeuronsInFPop=[1,0]
        m1cell=self.createNeurons([self.numNeuronsInFPop[0]])
        self.FOutCells=m1cell[0]       
        

        #RoundEXKincrements
       # EXKSum01Cells
       # numNeuronsInEXKSum01Pop
       # EXKSum23increments
        #print self.numNeuronsInFPop
        #adfasd

        #numNeuronsInEXKSum01Pop#

        #F=EXKSum23Cells+EXKSum01Cells
        #numNeuronsInEXKSum01Pop=self.numNeuronsInRoundEXKPopCells[2]+self.numNeuronsInRoundEXKPopCells[1]


        #print self.minEminusXMultKarray
        #print self.maxEminusXMultKarray
        #print self.minF
        #print self.maxF
        #fdfgsfdg
#self.EXKSum23Cells, self.FOutCells
#        =self.minmaxvalues[6]
#        self.maxEminusXMultKarray
#self.
#self.numNeuronsInEXKSum23Pop

        totalnumneurons=0


        print "X"
        print self.numNeuronsInEachXPop
        print "K"
        print self.numNeuronsInEachKPop        
        print "E"
        print self.numNeuronsInEachEPop
        print "E-X"
        print self.numNeuronsInEachEMinusXPop
        print "E-X*K"
        print self.numNeuronsInEachEMinusXMultKPop
        print "F"
        print self.numNeuronsInFPop
        print "k neurons per"
        print self.KneuronsPerEXneuron
        #print self.Earray
        #print inputs
        
        #adfadf
        
        #sin squared
        multattributes=self.numneuronsformult(self.numNeuronsInSinPop,self.numNeuronsInSinPop, self.MultSinSinincrements, self.RoundSinSinincrements,1, self.SINincrements,self.SINincrements)
        self.numNeuronsInMultSinSinPop=multattributes[0]
        self.sinsqpop=multattributes[1]
        self.numNeuronsInRoundSinSq=multattributes[2]
        self.RoundSinSqPopCells=multattributes[3]

        totalnumneurons+=self.numNeuronsInMultSinSinPop[0]
        totalnumneurons+=self.numNeuronsInRoundSinSq[0]
        
        print self.numNeuronsInRoundSinSq
        print self.numNeuronsInMultSinSinPop
        #sdfgdsf


        self.numNeuronsM0Pop=[int(round(self.M0/self.M0increments)),0] #M0=0.01
        m0cell=self.createNeurons([self.numNeuronsM0Pop[0]])
        self.M0Pop=m0cell[0]

        totalnumneurons+=self.numNeuronsM0Pop[0]

        self.numNeuronsM1Pop=[1,0] #M0=0.01
        
        m1cell=self.createNeurons([self.numNeuronsM1Pop[0]])
        self.M1Pop=m1cell[0]

        totalnumneurons+=1

        
        self.numNeuronsgPop=[int(round(self.g/self.gincrements)),0] #M0=0.01      
        gcell=self.createNeurons([self.numNeuronsgPop[0]])
        self.gPop=gcell[0]

        totalnumneurons+=self.numNeuronsgPop[0]

        
        self.numNeuronsoneDivLPop=[int(round(self.oneDivl/self.onedivlincrements)),0] #M0=0.01      
        onedivlcell=self.createNeurons([self.numNeuronsoneDivLPop[0]])
        self.oneDivLPop=onedivlcell[0]

        totalnumneurons+=self.numNeuronsoneDivLPop[0]
            
        self.numNeuronsMmultGPop=[int(round(self.M1Multg/self.MmultGincrements)),0] #M0=0.01      
        mmultgcell=self.createNeurons([self.numNeuronsMmultGPop[0]])
        self.MmultGPop=mmultgcell[0]

        totalnumneurons+=self.numNeuronsMmultGPop[0]
        
        self.numNeuronsMmultLPop=[int(round(self.M1Multl/self.MmultLincrements)),0] #M0=0.01      
        mmultlcell=self.createNeurons([self.numNeuronsMmultLPop[0]])
        self.MmultLPop=mmultlcell[0]

        totalnumneurons+=self.numNeuronsMmultLPop[0]



        multattributes=self.numneuronsformult(self.numNeuronsM1Pop,self.numNeuronsInRoundSinSq, self.MultSinM1increments, self.RoundSinM1increments,1, self.M1increments, self.RoundSinSinincrements)

        self.numNeuronsInMultSinM1Pop=multattributes[0]
        self.sinM1pop=multattributes[1]
        self.numNeuronsInRoundSinM1=multattributes[2]
        self.RoundSinM1PopCells=multattributes[3]

        totalnumneurons+=self.numNeuronsInMultSinM1Pop[0]
        totalnumneurons+=self.numNeuronsInRoundSinM1[0]

        print self.numNeuronsInRoundSinM1
        print self.numNeuronsInMultSinM1Pop
        print self.numNeuronsM1Pop
        print self.numNeuronsInRoundSinSq
        print self.MultSinM1increments
        print self.RoundSinM1increments
        print self.M0increments

        #adfda

        sumattributes=self.calculatenumforadditionpop(self.numNeuronsM0Pop, self.numNeuronsInRoundSinM1) 

        self.numNeuronsInSinsqM1M0Pop=sumattributes[0]
        self.SinM1M0SumCells=sumattributes[1]
        self.SinM1M0PopInterOutSumCells=sumattributes[2]

        totalnumneurons+=self.numNeuronsInSinsqM1M0Pop[0]*2.0
        
        self.RoundSinM1increments

        print self.numNeuronsInSinsqM1M0Pop
        #adfadf

        #self.numDivPops=[0,0]
        self.in1DivIncrements=1
        self.numNeuronsIn1DivPop=[int(round(1.0/self.in1DivIncrements)),0]

        in1div=self.createNeurons([self.numNeuronsIn1DivPop[0]])
        self.onedivpop=in1div[0]

        totalnumneurons+=self.numNeuronsIn1DivPop[0]

        divattributes=self.calculatedivnumber(self.numNeuronsIn1DivPop, self.numNeuronsInSinsqM1M0Pop, self.onedivSinsqM1M0Incr, self.RoundonedivSinsqM1M0Increments, self.in1DivIncrements, self.SinM1M0increments,1)
        ##THE DENOMINATOR OF BOTH INPUT AND OUTPUT HAS TO BE THE SAME, so that if only one neuron of both sets fire, the result == to 1, THE OUTPUT INCREMENT DOES NOT
        self.numonedivSinsqM1M0Pops=divattributes[0]
        self.onedivSinsqM1M0Pops=divattributes[1]
        self.numNeuronsonedivSinsqM1M0RoundPop=divattributes[2]
        self.onedivSinsqM1M0RoundPops=divattributes[3]

        totalnumneurons+=self.numonedivSinsqM1M0Pops[0]
        totalnumneurons+=self.numNeuronsonedivSinsqM1M0RoundPop[0]

        print self.numNeuronsIn1DivPop
        print self.numNeuronsInSinsqM1M0Pop
        print self.numonedivSinsqM1M0Pops
        print self.numNeuronsonedivSinsqM1M0RoundPop


        #x3 squared
        #print self.XPopsInpCells
        #self.XPopsInpCells[3]
        #self.numNeuronsInEachXPop[3]
        #self.Xincrements[3]


        
        multattributes=self.numneuronsformult(self.numNeuronsInEachXPop[3],self.numNeuronsInEachXPop[3], self.MultX3X3increments, self.RoundX3X3increments,1, self.Xincrements[3],self.Xincrements[3])
        self.numNeuronsInMultX3X3Pop=multattributes[0]
        self.X3sqpop=multattributes[1]
        self.numNeuronsInRoundX3Sq=multattributes[2]
        self.RoundX3SqPopCells=multattributes[3]

        totalnumneurons+=self.numNeuronsInMultX3X3Pop[0]
        totalnumneurons+=self.numNeuronsInRoundX3Sq[0]

        print self.MultX3X3increments
        print self.numNeuronsInMultX3X3Pop
        print self.numNeuronsInRoundX3Sq
        print self.onedivSinsqM1M0Pops





        multattributes=self.numneuronsformult(self.numNeuronsMmultLPop,self.numNeuronsInRoundX3Sq, self.MultX3sqM1Lincrements, self.RoundX3sqM1Lincrements,1, self.MmultLincrements, self.RoundX3X3increments)

        self.numNeuronsInMultX3sqM1LPop=multattributes[0]
        self.X3sqM1Lpop=multattributes[1]
        self.numNeuronsInRoundX3sqM1L=multattributes[2]
        self.RoundX3sqM1LPopCells=multattributes[3]

        totalnumneurons+=self.numNeuronsInMultX3sqM1LPop[0]
        totalnumneurons+=self.numNeuronsInRoundX3sqM1L[0]
        
        ####3 sets of feed forward sin cells
        
    
        SinPops=self.createNeurons([self.numNeuronsInSinPop[0]])
        self.SinPopCells1=SinPops[0]

        
        """
        SinPops=self.createNeurons([self.numNeuronsInSinPop[0]])
        self.SinPopCells2=SinPops[0]
        """
        SinPops=self.createNeurons([self.numNeuronsInSinPop[0]])
        self.SinPopCells3=SinPops[0]
        
        SinPops=self.createNeurons([self.numNeuronsInSinPop[0]])
        self.SinPopCells=SinPops[0]

        
        totalnumneurons+=self.numNeuronsInSinPop[0]*3.0




        multattributes=self.numneuronsformult(self.numNeuronsInSinPop,self.numNeuronsInRoundX3sqM1L, self.MultSinX3sqM1Lincrements, self.RoundSinX3sqM1Lincrements,0, self.SINincrements, self.RoundX3sqM1Lincrements)

        self.numNeuronsInMultSinX3sqM1LPop=multattributes[0]
        self.SinX3sqM1Lpop=multattributes[1]
        self.numNeuronsInRoundSinX3sqM1L=multattributes[2]
        self.RoundSinX3sqM1LPopCells=multattributes[3]

        totalnumneurons+=self.numNeuronsInMultSinX3sqM1LPop[0]
        totalnumneurons+=self.numNeuronsInRoundSinX3sqM1L[0]

        #self.MultM1gCosSinincrements=0.004905
        print self.MultM1gCosSinincrements
        print self.MmultGincrements
        print self.CosSinincrements
#        adadf
        #needs to be the same as M0 to add


        multattributes=self.numneuronsformult(self.numNeuronsMmultGPop,self.numNeuronsInSinCosPop, self.MultM1gCosSinincrements, self.RoundM1gCosSinincrements,0, self.MmultGincrements, self.CosSinincrements)

        self.numNeuronsInMultM1gCosSinPop=multattributes[0]
        self.M1gCosSinpop=multattributes[1]
        self.numNeuronsInRoundM1gCosSin=multattributes[2]
        self.RoundM1gCosSinPopCells=multattributes[3]

        totalnumneurons+=self.numNeuronsInMultM1gCosSinPop[0]
        totalnumneurons+=self.numNeuronsInRoundM1gCosSin[0]
        

        Pops=self.createNeurons([self.numNeuronsInRoundM1gCosSin[0]])
        self.RoundM1gCosSinPopCells2=Pops[0]

        totalnumneurons+=self.numNeuronsInRoundM1gCosSin[0]

        #subattributes=self.CalculateNumForSubtractionPop(self.numNeuronsInEachEPop[i], self.numNeuronsInEachXPop[i], self.Eincrements[i], self.varResX[i], self.varResEminusX[i])


        #self.numNeuronsInEachEMinusXPop[i]=subattributes[0]
        #self.EMinusXPops[i]=subattributes[1]
        #self.EXInterOutSubCells[i]=subattributes[2]

        

        subattributes=self.CalculateNumForSubtractionPop(self.numNeuronsInRoundM1gCosSin, self.numNeuronsInRoundSinX3sqM1L, self.RoundM1gCosSinincrements, self.RoundSinX3sqM1Lincrements, self.M1gCosSinMinusSinX3sqM1Lincrements)


        self.numNeuronsM1gCosSinMinusSinX3sqM1L=subattributes[0]
        self.M1gCosSinMinusSinX3sqM1LPops=subattributes[1]
        self.M1gCosSinMinusSinX3sqM1LInterCells=subattributes[2]

        totalnumneurons+=self.numNeuronsM1gCosSinMinusSinX3sqM1L[0]*2.0

        self.Force2increments=self.Fincrements
        #self.numNeuronsForce2=self.convertNeuronNumber(self.Force2increments, self.numNeuronsInFPop, self.Fincrements)
        
        #ForPops=self.createNeurons([self.numNeuronsForce2[0]])
        #self.Force2Cells=ForPops[0]
        print "add"

        
        sumattributes=self.calculatenumforadditionpop(self.numNeuronsM1gCosSinMinusSinX3sqM1L, self.numNeuronsInFPop) 

        self.numNeuronsInM1gCosSinMinusSinX3sqM1LPlusF=sumattributes[0]
        #self.M1gCosSinMinusSinX3sqM1LPlusFCells=sumattributes[1]
        self.M1gCosSinMinusSinX3sqM1LPlusFInterCells=sumattributes[2]
        
        ##output neurons have a different increment than the rest, usually, the inter and out neurons have the same increment
        self.numneuron=[0,0]
        self.numneuron[0]=int(round((self.numNeuronsInM1gCosSinMinusSinX3sqM1LPlusF[0]*self.Force2increments)/self.M1gCosSinMinusSinX3sqM1LPlusFincrements))#want to change the output to a different increment here
        self.numneuron[1]=int(round((self.numNeuronsInM1gCosSinMinusSinX3sqM1LPlusF[1]*self.Force2increments)/self.M1gCosSinMinusSinX3sqM1LPlusFincrements))#want to change the output to a different increment here
        
        Pops=self.createNeurons([self.numneuron[0]])
        self.M1gCosSinMinusSinX3sqM1LPlusFCells=Pops[0]        

        totalnumneurons+=self.numneuron[0]
        totalnumneurons+=self.numNeuronsInM1gCosSinMinusSinX3sqM1LPlusF[0]
    
        #Pops=self.createNeurons([self.numNeuronsM1gCosSinMinusSinX3sqM1L[0]])
        #self.M1gCosSinMinusSinX3sqM1LPops2=Pops[0]

        print self.numNeuronsInM1gCosSinMinusSinX3sqM1LPlusF






        #self.M1gCosSinMinusSinX3sqM1LPlusFonedivSinsqM1M0increments=0.005 #needs to be the same as M0 to add
        print "mult"

        multattributes=self.numneuronsformult(self.numNeuronsonedivSinsqM1M0RoundPop, self.numneuron, self.DX2increments, self.RoundDX2increments,0, self.RoundonedivSinsqM1M0Increments, self.M1gCosSinMinusSinX3sqM1LPlusFincrements)

        self.numNeuronsInDX2=multattributes[0]
        self.DX2Pop=multattributes[1]
        self.numNeuronsInRoundDX2Pop=multattributes[2]
        self.RoundDX2PopCells=multattributes[3]

        totalnumneurons+=self.numNeuronsInDX2[0]
        totalnumneurons+=self.numNeuronsInRoundDX2Pop[0]
        
        print self.numNeuronsonedivSinsqM1M0RoundPop
        print self.numonedivSinsqM1M0Pops
        print self.RoundDX2increments
        print self.RoundonedivSinsqM1M0Increments
        print self.M1gCosSinMinusSinX3sqM1LPlusFincrements
        print self.DX2increments
        print self.numNeuronsonedivSinsqM1M0RoundPop
        #print self.numNeuronsInEXKSum01Pop
        #print self.numNeuronsInEXKSum23Pop
        print self.numNeuronsInFPop
        print self.numneuron
        print self.numNeuronsM1gCosSinMinusSinX3sqM1L
        print self.numNeuronsInDX2
        print self.numNeuronsM1gCosSinMinusSinX3sqM1L
        #adfafd
        
        """
        Pops=self.createNeurons([self.numNeuronsonedivSinsqM1M0RoundPop[0]])
        self.onedivSinsqM1M0RoundPops1=Pops[0]

        Pops=self.createNeurons([self.numNeuronsonedivSinsqM1M0RoundPop[0]])
        self.onedivSinsqM1M0RoundPops2=Pops[0]
        """
        
  


        multattributes=self.numneuronsformult(self.numNeuronsInRoundDX2Pop,self.numNeuronsInCosPop, self.MultDX2Cosinincrements, self.RoundDX2Cosincrements,0, self.RoundDX2increments, self.COSincrements)

        self.numNeuronsInMultDX2CosPop=multattributes[0]
        self.DX2Cospop=multattributes[1]
        self.numNeuronsInRoundDX2Cos=multattributes[2]
        self.RoundDX2CosPopCells=multattributes[3]

        totalnumneurons+=self.numNeuronsInMultDX2CosPop[0]
        totalnumneurons+=self.numNeuronsInRoundDX2Cos[0]

        Pops=self.createNeurons([self.numNeuronsInCosPop[0]])
        self.CosPopCells1=Pops[0]

        totalnumneurons+=self.numNeuronsInCosPop[0]
        """
        Pops=self.createNeurons([self.numNeuronsInCosPop[0]])
        self.CosPopCells2=Pops[0]
        Pops=self.createNeurons([self.numNeuronsInCosPop[0]])
        self.CosPopCells3=Pops[0]
        Pops=self.createNeurons([self.numNeuronsInCosPop[0]])
        self.CosPopCells4=Pops[0]
        Pops=self.createNeurons([self.numNeuronsInCosPop[0]])
        self.CosPopCells5=Pops[0]
        Pops=self.createNeurons([self.numNeuronsInCosPop[0]])
        self.CosPopCells6=Pops[0]
        Pops=self.createNeurons([self.numNeuronsInCosPop[0]])
        self.CosPopCells7=Pops[0]
        Pops=self.createNeurons([self.numNeuronsInCosPop[0]])
        self.CosPopCells8=Pops[0]
        Pops=self.createNeurons([self.numNeuronsInCosPop[0]])
        self.CosPopCells9=Pops[0]
        Pops=self.createNeurons([self.numNeuronsInCosPop[0]])
        self.CosPopCells10=Pops[0]
        Pops=self.createNeurons([self.numNeuronsInCosPop[0]])
        self.CosPopCells11=Pops[0]
        """




        multattributes=self.numneuronsformult(self.numNeuronsgPop,self.numNeuronsInSinPop, self.MultSinGincrements, self.RoundSinGincrements,0, self.gincrements, self.SINincrements)

        self.numNeuronsInMultSinGPop=multattributes[0]
        self.SinGpop=multattributes[1]
        self.numNeuronsInRoundSinG=multattributes[2]
        self.RoundSinGPopCells=multattributes[3]

        totalnumneurons+=self.numNeuronsInMultSinGPop[0]
        totalnumneurons+=self.numNeuronsInRoundSinG[0]*2.0

        Pops=self.createNeurons([self.numNeuronsInRoundSinG[0]])
        self.RoundSinGPopCells1=Pops[0]
        """
        Pops=self.createNeurons([self.numNeuronsInRoundSinG[0]])
        self.RoundSinGPopCells2=Pops[0]
        Pops=self.createNeurons([self.numNeuronsInRoundSinG[0]])
        self.RoundSinGPopCells3=Pops[0]
        Pops=self.createNeurons([self.numNeuronsInRoundSinG[0]])
        self.RoundSinGPopCells4=Pops[0]
        Pops=self.createNeurons([self.numNeuronsInRoundSinG[0]])
        self.RoundSinGPopCells5=Pops[0]
        Pops=self.createNeurons([self.numNeuronsInRoundSinG[0]])
        self.RoundSinGPopCells6=Pops[0]
        Pops=self.createNeurons([self.numNeuronsInRoundSinG[0]])
        self.RoundSinGPopCells7=Pops[0]
        Pops=self.createNeurons([self.numNeuronsInRoundSinG[0]])
        self.RoundSinGPopCells8=Pops[0]
        Pops=self.createNeurons([self.numNeuronsInRoundSinG[0]])
        self.RoundSinGPopCells9=Pops[0]
        Pops=self.createNeurons([self.numNeuronsInRoundSinG[0]])
        self.RoundSinGPopCells10=Pops[0]
        Pops=self.createNeurons([self.numNeuronsInRoundSinG[0]])
        self.RoundSinGPopCells11=Pops[0]
        """

        sumattributes=self.calculatenumforadditionpop(self.numNeuronsInRoundDX2Cos, self.numNeuronsInRoundSinG) 

        self.numNeuronsDX2CosPlusSingGPop=sumattributes[0]
        self.DX2CosPlusSingGPop=sumattributes[1]
        self.DX2CosPlusSingGInterSumCells=sumattributes[2]

        totalnumneurons+=self.numNeuronsDX2CosPlusSingGPop[0]*2.0



        #self.M1gCosSinMinusSinX3sqM1LPlusFonedivSinsqM1M0increments=0.005 #needs to be the same as M0 to add
        print "mult"

        multattributes=self.numneuronsformult(self.numNeuronsDX2CosPlusSingGPop, self.numNeuronsoneDivLPop, self.DX3increments, self.RoundDX3increments,0, self.DX2CosPlusSingGincrements, self.onedivlincrements)

        self.numNeuronsInDX3=multattributes[0]
        self.DX3Pop=multattributes[1]
        self.numNeuronsInRoundDX3Pop=multattributes[2]
        self.RoundDX3PopCells=multattributes[3]

        totalnumneurons+=self.numNeuronsInDX3[0]
        totalnumneurons+=self.numNeuronsInRoundDX3Pop[0]

        """
        self.numNeuronsDX2CosPlusSingGPop=sumattributes[0]
        self.DX2CosPlusSingGPop=sumattributes[1]
        self.DX2CosPlusSingGInterSumCells=sumattributes[2]
        self.DX2CosPlusSingGincrements=0.05

        self.onedivlincrements=self.oneDivl
        self.numNeuronsoneDivLPop=[int(round(self.oneDivl/self.onedivlincrements)),0] #M0=0.01      
        onedivlcell=self.createNeurons([self.numNeuronsoneDivLPop[0]])
        self.oneDivLPop=onedivlcell[0]
        """

      
        self.numNeuronsDt0Pop=[1,0]
        dtc=self.createNeurons([self.numNeuronsDt0Pop[0]]) #createNeurons needs an array of numbers
        self.dt0cell=dtc[0]

        totalnumneurons+=4
        
        self.numNeuronsDt1Pop=[1,0]
        dtc=self.createNeurons([self.numNeuronsDt1Pop[0]]) #createNeurons needs an array of numbers
        self.dt1cell=dtc[0]

        
        #self.dt2increment=0.1 ##45ms
        self.numNeuronsDt2Pop=[1,0]
        dtc=self.createNeurons([self.numNeuronsDt2Pop[0]]) #createNeurons needs an array of numbers
        self.dt2cell=dtc[0]

        
        self.numNeuronsDt3Pop=[1,0]
        dtc=self.createNeurons([self.numNeuronsDt3Pop[0]]) #createNeurons needs an array of numbers
        self.dt3cell=dtc[0]        

        

        dc=self.numNeuronsInEachXPop[0]
        Pops=self.createNeurons([dc[0]])
        self.XPopsInpCells[0]=Pops[0]

        totalnumneurons+=dc[0]
        
        print "-----------------------------------X--------------"
        print self.XPopsInpCells[0]
        dc=self.numNeuronsInEachXPop[1]
        Pops=self.createNeurons([dc[0]])
        self.XPopsInpCells[1]=Pops[0]

        totalnumneurons+=dc[0]

######
        Pops=self.createNeurons([dc[0]])
        self.X1CopyPop=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X1CopyCosPop=Pops[0]

        totalnumneurons+=dc[0]*2.0
        
######        
        dc=self.numNeuronsInEachXPop[2]
        Pops=self.createNeurons([dc[0]])
        self.XPopsInpCells[2]=Pops[0]

        totalnumneurons+=dc[0]

        #print self.XPopsInpCells[2]
        #print self.numNeuronsInEachXPop[2]
        #adfafd
        dc=self.numNeuronsInEachXPop[3]
        Pops=self.createNeurons([dc[0]])
        self.XPopsInpCells[3]=Pops[0]

        totalnumneurons+=dc[0]

        ###############

        #self.M1gCosSinMinusSinX3sqM1LPlusFonedivSinsqM1M0increments=0.005 #needs to be the same as M0 to add
        print "mult"

        multattributes=self.numneuronsformult(self.numNeuronsInRoundDX3Pop, self.numNeuronsDt3Pop, self.DX3dtincrements, self.RoundDX3dtincrements,0, self.RoundDX3increments, self.dt3increment)

        self.numNeuronsInDX3dt=multattributes[0]
        self.DX3dtPop=multattributes[1]
        self.numNeuronsInRoundDX3dtPop=multattributes[2]
        self.RoundDX3dtPopCells=multattributes[3]

        totalnumneurons+=self.numNeuronsInDX3dt[0]
        totalnumneurons+=self.numNeuronsInRoundDX3dtPop[0]

        print self.numNeuronsInEachXPop[3]

        sumattributes=self.calculatenumforadditionpop(self.numNeuronsInRoundDX3dtPop, self.numNeuronsInEachXPop[3]) 

        #self.numNeuronsInEachXPop[3]=sumattributes[0]  ##X pop neuron number needs to equal the neuron pop numNeuronsInRoundDX3dtPop+self.numNeuronsInEachXPop[3]
        #self.XPopsInpCells[3]=sumattributes[1]

        self.numNeuronsX3PlusDX3dt3InterPop=sumattributes[0]
        #self.DX2CosPlusSingGPop=sumattributes[1]        
        self.X3PlusDX3dt3InterSumCells=sumattributes[2]

        totalnumneurons+=self.numNeuronsX3PlusDX3dt3InterPop[0]


        dc=self.numNeuronsInEachXPop[3]

        Pops=self.createNeurons([dc[0]])
        self.X3PopsInpCells1=Pops[0]

        totalnumneurons+=dc[0]
        """
        Pops=self.createNeurons([dc[0]])
        self.X3PopsInpCells2=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X3PopsInpCells3=Pops[0]        
        Pops=self.createNeurons([dc[0]])
        self.X3PopsInpCells4=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X3PopsInpCells5=Pops[0] 
        Pops=self.createNeurons([dc[0]])
        self.X3PopsInpCells6=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X3PopsInpCells7=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X3PopsInpCells8=Pops[0]        
        Pops=self.createNeurons([dc[0]])
        self.X3PopsInpCells9=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X3PopsInpCells10=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X3PopsInpCells11=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X3PopsInpCells12=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X3PopsInpCells13=Pops[0]        
        Pops=self.createNeurons([dc[0]])
        self.X3PopsInpCells14=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X3PopsInpCells15=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X3PopsInpCells16=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X3PopsInpCells17=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X3PopsInpCells18=Pops[0]        
        Pops=self.createNeurons([dc[0]])
        self.X3PopsInpCells19=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X3PopsInpCells20=Pops[0]         
        """



        ##DX[2]

        #self.M1gCosSinMinusSinX3sqM1LPlusFonedivSinsqM1M0increments=0.005 #needs to be the same as M0 to add
        print "mult"

        multattributes=self.numneuronsformult(self.numNeuronsInRoundDX2Pop, self.numNeuronsDt2Pop, self.DX2dtincrements, self.RoundDX2dtincrements,0, self.RoundDX2increments, self.dt2increment)

        self.numNeuronsInDX2dt=multattributes[0]
        self.DX2dtPop=multattributes[1]
        self.numNeuronsInRoundDX2dtPop=multattributes[2]
        self.RoundDX2dtPopCells=multattributes[3]

        totalnumneurons+=self.numNeuronsInDX2dt[0]
        totalnumneurons+=self.numNeuronsInRoundDX2dtPop[0]

        #print self.numNeuronsInEachXPop[3]

        sumattributes=self.calculatenumforadditionpop(self.numNeuronsInRoundDX2dtPop, self.numNeuronsInEachXPop[2]) 

        #self.numNeuronsInEachXPop[3]=sumattributes[0]  ##X pop neuron number needs to equal the neuron pop numNeuronsInRoundDX3dtPop+self.numNeuronsInEachXPop[3]
        #self.XPopsInpCells[3]=sumattributes[1]

        self.numNeuronsX2PlusDX2dt2InterPop=sumattributes[0]
        #self.DX2CosPlusSingGPop=sumattributes[1]        
        self.X2PlusDX2dt2InterSumCells=sumattributes[2]

        totalnumneurons+=self.numNeuronsX2PlusDX2dt2InterPop[0]


        dc=self.numNeuronsInEachXPop[2]

        Pops=self.createNeurons([dc[0]])
        self.X2PopsInpCells1=Pops[0]
        totalnumneurons+=dc[0]
        """
        Pops=self.createNeurons([dc[0]])
        self.X2PopsInpCells2=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X2PopsInpCells3=Pops[0]        
        Pops=self.createNeurons([dc[0]])
        self.X2PopsInpCells4=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X2PopsInpCells5=Pops[0] 
        Pops=self.createNeurons([dc[0]])
        self.X2PopsInpCells6=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X2PopsInpCells7=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X2PopsInpCells8=Pops[0]        
        Pops=self.createNeurons([dc[0]])
        self.X2PopsInpCells9=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X2PopsInpCells10=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X2PopsInpCells11=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X2PopsInpCells12=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X2PopsInpCells13=Pops[0]        
        Pops=self.createNeurons([dc[0]])
        self.X2PopsInpCells14=Pops[0]
        """
        """
        Pops=self.createNeurons([dc[0]])
        self.X2NextStateCells=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X2NextStateCells1=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X2NextStateCells2=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X2NextStateCells3=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X2NextStateCells4=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X2NextStateCells5=Pops[0]                 
        """


##################
        ###DX[0]==self.XPopsInpCells[2]
        ####self.numNeuronsInEachXPop[2]
        

        #self.M1gCosSinMinusSinX3sqM1LPlusFonedivSinsqM1M0increments=0.005 #needs to be the same as M0 to add
        print "mult"

        multattributes=self.numneuronsformult(self.numNeuronsInEachXPop[2], self.numNeuronsDt0Pop, self.DX0dtincrements, self.RoundDX0dtincrements,0, self.Xincrements[2], self.dt0increment)

        self.numNeuronsInDX0dt=multattributes[0]
        self.DX0dtPop=multattributes[1]
        self.numNeuronsInRoundDX0dtPop=multattributes[2]
        self.RoundDX0dtPopCells=multattributes[3]

        totalnumneurons+=self.numNeuronsInDX0dt[0]
        totalnumneurons+=self.numNeuronsInRoundDX0dtPop[0]
    
        #print self.numNeuronsInEachXPop[3]

        sumattributes=self.calculatenumforadditionpop(self.numNeuronsInRoundDX0dtPop, self.numNeuronsInEachXPop[0]) 

        #self.numNeuronsInEachXPop[3]=sumattributes[0]  ##X pop neuron number needs to equal the neuron pop numNeuronsInRoundDX3dtPop+self.numNeuronsInEachXPop[3]
        #self.XPopsInpCells[3]=sumattributes[1]

        self.numNeuronsX0PlusDX0dt0InterPop=sumattributes[0]
        #self.DX2CosPlusSingGPop=sumattributes[1]        
        self.X0PlusDX0dt0InterSumCells=sumattributes[2]

        totalnumneurons+=self.numNeuronsX0PlusDX0dt0InterPop[0]

        dc=self.numNeuronsInEachXPop[0]

        Pops=self.createNeurons([dc[0]])
        self.X0PopsInpCells1=Pops[0]
        totalnumneurons+=dc[0]
        """
        Pops=self.createNeurons([dc[0]])
        self.X0PopsInpCells2=Pops[0]
        """

        """
        #dc=self.numNeuronsInEachXPop[2]        
        Pops=self.createNeurons([dc[0]])
        self.X0NextStateCells=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X0NextStateCells1=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X0NextStateCells2=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X0NextStateCells3=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X0NextStateCells4=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X0NextStateCells5=Pops[0]       
        Pops=self.createNeurons([dc[0]])
        self.X0NextStateCells6=Pops[0]       
        Pops=self.createNeurons([dc[0]])
        self.X0NextStateCells7=Pops[0]        
        Pops=self.createNeurons([dc[0]])
        self.X0NextStateCells8=Pops[0]        
        Pops=self.createNeurons([dc[0]])
        self.X0NextStateCells9=Pops[0]        
        Pops=self.createNeurons([dc[0]])
        self.X0NextStateCells10=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X0NextStateCells11=Pops[0]        
        Pops=self.createNeurons([dc[0]])
        self.X0NextStateCells12=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X0NextStateCells13=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X0NextStateCells14=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X0NextStateCells15=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X0NextStateCells16=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X0NextStateCells17=Pops[0]
        """
#################
        ##DX[1]==self.XPopsInpCells[3]
        ####self.numNeuronsInEachXPop[3]


        #self.M1gCosSinMinusSinX3sqM1LPlusFonedivSinsqM1M0increments=0.005 #needs to be the same as M0 to add
        print "mult"

        multattributes=self.numneuronsformult(self.numNeuronsInEachXPop[3], self.numNeuronsDt1Pop, self.DX1dtincrements, self.RoundDX1dtincrements,0, self.Xincrements[3], self.dt1increment)

        self.numNeuronsInDX1dt=multattributes[0]
        self.DX1dtPop=multattributes[1]
        self.numNeuronsInRoundDX1dtPop=multattributes[2]
        self.RoundDX1dtPopCells=multattributes[3]

        totalnumneurons+=self.numNeuronsInDX1dt[0]
        totalnumneurons+=self.numNeuronsInRoundDX1dtPop[0]

        #print self.numNeuronsInEachXPop[3]

        sumattributes=self.calculatenumforadditionpop(self.numNeuronsInRoundDX1dtPop, self.numNeuronsInEachXPop[1]) 

        #self.numNeuronsInEachXPop[3]=sumattributes[0]  ##X pop neuron number needs to equal the neuron pop numNeuronsInRoundDX3dtPop+self.numNeuronsInEachXPop[3]
        #self.XPopsInpCells[3]=sumattributes[1]

        self.numNeuronsX1PlusDX1dt1InterPop=sumattributes[0]
        #self.DX2CosPlusSingGPop=sumattributes[1]        
        self.X1PlusDX1dt1InterSumCells=sumattributes[2]

        totalnumneurons+=self.numNeuronsX1PlusDX1dt1InterPop[0]

        dc=self.numNeuronsInEachXPop[1]

        Pops=self.createNeurons([dc[0]])
        self.X1PopsInpCells1=Pops[0]

        totalnumneurons+=dc[0]
        """
        Pops=self.createNeurons([dc[0]])
        self.X1PopsInpCells2=Pops[0]
        """
        #dc=self.numNeuronsInEachXPop[2]
        """
        Pops=self.createNeurons([dc[0]])
        self.X1NextStateCells=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X1NextStateCells1=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X1NextStateCells2=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X1NextStateCells3=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X1NextStateCells4=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X1NextStateCells5=Pops[0]       
        Pops=self.createNeurons([dc[0]])
        self.X1NextStateCells6=Pops[0]       
        Pops=self.createNeurons([dc[0]])
        self.X1NextStateCells7=Pops[0]        
        Pops=self.createNeurons([dc[0]])
        self.X1NextStateCells8=Pops[0]        
        Pops=self.createNeurons([dc[0]])
        self.X1NextStateCells9=Pops[0]        
        Pops=self.createNeurons([dc[0]])
        self.X1NextStateCells10=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X1NextStateCells11=Pops[0]        
        Pops=self.createNeurons([dc[0]])
        self.X1NextStateCells12=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X1NextStateCells13=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X1NextStateCells14=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X1NextStateCells15=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X1NextStateCells16=Pops[0]
        Pops=self.createNeurons([dc[0]])
        self.X1NextStateCells17=Pops[0]
        """

##################
       


        self.numNeuronsDtPop=[1,0]

        dtc=self.createNeurons([self.numNeuronsDtPop[0]]) #createNeurons needs an array of numbers
        self.dtcell=dtc[0]
        totalnumneurons+=1
        #afadf

        #print self.numNeuronsForce2
        #adfafd


        
        #adfadf
        #jhgjhg
        #self.onedivSinsqM1M0Incr=0.5
        #self.numonedivSinsqM1M0Pops=[int(round((1.0/self.SinM1M0increments)/self.onedivSinsqM1M0Incr)),0]
        #Pops=self.createNeurons([self.numonedivSinsqM1M0Pops[0]])
        #self.onedivSinsqM1M0Pops=Pops[0]
        #self.numonedivSinsqM1M0Pops=self.CalculateNeuronNumEachPop(self.minCosSinSumArray, self.maxCosSinSumArray,self.varMultCosSinSum)
        #print self.onedivSinsqM1M0Pops
        #adfadf

        #self.numNeuronsIn1DivPop=[int(round(1.0/self.in1DivIncrements)),0]
        
        ############
            
        """
        numNeurons=[row[0] for row in self.numNeuronsInEachEPop]         #acquire the first element from all of the lists in numNeuronsInEachXPop
        self.EPopsInpCells=self.createNeurons(numNeurons)

        numNeurons=[row[0] for row in self.numNeuronsInEachKPop]         #acquire the first element from all of the lists in numNeuronsInEachXPop
        self.KPopsInpCells=self.createNeurons(numNeurons)
        """
        #numNeurons=[row[0] for row in self.numNeuronsInEachKPop]         #acquire the first element from all of the lists in numNeuronsInEachXPop
        #self.KPopsInpCellsBuf=self.createNeurons(numNeurons)



        #numNeurons=[row[0] for row in self.numNeuronsInEachEMinusXPop]         #acquire the first element from all of the lists in numNeuronsInEachXPop
        #self.EMinusXBufPops=self.createNeurons(numNeurons)




        #numNeurons=[row[0] for row in numNeuronsInEachXPop]         #acquire the first element from all of the lists in numNeuronsInEachXPop

        CosPops=self.createNeurons([self.numNeuronsInCosPop[0]])
        self.CosPopCells=CosPops[0]

        totalnumneurons+=self.numNeuronsInCosPop[0]

        SinPops=self.createNeurons([self.numNeuronsInSinPop[0]])
        self.SinPopCells=SinPops[0]

        totalnumneurons+=self.numNeuronsInSinPop[0]

        #CosPops=self.createNeurons([self.numNeuronsInCosPop[0]])
        #self.CosPopBufCells=CosPops[0]

        #SinPops=self.createNeurons([self.numNeuronsInSinPop[0]])
        #self.SinPopBufCells=SinPops[0]

       

        coscell=self.createNeurons([self.numdepths])
        self.PulseCellPop=coscell[0]

        totalnumneurons+=self.numdepths

        CosSinPops=self.createNeurons([self.numNeuronsInSinCosPop[0]])
        self.CosSinPopCells=CosSinPops[0]

        totalnumneurons+=self.numNeuronsInSinCosPop[0]

        MultCosSinPops=self.createNeurons([self.numNeuronsInMultCosSinPop[0]])
        self.MultCosSinPopCells=MultCosSinPops[0]        

        totalnumneurons+=self.numNeuronsInMultCosSinPop[0]

        """
        PosOrNeg=self.createNeurons([4])
        self.PosOrNegCosSinPop=PosOrNeg[0]
        devil
        totalnumneurons+=

        
        
        CosSinSumPops=self.createNeurons([self.numNeuronsInCosSinSumPop[0]])
        self.CosSinSumCells=CosSinSumPops[0]

        CosSinSubPops=self.createNeurons([self.numNeuronsInCosSinSubPop[0]])
        self.CosSinSubCells=CosSinSubPops[0]

        CosSinDivPops=self.createNeurons([self.numNeuronsInCosSinDivPop[0]])
        self.CosSinDivCells=CosSinDivPops[0]        
        """
        
        TestInPops=self.createNeurons([2])
        self.testinputcells=TestInPops[0] 

        totalnumneurons+=4

        TestOutPops=self.createNeurons([2])
        self.testoutputcells=TestOutPops[0]


        """
        CosInterPops=self.createNeurons([self.numNeuronsInCosPop[0]])
        self.CosPopInterSumCells=CosInterPops[0]
        
        
        SinInterPops=self.createNeurons([self.numNeuronsInSinPop[0]])
        self.SinPopInterSumCells=SinInterPops[0]
        
        
        CosSinSumInterPops=self.createNeurons([self.numNeuronsInCosSinSumPop[0]])
        self.CosSinPopInterOutSumCells=CosSinSumInterPops[0]
        
        CosSinSubInterPops=self.createNeurons([self.numNeuronsInCosSinSubPop[0]])
        self.CosSinPopInterOutSubCells=CosSinSubInterPops[0]
        """




        #print self.numNeuronsInEachEMinusXPop
        #print numNeurons
        #adfadf

        #self.PosOrNegEXKPop=self.createNeurons([4,4,4,4])

        #print self.numNeuronsInRoundEXKPopCells
        







        """
        self.numNeuronsDtPop=[1,0]

        dtc=self.createNeurons([self.numNeuronsDtPop[0]]) #createNeurons needs an array of numbers
        self.dtcell=dtc[0]
        """
        
        """
        multattributes=self.numneuronsformult(self.numNeuronsInCosPop,self.numNeuronsDtPop, self.dtcosincrement, self.RoundOutDtIncrements,0, self.COSincrements, self.dtincrement)
        self.numNeuronsDtPopCos=multattributes[0]
        self.dtresultpopCos=multattributes[1]
        self.numNeuronsRoundDtCos=multattributes[2]
        self.rounddtcospop=multattributes[3]
        """
        #self.numNeuronsDtPopCos=self.CalculateNeuronNumEachPop(self.minCosArray*self.dtincrement, self.maxCosArray*self.dtincrement,self.dtcosincrement)

    
         

        






#numNeuronsInSinCosPop


#self.CosSinPopCells
#self.RoundEXKPopCells[popConnections], self.numNeuronsInRoundEXKPopCells[popConnections], self.RoundEXKincrements[popConnections]        
        
        #print self.PosOrNegEXKPop
        #print self.numNeuronsInEachEMinusXPop

        #adfafd
        #PosOrNegCosSinPop
        #PosOrNegCosSinPop

        #PosOrNegCosSinPop
        #PosOrNegEXKPop

#self.CosSinSubCells, self.CosSinSubincrements, self.numNeuronsInCosSinSubPop
#self.CosSinSumCells, self.numNeuronsInCosSinSumPop, self.CosSinSumincrements
        
        #print self.SingleCosCell
        #adfa

        #print self.numNeuronsInCosPop
        #print self.numNeuronsInSinPop
        #print self.CosPopCells
        #print self.SinPopCells
        #adfad

        """
        """

        #Pops=self.createNeurons([dc[0]])
        #self.X2NextStateCells6=Pops[0]

        print totalnumneurons
        #sdfsdf

    def ConnectX0(self, minWeight):
        EXHconnections=[]
        d=self.numNeuronsInEachXPop[0]
        
        for i in range(0, d[0]):
            EXHconnections+= [(i,i,minWeight,3.0)]

        connList = self.sim.FromListConnector(EXHconnections)
        exc_connections=self.sim.Projection(self.XPopsInpCells[0], self.X0PopsInpCells1, connList, receptor_type='excitatory') #5ms hit
        #exc_connections=self.sim.Projection(self.X0PopsInpCells1, self.X0PopsInpCells2, connList, receptor_type='excitatory')

    def ConnectX1(self, minWeight):
        EXHconnections=[]
        d=self.numNeuronsInEachXPop[1]
        
        for i in range(0, d[0]):
            EXHconnections+= [(i,i,minWeight,3.0)]

        connList = self.sim.FromListConnector(EXHconnections)
        exc_connections=self.sim.Projection(self.XPopsInpCells[1], self.X1PopsInpCells1, connList, receptor_type='excitatory')  #5ms hit
        #exc_connections=self.sim.Projection(self.X1PopsInpCells1, self.X1PopsInpCells2, connList, receptor_type='excitatory')        
        
    def ConnectNextStateX2Cells(self, minWeight):
        EXHconnections=[]
        d=self.numNeuronsInEachXPop[2]
        
        for i in range(0, d[0]):
            EXHconnections+= [(i,i,minWeight,nealParameters.DELAY)]

        connList = self.sim.FromListConnector(EXHconnections)
        exc_connections=self.sim.Projection(self.X2NextStateCells, self.X2NextStateCells1, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X2NextStateCells1, self.X2NextStateCells2, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X2NextStateCells2, self.X2NextStateCells3, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X2NextStateCells3, self.X2NextStateCells4, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X2NextStateCells4, self.X2NextStateCells5, connList, receptor_type='excitatory')
        #exc_connections=self.sim.Projection(self.X2NextStateCells5, self.XPopsInpCells[2], connList, receptor_type='excitatory')



    def ConnectNextStateX0Cells(self, minWeight):
        EXHconnections=[]
        d=self.numNeuronsInEachXPop[0]
        
        for i in range(0, d[0]):
            EXHconnections+= [(i,i,minWeight,nealParameters.DELAY)]

        connList = self.sim.FromListConnector(EXHconnections)
        exc_connections=self.sim.Projection(self.X0NextStateCells, self.X0NextStateCells1, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X0NextStateCells1, self.X0NextStateCells2, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X0NextStateCells2, self.X0NextStateCells3, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X0NextStateCells3, self.X0NextStateCells4, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X0NextStateCells4, self.X0NextStateCells5, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X0NextStateCells5, self.X0NextStateCells6, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X0NextStateCells6, self.X0NextStateCells7, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X0NextStateCells7, self.X0NextStateCells8, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X0NextStateCells8, self.X0NextStateCells9, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X0NextStateCells9, self.X0NextStateCells10, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X0NextStateCells10, self.X0NextStateCells11, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X0NextStateCells11, self.X0NextStateCells12, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X0NextStateCells12, self.X0NextStateCells13, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X0NextStateCells13, self.X0NextStateCells14, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X0NextStateCells14, self.X0NextStateCells15, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X0NextStateCells15, self.X0NextStateCells16, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X0NextStateCells16, self.X0NextStateCells17, connList, receptor_type='excitatory')
        #exc_connections=self.sim.Projection(self.X0NextStateCells17, self.XPopsInpCells[0], connList, receptor_type='excitatory')
#self.X0NextStateCells

    def ConnectNextStateX1Cells(self, minWeight):
        EXHconnections=[]
        d=self.numNeuronsInEachXPop[1]
        
        for i in range(0, d[0]):
            EXHconnections+= [(i,i,minWeight,nealParameters.DELAY)]

        connList = self.sim.FromListConnector(EXHconnections)
        exc_connections=self.sim.Projection(self.X1NextStateCells, self.X1NextStateCells1, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X1NextStateCells1, self.X1NextStateCells2, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X1NextStateCells2, self.X1NextStateCells3, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X1NextStateCells3, self.X1NextStateCells4, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X1NextStateCells4, self.X1NextStateCells5, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X1NextStateCells5, self.X1NextStateCells6, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X1NextStateCells6, self.X1NextStateCells7, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X1NextStateCells7, self.X1NextStateCells8, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X1NextStateCells8, self.X1NextStateCells9, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X1NextStateCells9, self.X1NextStateCells10, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X1NextStateCells10, self.X1NextStateCells11, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X1NextStateCells11, self.X1NextStateCells12, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X1NextStateCells12, self.X1NextStateCells13, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X1NextStateCells13, self.X1NextStateCells14, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X1NextStateCells14, self.X1NextStateCells15, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X1NextStateCells15, self.X1NextStateCells16, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X1NextStateCells16, self.X1NextStateCells17, connList, receptor_type='excitatory')
        #exc_connections=self.sim.Projection(self.X1NextStateCells17, self.XPopsInpCells[1], connList, receptor_type='excitatory')
        
    def ConnectX2(self, minWeight):
        EXHconnections=[]
        d=self.numNeuronsInEachXPop[2]
        
        for i in range(0, d[0]):
            EXHconnections+= [(i,i,minWeight,27.0)]

        connList = self.sim.FromListConnector(EXHconnections)
        exc_connections=self.sim.Projection(self.XPopsInpCells[2], self.X2PopsInpCells1, connList, receptor_type='excitatory')# delay of 27 to hit 29ms
        """
        exc_connections=self.sim.Projection(self.X2PopsInpCells1, self.X2PopsInpCells2, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X2PopsInpCells2, self.X2PopsInpCells3, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X2PopsInpCells3, self.X2PopsInpCells4, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X2PopsInpCells4, self.X2PopsInpCells5, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X2PopsInpCells5, self.X2PopsInpCells6, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X2PopsInpCells6, self.X2PopsInpCells7, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X2PopsInpCells7, self.X2PopsInpCells8, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X2PopsInpCells8, self.X2PopsInpCells9, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X2PopsInpCells9, self.X2PopsInpCells10, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X2PopsInpCells10, self.X2PopsInpCells11, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X2PopsInpCells11, self.X2PopsInpCells12, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X2PopsInpCells12, self.X2PopsInpCells13, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X2PopsInpCells13, self.X2PopsInpCells14, connList, receptor_type='excitatory')
        """

    def ConnectX3(self, minWeight):
        EXHconnections=[]
        d=self.numNeuronsInEachXPop[3]
        
        for i in range(0, d[0]):
            EXHconnections+= [(i,i,minWeight,39.0)]

        connList = self.sim.FromListConnector(EXHconnections)
        exc_connections=self.sim.Projection(self.XPopsInpCells[3], self.X3PopsInpCells1, connList, receptor_type='excitatory') #want it to hit 41
        """
        exc_connections=self.sim.Projection(self.X3PopsInpCells1, self.X3PopsInpCells2, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X3PopsInpCells2, self.X3PopsInpCells3, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X3PopsInpCells3, self.X3PopsInpCells4, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X3PopsInpCells4, self.X3PopsInpCells5, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X3PopsInpCells5, self.X3PopsInpCells6, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X3PopsInpCells6, self.X3PopsInpCells7, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X3PopsInpCells7, self.X3PopsInpCells8, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X3PopsInpCells8, self.X3PopsInpCells9, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X3PopsInpCells9, self.X3PopsInpCells10, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X3PopsInpCells10, self.X3PopsInpCells11, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X3PopsInpCells11, self.X3PopsInpCells12, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X3PopsInpCells12, self.X3PopsInpCells13, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X3PopsInpCells13, self.X3PopsInpCells14, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X3PopsInpCells14, self.X3PopsInpCells15, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X3PopsInpCells15, self.X3PopsInpCells16, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X3PopsInpCells16, self.X3PopsInpCells17, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X3PopsInpCells17, self.X3PopsInpCells18, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X3PopsInpCells18, self.X3PopsInpCells19, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.X3PopsInpCells19, self.X3PopsInpCells20, connList, receptor_type='excitatory')
        """



    def ConnectCosPops(self, minWeight):
        EXHconnections=[]
        
        for i in range(0, self.numNeuronsInCosPop[0]):
            EXHconnections+= [(i,i,minWeight,19.0)]


        #print EXHconnections
        #adfdas
        connList = self.sim.FromListConnector(EXHconnections)
        exc_connections=self.sim.Projection(self.CosPopCells, self.CosPopCells1, connList, receptor_type='excitatory') #DELAY 20, MUST HIT 25ms
        """
        exc_connections=self.sim.Projection(self.CosPopCells1, self.CosPopCells2, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.CosPopCells2, self.CosPopCells3, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.CosPopCells3, self.CosPopCells4, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.CosPopCells4, self.CosPopCells5, connList, receptor_type='excitatory')
        #exc_connections=self.sim.Projection(self.CosPopCells5, self.CosPopCells6, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.CosPopCells5, self.CosPopCells7, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.CosPopCells7, self.CosPopCells8, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.CosPopCells8, self.CosPopCells9, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.CosPopCells9, self.CosPopCells10, connList, receptor_type='excitatory')        
        exc_connections=self.sim.Projection(self.CosPopCells10, self.CosPopCells11, connList, receptor_type='excitatory')
        """
    def ConnectSinGPops(self, minWeight):
        EXHconnections=[]
        
        for i in range(0, self.numNeuronsInRoundSinG[0]):
            EXHconnections+= [(i,i,minWeight,19.0)]


        #print EXHconnections
        #adfdas
        connList = self.sim.FromListConnector(EXHconnections)
        exc_connections=self.sim.Projection(self.RoundSinGPopCells, self.RoundSinGPopCells1, connList, receptor_type='excitatory') #DELAY 22, MUST HIT 29ms
        """
        exc_connections=self.sim.Projection(self.RoundSinGPopCells1, self.RoundSinGPopCells2, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.RoundSinGPopCells2, self.RoundSinGPopCells3, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.RoundSinGPopCells3, self.RoundSinGPopCells4, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.RoundSinGPopCells4, self.RoundSinGPopCells5, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.RoundSinGPopCells5, self.RoundSinGPopCells6, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.RoundSinGPopCells6, self.RoundSinGPopCells7, connList, receptor_type='excitatory')
        #exc_connections=self.sim.Projection(self.RoundSinGPopCells7, self.RoundSinGPopCells8, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.RoundSinGPopCells7, self.RoundSinGPopCells9, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.RoundSinGPopCells9, self.RoundSinGPopCells10, connList, receptor_type='excitatory')        
        exc_connections=self.sim.Projection(self.RoundSinGPopCells10, self.RoundSinGPopCells11, connList, receptor_type='excitatory')
        """

        
    def convertNeuronNumber(self,newincrements, oldNum, oldincrements):
        newNum=[0,0]
        newNum[0]=int(round((oldNum[0]*oldincrements)/newincrements))
        newNum[1]=int(round((oldNum[1]*oldincrements)/newincrements))
        return newNum

    def ConvertConnectionsForForcePop(self, minWeight):
        EXHconnections=[]
        ToEachNeuron=int(round(self.Fincrements/self.Force2increments))
        for i in range(0, self.numNeuronsInFPop[0]):
            for j in range(0,ToEachNeuron):
                EXHconnections+= [(i,(i*ToEachNeuron)+j,minWeight,nealParameters.DELAY)]

        connList = self.sim.FromListConnector(EXHconnections)
        #exc_connections=self.sim.Projection(self.FOutCells, self.Force2Cells, connList, receptor_type='excitatory')
        
    def ConnectM1gCosSinMinusSinX3sqM1LPops(self, minWeight):
        EXHconnections=[]
        
        for i in range(0, self.numNeuronsM1gCosSinMinusSinX3sqM1L[0]):
            EXHconnections+= [(i,i,minWeight,nealParameters.DELAY)]


        #print EXHconnections
        #adfdas
        connList = self.sim.FromListConnector(EXHconnections)
#        exc_connections=self.sim.Projection(self.M1gCosSinMinusSinX3sqM1LPops, self.M1gCosSinMinusSinX3sqM1LPops2, connList, receptor_type='excitatory')
        


    def connectRoundM1gCosSinPopCellspops(self, minWeight):
        
        EXHconnections=[]
        for i in range(0, self.numNeuronsInRoundM1gCosSin[0]):
            EXHconnections+= [(i,i,minWeight,nealParameters.DELAY)]


        #print EXHconnections
        #adfdas
        connList = self.sim.FromListConnector(EXHconnections)
        exc_connections=self.sim.Projection(self.RoundM1gCosSinPopCells, self.RoundM1gCosSinPopCells2, connList, receptor_type='excitatory')
        #exc_connections=self.sim.Projection(self.SinPopCells1, self.SinPopCells2, connList, receptor_type='excitatory')
        #exc_connections=self.sim.Projection(self.SinPopCells2, self.SinPopCells3, connList, receptor_type='excitatory')
        #####################

    def connectsinpops(self, minWeight):
        
        EXHconnections=[]
        for i in range(0, self.numNeuronsInSinPop[0]):
            EXHconnections+= [(i,i,minWeight,nealParameters.DELAY)]


        #print EXHconnections
        #adfdas
        connList = self.sim.FromListConnector(EXHconnections)
        exc_connections=self.sim.Projection(self.SinPopCells, self.SinPopCells1, connList, receptor_type='excitatory')
        #exc_connections=self.sim.Projection(self.SinPopCells1, self.SinPopCells2, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.SinPopCells1, self.SinPopCells3, connList, receptor_type='excitatory')
        #####################
    
    def connectonedivSinsqM1M0RoundPops(self, minWeight):
        
        EXHconnections=[]
        for i in range(0, self.numNeuronsonedivSinsqM1M0RoundPop[0]):
            EXHconnections+= [(i,i,minWeight,nealParameters.DELAY)]


        #print EXHconnections
        #adfdas
        connList = self.sim.FromListConnector(EXHconnections)
        exc_connections=self.sim.Projection(self.onedivSinsqM1M0RoundPops, self.onedivSinsqM1M0RoundPops1, connList, receptor_type='excitatory')
        exc_connections=self.sim.Projection(self.onedivSinsqM1M0RoundPops1, self.onedivSinsqM1M0RoundPops2, connList, receptor_type='excitatory')
        #exc_connections=self.sim.Projection(self.SinPopCells2, self.SinPopCells3, connList, receptor_type='excitatory')
        #####################


    def calculatenumforadditionpop(self, Input1Num, Input2Num):

        SumPopNum=[0,0]
        SumPopNum[0]=Input1Num[0]+Input2Num[0]
        SumPopNum[1]=Input1Num[1]+Input2Num[1]


        SumPop=self.createNeurons([SumPopNum[0]])
        #self.EXKSum01Cells=EXKSum01[0]

        SumInterPop=self.createNeurons([SumPopNum[0]])
        #self.EXKPopInterOutSum01Cells=EXKSum01[0] 
                                                 

        return [SumPopNum, SumPop[0], SumInterPop[0]]

    def CalculateNumForSubtractionPop(self, Numinput1Pop, Numinput2Pop, in1increments, in2increments, in1Minusin2increments):
            #totalpopK=self.numNeuronsInEachKPop[i]


        in1minusin2pop=[0,0]
        in1minusin2pop[0]=Numinput1Pop[0]+Numinput2Pop[0]
        in1minusin2pop[1]=Numinput1Pop[1]+(Numinput2Pop[0]-Numinput2Pop[1])  #neg=whatevery input 1 neg is plus the the positive of neg2 as this is also neg
        
        #--
        #pos neg
        #neg pos

        #++
        #pos pos
        #neg neg

        
        
            
            #minKvalue=totalpopK[0]*self.Kincrements[i]
            #maxKvalue=(totalpopK[0]-totalpopK[1])*self.Kincrements[i]


        OutPops=self.createNeurons([in1minusin2pop[0]])
        #self.SinPopBufCells=SinPops[0]

        InterPops=self.createNeurons([in1minusin2pop[0]])
        
        #numNeurons=[row[0] for row in self.numNeuronsInEachEMinusXPop]         #acquire the first element from all of the lists in numNeuronsInEachXPop
        #self.EMinusXPops=self.createNeurons(numNeurons)

        #numNeurons=[row[0] for row in self.numNeuronsInEachEMinusXPop]         #acquire the first element from all of the lists in numNeuronsInEachXPop
        #self.EXInterOutSubCells=self.createNeurons(numNeurons)
        

        return [in1minusin2pop, OutPops[0], InterPops[0]] 
        
    def calculatedivnumber(self, numinput1, numinput2, DivPopIncr, RoundIncrement, input1increment,input2increment, isalwayspos):
        divnum=[0,0]
        #neg neg
        #pos pos
        #neg pos
        #pos neg

        keeppos1=0
        keeppos2=0
        keepneg1=0
        keepneg2=0
        keeppos=0
        keepneg=0

        if((numinput1[1]>0)and(numinput2[1]>0)):
            #neg neg=pos
            divnum[0]+=int(round((input1increment/input2increment)/DivPopIncr))*numinput1[1]
            #divnum[1]+=int(round(1.0/DivPopIncr))*numinput1[1]
            keeppos1=int(round((input1increment/input2increment)/DivPopIncr))*numinput1[1]
        if((numinput1[0]-numinput1[1]>0)and(numinput2[0]-numinput2[1]>0)):
            #pos pos=pos
             divnum[0]+=int(round((input1increment/input2increment)/DivPopIncr))*(numinput1[0]-numinput1[1])
             #divnum[1]+=int(round(1.0/DivPopIncr))*numinput1[1]
             keeppos2=int(round((input1increment/input2increment)/DivPopIncr))*(numinput1[0]-numinput1[1])
        if((numinput1[0]-numinput1[1]>0)and(numinput2[1]>0)):
            #pos neg = neg
             divnum[0]+=int(round((input1increment/input2increment)/DivPopIncr))*(numinput1[0]-numinput1[1])
             divnum[1]+=int(round((input1increment/input2increment)/DivPopIncr))*(numinput1[0]-numinput1[1])
             keepneg1=int(round((input1increment/input2increment)/DivPopIncr))*(numinput1[0]-numinput1[1])
        if((numinput1>0)and(numinput2[0]-numinput2[1]>0)):
            #neg pos = neg
             divnum[0]+=int(round((input1increment/input2increment)/DivPopIncr))*numinput1[1]
             divnum[1]+=int(round((input1increment/input2increment)/DivPopIncr))*numinput1[1]
             keepneg2=int(round((input1increment/input2increment)/DivPopIncr))*numinput1[1]
        #self.nmDivPops[1]=int(round(1.0/self.DivPopIncr))*self.numNeuronsIn1DivPop[1]+int(round(1.0/self.DivPopIncr))*self.numNeuronsInCosPop[1]

        if(keepneg1>keepneg2):
            keepneg=keepneg1
        else:
            keepneg=keepneg2
        
        if(keeppos1>keeppos2):
            keeppos=keeppos1
        else:
            keeppos=keeppos2 

        if(isalwayspos==1):
            d=divnum
            e=[0,0]
            e=[divnum[0]-divnum[1], 0]
            divnum=e
            keepneg=0


        
        #self.DivPops=divpop[0]
        
       

        divpop=self.createNeurons([divnum[0]])

        numNeuronsDivRoundOutPop=[0,0]
        numNeuronsDivRoundOutPop[0]=int(round(((keeppos+keepneg)*DivPopIncr)/RoundIncrement))
        numNeuronsDivRoundOutPop[1]=int(round((keepneg*DivPopIncr)/RoundIncrement))

        #print numNeuronsDivRoundOutPop
        #asdfa
        
        rounddivpop=self.createNeurons([numNeuronsDivRoundOutPop[0]]) #createNeurons needs an array of numbers

        return [divnum, divpop[0], numNeuronsDivRoundOutPop, rounddivpop[0]]
    def numneuronsformult(self, input1Num,input2Num, multIncrements, RoundIncrements, isalwayspos, in1increments, in2increments):

        totalin1=input1Num[0]
        in1neg=input1Num[1]
        totalin2=input2Num[0]
        in2neg=input2Num[1]
        in1pos=totalin1-in1neg
        in2pos=totalin2-in2neg

        nega=int(round(((in1neg*in1increments)*(in2pos*in2increments))/multIncrements))
        negb=int(round(((in2neg*in2increments)*(in1pos*in1increments))/multIncrements))
        negnum=nega+negb
        if(nega>negb):
            keepneg=nega
        else:
            keepneg=negb
        posa=int(round(((in1pos*in1increments)*(in2increments*in2pos))/multIncrements))
        posb=int(round(((in1neg*in1increments)*(in2increments*in2neg))/multIncrements))
        posnum=posa+posb
        if(posa>posb):
            keeppos=posa
        else:
            keeppos=posb        
        totalnum=posnum+negnum
        if(isalwayspos==1):
            MultPopNum=[posnum, 0]
            keepneg=0
        else:
            MultPopNum=[totalnum, negnum]

#multattributes=self.numneuronsformult(self.numNeuronsInEachEMinusXPop[i],self.numNeuronsInEachKPop[i], self.MultRes2, self.RoundEXKincrements[i])
        #numNeurons=[row[0] for row in self.numNeuronsInEachEMinusXMultKPop]         #acquire the first element from all of the lists in numNeuronsInEachXPop
        MultPop=self.createNeurons(MultPopNum)

        #numNeurons=[row[0] for row in self.numNeuronsInRoundEXKPopCells]         #acquire the first element from all of the lists in numNeuronsInEachXPop
        #self.RoundEXKPopCells=self.createNeurons(numNeurons)


            #total=self.numNeuronsInEachEMinusXMultKPop[i]
            
            #self.numNeuronsInRoundEXKPopCells[i]=self.CalculateNeuronNumEachPop(minexvalue*minKvalue, maxexvalue*minKvalue, self.RoundEXKincrements[i])



        RoundPopNum=[int(round(((keepneg+keeppos)*multIncrements)/RoundIncrements)),int(round((keepneg*multIncrements)/RoundIncrements))]
        print "round"
        print RoundPopNum
        RoundPop=self.createNeurons([RoundPopNum[0]])
        
        return[MultPopNum, MultPop[0], RoundPopNum, RoundPop[0]]
    def CalculateOutPopForSubOrSum(self, InputNum, summation, isFOutput):
        OutputNum=[0,0]
#        if(summation==1):
                ##Calculate output pop size and the order of pos and neg neurons from input neurons
                #for summation
        
        OutputNum[0]=sum([row[0] for row in InputNum])  #total number of neurons across all E populations
        OutputNum[1]=sum([row[1] for row in InputNum])  #total number of negative neurons across all E populations

        if(summation==0):
            if(isFOutput==1):
                num=self.numSets-1
            else:
                num=1
            entriesneg=[row[1] for row in InputNum]
            entriestotal=[row[0] for row in InputNum]
            #OutputNum[0]=Outnumber[0]
            OutputNum[1]=entriesneg[0]
            for i in range(0, num):
                OutputNum[1]+=(entriestotal[i+1]-entriesneg[i+1])
                    
        #OutputNum[1]=entriesneg[0]+(entriestotal[1]-entriesneg[1])+(entriestotal[2]-entriesneg[2])+(entriestotal[3]-entriesneg[3])
        return OutputNum      


    def setupRecording(self, cells):
        test=0
        if (nealParameters.simulator == 'nest'):
#            print "setupRecording"
#            print cells.celltype.recordable
            #print FOutCells.celltype.recordable
            if((self.test==1)or(test==1)):
                cells.record({'spikes','v','gsyn_exc','gsyn_inh'})
            else:
                cells.record({'spikes'})
            #cells.record({'spikes','v'})
        #FOutCells.record(['spikes','v','gsyn_exc','gsyn_inh'])
        elif (nealParameters.simulator == 'spinnaker'):
            cells.record()
            cells.record_v()
    #-53.0
    def createNeurons(self, numNeuronsInEachPop):
        #117.6=-65-52.6 (52.625 is where we want the voltage to rise to when there is there is a 0.26 difference between total excitation and total inhibition, i.e. for a neuron to spike
        if (nealParameters.simulator == 'nest'):   #make sure that the ihhibition (e_rev_I) has the same weight as (e_rev_e) so that when we want to fully inhibit something, membrane potential does not move from rest (in this case rev_e =0, rev_i =-130). this makes it so when we fully inhibit a cell through the conductance, it will
            CELL_PARAMS = {'v_thresh':-52.0, 'v_reset' : -65.0, 'tau_m' : 15.0, #reset was -70, tau was 15 ################V_THRESH WAS -52.0
                                'tau_refrac': 3.0 , 'tau_syn_E': 0.35, #5.0    #tau_refrac was 4.0
                                'e_rev_I': -130.0, #-130.0, #use -110.0 #-100.0,  #default-70.0
                                'tau_syn_I': 0.35, 'e_rev_E': 0.0, #5.0 'e_rev_E': 0.0, #0.0 by default #bug2 fix
                                #'tau_syn_I': 0.1,
                                'v_rest' : -65.0,'i_offset':0.0}
        elif (nealParameters.simulator == 'spinnaker'):
            CELL_PARAMS = {'v_thresh':-55.0, 'v_reset' : -70.0,
                                'tau_refrac': 2.0 , 'tau_syn_E': 5.0,
                                #'e_rev_I': -100.0,
                                'tau_syn_I': 5.0, #bug2 fix
                                #'tau_syn_I': 0.1,
                                'v_rest' : -65.0,'i_offset':0.0}
#        print "numNeuronsInEachPop"
#        print numNeuronsInEachPop
        #####self.pause()
        NumSets=len(numNeuronsInEachPop)
#        print "NumSets"
#        print NumSets

        CellSets=[]
        #IF_cond_exp=Leaky integrate and fire model with fixed threshold and exponentially-decaying post-synaptic conductance
        for i in range(0,NumSets):
#            print "numneurons"
#            print numNeuronsInEachPop[i]
            if(numNeuronsInEachPop[i]>0):
                CellSets.append(self.sim.Population(numNeuronsInEachPop[i],self.sim.IF_cond_exp,CELL_PARAMS))
            else:
                CellSets.append([])
        # X2InputCells=self.sim.Population(numNeuronsInEachPop[1],self.sim.IF_cond_exp,CELL_PARAMS)
        # X3InputCells=self.sim.Population(numNeuronsInEachPop,self.sim.IF_cond_exp,CELL_PARAMS)
        # X4InputCells=self.sim.Population(numNeuronsInEachPop,self.sim.IF_cond_exp,CELL_PARAMS)
#        print"self.sim.pop"
            #print self.sim.Population(numNeuronsInEachPop[i],self.sim.IF_cond_exp,CELL_PARAMS)
#        print "CellSets"
#        print CellSets
        return CellSets

    def SumOrSub(self, InputPop, OutputPop, InputIncr, OutputIncr, numOutCells, numInCells, minWeight, numSets, summation):
        # The size of the post-synaptic response (the “synaptic weight”), the temporal dynamics of the weight (synaptic plasticity) and the connection delay are handled by synapse models.
        #output values for each Force neuron
#outFValueincrements=CalculateIncrement(maxF,minF,numFcells)
        #NOTE: We cannot know whether a set of EXK neurons can activate an F output neuron even though the total of thh we EXK neurons is > the f output neuron.
        #       this is because we do not know whether the other sets of EXK neurons contains a positive or negative value when, therfore, when summed, may cause
        #       the higher valued EXK neuron population to decrease
        #####the first neurons in a population represent negative values (if any otherwise they all represent positive values)
        totalnumOutneurons=numOutCells[0]
        totalNegnumOutneurons=numOutCells[1]
        #totalNegnumFneurons=numFcells[2]
#        print "inconnectfunction"
        ExcOutConn=[[] for k in range(numSets)]  #set up numSets sets of empty lists in an array
        #InhOutConn=[[] for k in range(numSets)]  #set up numSets sets of empty lists in an array
        #numNegNeurons=0
        toFneuronTotalValue=0
        ConnectToOutputNegCell=0  #start connecting the negative input cells to negative output cells
        ConnectToOutputPosCell=0
        PosOrNeg=-1                                      #set the value that each neuron represents as positive or negative
        FneuronIsNeg=1
        startNeuronOutPop=0
#        print InputIncr
#        print OutputIncr
        #E1X1K1cells
#        print numInCells
        #adfadf
        #    connections=[]
        if(summation==1):
            ConnectToPosOutputCell=totalNegnumOutneurons              ##START THE POS COUNTER FROM THE NUM OF NEGATIVE NEURONS
            ConnectToNegOutputCell=0
        else:
            ConnectToPosOutputCell=totalNegnumOutneurons              ##START THE POS COUNTER FROM THE NUM OF NEGATIVE NEURONS
            ConnectToNegOutputCell=0

        for eachPop in range(0, numSets):
            numCells=numInCells[eachPop]
            totalPopCells=numCells[0]
            totalNegPopCells=numCells[1]
        #if(eachPop>0):
#ConnectToPosOutputCell=totalNegPopCells
            #    startNeuronOutPop+=totalCells
            if(InputIncr[eachPop]!=OutputIncr):
                print "WARNING:Input increments are not the same as output increments. Input: %s, Output: %s" % (str(InputIncr[eachPop]),str(OutputIncr))
                ####self.pause()
        #flag=0
            for EachInputCell in range (0, totalPopCells): #numCells[0]==total, numCells[1]==numNegCells
                if(summation==1):   #do summation, Pop1 + Pop2 + Pop3 + Pop4
                    if(totalNegPopCells>EachInputCell):    #if input cell is negative, connect to negative output cell else connect to positive cell
#ConnectToOutputCell=totalNegnumFneurons+totalNegCells  #start connecting the positive input cells to the positive output cells
                    #flag=1
                        ExcOutConn[eachPop]+=[(EachInputCell, ConnectToNegOutputCell,minWeight,nealParameters.DELAY)] #excitatory connections
                        ConnectToNegOutputCell+=1

                    else:
                        ExcOutConn[eachPop]+=[(EachInputCell, ConnectToPosOutputCell,minWeight,nealParameters.DELAY)] #excitatory connections
                        ConnectToPosOutputCell+=1

#                    print "make E %s X %s K %s cells connections" % (eachPop,eachPop,eachPop)

                else:       #subtraction, Pop1-Pop2-Pop3-Pop4
                    if(eachPop==0):
                        if(totalNegPopCells>EachInputCell): #if input cell is negative, connect to negative output cell else connect to positive cell
#ConnectToOutputCell=totalNegnumFneurons+totalNegCells  #start connecting the positive input cells to the positive output cells
                        #flag=1
                            ExcOutConn[eachPop]+=[(EachInputCell, ConnectToNegOutputCell,minWeight,nealParameters.DELAY)] #excitatory connections
                            ConnectToNegOutputCell+=1

                        else:
                            ExcOutConn[eachPop]+=[(EachInputCell, ConnectToPosOutputCell,minWeight,nealParameters.DELAY)] #excitatory connections
                            ConnectToPosOutputCell+=1
                    else:
                        if(totalNegPopCells>EachInputCell): #if input cell is positive, connect to negative output cell else connect to positive cell
#ConnectToOutputCell=totalNegnumFneurons+totalNegCells  #start connecting the positive input cells to the positive output cells
                        #flag=1
                            ExcOutConn[eachPop]+=[(EachInputCell, ConnectToPosOutputCell,minWeight,nealParameters.DELAY)] #excitatory connections
                            ConnectToPosOutputCell+=1
                        else:
                            ExcOutConn[eachPop]+=[(EachInputCell, ConnectToNegOutputCell,minWeight,nealParameters.DELAY)] #excitatory connections
                            ConnectToNegOutputCell+=1

 #                   print "make E %s X %s K %s cells connections" % (eachPop,eachPop,eachPop)

        for i in range(0, numSets):

 #           print i
    #neal.nealProjection(InputPop[i], OutputPop, EXKPopExcToFConn[i], 'excitatory')  #excitatory
    #neal.nealProjection(EMinusXMultKCells[i], OutputPop, EXKPopInhToFConn[i], 'inhibitory')  #inhibitory
#            print InputPop[i]
#            print OutputPop
             
            connList = self.sim.FromListConnector(ExcOutConn[i])
#            print connList
            exc_connections=self.sim.Projection(InputPop[i], OutputPop, connList, receptor_type='excitatory')
        #connList = self.sim.FromListConnector(EXKPopInhToFConn[i])
        #inh_connections=self.sim.Projection(InputPop[i], OutputPop, connList, receptor_type='inhibitory')


#            print "exc connections"
#            print exc_connections.get(["weight", "delay"], format="list")
#            ####self.pause()

#        print "finished"
    #return [EXKValueincrements, outFValueincrements]

    #def printtest(self, name):

        #print "hello %s" % name


    def init(self):
        #print "spin" or nest
        ##sets simulation time step, and setting the minimum and maximum synaptic delays
        #delay is set as 1ms
        self.sim.setup(timestep=nealParameters.DELAY,
                    min_delay=nealParameters.DELAY,
                    max_delay=10.0, debug=0)
    def pause(self):
        programPause = raw_input("Press the <ENTER> key to continue...")



    def deletedata(self):
        self.X3sqpop=[]
        self.onedivSinsqM1M0Pops=[]
        self.DX2Cospop=[]
        self.X0NextStateCells=[]
        self.X0NextStateCells1=[]
        self.X0NextStateCells2=[]
        self.X0NextStateCells3=[]
        self.X0NextStateCells4=[]
        self.X0NextStateCells5=[]
        self.X0NextStateCells6=[]
        self.X0NextStateCells7=[]
        self.X0NextStateCells8=[]
        self.X0NextStateCells9=[]
        self.X0NextStateCells10=[]
        self.X0NextStateCells11=[]
        self.X0NextStateCells12=[]
        self.X0NextStateCells13=[]
        self.X0NextStateCells14=[]        
        self.X0NextStateCells15=[]
        self.X0NextStateCells16=[]
        self.X0NextStateCells17=[]
        self.DX2Pop=[]

    def CalculateNeuronNumEachPop(self, minVal, maxVal, ValRes):
        #calculate the number of neuron in each population + the number of neurons that represent positive and negative values
        #we calculate the number of neuron using a min of 0 (so we divide the max by valres and we do not take the min off, i.e. when no neurons fire
        #population will be 0 when, e.g. maxVAl/ValRes is close to 0
        #we use floor for pos and neg (we firstly abs neg) as if we used ceil the last neuron would never fire as the input neurons could never reaach more than the max output value.  e.g min =-8.9, last neuron represents=-8, min =8.9, last neuron represents=8
        #print(ValRes)
        #print(maxVal)
        if((minVal<0)and(maxVal>0)):
            numPosNeu=int(round(maxVal/ValRes))
            numNegNeu=int(round(abs(minVal/ValRes)))  #we do the floor function in this function as if we have a neuron with an increment higher than the max value it would never be fired
            numTotalNeu=numPosNeu+numNegNeu
        if(minVal>=0):
            numPosNeu=int(round(maxVal/ValRes))
            numNegNeu=0
            numTotalNeu=numPosNeu
        if(maxVal<=0):
            numNegNeu=int(round(abs(minVal/ValRes)))
            numPosNeu=0
            numTotalNeu=numNegNeu

        if(numTotalNeu==0):
            print "WARNING, THERE WILL BE NO NEURONS IN THIS POPULATION USING THE RESOLUTION %s" % str(ValRes)
            ####self.pause()

    #print "numTotalNeu"
    #print numTotalNeu
    #print numNegNeu
    #pause()
        return [numTotalNeu, numNegNeu]

    def extractVariables(self, name):
    #extract variable values from file

        varValues = []
        inp = open (name,"r")
        #read line into array
        for line in inp.readlines():
            # add a new sublist
            varValues.append([])
            # loop over the elemets, split by whitespace
            for i in line.split():
                # convert to integer and append to the last
                # element of the list
                varValues[-1].append(float(i))

                #len(input)=number of rows
                #len(input[0])=number of columns
        return varValues



    def setupMultipleRecordngs(self, Populations, numPops):
        #numPops=len(Populations)
        for i in range(0,numPops):
            self.setupRecording(Populations[i])

    def extractMinMaxVals(self, varValues):
    ##########calculate min and max values for each variable
    #variables X[0], E[0], E[0]-X[0], K[0], (E[0]-X[0])*K[0], F[0], X[1] ......Total F   (Total F = 25th element in array)
    #minFarray=np.zeros(4)  #min force from each state
    #maxFarray=np.zeros(4)  #max force from each state
        maxF=0                #max total force
        minF=0                #min total force
        minXarray=np.zeros(4)  #min force from each state
        maxXarray=np.zeros(4)  #max force from each state
        minEminusXarray=np.zeros(4)  #min E-X
        maxEminusXarray=np.zeros(4)  #max E-X
        minEminusXMultKarray=np.zeros(4)  #min (E-X)*K
        maxEminusXMultKarray=np.zeros(4)  #max (E-X)*K
        Earray=np.zeros(4)
        Karray=np.zeros(4)
        numvar=5  #number of variables in file



        for j in range(0,4):
            minXarray[j]=min([row[(j*numvar)] for row in varValues])
            maxXarray[j]=max([row[(j*numvar)] for row in varValues])
            Earray[j]=varValues[0][(j*numvar)+1]
            minEminusXarray[j]=min([row[(j*numvar)+2] for row in varValues])
            maxEminusXarray[j]=max([row[(j*numvar)+2] for row in varValues])
            Karray[j]=varValues[0][(j*numvar)+3]
            minEminusXMultKarray[j]=min([row[(j*numvar)+4] for row in varValues]) #=single force
            maxEminusXMultKarray[j]=max([row[(j*numvar)+4] for row in varValues])
        #    minFarray[j]=min([row[(j*6)+5] for row in varValues])  #min force from each state
    #    maxFarray[j]=max([row[(j*6)+5] for row in varValues]) #max force from each state
    # Farray=minEminusXMultKarray

        minF=min([row[20] for row in varValues])
        maxF=max([row[20] for row in varValues])

        """
        print "minf"
        print minF
        print "maxf"
        print maxF
        print "minxarray"
        print minXarray
        print "maxXarray"
        print maxXarray
        print "Earray"
        print Earray
        print "minEminusXarrayp"
        print minEminusXarray
        print "minEminusXarray"
        print maxEminusXarray
        print "Karray"
        print Karray
        print "minEminusXMultKarray"
        print minEminusXMultKarray
        print "maxEminusXMultKarray"
        print maxEminusXMultKarray
        """
        #print "minFarray"
        #print minFarray
        #print "maxFarray"
        #print maxFarray

        return [minXarray, maxXarray, Earray, minEminusXarray, maxEminusXarray, Karray, minEminusXMultKarray, maxEminusXMultKarray, minF, maxF]


    """
    def makePlusConnections(self, FromCell, ToCell, minWeight):
        print "inside make plus connections"
        ##the first neurons in a population represent negative values (if any otherwise they all represent positive values)
        ###NOTE WE STOPPED OVER CONNECTION STRENGTH WITHIN EACH EXK POPULATION BUT WE NOW NEED TO INHIBIT THE VOLTAGE BETWEEN THE EXK POPULATIONS
        TotalNumCells=NumFromCells[0]
        TotalNumNegCells=NumFromCells[1]
        ExcConnector=[]
        InhConnector=[]
        #ExhOrInh=[]
        #StopConnectionsToNeuron=0
        TotalWt=0
        #fromCell=0
        PosORNeg=-1
        tocellnum=400
        hinum=1000
        fromCellValue=0
        NumSets=4
        maxweight=minWeight*NumSets
        for fromCell in range(0, TotalNumCells):


        #print fromCell
        #print TotalNumCells
        #pause()
    #while ((StopConnectionsToNeuron==0)and(fromCell<TotalNumNegCells)):
   # for fromCell in range(0, NumFromCells):
            if(fromCell==TotalNumNegCells):
                PosORNeg=1
                fromCellValue=0
            #if(ToCell>=0):
           # if(ToCell>=hinum):
           #     print "MAKECONNECTION"
           #     print "Totalnumcells"
           #     print TotalNumCells
            #    print "fromcell"
           #     print fromCell
           #     print "ToCell"
           #     print ToCell
        #if(fromCell+1>
            fromCellValue+=FromCellValueIncrements*PosORNeg
           # if(ToCell>=hinum):
           #     print "fromcellvalue"
           #     print fromCellValue
           #     print "toCellValue"
           #     print ToCellTotalValue

            ValueDif=(FromCellValueIncrements*PosORNeg)/ToCellTotalValue #the percentage difference between the toValue and the FromValue
            #if(ToCell>=hinum):
            #    print "ValueDif"
            #    print ValueDif

            if((ValueDif>0)and(((PosORNeg==1)and(ToCellTotalValue>=fromCellValue))or((PosORNeg==-1)and(ToCellTotalValue<=fromCellValue)))): #connect only same signed neurons, i.e. if both - or both +, valuedif>0...and only connect higher neurons to higher f values as the lower neurons will already be activated to activate the lower input neurons
        #        print "same signed neurons"
                wt=abs(minWeight*ValueDif)
                ExcConnector += [(fromCell,ToCell,abs(wt),nealParameters.DELAY)]
#delay=np.ceil((nealParameters.MAX_DELAY/maxweight)*(wt*NumSets)
            #delay=[9.0,8.0,6.0,1.0]
            #whichdelay=int(round(minWeight/wt))
      #      delay=abs(np.ceil(ValueDif*nealParameters.MAX_DELAY)) #we want the delay in proportion to the weight given to each connection.  If the wt=minWeight, i.w. if wt=maximum, then the delay is the highest, smaller the wt the smaller the delay. This will therefore generate spikes at similar times even when there is a high input.  For example, if 0.5 is fired by each population, this will give the 0.5 output cells 0.0667*4 input which will make the output cell fire four times faster than the output cell that needs all cells to fire, where each have a smaller weight.  the min and max delay were found by trying different values until the all neurons fired at the same time
      #      ExcConnector += [(fromCell,ToCell,abs(wt),delay)] #synaptic delay=the time for propagation of the action potential from soma/initial segment to axon terminal
        #if(ToCellTotalValue>=fromCellValue):  #no point connecting an EXK value (where the number of neurons fired represent the total EXK value (current EXK value + previous EXK values) which is > the F total value (represented by the current F neuron (total F value = current F neuron + previous F neurons)
        #if(ToCellTotalValue>=fromCellValue):
            #    if(ToCell>=hinum):
            #        print "tocellvalue"
            #        print ToCellTotalValue
            #        print "fromcellvalue"
            #        print fromCellValue
                #print "minfromcellvalue"
                #print MinFromCellValue
            #        print "FromCellValueIncrements"
            #        print FromCellValueIncrements*PosORNeg

             #       print "PosORNeg"
             #       print PosORNeg
        #PosORNeg=PosOrNegNeurons(MinFromCellValue, FromCellValueIncrements, fromCell+1)
        #####cant stop connecting from neurons (from the same populaion) to an output neuron as we do not know whatc values the
        #####the other populations will send.  For example E1X1K1 neuron 0==-0.5, might activate output neuron 0 == -0.5, however, if
        #####E2X2K2 neuron 0 is 0.5, that would negate the value from E1X1K1 neuron 0, therefore, preventing the output neuron 0 from firing
        #####Therefore, we might need the extra neurons in a population (vs the extra negating neurons in another population) to fire to activate the output
        #the percentage of MinWeight to give to the connection. minWeight=0.065 will make the post synaptic neuron fire
        #if (TotalWt+wt)>=minWeight: #we now know the toNeuron will fire when this from neuron is activated, therefore, there is no point connecting higher valued from neurons to the to neuron
        #    wt=minWeight-TotalWt
        #    StopConnectionsToNeuron=1            #stop connections to higher valued neurons
        #    print "total weight for activation of output neuron %s has been reached" % str(ToCell)
        #else:
        #    TotalWt+=wt                          #keep a record of the previous wt connections of the previous from neurons to the particular to neuron
            #    if(ToCell>=hinum):
             #       print "wt"
             #       print wt
             #       print "minweight"
             #       print minWeight
             #       print "TotalWt"
             #       print TotalWt
             #       pause()
        return ExcConnector
    """
    def printResults(self,inputCells,outputCells):
        #print
        if  (nealParameters.simulator == 'nest'):
            inputCells.printSpikes('tempInp.pkl')
            outputCells.printSpikes('tempOut.pkl')
        elif (nealParameters.simulator == 'spinnaker'):
            inputCells.printSpikes('tempInp.sp')
            outputCells.printSpikes('tempOut.sp')
            outputCells.print_v('temp.volts')

    def initializeCellsUsingValue(self, Population, value, increment, voltage, PopSize,rest):
        #activate the correct neurons when a particular value is given,
        #e.g. if pos value, activate the correct number of the pos neurons with respect to the value
        # if neg value, activate the correct number of the neg neurons with respect to the value
        TotalNumNeurons=PopSize[0]
        NumNegNeurons=PopSize[1]
        #print "total"
        #print TotalNumNeurons
       # print NumNegNeurons
        NumPosNeurons=TotalNumNeurons-NumNegNeurons
        InitializeList=np.ones(TotalNumNeurons)*rest
        #totalvalue=0
        #adddec=0.00000001
        adddec=0.0
        if((value)<0):
            adddec=-0.00001
        elif((value)>0):
            adddec=0.00001
        else:
            adddec=0.0
            
        if(increment!=0):
            numberOfCellsToActivate=int(np.fix(abs((value/increment)+adddec)))
        else:
            numberOfCellsToActivate=0
    
        for i in range(0, numberOfCellsToActivate):
            #if a negative number, do not activate the positive neurons
            if(value<0):
                if(i<NumNegNeurons):
                    InitializeList[i]=voltage
                else:
                #    print "WARNING:Number Of Cells To Activate is larger than the number of negative neurons supplied.  Therefore, only activated the available number, i.e.: %s" % str(NumNegNeurons)
                #    ####self.pause()
                    break
            elif(value>0):
                if(i<NumPosNeurons):
                    InitializeList[i+NumNegNeurons]=voltage    
                else:
                #    print "WARNING:Number Of Cells To Activate is larger than the number of positive neurons supplied.  Therefore, only activated the available number, i.e.: %s" % str(NumPosNeurons)
                #    ####self.pause()
                    break
            #totalvalue+=increment*-1
            #print "totalvalue"
            #print totalvalue
            #print "value"
            #print value
            #if(totalvalue>value):                               #underestimate the value, not over
                
            #else:
            #    InitializeList[i]=rest
 #       elif(value>0):
 #           if(i>=TotalNumNegNeurons):              #the first few of the population represent negative values (if any). the rest are postive
 #               totalvalue+=increment
  #              if(totalvalue<value):                               #underestimate the value, not over                
  #                  InitializeList[i]=voltage
  #              else:
  #                  InitializeList[i]=rest
 #           else:
 #               InitializeList[i]=rest              #if a posiitive number, do not activate the negative neurons

        #print "value"
        #print value
        #print InitializeList
        Population.initialize(v=InitializeList)

    def makeSubtractConnections(self, NumFromCells, ToCell, FromCellValueIncrements, minWeight, ToCellTotalValue, WhichInputPop):
        #print "inside make plus connections"
        ##the first neurons in a population represent negative values (if any otherwise they all represent positive values)
        ###NOTE WE STOPPED OVER CONNECTION STRENGTH WITHIN EACH EXK POPULATION BUT WE NOW NEED TO INHIBIT THE VOLTAGE BETWEEN THE EXK POPULATIONS
        TotalNumCells=NumFromCells[0]
        TotalNumNegCells=NumFromCells[1]
        ExcConnector=[]
        InhConnector=[]
        #ExhOrInh=[]
        #StopConnectionsToNeuron=0
        TotalWt=0
        #fromCell=0
        PosORNeg=-1
        tocellnum=3
        inputpop=1
        #fromtotalvalue=FromCellValueIncrements
        #minWeight=0.0667 #0.0756 
        for fromCell in range(0, TotalNumCells):
        #while ((StopConnectionsToNeuron==0)and(fromCell<TotalNumNegCells)):
       # for fromCell in range(0, NumFromCells):
            if(fromCell==TotalNumNegCells):
                PosORNeg=1
            #if((ToCell==tocellnum)):#and(WhichInputPop==inputpop)):
            #    print "MAKECONNECTION"
            #    print "Totalnumcells"
            #    print TotalNumCells
            #    print "fromcell"
            #    print fromCell
            #    print "ToCell"
            #    print ToCell
        #fromCellValue=FromCellValueIncrements*(fromCell+1)
        #if(ToCellTotalValue>=fromCellValue):  #no point connecting an EXK value (where the number of neurons fired represent the total EXK value (current EXK value + previous EXK values) which is > the F total value (represented by the current F neuron (total F value = current F neuron + previous F neurons)
        
        
             #   print "tocellvalue"
             #   print ToCellTotalValue
        #print "fromcellvalue"
        #print fromCellValue
        #print "minfromcellvalue"
        #print MinFromCellValue
             #   print "FromCellValueIncrements"
             #   print FromCellValueIncrements*PosORNeg

             #   print "PosORNeg"
             #   print PosORNeg
        #PosORNeg=PosOrNegNeurons(MinFromCellValue, FromCellValueIncrements, fromCell+1)
        
            ValueDif=(FromCellValueIncrements*PosORNeg)/ToCellTotalValue   #the percentage difference between the toValue and the FromValue
        
            wt=abs(minWeight*ValueDif)
            wt=round(wt,5)
        #####cant stop connecting from neurons (from the same populaion) to an output neuron as we do not know whatc values the
        #####the other populations will send.  For example E1X1K1 neuron 0==-0.5, might activate output neuron 0 == -0.5, however, if
        #####E2X2K2 neuron 0 is 0.5, that would negate the value from E1X1K1 neuron 0, therefore, preventing the output neuron 0 from firing
        #####Therefore, we might need the extra neurons in a population (vs the extra negating neurons in another population)  to fire to activate the output
        #the percentage of MinWeight to give to the connection. minWeight=0.065 will make the post synaptic neuron fire                 
        #if (TotalWt+wt)>=minWeight:                          #we now know the toNeuron will fire when this from neuron is activated, therefore, there is no point connecting higher valued from neurons to the to neuron
        #    wt=minWeight-TotalWt
        #    StopConnectionsToNeuron=1            #stop connections to higher valued neurons
        #    print "total weight for activation of output neuron %s has been reached" % str(ToCell)
        #else:
        #    TotalWt+=wt                          #keep a record of the previous wt connections of the previous from neurons to the particular to neuron
            #if((ToCell==tocellnum)):#and(WhichInputPop==inputpop)):
                #wt=0.0111
            #    print "wt"
            #    print wt
            #    print "minweight"
            #    print minWeight
            #    print "TotalWt" 
            #    print TotalWt
        #print "StopConnectionsToNeuron"
        #print StopConnectionsToNeuron
        #print "ToCellTotalVAlue"
        #print ToCellTotalValue
            #if((ToCell>=fromCell)or(ToCell>=abs(fromCell-TotalNumNegCells))):# no point connecting higher input valued cells to lower output cells
            #if((ToCell==tocellnum)):#and(WhichInputPop==inputpop)):
            #    print "connecting"
           #     print "from"
           #     print fromCell
           #     print "to"
          #      print ToCell
            
            if(WhichInputPop==0):  #if input population 1
                if(((PosORNeg==-1)and(ToCellTotalValue<0))or((PosORNeg==1)and(ToCellTotalValue>0))):
                    #conn='excitatory'
                    ExcConnector += [(fromCell,ToCell,abs(wt),nealParameters.DELAY)]
           #         if(ToCell==tocellnum): 
           #             print "making excitatory connection"
                else:
                    #conn='inhibitory'
                    InhConnector += [(fromCell,ToCell,round(abs(wt)*0.7875,5),nealParameters.DELAY)]
           #         if(ToCell==tocellnum): 
           #             print "making inhibitory connection"
            else:       #if input population 2, which we subtract from input pop 1
                if(((PosORNeg==1)and(ToCellTotalValue<0))or((PosORNeg==-1)and(ToCellTotalValue>0))):
                    #conn='excitatory'
                    ExcConnector += [(fromCell,ToCell,abs(wt),nealParameters.DELAY)]
            #        if(ToCell==tocellnum): 
            #            print "making excitatory connection"
                else:
                #conn='inhibitory'
                    InhConnector += [(fromCell,ToCell,round(abs(wt)*0.7875,5),nealParameters.DELAY)]
            #        if(ToCell==tocellnum): 
            #            print "making inhibitory connection"                        
        #connector += [(fromCell,ToCell,abs(wt),nealParameters.DELAY)]
        #ExhOrInh+=[conn]
     #   fromCell+=1
        #if(StopConnectionsToNeuron==1):
        #    print "stop connecting the from cells to %s" % str(ToCell)
        #    pause() 
        #    break                   #break from connecting the from neurons to the particular to neuron as all of the from neurons so far would activate the to neuron
             #   if(ToCell==tocellnum): 
             #       print "hello"                             
        #fromtotalvalue+=FromCellValueIncrements
        #if((ToCell==tocellnum)):
        #    print "connections"
        #    print WhichInputPop
        #    print ExcConnector
        #    print InhConnector
            ####self.pause()

        return [ExcConnector, InhConnector]
        """
def PosOrNegNeurons(minVal, increments, WhichNeuron):
    if((minVal<0)and(minVal<(increments*WhichNeuron*-1))):  #use negative neurons if negative min, however once the to tal value goes outside min use positive neurons
        PosORNeg=-1
    else:
        PosORNeg=1 #use positive neurons for the result of the population

    return PosORNeg
        """

    def subtractTwoPops(self, InputPops1, InputPops2, OutputPops, Input1Incr, Input2Incr, OutputIncr, numOutcells, numIn1Cells, numIn2Cells, minWeight):
    #INPUTPOPS1 - INPUTPOPS
    # The size of the post-synaptic response (the “synaptic weight”), the temporal dynamics of the weight (synaptic plasticity) and the connection delay are handled by synapse models.
    #output values for each Force neuron
    #outFValueincrements=CalculateIncrement(maxF,minF,numFcells)
    #NOTE: We cannot know whether a set of EXK neurons can activate an F output neuron even though the total of thh we EXK neurons is > the f output neuron.
    #       this is because we do not know whether the other sets of EXK neurons contains a positive or negative value when, therfore, when summed, may cause
    #       the higher valued EXK neuron population to decrease


    #####the first neurons in a population represent negative values (if any otherwise they all represent positive values)
        totalnumOutneurons=numOutcells[0]
        totalNegnumOutneurons=numOutcells[1]
    #totalNegnumFneurons=numFcells[2]
        #print "inconnectfunction"
        """
    #
    #print "maxF"
    #print maxF
    #print "minF"
   # print minF
   # print "numFcells"
   # print numFcells
    #print adfds
   # EXKValueincrements=np.zeros(numSets)
    #EMinusXMultKFromNeuron=np.zeros(numSets)
    
    #for i in range(0,numSets):
    #    EXKValueincrements[i]=CalculateIncrement(maxEminusXMultKarray[i], minEminusXMultKarray[i], numEXKcells[i]) 
        #(maxEminusXMultKarray[i]-minEminusXMultKarray[i])/numEXKcells[i]
     #   print "i"
     #   print i
     #   print "increments"
     #   print EXKValueincrements[i]
     #   print "max"
     #   print maxEminusXMultKarray[i]
     #   print "min"
    #    print minEminusXMultKarray[i]
     #   print "numcells"
     #   print numEXKcells[i]
        #EXKValueincrements[1]=(maxEminusXMultKarray[1]-minEminusXMultKarray[1])/numE2X2K2cells
        #EXKValueincrements[2]=(maxEminusXMultKarray[2]-minEminusXMultKarray[2])/numE3X3K3cells
       # EXKValueincrements[3]=(maxEminusXMultKarray[3]-minEminusXMultKarray[3])/numE4X4K4cells

    

    #wt1 = minWeight/numE1X1K1cells   #0.0665 is the min (with all the above variables) to make one cell make another cell fire  #weight is in microsiemens as IF_cond_exp has a post-synaptic mechanism which implements a change in conductance. delays are in milliseconds
    #wt2 = minWeight/numE2X2K2cells
    #wt3 = minWeight/numE3X3K3cells
    #wt4 = minWeight/numE4X4K4cells
    
    E1X1K1celltoFconnector = []
    E2X2K2celltoFconnector = []
    E3X3K3celltoFconnector = []
    E4X4K4celltoFconnector = []

    numStates=len(varValues) #number of rows
    numVariables=len(varValues[0]) #number of columns

    E1MinusX1MultK1Values=[row[4] for row in varValues]
    E2MinusX2MultK2Values=[row[9] for row in varValues]
    E3MinusX3MultK3Values=[row[14] for row in varValues]
    E4MinusX4MultK4Values=[row[19] for row in varValues]

    EMinusXMultKValues=[E1MinusX1MultK1Values, E2MinusX2MultK2Values, E3MinusX3MultK3Values, E4MinusX4MultK4Values]
    
    FValues=[row[20] for row in varValues]

    alreadyconnected=np.zeros(numFcells)
    
    print numStates
    print numVariables
    print E1MinusX1MultK1Values
    print E2MinusX2MultK2Values
    print E3MinusX3MultK3Values
    print E4MinusX4MultK4Values

    print "increments"
    print outFValueincrements
    print EXKValueincrements[0]
    print EXKValueincrements[1]
    print EXKValueincrements[2]
    print EXKValueincrements[3]

    print minF
    print maxF
    print maxEminusXMultKarray[0]
    print maxEminusXMultKarray[1]
    print maxEminusXMultKarray[2]
    print maxEminusXMultKarray[3]
    print minEminusXMultKarray[0]
    print minEminusXMultKarray[1]
    print minEminusXMultKarray[2]
    print minEminusXMultKarray[3]
    
    print "FValues"
    print FValues
        """
    #EXKPopExcToFConn=[[] for k in range(numSets)]  #set up numSets sets of empty lists in an array
    #EXKPopInhToFConn=[[] for k in range(numSets)]  #set up numSets sets of empty lists in an array
        EXConnections=[]
        INHconnections=[]
        EXConnections2=[]     #excitatory connections            
        INHconnections2=[]    #inhibitory connections    
    #numNegNeurons=0
        toNeuronTotalValue=0
        PosOrNeg=-1                                      #set the value that each neuron represents as positive or negative
    
        for toNeuron in range(0, totalnumOutneurons):           
            #print "connections"
            #print "toFneuron"
            #print toNeuron
        #PosORNeg=PosOrNegNeurons(minF, outFValueincrements, toFneuron)
        ##calculate which neurons in the population represent positive or negative values (if negative and positive valued neurons, the first neurons will represent
        #negative neurons.
        
        #if((minF>0)or(((minF+(outFValueincrements*(toFneuron+1)))>=0)and(PosOrNeg==-1)and(toFneuron>0))):
       #     numOfNegNeurons=toFneuron
       #     PosOrNeg=1
            if(totalNegnumOutneurons>toNeuron):
                toNeuronTotalValue+=OutputIncr*-1   
            else:
                if(totalNegnumOutneurons==toNeuron):
                    toNeuronTotalValue=OutputIncr
                else:
                    toNeuronTotalValue+=OutputIncr    
            """
        print "toFneuronTotalValue"
        print toFneuronTotalValue
        print "minF"
        print minF
        print "outFValueincrements"
        print outFValueincrements
            """
        #E1X1K1cells
            #connections=[]
            for i in range(0, 2):
            #print "make E %s X %s K %s cells connections" % (i,i,i) 
                if(i==0):
                    connections=self.makeSubtractConnections(numIn1Cells, toNeuron, Input1Incr, minWeight, toNeuronTotalValue, i)
                    EXConnections+=connections[0]     #excitatory connections            
                    INHconnections+=connections[1]     #inhibitory connections
                else:
                    connections=self.makeSubtractConnections(numIn2Cells, toNeuron, Input2Incr, minWeight, toNeuronTotalValue, i)
                    EXConnections2+=connections[0]     #excitatory connections            
                    INHconnections2+=connections[1]     #inhibitory connections
        #E1X1K1celltoFconnector += connections
        
        #E2X2K2cells
        #print "make E2X2K2cells connections"
        #connections=makePlusConnections(numEXKcells[1], toFneuron, EXKValueincrements[1], minEminusXMultKarray[1], minWeight, toFneuronTotalValue)
        #E2X2K2celltoFconnector += connections
        #E3X3K3cells
        #print "make E3X3K3cells connections"
        #connections=makePlusConnections(numEXKcells[2], toFneuron, EXKValueincrements[2], minEminusXMultKarray[2], minWeight, toFneuronTotalValue)
        #E3X3K3celltoFconnector += connections
        #E4X4K4cells
        #print "make E4X4K4cells connections"
        #connections=makePlusConnections(numEXKcells[3], toFneuron, EXKValueincrements[3], minEminusXMultKarray[3], minWeight, toFneuronTotalValue)
        #E4X4K4celtoFconnector += connections        

    #for i in range(0, numSets):
            
        
        #neal.nealProjection(EMinusXMultKCells[i], FOutputCells, EXKPopExcToFConn[i], 'excitatory')  #excitatory
        #neal.nealProjection(EMinusXMultKCells[i], FOutputCells, EXKPopInhToFConn[i], 'inhibitory')  #inhibitory
        #print EXConnections
        connList = self.sim.FromListConnector(EXConnections)
        exc_connections=self.sim.Projection(InputPops1, OutputPops, connList, receptor_type='excitatory')
        connList = self.sim.FromListConnector(INHconnections)
        inh_connections=self.sim.Projection(InputPops1, OutputPops, connList, receptor_type='inhibitory')
        connList = self.sim.FromListConnector(EXConnections2)
        exc_connections=self.sim.Projection(InputPops2, OutputPops, connList, receptor_type='excitatory')
        connList = self.sim.FromListConnector(INHconnections2)
        inh_connections=self.sim.Projection(InputPops2, OutputPops, connList, receptor_type='inhibitory')
        """
        print "exc connections"
        print exc_connections.get(["weight", "delay"], format="list")
        pause()
        print "inh connections"
        print inh_connections.get(["weight", "delay"], format="list")
        pause()
        """
        """
        #self.sim.Projection(EMinusXMultKCells[i], FOutputCells, connector=EXKPopToFConn[i], receptor_type='inhibitory')
    #neal.nealProjection(E2MinusX2MultK2Cells, FOutputCells, E2X2K2celltoFconnector,'excitatory')
    #neal.nealProjection(E3MinusX3MultK3Cells, FOutputCells, E3X3K3celltoFconnector,'excitatory')
    #neal.nealProjection(E4MinusX4MultK4Cells, FOutputCells, E4X4K4celltoFconnector,'excitatory')
        print "NEALADFLASJFLKSAJDFLKAJSDFLJ"
        print "i"
        print i
        print EMinusXMultKCells[i]
        print FOutputCells
        print EXKPopExcToFConn[i]
        print EXKPopInhToFConn[i]
        
    print "CONNNNLKJADLKFJALKDFJASLKJFDLKDSJ"
    print EXKPopExcToFConn[3]
    print EXKPopInhToFConn[3]
    print EMinusXMultKCells[3]
        """
        """   
    for i in range(0,numStates):
        print "i"
        print i
        print "values"
        #F=0
        toFneuron=int(round((FValues[i]-minF)/outFValueincrements))
        if(alreadyconnected[toFneuron-1]==0):
            alreadyconnected[toFneuron-1]=1
            print "Fvalues"
            print(FValues[i])
            print minF
            print outFValueincrements
            NumNeuronsToEachF=0
            for j in range(0,4):
                #F+=E1MinusX1MultK1Values[i]
                Value=EMinusXMultKValues[j]
                EMinusXMultKFromNeuron[j]=round((Value[i]-minEminusXMultKarray[j])/EXKValueincrements[j])
                print "I"
                print Value[i]
                print minEminusXMultKarray[j]
                print EXKValueincrements[j]
            
                NumNeuronsToEachF+=EMinusXMultKFromNeuron[j]
        
            wt = minWeight/NumNeuronsToEachF
            print "parameters"
            print toFneuron
            print NumNeuronsToEachF
            print EMinusXMultKFromNeuron
        
        
            for j in range(0,4):   
                for k in range(0, int(EMinusXMultKFromNeuron[j])):
                    for l in range(0,toFneuron):
                        if(j==0):  #E1-X1*K1
                            connector = connector + [(k,l,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
                        elif(j==1):#E2-X2*K2
                            connector2 = connector2 + [(k,l,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
                        elif(j==2):#E3-X3*K3
                            connector3 = connector3 + [(k,l,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
                        else:#E4-X4*K4
                            connector4 = connector4 + [(k,l,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
        #connector = connector + [(EMinusXMultKFromNeuron[0],toFneuron,wt1,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
       # connector2 = connector2 + [(EMinusXMultKFromNeuron[1],toFneuron,wt2,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
       # connector3 = connector3 + [(EMinusXMultKFromNeuron[2],toFneuron,wt3,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
       # connector4 = connector4 + [(EMinusXMultKFromNeuron[3],toFneuron,wt4,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
    
            neal.nealProjection(E1MinusX1MultK1Cells, FOutputCells, connector,'excitatory')
            neal.nealProjection(E2MinusX2MultK2Cells, FOutputCells, connector2,'excitatory')
            neal.nealProjection(E3MinusX3MultK3Cells, FOutputCells, connector3,'excitatory')
            neal.nealProjection(E4MinusX4MultK4Cells, FOutputCells, connector4,'excitatory')
        
        
 #       for j in range(0,numE2X2K2cells):
 #           print "j"
 #           print j
 #           for k in range(0,numE3X3K3cells):
 #               for l in range(0,numE4X4K4cells):
 #                   F=minEminusXMultKarray[0]+(i*E1X1K1Valueincrements)+minEminusXMultKarray[1]+(j*E2X2K2Valueincrements)+minEminusXMultKarray[2]+(k*E3X3K3Valueincrements)+minEminusXMultKarray[3]+(l*E4X4K4Valueincrements)
 #                   toFneuron=round((F-minF)/outFValueincrements)
                    
#                    connector = connector + [(i,toFneuron,wt1,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
#                    connector2 = connector2 + [(j,toFneuron,wt2,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
#                    connector3 = connector3 + [(k,toFneuron,wt3,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
#                    connector4 = connector4 + [(l,toFneuron,wt4,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
#    
#    neal.nealProjection(E1MinusX1MultK1Cells, FOutputCells, connector,'excitatory')
#    neal.nealProjection(E2MinusX2MultK2Cells, FOutputCells, connector2,'excitatory')
#    neal.nealProjection(E3MinusX3MultK3Cells, FOutputCells, connector3,'excitatory')
#    neal.nealProjection(E4MinusX4MultK4Cells, FOutputCells, connector4,'excitatory')
                                       
#    wt = minWeight/NumInputNeurons   #0.0665 is the min (with all the above variables) to make one cell make another cell fire  #weight is in microsiemens as IF_cond_exp has a post-synaptic mechanism which implements a change in conductance. delays are in milliseconds
#    connector = []
    #fromNeuron=0
#    toNeuron = 0
#    for InputNeuron in range (0,numInputNeurons):
#        fromNeuron = InputNeuron
     #   theta = fromOffset/float(100)
     #   currentSinRound = round(sin(theta),2)
     #   earlierSinRound = round(sin(theta-0.01),2)
    #    if (earlierSinRound < currentSinRound):
#        connector = connector + [(fromNeuron,toNeuron,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
        #toNeuron = toNeuron + 1 connect to next neuro

#    neal.nealProjection(fromNeurons, toNeurons, connector,'excitatory') 
        """
        print "finished"
   #return [EXKValueincrements, outFValueincrements]
        

    def OneDivideByPop(self, InputPops, numNeuronsInputPops, InputPopsIncr, OutputPops, Outincrements, numNeuronsOutputPops, minWeight):
        print "division"

        inputtotal=numNeuronsInputPops[0]
        inputnegnum=numNeuronsInputPops[1]

        outputtotal=numNeuronsOutputPops[0]
        outnegnum=numNeuronsOutputPops[1]

        EXCconnector=[]
        INHConnector=[]
        inputincrements=0
        previnhconn=0
        flag=1
        #print "numNeuronsInputPops"
        #print numNeuronsInputPops
        #print "numNeuronsOutputPops"
        #print numNeuronsOutputPops

        for fromCell in range(0,inputtotal):
            if(fromCell==0):
                inputincrements=InputPopsIncr
                printEXC=[]
                for ToCell in range(0,outnegnum):
                    EXCconnector += [(fromCell,ToCell,minWeight,nealParameters.DELAY)]
                    printEXC+=[(fromCell,ToCell,minWeight,nealParameters.DELAY)]
                #print "fromCell==0"
                #print "inputincrements"
                #print inputincrements               
                #print "printexc"
                #print printEXC
                #####self.pause()
            elif(fromCell==inputnegnum):
                inputincrements=inputnegnum
                printEXC=[]
                for ToCell in range(0,outputtotal-outnegnum):
                    EXCconnector += [(fromCell,ToCell+outnegnum,minWeight,nealParameters.DELAY)]
                    printEXC+=[(fromCell,ToCell+outnegnum,minWeight,nealParameters.DELAY)]

                #print "fromCell==400"
                #print "inputincrements"
                #print inputincrements                
                #print "printexc"
                #print printEXC
                #####self.pause()
            elif(inputnegnum>fromCell):
                inputincrements+=InputPopsIncr
                connections=int(round((1/inputincrements)/Outincrements))
                inhconnect=(outnegnum-connections)-previnhconn
                previnhconn+=inhconnect
                printEXC=[]
                for i in range(0,inhconnect):
                    INHConnector += [(fromCell,connections+i,minWeight,nealParameters.DELAY)]
                    printEXC+=[(fromCell,connections+i,minWeight,nealParameters.DELAY)]
                #previnhconn=inhconnect
                #print "INH conn"
                
                #print "number of exc connections to keep active"
                #print connections
                #print "number of inhib connections"
                #print inhconnect
                #print "inputincrements"
                #print inputincrements
                #print "num prev inh conn"
                #print previnhconn
                #print "printinh"
                #print printEXC
                #####self.pause()
            else:
                if(flag==1):
                    previnhconn=0
                    flag=0
                    inputincrements=InputPopsIncr
                inputincrements+=InputPopsIncr
                connections=int(round((1/inputincrements)/Outincrements))
                inhconnect=(outnegnum-connections)-previnhconn
                previnhconn+=inhconnect
                printEXC=[]
                for i in range(0,inhconnect):
                    INHConnector += [(fromCell,outnegnum+connections+i,minWeight,nealParameters.DELAY)]               
                    printEXC+=[(fromCell,outnegnum+connections+i,minWeight,nealParameters.DELAY)]
                
                #print "INH conn"
                
                #print "number of exc connections to keep active"
                #print connections
                #print "number of inhib connections"
                #print inhconnect
                #print "inputincrements"
                #print inputincrements
                #print "num prev inh conn"
                #print previnhconn                
                #print "printinh"
                #print printEXC
                #####self.pause()


        ##print "excite connections"
        #print EXCconnector
        #print "inhib connections"
        #print INHConnector

        #adfaf

        connList = self.sim.FromListConnector(EXCconnector)
        exc_connections=self.sim.Projection(InputPops, OutputPops, connList, receptor_type='excitatory')
        connList = self.sim.FromListConnector(INHConnector)
        inh_connections=self.sim.Projection(InputPops, OutputPops, connList, receptor_type='inhibitory')

    def subtractTwoPopsV2(self, InputPops1, InputPops2, OutputPops, Input1Incr, Input2Incr, OutputIncr, numOutcells, numIn1Cells, numIn2Cells, minWeight, subInterPop, Reorder, synDelay):
        #sum inter pop has to be the same numbers as the output pop
    # The size of the post-synaptic response (the “synaptic weight”), the temporal dynamics of the weight (synaptic plasticity) and the connection delay are handled by synapse models.
    #output values for each Force neuron
    #outFValueincrements=CalculateIncrement(maxF,minF,numFcells)
    #NOTE: We cannot know whether a set of EXK neurons can activate an F output neuron even though the total of thh we EXK neurons is > the f output neuron.
    #       this is because we do not know whether the other sets of EXK neurons contains a positive or negative value when, therfore, when summed, may cause
    #       the higher valued EXK neuron population to decrease


    #####the first neurons in a population represent negative values (if any otherwise they all represent positive values)
        totalnumOutneurons=numOutcells[0]
        totalNegnumOutneurons=numOutcells[1]
        totalnumInp1neurons=numIn1Cells[0]
        totalNegnumInp1neurons=numIn1Cells[1]
        totalnumInp2neurons=numIn2Cells[0]
        totalNegnumInp2neurons=numIn2Cells[1]        
        EXConnections=[]
        INHconnections=[]
        EXConnections2=[]
        INHconnections2=[]
        #totalnumSubInterCells=numSubInterCells[0]
        #totalNegnumSubInterCells=numSubInterCells[1]
        #totalnumSumInterCells=numSumInterCells[0]
        #totalNegnumSumInterCells=numSumInterCells[1]
        EXConnections=[]
        INHconnections=[]
        EXConnections2=[]
        INHconnections2=[]

        #####connect input1 to sub intermediate pop
        #for pop in range(0,2)
        numpos=0
        numneg=0
        #totalInp2Pos=totalNegnumInp2neurons
        totalInp2Pos=totalnumInp2neurons-totalNegnumInp2neurons
        totalInp1Pos=totalnumInp1neurons-totalNegnumInp1neurons
        Cell=0
        #totalInp1Pos=totalnumInp1neurons-totalNegnumInp1neurons
        #neg inhibit neg (inhbit pos values)   -- in1 have excited neg values, in2 has excited pos values, thus, in1 needs to 
        #neg excite pos   (excite neg values)
        #pos inhibit pos  (inhibit neg values) -- pos have excited pos values, need to 
        #pos excite neg   (excite pos values)
        for inp1Cell in range(0,totalnumInp1neurons):
            if(totalNegnumInp1neurons>inp1Cell):
                EXConnections += [(inp1Cell,inp1Cell,minWeight,nealParameters.DELAY)]
                if(totalNegnumInp2neurons>0):
                    if(numpos<totalNegnumInp2neurons):
                        INHconnections+= [(inp1Cell,inp1Cell+totalNegnumOutneurons+totalInp1Pos,minWeight,nealParameters.DELAY)]
                        numpos+=1
            else:
                EXConnections += [(inp1Cell,Cell+totalNegnumOutneurons,minWeight,nealParameters.DELAY)]
                if(totalInp2Pos>0):
                    if(Cell<totalInp2Pos):
                        INHconnections+= [(inp1Cell,Cell+totalNegnumInp1neurons,minWeight,nealParameters.DELAY)]
                        #numneg+=1
                Cell+=1

        connList = self.sim.FromListConnector(EXConnections)
        connList2 = self.sim.FromListConnector(INHconnections)
        if(Reorder==1):
            exc_connections=self.sim.Projection(InputPops1, subInterPop, connList, receptor_type='excitatory')
            inh_connections=self.sim.Projection(InputPops1, subInterPop, connList2, receptor_type='inhibitory')
        else:
            exc_connections=self.sim.Projection(InputPops1, OutputPops, connList, receptor_type='excitatory')
            inh_connections=self.sim.Projection(InputPops1, OutputPops, connList2, receptor_type='inhibitory')            
            

        print "subtract input1 pop"
        print "ex"
        print EXConnections
        print "in"
        print INHconnections

        EXConnections=[]
        INHconnections=[]

        #####connect input2 to sub intermediate pop
        
        
    #totalNegnumFneurons=numFcells[2]
        print "inconnectfunction"

        numpos=0
        numneg=0
        Cell=0
        totalInp1Pos=totalnumInp1neurons-totalNegnumInp1neurons
        #totalInp1Pos=totalnumInp1neurons-totalNegnumInp1neurons
        for inp2Cell in range(0,totalnumInp2neurons):
            if(totalNegnumInp2neurons>inp2Cell):
                EXConnections += [(inp2Cell,inp2Cell+totalInp1Pos+totalNegnumOutneurons,minWeight,nealParameters.DELAY)]
                if(totalNegnumInp1neurons>0):
                    if(numpos<totalNegnumInp1neurons):
                        INHconnections+= [(inp2Cell,inp2Cell,minWeight,nealParameters.DELAY)]
                        numpos+=1
            else:
                EXConnections += [(inp2Cell,Cell+totalNegnumInp1neurons,minWeight,nealParameters.DELAY)]
                if(totalInp1Pos>0):
                    if(Cell<totalInp1Pos):
                        INHconnections+= [(inp2Cell,Cell+totalNegnumOutneurons,minWeight,nealParameters.DELAY)]
                Cell+=1
                

        connList = self.sim.FromListConnector(EXConnections)
        connList2 = self.sim.FromListConnector(INHconnections)
        if(Reorder==1):
            exc_connections=self.sim.Projection(InputPops2, subInterPop, connList, receptor_type='excitatory')
            inh_connections=self.sim.Projection(InputPops2, subInterPop, connList2, receptor_type='inhibitory')
        else:
            exc_connections=self.sim.Projection(InputPops2, OutputPops, connList, receptor_type='excitatory')
            inh_connections=self.sim.Projection(InputPops2, OutputPops, connList2, receptor_type='inhibitory')

        
        print "subtract input2 pop"
        print "ex"
        print EXConnections
        print "in"
        print INHconnections

        ###self.pause()
        EXConnections=[]
        INHconnections=[]        
        """
    #
    #print "maxF"
    #print maxF
    #print "minF"
   # print minF
   # print "numFcells"
   # print numFcells
    #print adfds
   # EXKValueincrements=np.zeros(numSets)
    #EMinusXMultKFromNeuron=np.zeros(numSets)
    
    #for i in range(0,numSets):
    #    EXKValueincrements[i]=CalculateIncrement(maxEminusXMultKarray[i], minEminusXMultKarray[i], numEXKcells[i]) 
        #(maxEminusXMultKarray[i]-minEminusXMultKarray[i])/numEXKcells[i]
     #   print "i"
     #   print i
     #   print "increments"
     #   print EXKValueincrements[i]
     #   print "max"
     #   print maxEminusXMultKarray[i]
     #   print "min"
    #    print minEminusXMultKarray[i]
     #   print "numcells"
     #   print numEXKcells[i]
        #EXKValueincrements[1]=(maxEminusXMultKarray[1]-minEminusXMultKarray[1])/numE2X2K2cells
        #EXKValueincrements[2]=(maxEminusXMultKarray[2]-minEminusXMultKarray[2])/numE3X3K3cells
       # EXKValueincrements[3]=(maxEminusXMultKarray[3]-minEminusXMultKarray[3])/numE4X4K4cells

    

    #wt1 = minWeight/numE1X1K1cells   #0.0665 is the min (with all the above variables) to make one cell make another cell fire  #weight is in microsiemens as IF_cond_exp has a post-synaptic mechanism which implements a change in conductance. delays are in milliseconds
    #wt2 = minWeight/numE2X2K2cells
    #wt3 = minWeight/numE3X3K3cells
    #wt4 = minWeight/numE4X4K4cells
    
    E1X1K1celltoFconnector = []
    E2X2K2celltoFconnector = []
    E3X3K3celltoFconnector = []
    E4X4K4celltoFconnector = []

    numStates=len(varValues) #number of rows
    numVariables=len(varValues[0]) #number of columns

    E1MinusX1MultK1Values=[row[4] for row in varValues]
    E2MinusX2MultK2Values=[row[9] for row in varValues]
    E3MinusX3MultK3Values=[row[14] for row in varValues]
    E4MinusX4MultK4Values=[row[19] for row in varValues]

    EMinusXMultKValues=[E1MinusX1MultK1Values, E2MinusX2MultK2Values, E3MinusX3MultK3Values, E4MinusX4MultK4Values]
    
    FValues=[row[20] for row in varValues]

    alreadyconnected=np.zeros(numFcells)
    
    print numStates
    print numVariables
    print E1MinusX1MultK1Values
    print E2MinusX2MultK2Values
    print E3MinusX3MultK3Values
    print E4MinusX4MultK4Values

    print "increments"
    print outFValueincrements
    print EXKValueincrements[0]
    print EXKValueincrements[1]
    print EXKValueincrements[2]
    print EXKValueincrements[3]

    print minF
    print maxF
    print maxEminusXMultKarray[0]
    print maxEminusXMultKarray[1]
    print maxEminusXMultKarray[2]
    print maxEminusXMultKarray[3]
    print minEminusXMultKarray[0]
    print minEminusXMultKarray[1]
    print minEminusXMultKarray[2]
    print minEminusXMultKarray[3]
    
    print "FValues"
    print FValues
        """
        if(Reorder==1):
        #minWeight=0.346
    #EXKPopExcToFConn=[[] for k in range(numSets)]  #set up numSets sets of empty lists in an array
    #EXKPopInhToFConn=[[] for k in range(numSets)]  #set up numSets sets of empty lists in an array
            EXConnections=[]
            INHconnections=[]
            EXConnections2=[]     #excitatory connections            
            INHconnections2=[]    #inhibitory connections    
    #numNegNeurons=0
            toNeuronTotalValue=0
            PosOrNeg=-1                                      #set the value that each neuron represents as positive or negative
    
            for toNeuron in range(0, totalnumOutneurons):           
                print "connections"
                print "toFneuron"
                print toNeuron
        #PosORNeg=PosOrNegNeurons(minF, outFValueincrements, toFneuron)
        ##calculate which neurons in the population represent positive or negative values (if negative and positive valued neurons, the first neurons will represent
        #negative neurons.
        
        #if((minF>0)or(((minF+(outFValueincrements*(toFneuron+1)))>=0)and(PosOrNeg==-1)and(toFneuron>0))):
       #     numOfNegNeurons=toFneuron
       #     PosOrNeg=1
                if(totalNegnumOutneurons>toNeuron):
                    toNeuronTotalValue+=OutputIncr*-1   
                else:
                    if(totalNegnumOutneurons==toNeuron):
                        toNeuronTotalValue=OutputIncr
                    else:
                        toNeuronTotalValue+=OutputIncr

            
                """
        print "toFneuronTotalValue"
        print toFneuronTotalValue
        print "minF"
        print minF
        print "outFValueincrements"
        print outFValueincrements
                """
        #E1X1K1cells
            #connections=[]
            #for i in range(0, 2):
            #print "make E %s X %s K %s cells connections" % (i,i,i) 
                #if(i==0):
            #if(toNeuronTotalValue<0):
            #    numCells=totalNegnumOutneurons
                
                connections=self.makePlusConnectionsV2(numOutcells, toNeuron, Input1Incr, minWeight, toNeuronTotalValue, synDelay)
                EXConnections+=connections[0]     #excitatory connections            
                    #INHconnections+=connections[1]     #inhibitory connections
                #lse:
               #     connections=self.makePlusConnections(numIn2Cells, toNeuron, Input2Incr, minWeight, toNeuronTotalValue)
                #    EXConnections2+=connections[0]     #excitatory connections            
                #    INHconnections2+=connections[1]     #inhibitory connections
        #E1X1K1celltoFconnector += connections
        
        #E2X2K2cells
        #print "make E2X2K2cells connections"
        #connections=makePlusConnections(numEXKcells[1], toFneuron, EXKValueincrements[1], minEminusXMultKarray[1], minWeight, toFneuronTotalValue)
        #E2X2K2celltoFconnector += connections
        #E3X3K3cells
        #print "make E3X3K3cells connections"
        #connections=makePlusConnections(numEXKcells[2], toFneuron, EXKValueincrements[2], minEminusXMultKarray[2], minWeight, toFneuronTotalValue)
        #E3X3K3celltoFconnector += connections
        #E4X4K4cells
        #print "make E4X4K4cells connections"
        #connections=makePlusConnections(numEXKcells[3], toFneuron, EXKValueincrements[3], minEminusXMultKarray[3], minWeight, toFneuronTotalValue)
        #E4X4K4celtoFconnector += connections        

    #for i in range(0, numSets):
            
        
        #neal.nealProjection(EMinusXMultKCells[i], FOutputCells, EXKPopExcToFConn[i], 'excitatory')  #excitatory
        #neal.nealProjection(EMinusXMultKCells[i], FOutputCells, EXKPopInhToFConn[i], 'inhibitory')  #inhibitory
        #print EXConnections
            connList = self.sim.FromListConnector(EXConnections)
            exc_connections=self.sim.Projection(subInterPop, OutputPops, connList, receptor_type='excitatory')
        #connList = self.sim.FromListConnector(INHconnections)
        #inh_connections=self.sim.Projection(InputPops1, OutputPops, connList, receptor_type='inhibitory')
        #connList = self.sim.FromListConnector(EXConnections2)
        #exc_connections=self.sim.Projection(InputPops2, OutputPops, connList, receptor_type='excitatory')
        #connList = self.sim.FromListConnector(INHconnections2)
        #inh_connections=self.sim.Projection(InputPops2, OutputPops, connList, receptor_type='inhibitory')


        """
        ##decrease higher inputs to stop neurons firing out of sync (do negative neurons first)
        toNeuronTotalValue=0
        INHconnections=[]
        for toNeuron in range(0, totalNegnumOutneurons):           
            print "connections"
            print "toFneuron"
            print toNeuron
            toNeuronTotalValue+=OutputIncr
            ValueDif=round(OutputIncr/toNeuronTotalValue,5)   #the percentage difference between the toValue and the FromValue
        
            wt=abs(minWeight*ValueDif)
            wt=round(wt,5)            
            for toNeuron2 in range(0,totalNegnumOutneurons):
                if(toNeuron<toNeuron2):
                    INHconnections+= [(toNeuron2,toNeuron,wt,nealParameters.DELAY)]
                    
        #(do positive neurons next)
        toNeuronTotalValue=0
        #EXConnections=[]
        start=totalNegnumOutneurons
        for toNeuron in range(0, totalnumOutneurons-totalNegnumOutneurons):           
            print "connections"
            print "toFneuron"
            print toNeuron
            toNeuronTotalValue+=OutputIncr
            ValueDif=round(OutputIncr/toNeuronTotalValue,5)   #the percentage difference between the toValue and the FromValue
        
            wt=abs(minWeight*ValueDif)
            wt=round(wt,5)            
            for toNeuron2 in range(0,totalnumOutneurons-totalNegnumOutneurons):
                if(toNeuron<toNeuron2):
                    INHconnections+= [(start+toNeuron2,start+toNeuron,wt,nealParameters.DELAY)]





        print INHconnections
        jhjh

        connList = self.sim.FromListConnector(INHconnections)
        exc_connections=self.sim.Projection(OutputPops, OutputPops, connList, receptor_type='inhibitory')
        """  
        """
        print "exc connections"
        print exc_connections.get(["weight", "delay"], format="list")
        pause()
        print "inh connections"
        print inh_connections.get(["weight", "delay"], format="list")
        pause()
        """
        """
        #self.sim.Projection(EMinusXMultKCells[i], FOutputCells, connector=EXKPopToFConn[i], receptor_type='inhibitory')
    #neal.nealProjection(E2MinusX2MultK2Cells, FOutputCells, E2X2K2celltoFconnector,'excitatory')
    #neal.nealProjection(E3MinusX3MultK3Cells, FOutputCells, E3X3K3celltoFconnector,'excitatory')
    #neal.nealProjection(E4MinusX4MultK4Cells, FOutputCells, E4X4K4celltoFconnector,'excitatory')
        print "NEALADFLASJFLKSAJDFLKAJSDFLJ"
        print "i"
        print i
        print EMinusXMultKCells[i]
        print FOutputCells
        print EXKPopExcToFConn[i]
        print EXKPopInhToFConn[i]
        
    print "CONNNNLKJADLKFJALKDFJASLKJFDLKDSJ"
    print EXKPopExcToFConn[3]
    print EXKPopInhToFConn[3]
    print EMinusXMultKCells[3]
        """
        """   
    for i in range(0,numStates):
        print "i"
        print i
        print "values"
        #F=0
        toFneuron=int(round((FValues[i]-minF)/outFValueincrements))
        if(alreadyconnected[toFneuron-1]==0):
            alreadyconnected[toFneuron-1]=1
            print "Fvalues"
            print(FValues[i])
            print minF
            print outFValueincrements
            NumNeuronsToEachF=0
            for j in range(0,4):
                #F+=E1MinusX1MultK1Values[i]
                Value=EMinusXMultKValues[j]
                EMinusXMultKFromNeuron[j]=round((Value[i]-minEminusXMultKarray[j])/EXKValueincrements[j])
                print "I"
                print Value[i]
                print minEminusXMultKarray[j]
                print EXKValueincrements[j]
            
                NumNeuronsToEachF+=EMinusXMultKFromNeuron[j]
        
            wt = minWeight/NumNeuronsToEachF
            print "parameters"
            print toFneuron
            print NumNeuronsToEachF
            print EMinusXMultKFromNeuron
        
        
            for j in range(0,4):   
                for k in range(0, int(EMinusXMultKFromNeuron[j])):
                    for l in range(0,toFneuron):
                        if(j==0):  #E1-X1*K1
                            connector = connector + [(k,l,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
                        elif(j==1):#E2-X2*K2
                            connector2 = connector2 + [(k,l,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
                        elif(j==2):#E3-X3*K3
                            connector3 = connector3 + [(k,l,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
                        else:#E4-X4*K4
                            connector4 = connector4 + [(k,l,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
        #connector = connector + [(EMinusXMultKFromNeuron[0],toFneuron,wt1,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
       # connector2 = connector2 + [(EMinusXMultKFromNeuron[1],toFneuron,wt2,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
       # connector3 = connector3 + [(EMinusXMultKFromNeuron[2],toFneuron,wt3,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
       # connector4 = connector4 + [(EMinusXMultKFromNeuron[3],toFneuron,wt4,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
    
            neal.nealProjection(E1MinusX1MultK1Cells, FOutputCells, connector,'excitatory')
            neal.nealProjection(E2MinusX2MultK2Cells, FOutputCells, connector2,'excitatory')
            neal.nealProjection(E3MinusX3MultK3Cells, FOutputCells, connector3,'excitatory')
            neal.nealProjection(E4MinusX4MultK4Cells, FOutputCells, connector4,'excitatory')
        
        
 #       for j in range(0,numE2X2K2cells):
 #           print "j"
 #           print j
 #           for k in range(0,numE3X3K3cells):
 #               for l in range(0,numE4X4K4cells):
 #                   F=minEminusXMultKarray[0]+(i*E1X1K1Valueincrements)+minEminusXMultKarray[1]+(j*E2X2K2Valueincrements)+minEminusXMultKarray[2]+(k*E3X3K3Valueincrements)+minEminusXMultKarray[3]+(l*E4X4K4Valueincrements)
 #                   toFneuron=round((F-minF)/outFValueincrements)
                    
#                    connector = connector + [(i,toFneuron,wt1,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
#                    connector2 = connector2 + [(j,toFneuron,wt2,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
#                    connector3 = connector3 + [(k,toFneuron,wt3,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
#                    connector4 = connector4 + [(l,toFneuron,wt4,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
#    
#    neal.nealProjection(E1MinusX1MultK1Cells, FOutputCells, connector,'excitatory')
#    neal.nealProjection(E2MinusX2MultK2Cells, FOutputCells, connector2,'excitatory')
#    neal.nealProjection(E3MinusX3MultK3Cells, FOutputCells, connector3,'excitatory')
#    neal.nealProjection(E4MinusX4MultK4Cells, FOutputCells, connector4,'excitatory')
                                       
#    wt = minWeight/NumInputNeurons   #0.0665 is the min (with all the above variables) to make one cell make another cell fire  #weight is in microsiemens as IF_cond_exp has a post-synaptic mechanism which implements a change in conductance. delays are in milliseconds
#    connector = []
    #fromNeuron=0
#    toNeuron = 0
#    for InputNeuron in range (0,numInputNeurons):
#        fromNeuron = InputNeuron
     #   theta = fromOffset/float(100)
     #   currentSinRound = round(sin(theta),2)
     #   earlierSinRound = round(sin(theta-0.01),2)
    #    if (earlierSinRound < currentSinRound):
#        connector = connector + [(fromNeuron,toNeuron,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
        #toNeuron = toNeuron + 1 connect to next neuro

#    neal.nealProjection(fromNeurons, toNeurons, connector,'excitatory') 
        """
        print "finished"        


#self.summationTwoPopsV3(self.M1gCosSinMinusSinX3sqM1LPops, self.FOutCells, self.M1gCosSinMinusSinX3sqM1LPlusFCells, self.M1gCosSinMinusSinX3sqM1Lincrements, self.Force2increments, self.M1gCosSinMinusSinX3sqM1LPlusFincrements, self.numneuron, self.numNeuronsM1gCosSinMinusSinX3sqM1L, self.numNeuronsInFPop, minWeight, self.M1gCosSinMinusSinX3sqM1LPlusFInterCells,1, 1,self.numNeuronsInM1gCosSinMinusSinX3sqM1LPlusF)


    def summationTwoPopsV3(self, InputPops1, InputPops2, OutputPops, Input1Incr, Input2Incr, OutputIncr, numOutcells, numIn1Cells, numIn2Cells, minWeight, sumInterPop, Reorder, useintervalues, numintercells, synDelay):
        #sum inter pop has to be the same numbers as the output pop
    # The size of the post-synaptic response (the “synaptic weight”), the temporal dynamics of the weight (synaptic plasticity) and the connection delay are handled by synapse models.
    #output values for each Force neuron
    #outFValueincrements=CalculateIncrement(maxF,minF,numFcells)
    #NOTE: We cannot know whether a set of EXK neurons can activate an F output neuron even though the total of thh we EXK neurons is > the f output neuron.
    #       this is because we do not know whether the other sets of EXK neurons contains a positive or negative value when, therfore, when summed, may cause
    #       the higher valued EXK neuron population to decrease


    #####the first neurons in a population represent negative values (if any otherwise they all represent positive values)

    
        #totalnumOutneurons=numOutcells[0]
        #totalNegnumOutneurons=numOutcells[1]

        if(useintervalues==1):
            totalnumOutneurons=numintercells[0]
            totalNegnumOutneurons=numintercells[1]
        else:
            totalnumOutneurons=numOutcells[0]
            totalNegnumOutneurons=numOutcells[1]
        
        totalnumInp1neurons=numIn1Cells[0]
        totalNegnumInp1neurons=numIn1Cells[1]
        totalnumInp2neurons=numIn2Cells[0]
        totalNegnumInp2neurons=numIn2Cells[1]        
        EXConnections=[]
        INHconnections=[]
        EXConnections2=[]
        INHconnections2=[]
        #totalnumSubInterCells=numSubInterCells[0]
        #totalNegnumSubInterCells=numSubInterCells[1]
        #totalnumSumInterCells=numSumInterCells[0]
        #totalNegnumSumInterCells=numSumInterCells[1]
        EXConnections=[]
        INHconnections=[]
        EXConnections2=[]
        INHconnections2=[]

        #####connect input1 to sub intermediate pop
        #for pop in range(0,2)
        numpos=0
        numneg=0
        totalInp2Pos=totalnumInp2neurons-totalNegnumInp2neurons
        Cell=0
        #totalInp1Pos=totalnumInp1neurons-totalNegnumInp1neurons
        for inp1Cell in range(0,totalnumInp1neurons):
            if(totalNegnumInp1neurons>inp1Cell):
                EXConnections += [(inp1Cell,inp1Cell,minWeight,nealParameters.DELAY)]
                if(totalInp2Pos>0):
                    if(numpos<totalInp2Pos):
                        INHconnections+= [(inp1Cell,inp1Cell+totalNegnumOutneurons,minWeight,nealParameters.DELAY)]
                        numpos+=1
            else:
                EXConnections += [(inp1Cell,Cell+totalNegnumOutneurons+totalInp2Pos,minWeight,nealParameters.DELAY)]
                if(totalNegnumInp2neurons>0):
                    if(Cell<totalNegnumInp2neurons):
                        INHconnections+= [(inp1Cell,Cell+totalNegnumInp1neurons,minWeight,nealParameters.DELAY)]
                        #numneg+=1
                Cell+=1
        if(INHconnections!=[]):
            connList2 = self.sim.FromListConnector(INHconnections)
        if(EXConnections!=[]):
            connList = self.sim.FromListConnector(EXConnections)
        
        if(Reorder==1):
            if(EXConnections!=[]):
                exc_connections=self.sim.Projection(InputPops1, sumInterPop, connList, receptor_type='excitatory')
            if(INHconnections!=[]):
                inh_connections=self.sim.Projection(InputPops1, sumInterPop, connList2, receptor_type='inhibitory')
        else:
            if(EXConnections!=[]):
                exc_connections=self.sim.Projection(InputPops1, OutputPops, connList, receptor_type='excitatory')
            if(INHconnections!=[]):
                inh_connections=self.sim.Projection(InputPops1, OutputPops, connList2, receptor_type='inhibitory')            

        #print "input 1 con"
        #print numOutcells
        #print numIn1Cells,
        #print EXConnections
        #print INHconnections

        EXConnections=[]
        INHconnections=[]

        #####connect input2 to sub intermediate pop
        
        
    #totalNegnumFneurons=numFcells[2]
        print "inconnectfunction"

        numpos=0
        numneg=0
        Cell=0
        totalInp1Pos=totalnumInp1neurons-totalNegnumInp1neurons
        #totalInp1Pos=totalnumInp1neurons-totalNegnumInp1neurons
        for inp2Cell in range(0,totalnumInp2neurons):
            if(totalNegnumInp2neurons>inp2Cell):
                EXConnections += [(inp2Cell,inp2Cell+totalNegnumInp1neurons,minWeight,nealParameters.DELAY)]
                if(totalInp1Pos>0):
                    if(numpos<totalInp1Pos):
                        INHconnections+= [(inp2Cell,inp2Cell+totalInp2Pos+totalNegnumOutneurons,minWeight,nealParameters.DELAY)]
                        numpos+=1
            else:
                EXConnections += [(inp2Cell,Cell+totalNegnumOutneurons,minWeight,nealParameters.DELAY)]
                if(totalNegnumInp1neurons>0):
                    if(Cell<totalNegnumInp1neurons):
                        INHconnections+= [(inp2Cell,Cell,minWeight,nealParameters.DELAY)]
                Cell+=1


        if(EXConnections!=[]):
            connList = self.sim.FromListConnector(EXConnections)
        if(INHconnections!=[]):
            connList2 = self.sim.FromListConnector(INHconnections)
            
        if(Reorder==1):
            print "reorder"
            if(EXConnections!=[]):
                exc_connections=self.sim.Projection(InputPops2, sumInterPop, connList, receptor_type='excitatory')
            if(INHconnections!=[]):
                inh_connections=self.sim.Projection(InputPops2, sumInterPop, connList2, receptor_type='inhibitory')
        else:
            print "dont reorder"
            if(EXConnections!=[]):
                exc_connections=self.sim.Projection(InputPops2, OutputPops, connList, receptor_type='excitatory')
            if(INHconnections!=[]):
                inh_connections=self.sim.Projection(InputPops2, OutputPops, connList2, receptor_type='inhibitory')

        #print "input 2 con"
        #print numOutcells
        #print numIn2Cells,
        #print EXConnections
        #print INHconnections
        ###self.pause()

        EXConnections=[]
        INHconnections=[]        
        """
    #
    #print "maxF"
    #print maxF
    #print "minF"
   # print minF
   # print "numFcells"
   # print numFcells
    #print adfds
   # EXKValueincrements=np.zeros(numSets)
    #EMinusXMultKFromNeuron=np.zeros(numSets)
    
    #for i in range(0,numSets):
    #    EXKValueincrements[i]=CalculateIncrement(maxEminusXMultKarray[i], minEminusXMultKarray[i], numEXKcells[i]) 
        #(maxEminusXMultKarray[i]-minEminusXMultKarray[i])/numEXKcells[i]
     #   print "i"
     #   print i
     #   print "increments"
     #   print EXKValueincrements[i]
     #   print "max"
     #   print maxEminusXMultKarray[i]
     #   print "min"
    #    print minEminusXMultKarray[i]
     #   print "numcells"
     #   print numEXKcells[i]
        #EXKValueincrements[1]=(maxEminusXMultKarray[1]-minEminusXMultKarray[1])/numE2X2K2cells
        #EXKValueincrements[2]=(maxEminusXMultKarray[2]-minEminusXMultKarray[2])/numE3X3K3cells
       # EXKValueincrements[3]=(maxEminusXMultKarray[3]-minEminusXMultKarray[3])/numE4X4K4cells

    

    #wt1 = minWeight/numE1X1K1cells   #0.0665 is the min (with all the above variables) to make one cell make another cell fire  #weight is in microsiemens as IF_cond_exp has a post-synaptic mechanism which implements a change in conductance. delays are in milliseconds
    #wt2 = minWeight/numE2X2K2cells
    #wt3 = minWeight/numE3X3K3cells
    #wt4 = minWeight/numE4X4K4cells
    
    E1X1K1celltoFconnector = []
    E2X2K2celltoFconnector = []
    E3X3K3celltoFconnector = []
    E4X4K4celltoFconnector = []

    numStates=len(varValues) #number of rows
    numVariables=len(varValues[0]) #number of columns

    E1MinusX1MultK1Values=[row[4] for row in varValues]
    E2MinusX2MultK2Values=[row[9] for row in varValues]
    E3MinusX3MultK3Values=[row[14] for row in varValues]
    E4MinusX4MultK4Values=[row[19] for row in varValues]

    EMinusXMultKValues=[E1MinusX1MultK1Values, E2MinusX2MultK2Values, E3MinusX3MultK3Values, E4MinusX4MultK4Values]
    
    FValues=[row[20] for row in varValues]

    alreadyconnected=np.zeros(numFcells)
    
    print numStates
    print numVariables
    print E1MinusX1MultK1Values
    print E2MinusX2MultK2Values
    print E3MinusX3MultK3Values
    print E4MinusX4MultK4Values

    print "increments"
    print outFValueincrements
    print EXKValueincrements[0]
    print EXKValueincrements[1]
    print EXKValueincrements[2]
    print EXKValueincrements[3]

    print minF
    print maxF
    print maxEminusXMultKarray[0]
    print maxEminusXMultKarray[1]
    print maxEminusXMultKarray[2]
    print maxEminusXMultKarray[3]
    print minEminusXMultKarray[0]
    print minEminusXMultKarray[1]
    print minEminusXMultKarray[2]
    print minEminusXMultKarray[3]
    
    print "FValues"
    print FValues
        """
        if(useintervalues==1):
            totalnumOutneurons=numOutcells[0]       #output
            totalNegnumOutneurons=numOutcells[1]
            fromneurons=numintercells

        else:
            fromneurons=numOutcells
        
        if(Reorder==1):
    #EXKPopExcToFConn=[[] for k in range(numSets)]  #set up numSets sets of empty lists in an array
    #EXKPopInhToFConn=[[] for k in range(numSets)]  #set up numSets sets of empty lists in an array
            EXConnections=[]
            INHconnections=[]
            EXConnections2=[]     #excitatory connections            
            INHconnections2=[]    #inhibitory connections    
    #numNegNeurons=0
            toNeuronTotalValue=0
            PosOrNeg=-1                                      #set the value that each neuron represents as positive or negative
        #minWeight=0.346
            for toNeuron in range(0, totalnumOutneurons):           
                #print "connections"
                #print "toFneuron"
                #print toNeuron
        #PosORNeg=PosOrNegNeurons(minF, outFValueincrements, toFneuron)
        ##calculate which neurons in the population represent positive or negative values (if negative and positive valued neurons, the first neurons will represent
        #negative neurons.
        
        #if((minF>0)or(((minF+(outFValueincrements*(toFneuron+1)))>=0)and(PosOrNeg==-1)and(toFneuron>0))):
       #     numOfNegNeurons=toFneuron
       #     PosOrNeg=1
                if(totalNegnumOutneurons>toNeuron):
                    toNeuronTotalValue+=OutputIncr*-1   
                else:
                    if(totalNegnumOutneurons==toNeuron):
                        toNeuronTotalValue=OutputIncr
                    else:
                        toNeuronTotalValue+=OutputIncr    
                """
        print "toFneuronTotalValue"
        print toFneuronTotalValue
        print "minF"
        print minF
        print "outFValueincrements"
        print outFValueincrements
                """
        #E1X1K1cells
            #connections=[]
            #for i in range(0, 2):
            #print "make E %s X %s K %s cells connections" % (i,i,i) 
                #if(i==0):
            #if(toNeuronTotalValue<0):
            #    numCells=totalNegnumOutneurons
                
                connections=self.makePlusConnectionsV2(fromneurons, toNeuron, Input1Incr, minWeight, toNeuronTotalValue, synDelay)
                EXConnections+=connections[0]     #excitatory connections            
                    #INHconnections+=connections[1]     #inhibitory connections
                #lse:
               #     connections=self.makePlusConnections(numIn2Cells, toNeuron, Input2Incr, minWeight, toNeuronTotalValue)
                #    EXConnections2+=connections[0]     #excitatory connections            
                #    INHconnections2+=connections[1]     #inhibitory connections
        #E1X1K1celltoFconnector += connections
        
        #E2X2K2cells
        #print "make E2X2K2cells connections"
        #connections=makePlusConnections(numEXKcells[1], toFneuron, EXKValueincrements[1], minEminusXMultKarray[1], minWeight, toFneuronTotalValue)
        #E2X2K2celltoFconnector += connections
        #E3X3K3cells
        #print "make E3X3K3cells connections"
        #connections=makePlusConnections(numEXKcells[2], toFneuron, EXKValueincrements[2], minEminusXMultKarray[2], minWeight, toFneuronTotalValue)
        #E3X3K3celltoFconnector += connections
        #E4X4K4cells
        #print "make E4X4K4cells connections"
        #connections=makePlusConnections(numEXKcells[3], toFneuron, EXKValueincrements[3], minEminusXMultKarray[3], minWeight, toFneuronTotalValue)
        #E4X4K4celtoFconnector += connections        

    #for i in range(0, numSets):
            
        
        #neal.nealProjection(EMinusXMultKCells[i], FOutputCells, EXKPopExcToFConn[i], 'excitatory')  #excitatory
        #neal.nealProjection(EMinusXMultKCells[i], FOutputCells, EXKPopInhToFConn[i], 'inhibitory')  #inhibitory
        #print EXConnections
            connList = self.sim.FromListConnector(EXConnections)
            exc_connections=self.sim.Projection(sumInterPop, OutputPops, connList, receptor_type='excitatory')
        #connList = self.sim.FromListConnector(INHconnections)
        #inh_connections=self.sim.Projection(InputPops1, OutputPops, connList, receptor_type='inhibitory')
        #connList = self.sim.FromListConnector(EXConnections2)
        #exc_connections=self.sim.Projection(InputPops2, OutputPops, connList, receptor_type='excitatory')
        #connList = self.sim.FromListConnector(INHconnections2)
        #inh_connections=self.sim.Projection(InputPops2, OutputPops, connList, receptor_type='inhibitory')
        """
        print "exc connections"
        print exc_connections.get(["weight", "delay"], format="list")
        pause()
        print "inh connections"
        print inh_connections.get(["weight", "delay"], format="list")
        pause()
        """
        """
        #self.sim.Projection(EMinusXMultKCells[i], FOutputCells, connector=EXKPopToFConn[i], receptor_type='inhibitory')
    #neal.nealProjection(E2MinusX2MultK2Cells, FOutputCells, E2X2K2celltoFconnector,'excitatory')
    #neal.nealProjection(E3MinusX3MultK3Cells, FOutputCells, E3X3K3celltoFconnector,'excitatory')
    #neal.nealProjection(E4MinusX4MultK4Cells, FOutputCells, E4X4K4celltoFconnector,'excitatory')
        print "NEALADFLASJFLKSAJDFLKAJSDFLJ"
        print "i"
        print i
        print EMinusXMultKCells[i]
        print FOutputCells
        print EXKPopExcToFConn[i]
        print EXKPopInhToFConn[i]
        
    print "CONNNNLKJADLKFJALKDFJASLKJFDLKDSJ"
    print EXKPopExcToFConn[3]
    print EXKPopInhToFConn[3]
    print EMinusXMultKCells[3]
        """
        """   
    for i in range(0,numStates):
        print "i"
        print i
        print "values"
        #F=0
        toFneuron=int(round((FValues[i]-minF)/outFValueincrements))
        if(alreadyconnected[toFneuron-1]==0):
            alreadyconnected[toFneuron-1]=1
            print "Fvalues"
            print(FValues[i])
            print minF
            print outFValueincrements
            NumNeuronsToEachF=0
            for j in range(0,4):
                #F+=E1MinusX1MultK1Values[i]
                Value=EMinusXMultKValues[j]
                EMinusXMultKFromNeuron[j]=round((Value[i]-minEminusXMultKarray[j])/EXKValueincrements[j])
                print "I"
                print Value[i]
                print minEminusXMultKarray[j]
                print EXKValueincrements[j]
            
                NumNeuronsToEachF+=EMinusXMultKFromNeuron[j]
        
            wt = minWeight/NumNeuronsToEachF
            print "parameters"
            print toFneuron
            print NumNeuronsToEachF
            print EMinusXMultKFromNeuron
        
        
            for j in range(0,4):   
                for k in range(0, int(EMinusXMultKFromNeuron[j])):
                    for l in range(0,toFneuron):
                        if(j==0):  #E1-X1*K1
                            connector = connector + [(k,l,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
                        elif(j==1):#E2-X2*K2
                            connector2 = connector2 + [(k,l,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
                        elif(j==2):#E3-X3*K3
                            connector3 = connector3 + [(k,l,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
                        else:#E4-X4*K4
                            connector4 = connector4 + [(k,l,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
        #connector = connector + [(EMinusXMultKFromNeuron[0],toFneuron,wt1,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
       # connector2 = connector2 + [(EMinusXMultKFromNeuron[1],toFneuron,wt2,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
       # connector3 = connector3 + [(EMinusXMultKFromNeuron[2],toFneuron,wt3,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
       # connector4 = connector4 + [(EMinusXMultKFromNeuron[3],toFneuron,wt4,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
    
            neal.nealProjection(E1MinusX1MultK1Cells, FOutputCells, connector,'excitatory')
            neal.nealProjection(E2MinusX2MultK2Cells, FOutputCells, connector2,'excitatory')
            neal.nealProjection(E3MinusX3MultK3Cells, FOutputCells, connector3,'excitatory')
            neal.nealProjection(E4MinusX4MultK4Cells, FOutputCells, connector4,'excitatory')
        
        
 #       for j in range(0,numE2X2K2cells):
 #           print "j"
 #           print j
 #           for k in range(0,numE3X3K3cells):
 #               for l in range(0,numE4X4K4cells):
 #                   F=minEminusXMultKarray[0]+(i*E1X1K1Valueincrements)+minEminusXMultKarray[1]+(j*E2X2K2Valueincrements)+minEminusXMultKarray[2]+(k*E3X3K3Valueincrements)+minEminusXMultKarray[3]+(l*E4X4K4Valueincrements)
 #                   toFneuron=round((F-minF)/outFValueincrements)
                    
#                    connector = connector + [(i,toFneuron,wt1,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
#                    connector2 = connector2 + [(j,toFneuron,wt2,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
#                    connector3 = connector3 + [(k,toFneuron,wt3,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
#                    connector4 = connector4 + [(l,toFneuron,wt4,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
#    
#    neal.nealProjection(E1MinusX1MultK1Cells, FOutputCells, connector,'excitatory')
#    neal.nealProjection(E2MinusX2MultK2Cells, FOutputCells, connector2,'excitatory')
#    neal.nealProjection(E3MinusX3MultK3Cells, FOutputCells, connector3,'excitatory')
#    neal.nealProjection(E4MinusX4MultK4Cells, FOutputCells, connector4,'excitatory')
                                       
#    wt = minWeight/NumInputNeurons   #0.0665 is the min (with all the above variables) to make one cell make another cell fire  #weight is in microsiemens as IF_cond_exp has a post-synaptic mechanism which implements a change in conductance. delays are in milliseconds
#    connector = []
    #fromNeuron=0
#    toNeuron = 0
#    for InputNeuron in range (0,numInputNeurons):
#        fromNeuron = InputNeuron
     #   theta = fromOffset/float(100)
     #   currentSinRound = round(sin(theta),2)
     #   earlierSinRound = round(sin(theta-0.01),2)
    #    if (earlierSinRound < currentSinRound):
#        connector = connector + [(fromNeuron,toNeuron,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
        #toNeuron = toNeuron + 1 connect to next neuro

#    neal.nealProjection(fromNeurons, toNeurons, connector,'excitatory') 
        """
        print "finished"        
#connections=self.makePlusConnectionsV2(MultPops, eachOutNeuron, MultPopIncr, minWeight, toNeuronTotalValue)
        #connections=self.makePlusConnectionsV2(numMultPops, eachOutNeuron, MultPopIncr, minWeight, toNeuronTotalValue)

        
        #connections=self.makePlusConnectionsV2(numMultPops, eachOutNeuron, MultPopIncr, minWeight, toNeuronTotalValue)
    def makePlusConnectionsV2(self, NumFromCells, ToCell, FromCellValueIncrements, minWeight, ToCellTotalValue, synDelay):
        #print "inside make plus connections"
        ##the first neurons in a population represent negative values (if any otherwise they all represent positive values)
        ###NOTE WE STOPPED OVER CONNECTION STRENGTH WITHIN EACH EXK POPULATION BUT WE NOW NEED TO INHIBIT THE VOLTAGE BETWEEN THE EXK POPULATIONS
        
        TotalNumCells=NumFromCells[0]
        TotalNumNegCells=NumFromCells[1]
        ExcConnector=[]
        #InhConnector=[]
        #ExhOrInh=[]
        #StopConnectionsToNeuron=0
        TotalWt=0
        #fromCell=0
        PosORNeg=-1
        tocellnum=47
        #0.0756
        if(ToCellTotalValue<0):
            totalcells=TotalNumNegCells
        else:
            totalcells=TotalNumCells-TotalNumNegCells   
        
        for fromCell in range(0, totalcells):
        #while ((StopConnectionsToNeuron==0)and(fromCell<TotalNumNegCells)):
       # for fromCell in range(0, NumFromCells):
            #if(fromCell==TotalNumNegCells):
            #    PosORNeg=1
            #if(ToCell==tocellnum):
            #    print "MAKECONNECTION"
            #    print "Totalnumcells"
            #    print TotalNumCells
            #    print "fromcell"
            #    print fromCell
            #    print "ToCell"
            #    print ToCell
                
        #fromCellValue=FromCellValueIncrements*(fromCell+1)
        #if(ToCellTotalValue>=fromCellValue):  #no point connecting an EXK value (where the number of neurons fired represent the total EXK value (current EXK value + previous EXK values) which is > the F total value (represented by the current F neuron (total F value = current F neuron + previous F neurons)
        
        
            #    print "tocellvalue"
            #    print ToCellTotalValue
        #print "fromcellvalue"
        #print fromCellValue
        #print "minfromcellvalue"
        #print MinFromCellValue
            #    print "FromCellValueIncrements"
            #    print FromCellValueIncrements*PosORNeg

            #    print "PosORNeg"
            #    print PosORNeg
        #PosORNeg=PosOrNegNeurons(MinFromCellValue, FromCellValueIncrements, fromCell+1)
        
            ValueDif=(FromCellValueIncrements*PosORNeg)/ToCellTotalValue   #the percentage difference between the toValue and the FromValue
        
            wt=abs(minWeight*ValueDif)
            wt=round(wt,100)
        #####cant stop connecting from neurons (from the same populaion) to an output neuron as we do not know whatc values the
        #####the other populations will send.  For example E1X1K1 neuron 0==-0.5, might activate output neuron 0 == -0.5, however, if
        #####E2X2K2 neuron 0 is 0.5, that would negate the value from E1X1K1 neuron 0, therefore, preventing the output neuron 0 from firing
        #####Therefore, we might need the extra neurons in a population (vs the extra negating neurons in another population)  to fire to activate the output
        #the percentage of MinWeight to give to the connection. minWeight=0.065 will make the post synaptic neuron fire                 
        #if (TotalWt+wt)>=minWeight:                          #we now know the toNeuron will fire when this from neuron is activated, therefore, there is no point connecting higher valued from neurons to the to neuron
        #    wt=minWeight-TotalWt
        #    StopConnectionsToNeuron=1            #stop connections to higher valued neurons
        #    print "total weight for activation of output neuron %s has been reached" % str(ToCell)
        #else:
        #    TotalWt+=wt                          #keep a record of the previous wt connections of the previous from neurons to the particular to neuron
            #if(ToCell==tocellnum):
            #    print "wt"
            #    print wt
            #    print "minweight"
            #    print minWeight
            #    print "TotalWt"
            #    print TotalWt
        #print "StopConnectionsToNeuron"
        #print StopConnectionsToNeuron
        #print "ToCellTotalVAlue"
        #print ToCellTotalValue
        
            #if(((PosORNeg==-1)and(ToCellTotalValue<0))or((PosORNeg==1)and(ToCellTotalValue>0))):
                #conn='excitatory'
            if(ToCellTotalValue<0):
                ExcConnector += [(fromCell,ToCell,abs(wt),synDelay)]
            else:
                ExcConnector += [(fromCell+TotalNumNegCells,ToCell,abs(wt),synDelay)]
            #    if(ToCell==tocellnum): 
                    #print "making excitatory connection"
            #else:
                #conn='inhibitory'
            #    InhConnector += [(fromCell,ToCell,abs(wt)),nealParameters.DELAY)] #0.7905 (calculated by hand)  is a constant to decrease the inhibition when the weighting gets higher, this prevents cells that should be firing to fire.
            #    if(ToCell==tocellnum): 
            #        print "making inhibitory connection"
        #connector += [(fromCell,ToCell,abs(wt),nealParameters.DELAY)]
        #ExhOrInh+=[conn]
     #   fromCell+=1
        #if(StopConnectionsToNeuron==1):
        #    print "stop connecting the from cells to %s" % str(ToCell)
        #    pause() 
        #    break                   #break from connecting the from neurons to the particular to neuron as all of the from neurons so far would activate the to neuron
        #if(ToCell==tocellnum): 
                    
         #   print "PLUSconnections"
            #print WhichInputPop
         #   print ExcConnector
            #print InhConnector
            ####self.pause()                            

        return [ExcConnector]
        
    def makePlusConnections(self, NumFromCells, ToCell, FromCellValueIncrements, minWeight, ToCellTotalValue):
        #print "inside make plus connections"
        ##the first neurons in a population represent negative values (if any otherwise they all represent positive values)
        ###NOTE WE STOPPED OVER CONNECTION STRENGTH WITHIN EACH EXK POPULATION BUT WE NOW NEED TO INHIBIT THE VOLTAGE BETWEEN THE EXK POPULATIONS
        TotalNumCells=NumFromCells[0]
        TotalNumNegCells=NumFromCells[1]
        ExcConnector=[]
        InhConnector=[]
        #ExhOrInh=[]
        #StopConnectionsToNeuron=0
        TotalWt=0
        #fromCell=0
        PosORNeg=-1
        tocellnum=47
        #0.0756
        for fromCell in range(0, TotalNumCells):
        #while ((StopConnectionsToNeuron==0)and(fromCell<TotalNumNegCells)):
       # for fromCell in range(0, NumFromCells):
            if(fromCell==TotalNumNegCells):
                PosORNeg=1
         #   if(ToCell==tocellnum):
         #       print "MAKECONNECTION"
         #       print "Totalnumcells"
         #       print TotalNumCells
         #       print "fromcell"
         #       print fromCell
         #       print "ToCell"
         #       print ToCell
                
        #fromCellValue=FromCellValueIncrements*(fromCell+1)
        #if(ToCellTotalValue>=fromCellValue):  #no point connecting an EXK value (where the number of neurons fired represent the total EXK value (current EXK value + previous EXK values) which is > the F total value (represented by the current F neuron (total F value = current F neuron + previous F neurons)
        
        
         #       print "tocellvalue"
         #       print ToCellTotalValue
        #print "fromcellvalue"
        #print fromCellValue
        #print "minfromcellvalue"
        #print MinFromCellValue
         #       print "FromCellValueIncrements"
         #       print FromCellValueIncrements*PosORNeg

         #       print "PosORNeg"
         #       print PosORNeg
        #PosORNeg=PosOrNegNeurons(MinFromCellValue, FromCellValueIncrements, fromCell+1)
        
            ValueDif=(FromCellValueIncrements*PosORNeg)/ToCellTotalValue   #the percentage difference between the toValue and the FromValue
        
            wt=abs(minWeight*ValueDif)
            wt=round(wt,4)
        #####cant stop connecting from neurons (from the same populaion) to an output neuron as we do not know whatc values the
        #####the other populations will send.  For example E1X1K1 neuron 0==-0.5, might activate output neuron 0 == -0.5, however, if
        #####E2X2K2 neuron 0 is 0.5, that would negate the value from E1X1K1 neuron 0, therefore, preventing the output neuron 0 from firing
        #####Therefore, we might need the extra neurons in a population (vs the extra negating neurons in another population)  to fire to activate the output
        #the percentage of MinWeight to give to the connection. minWeight=0.065 will make the post synaptic neuron fire                 
        #if (TotalWt+wt)>=minWeight:                          #we now know the toNeuron will fire when this from neuron is activated, therefore, there is no point connecting higher valued from neurons to the to neuron
        #    wt=minWeight-TotalWt
        #    StopConnectionsToNeuron=1            #stop connections to higher valued neurons
        #    print "total weight for activation of output neuron %s has been reached" % str(ToCell)
        #else:
        #    TotalWt+=wt                          #keep a record of the previous wt connections of the previous from neurons to the particular to neuron
          #  if(ToCell==tocellnum):
          #      print "wt"
          #      print wt
          #      print "minweight"
          #      print minWeight
          #      print "TotalWt"
          #      print TotalWt
        #print "StopConnectionsToNeuron"
        #print StopConnectionsToNeuron
        #print "ToCellTotalVAlue"
        #print ToCellTotalValue
        
            if(((PosORNeg==-1)and(ToCellTotalValue<0))or((PosORNeg==1)and(ToCellTotalValue>0))):
                #conn='excitatory'
                ExcConnector += [(fromCell,ToCell,abs(wt),nealParameters.DELAY)]
           #     if(ToCell==tocellnum): 
           #         print "making excitatory connection"
            else:
                #conn='inhibitory'
                InhConnector += [(fromCell,ToCell,round(abs(wt)*0.7875,4),nealParameters.DELAY)] #0.7905 (calculated by hand)  is a constant to decrease the inhibition when the weighting gets higher, this prevents cells that should be firing to fire.
           #     if(ToCell==tocellnum): 
           #         print "making inhibitory connection"
        #connector += [(fromCell,ToCell,abs(wt),nealParameters.DELAY)]
        #ExhOrInh+=[conn]
     #   fromCell+=1
        #if(StopConnectionsToNeuron==1):
        #    print "stop connecting the from cells to %s" % str(ToCell)
        #    pause() 
        #    break                   #break from connecting the from neurons to the particular to neuron as all of the from neurons so far would activate the to neuron
        #if(ToCell==tocellnum): 
                    
        #    print "PLUSconnections"
            #print WhichInputPop
        #    print ExcConnector
        #    print InhConnector
            ####self.pause()                            

        return [ExcConnector, InhConnector]
        """
def PosOrNegNeurons(minVal, increments, WhichNeuron):
    if((minVal<0)and(minVal<(increments*WhichNeuron*-1))):  #use negative neurons if negative min, however once the to tal value goes outside min use positive neurons
        PosORNeg=-1
    else:
        PosORNeg=1 #use positive neurons for the result of the population

    return PosORNeg
        """
    def summationTwoPopsV2(self, InputPops1, InputPops2, OutputPops, Input1Incr, Input2Incr, OutputIncr, numOutcells, numIn1Cells, numIn2Cells, minWeight, IntermediatePops1, IntermediatePops2, IntermediateOutPops):
    # The size of the post-synaptic response (the “synaptic weight”), the temporal dynamics of the weight (synaptic plasticity) and the connection delay are handled by synapse models.
    #output values for each Force neuron
    #outFValueincrements=CalculateIncrement(maxF,minF,numFcells)
    #NOTE: We cannot know whether a set of EXK neurons can activate an F output neuron even though the total of thh we EXK neurons is > the f output neuron.
    #       this is because we do not know whether the other sets of EXK neurons contains a positive or negative value when, therfore, when summed, may cause
    #       the higher valued EXK neuron population to decrease


    #####the first neurons in a population represent negative values (if any otherwise they all represent positive values)
        totalnumOutneurons=numOutcells[0]
        totalNegnumOutneurons=numOutcells[1]
    #totalNegnumFneurons=numFcells[2]
        print "inconnectfunction"
        """
    #
    #print "maxF"
    #print maxF
    #print "minF"
   # print minF
   # print "numFcells"
   # print numFcells
    #print adfds
   # EXKValueincrements=np.zeros(numSets)
    #EMinusXMultKFromNeuron=np.zeros(numSets)
    
    #for i in range(0,numSets):
    #    EXKValueincrements[i]=CalculateIncrement(maxEminusXMultKarray[i], minEminusXMultKarray[i], numEXKcells[i]) 
        #(maxEminusXMultKarray[i]-minEminusXMultKarray[i])/numEXKcells[i]
     #   print "i"
     #   print i
     #   print "increments"
     #   print EXKValueincrements[i]
     #   print "max"
     #   print maxEminusXMultKarray[i]
     #   print "min"
    #    print minEminusXMultKarray[i]
     #   print "numcells"
     #   print numEXKcells[i]
        #EXKValueincrements[1]=(maxEminusXMultKarray[1]-minEminusXMultKarray[1])/numE2X2K2cells
        #EXKValueincrements[2]=(maxEminusXMultKarray[2]-minEminusXMultKarray[2])/numE3X3K3cells
       # EXKValueincrements[3]=(maxEminusXMultKarray[3]-minEminusXMultKarray[3])/numE4X4K4cells

    

    #wt1 = minWeight/numE1X1K1cells   #0.0665 is the min (with all the above variables) to make one cell make another cell fire  #weight is in microsiemens as IF_cond_exp has a post-synaptic mechanism which implements a change in conductance. delays are in milliseconds
    #wt2 = minWeight/numE2X2K2cells
    #wt3 = minWeight/numE3X3K3cells
    #wt4 = minWeight/numE4X4K4cells
    
    E1X1K1celltoFconnector = []
    E2X2K2celltoFconnector = []
    E3X3K3celltoFconnector = []
    E4X4K4celltoFconnector = []

    numStates=len(varValues) #number of rows
    numVariables=len(varValues[0]) #number of columns

    E1MinusX1MultK1Values=[row[4] for row in varValues]
    E2MinusX2MultK2Values=[row[9] for row in varValues]
    E3MinusX3MultK3Values=[row[14] for row in varValues]
    E4MinusX4MultK4Values=[row[19] for row in varValues]

    EMinusXMultKValues=[E1MinusX1MultK1Values, E2MinusX2MultK2Values, E3MinusX3MultK3Values, E4MinusX4MultK4Values]
    
    FValues=[row[20] for row in varValues]

    alreadyconnected=np.zeros(numFcells)
    
    print numStates
    print numVariables
    print E1MinusX1MultK1Values
    print E2MinusX2MultK2Values
    print E3MinusX3MultK3Values
    print E4MinusX4MultK4Values

    print "increments"
    print outFValueincrements
    print EXKValueincrements[0]
    print EXKValueincrements[1]
    print EXKValueincrements[2]
    print EXKValueincrements[3]

    print minF
    print maxF
    print maxEminusXMultKarray[0]
    print maxEminusXMultKarray[1]
    print maxEminusXMultKarray[2]
    print maxEminusXMultKarray[3]
    print minEminusXMultKarray[0]
    print minEminusXMultKarray[1]
    print minEminusXMultKarray[2]
    print minEminusXMultKarray[3]
    
    print "FValues"
    print FValues
        """
    #EXKPopExcToFConn=[[] for k in range(numSets)]  #set up numSets sets of empty lists in an array
    #EXKPopInhToFConn=[[] for k in range(numSets)]  #set up numSets sets of empty lists in an array
        ExcConnector1=[]
        #INHconnections=[]
        ExcConnector2=[]     #excitatory connections
        INHConnector2=[]
        INHConnector1=[]
        printinconn2=[]
        printinconn1=[]
        printconn1=[]
        printconn2=[]
                        #printinconn2=[]
                        #printinconn1=[]        
        #INHconnections2=[]    #inhibitory connections    
    #numNegNeurons=0
        toNeuronTotalValue=0
        PosOrNeg=-1                                      #set the value that each neuron represents as positive or negative
        TotalNumCellsIn1=numIn1Cells[0]
        TotalNumNegCellsIn1=numIn1Cells[1]

        TotalNumCellsIn2=numIn2Cells[0]
        TotalNumNegCellsIn2=numIn2Cells[1]
        In1NeuronTotalValue=0
        In2NeuronTotalValue=0
        alreadyconnectedIn1=zeros(TotalNumCellsIn1)
        alreadyconnectedIn2=zeros(TotalNumCellsIn2)
        
        ##connect input populations to intermediate populations
        ####Inhibit the cells below the total input value, i.e. so that only one cell is activated which represents the total value coming in
        IntExcConnector1=[] #excite connections between the intermediate population and the input and output populations
        IntExcConnector2=[] #excite connections between the intermediate population and the input and output populations
        IntINHConnector1=[] #inhibit connections between the intermediate population and the input and output populations
        IntINHConnector2=[] #inhibit connections between the intermediate population and the input and output populations

        for in1Neuron in range(0, TotalNumCellsIn1):
            IntExcConnector1+=[(in1Neuron,in1Neuron,minWeight,nealParameters.DELAY)]
            if((in1Neuron!=0)and(in1Neuron!=TotalNumNegCellsIn1)):
                IntINHConnector1+=[(in1Neuron,in1Neuron-1,minWeight,nealParameters.DELAY)]

        for in2Neuron in range(0, TotalNumCellsIn2):    
            IntExcConnector2+=[(in2Neuron,in2Neuron,minWeight,nealParameters.DELAY)]
            if((in2Neuron!=0)and(in2Neuron!=TotalNumNegCellsIn2)):
                IntINHConnector2+=[(in2Neuron,in2Neuron-1,minWeight,nealParameters.DELAY)]

        connList = self.sim.FromListConnector(IntExcConnector1)
        exc_connections=self.sim.Projection(InputPops1, IntermediatePops1, connList, receptor_type='excitatory')
        connList = self.sim.FromListConnector(IntExcConnector2)
        exc_connections=self.sim.Projection(InputPops2, IntermediatePops2, connList, receptor_type='excitatory')
        connList = self.sim.FromListConnector(IntINHConnector1)
        exc_connections=self.sim.Projection(InputPops1, IntermediatePops1, connList, receptor_type='inhibitory')
        connList = self.sim.FromListConnector(IntINHConnector2)
        inh_connections=self.sim.Projection(InputPops2, IntermediatePops2, connList, receptor_type='inhibitory')

        ##connect intermediate population to intermediate output population
        for toNeuron in range(0, totalnumOutneurons):           
            #print "connections"
            #print "toFneuron"
            #print toNeuron
        #PosORNeg=PosOrNegNeurons(minF, outFValueincrements, toFneuron)
        ##calculate which neurons in the population represent positive or negative values (if negative and positive valued neurons, the first neurons will represent
        #negative neurons.
        
        #if((minF>0)or(((minF+(outFValueincrements*(toFneuron+1)))>=0)and(PosOrNeg==-1)and(toFneuron>0))):
       #     numOfNegNeurons=toFneuron
       #     PosOrNeg=1
            if(totalNegnumOutneurons>toNeuron):
                toNeuronTotalValue+=OutputIncr*-1   
            else:
                if(totalNegnumOutneurons==toNeuron):
                    toNeuronTotalValue=OutputIncr
                else:
                    toNeuronTotalValue+=OutputIncr    
            """
        print "toFneuronTotalValue"
        print toFneuronTotalValue
        print "minF"
        print minF
        print "outFValueincrements"
        print outFValueincrements
            """
            In1NeuronTotalValue=0
            for In1Cell in range(0,TotalNumCellsIn1):
                if(TotalNumNegCellsIn1>In1Cell):
                    In1NeuronTotalValue+=Input1Incr*-1
                    PosOrNeg=-1
                else:
                    PosOrNeg=1
                    if(TotalNumNegCellsIn1==In1Cell):
                        In1NeuronTotalValue=Input1Incr
                    else:
                        In1NeuronTotalValue+=Input1Incr
                In2NeuronTotalValue=0
                if((round(In1NeuronTotalValue,2)==round(toNeuronTotalValue,2))and(alreadyconnectedIn1[In1Cell]==0)):
                    ExcConnector1 += [(In1Cell,toNeuron,minWeight,nealParameters.DELAY)]
                    print "in1single"
                    print "connections"
                    print [(In1Cell,toNeuron,minWeight,nealParameters.DELAY)]
                    print "In1 Cell num"
                    print In1Cell
                    print "In1 total value"
                    print In1NeuronTotalValue
                    print "Output value"
                    print toNeuronTotalValue
                    print "to neuron value num"
                    print toNeuron
                    #In1NeuronTotalValue=0
                    alreadyconnectedIn1[In1Cell]=1
                    print "alreadyconnected"
                    print alreadyconnectedIn1
                    #if(In1Cell==37):
                        ####self.pause()
                for In2Cell in range(0,TotalNumCellsIn2):
                    if(TotalNumNegCellsIn2>In2Cell):
                        In2NeuronTotalValue+=Input2Incr*-1
                    else:
                        if(TotalNumNegCellsIn2==In2Cell):
                            In2NeuronTotalValue=Input2Incr
                        else:
                            In2NeuronTotalValue+=Input2Incr
                    

                    if((round(In2NeuronTotalValue,2)==round(toNeuronTotalValue,2))and(alreadyconnectedIn2[In2Cell]==0)):
                        ExcConnector2 += [(In2Cell,toNeuron,minWeight,nealParameters.DELAY)]
                        print "in2single"
                        print "connections"
                        print [(In2Cell,toNeuron,minWeight,nealParameters.DELAY)]
                        print "In2 Cell num"
                        print In2Cell
                        print "In2 total value"
                        print In2NeuronTotalValue
                        print "Output value"
                        print toNeuronTotalValue
                        print "to neuron value num"
                        print toNeuron
                        
                        
                        alreadyconnectedIn2[In2Cell]=1
                        print "alreadyconnected"
                        print alreadyconnectedIn2
                        #if(In2Cell==9):
                        ####self.pause()
                    #if(toNeuron==23):
                    #    print "IN2NEURON VALUE"
                    #    print In2NeuronTotalValue
                    #    print "IN1NEURON VALUE"
                    #    print In1NeuronTotalValue
                    #    print "TO NEURON VALUE"
                    #    print toNeuronTotalValue
                    #    print In2NeuronTotalValue+In1NeuronTotalValue
                    if((round(In2NeuronTotalValue+In1NeuronTotalValue,2))==round(toNeuronTotalValue,2)):  #we only want one cell to activate which represent the input value. we want to connect the input values to the output value and all the cells below the output value.  we also need to inhibit the output value (if not within the output values) that each single input will activate
                    #    print "INIF............................................."
                        printconn1=[]
                        printconn2=[]
                        printinconn2=[]
                        printinconn1=[]
                        doNotInhibit2=0
                        doNotInhibit1=0
                        total=round(abs(In2NeuronTotalValue)+abs(In1NeuronTotalValue),2)
                        if(totalNegnumOutneurons>toNeuron):
                            toNeuronTotal=Input1Incr*-1
                            
                            wt=abs(round(In2NeuronTotalValue/total,2))
                            ExcConnector2 += [(In2Cell,toNeuron,round(minWeight*wt,2),nealParameters.DELAY)]
                            printconn2+=[(In2Cell,toNeuron,round(minWeight*wt,2),nealParameters.DELAY)]
                            wt=abs(round(In1NeuronTotalValue/total,2))
                            ExcConnector1 += [(In1Cell,toNeuron,round(minWeight*wt,2),nealParameters.DELAY)]
                            printconn1+=[(In1Cell,toNeuron,round(minWeight*wt,2),nealParameters.DELAY)]                            
                            for i in range(0, toNeuron+1):
                                if(round(In2NeuronTotalValue,2)==round(toNeuronTotal,2)):
                                    doNotInhibit2=1
                                    print "donotinhbit2"
                                toNeuronTotal+=Input1Incr*-1
                            toNeuronTotal=Input1Incr*-1
                            for i in range(0, toNeuron+1):
                                if(round(In1NeuronTotalValue,2)==round(toNeuronTotal,2)):
                                    doNotInhibit1=1
                                    print "donotinhbit1"
                                toNeuronTotal+=Input1Incr*-1
                            if(doNotInhibit2==0):                               
                                INHConnector2 += [(In1Cell,In2Cell,minWeight,nealParameters.DELAY)]  #the value at in2cell will be in the same place in the output cell when the values are negative
                                printinconn2+=[(In1Cell,In2Cell,minWeight,nealParameters.DELAY)]
                            if(doNotInhibit1==0):                               
                                INHConnector1 += [(In2Cell,In1Cell,minWeight,nealParameters.DELAY)]  #the value at in1cell will be in the same place in the output cell when the values are negative
                                printinconn1+=[(In2Cell,In1Cell,minWeight,nealParameters.DELAY)]
                        else:
                            toNeuronTotal=Input1Incr
                            wt=abs(round(In2NeuronTotalValue/total,2))
                            ExcConnector2 += [(In2Cell,toNeuron,round(minWeight*wt,2),nealParameters.DELAY)]
                            printconn2+=[(In2Cell,toNeuron,round(minWeight*wt,2),nealParameters.DELAY)]
                            wt=abs(round(In1NeuronTotalValue/total,2))
                            ExcConnector1 += [(In1Cell,toNeuron,round(minWeight*wt,2),nealParameters.DELAY)]
                            printconn1+=[(In1Cell,toNeuron,round(minWeight*wt,2),nealParameters.DELAY)]                            
                            for i in range(0, toNeuron-totalNegnumOutneurons+1):          ##connect all the neurons under the active output (in terms of value) to the one activated intermediate neuron
                                if(round(In2NeuronTotalValue,2)==round(toNeuronTotal,2)):
                                    doNotInhibit2=1
                                    print "donotinhbit2"
                                toNeuronTotal+=Input1Incr
                            toNeuronTotal+=Input1Incr
                            for i in range(0, toNeuron-totalNegnumOutneurons+1):
                                if(round(In1NeuronTotalValue,2)==round(toNeuronTotal,2)):
                                    doNotInhibit1=1
                                    print "donotinhbit1"
                                toNeuronTotal+=Input1Incr
                            if(doNotInhibit2==0):                               #inhibit the output neuron which is equal to the intermediate neuron (which is not activated within the summation) otherwise this will be activated when it shouldnt be
                                if(round(In2NeuronTotalValue,2)>0):
                                    INHConnector2 += [(In1Cell,In2Cell+int(round(totalNegnumOutneurons/2)),minWeight,nealParameters.DELAY)]  #the value at in2cell will be in the same place in the output cell when the values are negative
                                    printinconn2+=[(In1Cell,In2Cell+int(round(totalNegnumOutneurons/2)),minWeight,nealParameters.DELAY)]
                                else:
                                    INHConnector2 += [(In1Cell,In2Cell,minWeight,nealParameters.DELAY)]  #the value at in2cell will be in the same place in the output cell when the values are negative
                                    printinconn2+=[(In1Cell,In2Cell,minWeight,nealParameters.DELAY)]                 
                            if(doNotInhibit1==0):
                                if(round(In1NeuronTotalValue,2)>0):
                                    INHConnector1 += [(In2Cell,In1Cell+int(round(totalNegnumOutneurons/2)),minWeight,nealParameters.DELAY)]  #the value at in1cell will be in the same place in the output cell when the values are negative
                                    printinconn1+=[(In2Cell,In1Cell+int(round(totalNegnumOutneurons/2)),minWeight,nealParameters.DELAY)]
                                else:
                                    INHConnector1 += [(In2Cell,In1Cell,minWeight,nealParameters.DELAY)]  #the value at in1cell will be in the same place in the output cell when the values are negative
                                    printinconn1+=[(In2Cell,In1Cell,minWeight,nealParameters.DELAY)]                                    
                                
                        #ExcConnector1 += [(In1Cell,toNeuron,minWeight/2,nealParameters.DELAY)]
                        
                        print "in1pair"
                        print "exc connections"
                        print printconn1
                        print "inh connections"
                        print printinconn1
                        print "In1 Cell num"
                        print In1Cell
                        print "In1 total value"
                        print In1NeuronTotalValue
                        #print "Output value"
                        #print toNeuronTotalValue
                        #print "to neuron value num"
                        #print toNeuron
                        print "in2pair"
                        print "exc connections"
                        print printconn2
                        print "inh connections"
                        print printinconn2                        
                        print "In2 Cell num"
                        print In2Cell
                        print "In2 total value"
                        print In2NeuronTotalValue
                        print "Output value"
                        print toNeuronTotalValue
                        print "to neuron value num"
                        print toNeuron
                        #if(((toNeuron==40)and(In1Cell==37))or((toNeuron==40)and(In2Cell==9))):
                        #if(((In2Cell==9)and((In1Cell+int(round(totalNegnumOutneurons/2)))==47))or((In1Cell==37)and((In2Cell+int(round(totalNegnumOutneurons/2)))==47))):
                            ####self.pause()
        
            
        #E1X1K1cells
            #connections=[]
       #     for i in range(0, 2):
            #print "make E %s X %s K %s cells connections" % (i,i,i) 
       #         if(i==0):
       #             connections=self.makePlusConnections(numIn1Cells, toNeuron, Input1Incr, minWeight, toNeuronTotalValue)
       #             EXConnections+=connections[0]     #excitatory connections            
        #            INHconnections+=connections[1]     #inhibitory connections
        #        else:
        #            connections=self.makePlusConnections(numIn2Cells, toNeuron, Input2Incr, minWeight, toNeuronTotalValue)
        #            EXConnections2+=connections[0]     #excitatory connections            
        #           INHconnections2+=connections[1]     #inhibitory connections
        #E1X1K1celltoFconnector += connections
        
        #E2X2K2cells
        #print "make E2X2K2cells connections"
        #connections=makePlusConnections(numEXKcells[1], toFneuron, EXKValueincrements[1], minEminusXMultKarray[1], minWeight, toFneuronTotalValue)
        #E2X2K2celltoFconnector += connections
        #E3X3K3cells
        #print "make E3X3K3cells connections"
        #connections=makePlusConnections(numEXKcells[2], toFneuron, EXKValueincrements[2], minEminusXMultKarray[2], minWeight, toFneuronTotalValue)
        #E3X3K3celltoFconnector += connections
        #E4X4K4cells
        #print "make E4X4K4cells connections"
        #connections=makePlusConnections(numEXKcells[3], toFneuron, EXKValueincrements[3], minEminusXMultKarray[3], minWeight, toFneuronTotalValue)
        #E4X4K4celtoFconnector += connections        

    #for i in range(0, numSets):
            
        
        #neal.nealProjection(EMinusXMultKCells[i], FOutputCells, EXKPopExcToFConn[i], 'excitatory')  #excitatory
        #neal.nealProjection(EMinusXMultKCells[i], FOutputCells, EXKPopInhToFConn[i], 'inhibitory')  #inhibitory
        #print EXConnections

        #print INHConnector1
        #print INHConnector2

        #ExcConnector1=[(37,47,minWeight/2,nealParameters.DELAY)]
        #ExcConnector1+=[(36,45,minWeight/3,nealParameters.DELAY)]
        #ExcConnector2=[(9,47,minWeight/2,nealParameters.DELAY)]
        #ExcConnector2+=[(8,46,minWeight/2,nealParameters.DELAY)]
        
        connList = self.sim.FromListConnector(ExcConnector1)
        exc_connections=self.sim.Projection(IntermediatePops1, IntermediateOutPops, connList, receptor_type='excitatory')
        connList = self.sim.FromListConnector(ExcConnector2)
        exc_connections=self.sim.Projection(IntermediatePops2, IntermediateOutPops, connList, receptor_type='excitatory')
        connList = self.sim.FromListConnector(INHConnector2)
        exc_connections=self.sim.Projection(IntermediatePops1, IntermediateOutPops, connList, receptor_type='inhibitory')
        connList = self.sim.FromListConnector(INHConnector1)
        inh_connections=self.sim.Projection(IntermediatePops2, IntermediateOutPops, connList, receptor_type='inhibitory')


        ##connect intermediate output pop to output pop
                
        ExcConnector3=[]
        for outNeuron in range(0, totalnumOutneurons):
            ExcConnector3+=[(outNeuron,outNeuron,minWeight,nealParameters.DELAY)]
            if((outNeuron!=0)and(outNeuron!=totalNegnumOutneurons)):
                if(totalNegnumOutneurons>toNeuron):
                    for i in range(0, outNeuron+1):
                        ExcConnector3+=[(outNeuron,i,minWeight,nealParameters.DELAY)]
                else:
                    for i in range(0, outNeuron-totalNegnumOutneurons+1):
                        ExcConnector3+=[(outNeuron,i+totalNegnumOutneurons,minWeight,nealParameters.DELAY)]
        

        connList = self.sim.FromListConnector(ExcConnector3)
        exc_connections=self.sim.Projection(IntermediateOutPops, OutputPops, connList, receptor_type='excitatory')


        """
        print "exc connections"
        print exc_connections.get(["weight", "delay"], format="list")
        pause()
        print "inh connections"
        print inh_connections.get(["weight", "delay"], format="list")
        pause()
        """
        """
        #self.sim.Projection(EMinusXMultKCells[i], FOutputCells, connector=EXKPopToFConn[i], receptor_type='inhibitory')
    #neal.nealProjection(E2MinusX2MultK2Cells, FOutputCells, E2X2K2celltoFconnector,'excitatory')
    #neal.nealProjection(E3MinusX3MultK3Cells, FOutputCells, E3X3K3celltoFconnector,'excitatory')
    #neal.nealProjection(E4MinusX4MultK4Cells, FOutputCells, E4X4K4celltoFconnector,'excitatory')
        print "NEALADFLASJFLKSAJDFLKAJSDFLJ"
        print "i"
        print i
        print EMinusXMultKCells[i]
        print FOutputCells
        print EXKPopExcToFConn[i]
        print EXKPopInhToFConn[i]
        
    print "CONNNNLKJADLKFJALKDFJASLKJFDLKDSJ"
    print EXKPopExcToFConn[3]
    print EXKPopInhToFConn[3]
    print EMinusXMultKCells[3]
        """
        """   
    for i in range(0,numStates):
        print "i"
        print i
        print "values"
        #F=0
        toFneuron=int(round((FValues[i]-minF)/outFValueincrements))
        if(alreadyconnected[toFneuron-1]==0):
            alreadyconnected[toFneuron-1]=1
            print "Fvalues"
            print(FValues[i])
            print minF
            print outFValueincrements
            NumNeuronsToEachF=0
            for j in range(0,4):
                #F+=E1MinusX1MultK1Values[i]
                Value=EMinusXMultKValues[j]
                EMinusXMultKFromNeuron[j]=round((Value[i]-minEminusXMultKarray[j])/EXKValueincrements[j])
                print "I"
                print Value[i]
                print minEminusXMultKarray[j]
                print EXKValueincrements[j]
            
                NumNeuronsToEachF+=EMinusXMultKFromNeuron[j]
        
            wt = minWeight/NumNeuronsToEachF
            print "parameters"
            print toFneuron
            print NumNeuronsToEachF
            print EMinusXMultKFromNeuron
        
        
            for j in range(0,4):   
                for k in range(0, int(EMinusXMultKFromNeuron[j])):
                    for l in range(0,toFneuron):
                        if(j==0):  #E1-X1*K1
                            connector = connector + [(k,l,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
                        elif(j==1):#E2-X2*K2
                            connector2 = connector2 + [(k,l,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
                        elif(j==2):#E3-X3*K3
                            connector3 = connector3 + [(k,l,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
                        else:#E4-X4*K4
                            connector4 = connector4 + [(k,l,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
        #connector = connector + [(EMinusXMultKFromNeuron[0],toFneuron,wt1,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
       # connector2 = connector2 + [(EMinusXMultKFromNeuron[1],toFneuron,wt2,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
       # connector3 = connector3 + [(EMinusXMultKFromNeuron[2],toFneuron,wt3,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
       # connector4 = connector4 + [(EMinusXMultKFromNeuron[3],toFneuron,wt4,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
    
            neal.nealProjection(E1MinusX1MultK1Cells, FOutputCells, connector,'excitatory')
            neal.nealProjection(E2MinusX2MultK2Cells, FOutputCells, connector2,'excitatory')
            neal.nealProjection(E3MinusX3MultK3Cells, FOutputCells, connector3,'excitatory')
            neal.nealProjection(E4MinusX4MultK4Cells, FOutputCells, connector4,'excitatory')
        
        
 #       for j in range(0,numE2X2K2cells):
 #           print "j"
 #           print j
 #           for k in range(0,numE3X3K3cells):
 #               for l in range(0,numE4X4K4cells):
 #                   F=minEminusXMultKarray[0]+(i*E1X1K1Valueincrements)+minEminusXMultKarray[1]+(j*E2X2K2Valueincrements)+minEminusXMultKarray[2]+(k*E3X3K3Valueincrements)+minEminusXMultKarray[3]+(l*E4X4K4Valueincrements)
 #                   toFneuron=round((F-minF)/outFValueincrements)
                    
#                    connector = connector + [(i,toFneuron,wt1,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
#                    connector2 = connector2 + [(j,toFneuron,wt2,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
#                    connector3 = connector3 + [(k,toFneuron,wt3,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
#                    connector4 = connector4 + [(l,toFneuron,wt4,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
#    
#    neal.nealProjection(E1MinusX1MultK1Cells, FOutputCells, connector,'excitatory')
#    neal.nealProjection(E2MinusX2MultK2Cells, FOutputCells, connector2,'excitatory')
#    neal.nealProjection(E3MinusX3MultK3Cells, FOutputCells, connector3,'excitatory')
#    neal.nealProjection(E4MinusX4MultK4Cells, FOutputCells, connector4,'excitatory')
                                       
#    wt = minWeight/NumInputNeurons   #0.0665 is the min (with all the above variables) to make one cell make another cell fire  #weight is in microsiemens as IF_cond_exp has a post-synaptic mechanism which implements a change in conductance. delays are in milliseconds
#    connector = []
    #fromNeuron=0
#    toNeuron = 0
#    for InputNeuron in range (0,numInputNeurons):
#        fromNeuron = InputNeuron
     #   theta = fromOffset/float(100)
     #   currentSinRound = round(sin(theta),2)
     #   earlierSinRound = round(sin(theta-0.01),2)
    #    if (earlierSinRound < currentSinRound):
#        connector = connector + [(fromNeuron,toNeuron,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
        #toNeuron = toNeuron + 1 connect to next neuro

#    neal.nealProjection(fromNeurons, toNeurons, connector,'excitatory') 
        """
        print "finished"
    #return [EXKValueincrements, outFValueincrements]
        """
def connectToFOutput(E1MinusX1MultK1Cells,E2MinusX2MultK2Cells,E3MinusX3MultK3Cells, E4MinusX4MultK4Cells, FOutputCells, minEminusXMultKarray, maxEminusXMultKarray, minF, maxF, numFcells, numE1X1K1cells, numE2X2K2cells, numE3X3K3cells, numE4X4K4cells, minWeight):
    # The size of the post-synaptic response (the “synaptic weight”), the temporal dynamics of the weight (synaptic plasticity) and the connection delay are handled by synapse models.
    #output values for each Force neuron
      #this calculates every F result (and therefore every possible set of connections) for every possible combination of (E-X)*K cells (value).  However, this it too slow if we have 100 neurons in each of the 4 populations, i.e. 100^4 calculations (this is also the same every calculate every possible combination of values for each F output)
     # we could randomly choose a cell out of each of the 4 populations to connect to the correct F cell but the cells connected may never be used 
    
    outFValueincrements=(maxF-minF)/numFcells
    E1X1K1Valueincrements=(maxEminusXMultKarray[0]-minEminusXMultKarray[0])/numE1X1K1cells
    E2X2K2Valueincrements=(maxEminusXMultKarray[1]-minEminusXMultKarray[1])/numE2X2K2cells
    E3X3K3Valueincrements=(maxEminusXMultKarray[2]-minEminusXMultKarray[2])/numE3X3K3cells
    E4X4K4Valueincrements=(maxEminusXMultKarray[3]-minEminusXMultKarray[3])/numE4X4K4cells

    wt1 = minWeight/numE1X1K1cells   #0.0665 is the min (with all the above variables) to make one cell make another cell fire  #weight is in microsiemens as IF_cond_exp has a post-synaptic mechanism which implements a change in conductance. delays are in milliseconds
    wt2 = minWeight/numE2X2K2cells
    wt3 = minWeight/numE3X3K3cells
    wt4 = minWeight/numE4X4K4cells

    connector = []
    connector2 = []
    connector3 = []
    connector4 = []

    print "increments"
    print outFValueincrements
    print E1X1K1Valueincrements
    print E2X2K2Valueincrements
    print E3X3K3Valueincrements
    print E4X4K4Valueincrements

    print minF
    print maxF
    print maxEminusXMultKarray[0]
    print maxEminusXMultKarray[1]
    print maxEminusXMultKarray[2]
    print maxEminusXMultKarray[3]
    print minEminusXMultKarray[0]
    print minEminusXMultKarray[1]
    print minEminusXMultKarray[2]
    print minEminusXMultKarray[3]
    
    
    for i in range(0,numE1X1K1cells):
        print "i"
        print i
        
        for j in range(0,numE2X2K2cells):
            print "j"
            print j
            for k in range(0,numE3X3K3cells):
                for l in range(0,numE4X4K4cells):
                    F=minEminusXMultKarray[0]+(i*E1X1K1Valueincrements)+minEminusXMultKarray[1]+(j*E2X2K2Valueincrements)+minEminusXMultKarray[2]+(k*E3X3K3Valueincrements)+minEminusXMultKarray[3]+(l*E4X4K4Valueincrements)
                    toFneuron=round((F-minF)/outFValueincrements)
                    
                    connector = connector + [(i,toFneuron,wt1,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
                    connector2 = connector2 + [(j,toFneuron,wt2,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
                    connector3 = connector3 + [(k,toFneuron,wt3,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
                    connector4 = connector4 + [(l,toFneuron,wt4,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
    
    neal.nealProjection(E1MinusX1MultK1Cells, FOutputCells, connector,'excitatory')
    neal.nealProjection(E2MinusX2MultK2Cells, FOutputCells, connector2,'excitatory')
    neal.nealProjection(E3MinusX3MultK3Cells, FOutputCells, connector3,'excitatory')
    neal.nealProjection(E4MinusX4MultK4Cells, FOutputCells, connector4,'excitatory')
                                       
#    wt = minWeight/NumInputNeurons   #0.0665 is the min (with all the above variables) to make one cell make another cell fire  #weight is in microsiemens as IF_cond_exp has a post-synaptic mechanism which implements a change in conductance. delays are in milliseconds
#    connector = []
    #fromNeuron=0
#    toNeuron = 0
#    for InputNeuron in range (0,numInputNeurons):
#        fromNeuron = InputNeuron
     #   theta = fromOffset/float(100)
     #   currentSinRound = round(sin(theta),2)
     #   earlierSinRound = round(sin(theta-0.01),2)
    #    if (earlierSinRound < currentSinRound):
#        connector = connector + [(fromNeuron,toNeuron,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
        #toNeuron = toNeuron + 1 connect to next neuro

#    neal.nealProjection(fromNeurons, toNeurons, connector,'excitatory') 

    print "finished"
"""
    def summationTwoPops(self, InputPops1, InputPops2, OutputPops, Input1Incr, Input2Incr, OutputIncr, numOutcells, numIn1Cells, numIn2Cells, minWeight):
    # The size of the post-synaptic response (the “synaptic weight”), the temporal dynamics of the weight (synaptic plasticity) and the connection delay are handled by synapse models.
    #output values for each Force neuron
    #outFValueincrements=CalculateIncrement(maxF,minF,numFcells)
    #NOTE: We cannot know whether a set of EXK neurons can activate an F output neuron even though the total of thh we EXK neurons is > the f output neuron.
    #       this is because we do not know whether the other sets of EXK neurons contains a positive or negative value when, therfore, when summed, may cause
    #       the higher valued EXK neuron population to decrease


    #####the first neurons in a population represent negative values (if any otherwise they all represent positive values)
        totalnumOutneurons=numOutcells[0]
        totalNegnumOutneurons=numOutcells[1]
    #totalNegnumFneurons=numFcells[2]
        print "inconnectfunction"
        """
    #
    #print "maxF"
    #print maxF
    #print "minF"
   # print minF
   # print "numFcells"
   # print numFcells
    #print adfds
   # EXKValueincrements=np.zeros(numSets)
    #EMinusXMultKFromNeuron=np.zeros(numSets)
    
    #for i in range(0,numSets):
    #    EXKValueincrements[i]=CalculateIncrement(maxEminusXMultKarray[i], minEminusXMultKarray[i], numEXKcells[i]) 
        #(maxEminusXMultKarray[i]-minEminusXMultKarray[i])/numEXKcells[i]
     #   print "i"
     #   print i
     #   print "increments"
     #   print EXKValueincrements[i]
     #   print "max"
     #   print maxEminusXMultKarray[i]
     #   print "min"
    #    print minEminusXMultKarray[i]
     #   print "numcells"
     #   print numEXKcells[i]
        #EXKValueincrements[1]=(maxEminusXMultKarray[1]-minEminusXMultKarray[1])/numE2X2K2cells
        #EXKValueincrements[2]=(maxEminusXMultKarray[2]-minEminusXMultKarray[2])/numE3X3K3cells
       # EXKValueincrements[3]=(maxEminusXMultKarray[3]-minEminusXMultKarray[3])/numE4X4K4cells

    

    #wt1 = minWeight/numE1X1K1cells   #0.0665 is the min (with all the above variables) to make one cell make another cell fire  #weight is in microsiemens as IF_cond_exp has a post-synaptic mechanism which implements a change in conductance. delays are in milliseconds
    #wt2 = minWeight/numE2X2K2cells
    #wt3 = minWeight/numE3X3K3cells
    #wt4 = minWeight/numE4X4K4cells
    
    E1X1K1celltoFconnector = []
    E2X2K2celltoFconnector = []
    E3X3K3celltoFconnector = []
    E4X4K4celltoFconnector = []

    numStates=len(varValues) #number of rows
    numVariables=len(varValues[0]) #number of columns

    E1MinusX1MultK1Values=[row[4] for row in varValues]
    E2MinusX2MultK2Values=[row[9] for row in varValues]
    E3MinusX3MultK3Values=[row[14] for row in varValues]
    E4MinusX4MultK4Values=[row[19] for row in varValues]

    EMinusXMultKValues=[E1MinusX1MultK1Values, E2MinusX2MultK2Values, E3MinusX3MultK3Values, E4MinusX4MultK4Values]
    
    FValues=[row[20] for row in varValues]

    alreadyconnected=np.zeros(numFcells)
    
    print numStates
    print numVariables
    print E1MinusX1MultK1Values
    print E2MinusX2MultK2Values
    print E3MinusX3MultK3Values
    print E4MinusX4MultK4Values

    print "increments"
    print outFValueincrements
    print EXKValueincrements[0]
    print EXKValueincrements[1]
    print EXKValueincrements[2]
    print EXKValueincrements[3]

    print minF
    print maxF
    print maxEminusXMultKarray[0]
    print maxEminusXMultKarray[1]
    print maxEminusXMultKarray[2]
    print maxEminusXMultKarray[3]
    print minEminusXMultKarray[0]
    print minEminusXMultKarray[1]
    print minEminusXMultKarray[2]
    print minEminusXMultKarray[3]
    
    print "FValues"
    print FValues
        """
    #EXKPopExcToFConn=[[] for k in range(numSets)]  #set up numSets sets of empty lists in an array
    #EXKPopInhToFConn=[[] for k in range(numSets)]  #set up numSets sets of empty lists in an array
        EXConnections=[]
        INHconnections=[]
        EXConnections2=[]     #excitatory connections            
        INHconnections2=[]    #inhibitory connections    
    #numNegNeurons=0
        toNeuronTotalValue=0
        PosOrNeg=-1                                      #set the value that each neuron represents as positive or negative
    
        for toNeuron in range(0, totalnumOutneurons):           
            #print "connections"
            #print "toFneuron"
            #print toNeuron
        #PosORNeg=PosOrNegNeurons(minF, outFValueincrements, toFneuron)
        ##calculate which neurons in the population represent positive or negative values (if negative and positive valued neurons, the first neurons will represent
        #negative neurons.
        
        #if((minF>0)or(((minF+(outFValueincrements*(toFneuron+1)))>=0)and(PosOrNeg==-1)and(toFneuron>0))):
       #     numOfNegNeurons=toFneuron
       #     PosOrNeg=1
            if(totalNegnumOutneurons>toNeuron):
                toNeuronTotalValue+=OutputIncr*-1   
            else:
                if(totalNegnumOutneurons==toNeuron):
                    toNeuronTotalValue=OutputIncr
                else:
                    toNeuronTotalValue+=OutputIncr    
            """
        print "toFneuronTotalValue"
        print toFneuronTotalValue
        print "minF"
        print minF
        print "outFValueincrements"
        print outFValueincrements
            """
        #E1X1K1cells
            #connections=[]
            for i in range(0, 2):
            #print "make E %s X %s K %s cells connections" % (i,i,i) 
                if(i==0):
                    connections=self.makePlusConnections(numIn1Cells, toNeuron, Input1Incr, minWeight, toNeuronTotalValue)
                    EXConnections+=connections[0]     #excitatory connections            
                    INHconnections+=connections[1]     #inhibitory connections
                else:
                    connections=self.makePlusConnections(numIn2Cells, toNeuron, Input2Incr, minWeight, toNeuronTotalValue)
                    EXConnections2+=connections[0]     #excitatory connections            
                    INHconnections2+=connections[1]     #inhibitory connections
        #E1X1K1celltoFconnector += connections
        
        #E2X2K2cells
        #print "make E2X2K2cells connections"
        #connections=makePlusConnections(numEXKcells[1], toFneuron, EXKValueincrements[1], minEminusXMultKarray[1], minWeight, toFneuronTotalValue)
        #E2X2K2celltoFconnector += connections
        #E3X3K3cells
        #print "make E3X3K3cells connections"
        #connections=makePlusConnections(numEXKcells[2], toFneuron, EXKValueincrements[2], minEminusXMultKarray[2], minWeight, toFneuronTotalValue)
        #E3X3K3celltoFconnector += connections
        #E4X4K4cells
        #print "make E4X4K4cells connections"
        #connections=makePlusConnections(numEXKcells[3], toFneuron, EXKValueincrements[3], minEminusXMultKarray[3], minWeight, toFneuronTotalValue)
        #E4X4K4celtoFconnector += connections        

    #for i in range(0, numSets):
            
        
        #neal.nealProjection(EMinusXMultKCells[i], FOutputCells, EXKPopExcToFConn[i], 'excitatory')  #excitatory
        #neal.nealProjection(EMinusXMultKCells[i], FOutputCells, EXKPopInhToFConn[i], 'inhibitory')  #inhibitory
        #print EXConnections
        connList = self.sim.FromListConnector(EXConnections)
        exc_connections=self.sim.Projection(InputPops1, OutputPops, connList, receptor_type='excitatory')
        connList = self.sim.FromListConnector(INHconnections)
        inh_connections=self.sim.Projection(InputPops1, OutputPops, connList, receptor_type='inhibitory')
        connList = self.sim.FromListConnector(EXConnections2)
        exc_connections=self.sim.Projection(InputPops2, OutputPops, connList, receptor_type='excitatory')
        connList = self.sim.FromListConnector(INHconnections2)
        inh_connections=self.sim.Projection(InputPops2, OutputPops, connList, receptor_type='inhibitory')
        """
        print "exc connections"
        print exc_connections.get(["weight", "delay"], format="list")
        pause()
        print "inh connections"
        print inh_connections.get(["weight", "delay"], format="list")
        pause()
        """
        """
        #self.sim.Projection(EMinusXMultKCells[i], FOutputCells, connector=EXKPopToFConn[i], receptor_type='inhibitory')
    #neal.nealProjection(E2MinusX2MultK2Cells, FOutputCells, E2X2K2celltoFconnector,'excitatory')
    #neal.nealProjection(E3MinusX3MultK3Cells, FOutputCells, E3X3K3celltoFconnector,'excitatory')
    #neal.nealProjection(E4MinusX4MultK4Cells, FOutputCells, E4X4K4celltoFconnector,'excitatory')
        print "NEALADFLASJFLKSAJDFLKAJSDFLJ"
        print "i"
        print i
        print EMinusXMultKCells[i]
        print FOutputCells
        print EXKPopExcToFConn[i]
        print EXKPopInhToFConn[i]
        
    print "CONNNNLKJADLKFJALKDFJASLKJFDLKDSJ"
    print EXKPopExcToFConn[3]
    print EXKPopInhToFConn[3]
    print EMinusXMultKCells[3]
        """
        """   
    for i in range(0,numStates):
        print "i"
        print i
        print "values"
        #F=0
        toFneuron=int(round((FValues[i]-minF)/outFValueincrements))
        if(alreadyconnected[toFneuron-1]==0):
            alreadyconnected[toFneuron-1]=1
            print "Fvalues"
            print(FValues[i])
            print minF
            print outFValueincrements
            NumNeuronsToEachF=0
            for j in range(0,4):
                #F+=E1MinusX1MultK1Values[i]
                Value=EMinusXMultKValues[j]
                EMinusXMultKFromNeuron[j]=round((Value[i]-minEminusXMultKarray[j])/EXKValueincrements[j])
                print "I"
                print Value[i]
                print minEminusXMultKarray[j]
                print EXKValueincrements[j]
            
                NumNeuronsToEachF+=EMinusXMultKFromNeuron[j]
        
            wt = minWeight/NumNeuronsToEachF
            print "parameters"
            print toFneuron
            print NumNeuronsToEachF
            print EMinusXMultKFromNeuron
        
        
            for j in range(0,4):   
                for k in range(0, int(EMinusXMultKFromNeuron[j])):
                    for l in range(0,toFneuron):
                        if(j==0):  #E1-X1*K1
                            connector = connector + [(k,l,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
                        elif(j==1):#E2-X2*K2
                            connector2 = connector2 + [(k,l,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
                        elif(j==2):#E3-X3*K3
                            connector3 = connector3 + [(k,l,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
                        else:#E4-X4*K4
                            connector4 = connector4 + [(k,l,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
        #connector = connector + [(EMinusXMultKFromNeuron[0],toFneuron,wt1,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
       # connector2 = connector2 + [(EMinusXMultKFromNeuron[1],toFneuron,wt2,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
       # connector3 = connector3 + [(EMinusXMultKFromNeuron[2],toFneuron,wt3,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
       # connector4 = connector4 + [(EMinusXMultKFromNeuron[3],toFneuron,wt4,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
    
            neal.nealProjection(E1MinusX1MultK1Cells, FOutputCells, connector,'excitatory')
            neal.nealProjection(E2MinusX2MultK2Cells, FOutputCells, connector2,'excitatory')
            neal.nealProjection(E3MinusX3MultK3Cells, FOutputCells, connector3,'excitatory')
            neal.nealProjection(E4MinusX4MultK4Cells, FOutputCells, connector4,'excitatory')
        
        
 #       for j in range(0,numE2X2K2cells):
 #           print "j"
 #           print j
 #           for k in range(0,numE3X3K3cells):
 #               for l in range(0,numE4X4K4cells):
 #                   F=minEminusXMultKarray[0]+(i*E1X1K1Valueincrements)+minEminusXMultKarray[1]+(j*E2X2K2Valueincrements)+minEminusXMultKarray[2]+(k*E3X3K3Valueincrements)+minEminusXMultKarray[3]+(l*E4X4K4Valueincrements)
 #                   toFneuron=round((F-minF)/outFValueincrements)
                    
#                    connector = connector + [(i,toFneuron,wt1,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
#                    connector2 = connector2 + [(j,toFneuron,wt2,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
#                    connector3 = connector3 + [(k,toFneuron,wt3,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
#                    connector4 = connector4 + [(l,toFneuron,wt4,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
#    
#    neal.nealProjection(E1MinusX1MultK1Cells, FOutputCells, connector,'excitatory')
#    neal.nealProjection(E2MinusX2MultK2Cells, FOutputCells, connector2,'excitatory')
#    neal.nealProjection(E3MinusX3MultK3Cells, FOutputCells, connector3,'excitatory')
#    neal.nealProjection(E4MinusX4MultK4Cells, FOutputCells, connector4,'excitatory')
                                       
#    wt = minWeight/NumInputNeurons   #0.0665 is the min (with all the above variables) to make one cell make another cell fire  #weight is in microsiemens as IF_cond_exp has a post-synaptic mechanism which implements a change in conductance. delays are in milliseconds
#    connector = []
    #fromNeuron=0
#    toNeuron = 0
#    for InputNeuron in range (0,numInputNeurons):
#        fromNeuron = InputNeuron
     #   theta = fromOffset/float(100)
     #   currentSinRound = round(sin(theta),2)
     #   earlierSinRound = round(sin(theta-0.01),2)
    #    if (earlierSinRound < currentSinRound):
#        connector = connector + [(fromNeuron,toNeuron,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
        #toNeuron = toNeuron + 1 connect to next neuro

#    neal.nealProjection(fromNeurons, toNeurons, connector,'excitatory') 
        """
        print "finished"
    #return [EXKValueincrements, outFValueincrements]
        """
def connectToFOutput(E1MinusX1MultK1Cells,E2MinusX2MultK2Cells,E3MinusX3MultK3Cells, E4MinusX4MultK4Cells, FOutputCells, minEminusXMultKarray, maxEminusXMultKarray, minF, maxF, numFcells, numE1X1K1cells, numE2X2K2cells, numE3X3K3cells, numE4X4K4cells, minWeight):
    # The size of the post-synaptic response (the “synaptic weight”), the temporal dynamics of the weight (synaptic plasticity) and the connection delay are handled by synapse models.
    #output values for each Force neuron
      #this calculates every F result (and therefore every possible set of connections) for every possible combination of (E-X)*K cells (value).  However, this it too slow if we have 100 neurons in each of the 4 populations, i.e. 100^4 calculations (this is also the same every calculate every possible combination of values for each F output)
     # we could randomly choose a cell out of each of the 4 populations to connect to the correct F cell but the cells connected may never be used 
    
    outFValueincrements=(maxF-minF)/numFcells
    E1X1K1Valueincrements=(maxEminusXMultKarray[0]-minEminusXMultKarray[0])/numE1X1K1cells
    E2X2K2Valueincrements=(maxEminusXMultKarray[1]-minEminusXMultKarray[1])/numE2X2K2cells
    E3X3K3Valueincrements=(maxEminusXMultKarray[2]-minEminusXMultKarray[2])/numE3X3K3cells
    E4X4K4Valueincrements=(maxEminusXMultKarray[3]-minEminusXMultKarray[3])/numE4X4K4cells

    wt1 = minWeight/numE1X1K1cells   #0.0665 is the min (with all the above variables) to make one cell make another cell fire  #weight is in microsiemens as IF_cond_exp has a post-synaptic mechanism which implements a change in conductance. delays are in milliseconds
    wt2 = minWeight/numE2X2K2cells
    wt3 = minWeight/numE3X3K3cells
    wt4 = minWeight/numE4X4K4cells

    connector = []
    connector2 = []
    connector3 = []
    connector4 = []

    print "increments"
    print outFValueincrements
    print E1X1K1Valueincrements
    print E2X2K2Valueincrements
    print E3X3K3Valueincrements
    print E4X4K4Valueincrements

    print minF
    print maxF
    print maxEminusXMultKarray[0]
    print maxEminusXMultKarray[1]
    print maxEminusXMultKarray[2]
    print maxEminusXMultKarray[3]
    print minEminusXMultKarray[0]
    print minEminusXMultKarray[1]
    print minEminusXMultKarray[2]
    print minEminusXMultKarray[3]
    
    
    for i in range(0,numE1X1K1cells):
        print "i"
        print i
        
        for j in range(0,numE2X2K2cells):
            print "j"
            print j
            for k in range(0,numE3X3K3cells):
                for l in range(0,numE4X4K4cells):
                    F=minEminusXMultKarray[0]+(i*E1X1K1Valueincrements)+minEminusXMultKarray[1]+(j*E2X2K2Valueincrements)+minEminusXMultKarray[2]+(k*E3X3K3Valueincrements)+minEminusXMultKarray[3]+(l*E4X4K4Valueincrements)
                    toFneuron=round((F-minF)/outFValueincrements)
                    
                    connector = connector + [(i,toFneuron,wt1,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
                    connector2 = connector2 + [(j,toFneuron,wt2,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
                    connector3 = connector3 + [(k,toFneuron,wt3,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
                    connector4 = connector4 + [(l,toFneuron,wt4,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
    
    neal.nealProjection(E1MinusX1MultK1Cells, FOutputCells, connector,'excitatory')
    neal.nealProjection(E2MinusX2MultK2Cells, FOutputCells, connector2,'excitatory')
    neal.nealProjection(E3MinusX3MultK3Cells, FOutputCells, connector3,'excitatory')
    neal.nealProjection(E4MinusX4MultK4Cells, FOutputCells, connector4,'excitatory')
                                       
#    wt = minWeight/NumInputNeurons   #0.0665 is the min (with all the above variables) to make one cell make another cell fire  #weight is in microsiemens as IF_cond_exp has a post-synaptic mechanism which implements a change in conductance. delays are in milliseconds
#    connector = []
    #fromNeuron=0
#    toNeuron = 0
#    for InputNeuron in range (0,numInputNeurons):
#        fromNeuron = InputNeuron
     #   theta = fromOffset/float(100)
     #   currentSinRound = round(sin(theta),2)
     #   earlierSinRound = round(sin(theta-0.01),2)
    #    if (earlierSinRound < currentSinRound):
#        connector = connector + [(fromNeuron,toNeuron,wt,nealParameters.DELAY)]  #DELAY=synaptic delay and is in milliseconds
        #toNeuron = toNeuron + 1 connect to next neuro

#    neal.nealProjection(fromNeurons, toNeurons, connector,'excitatory') 

    print "finished"
    """
    """
    def MultPosOrNeg(self, inputPops1, inputPops2, numNeuronsIn1Pop, numNeuronsIn2Pop, PosOrNegPop, minWeight, inputPops1Buf, inputPops2Buf):
        #PosOrNegPop= 1st and second neurons represent a pos (++,--), 3rd and fourth represent a neg (+-,-+) multiplication
        #ASSUMING ALL MULT POPS HAVE POS AND NEGATIVE SUBSETS
        ExcConnector=[]
        ExcConnector2=[]
        In1totalNum=numNeuronsIn1Pop[0]
        In1negNum=numNeuronsIn1Pop[1]
        In2totalNum=numNeuronsIn2Pop[0]
        In2negNum=numNeuronsIn2Pop[1]
        Weight=round(minWeight/2.0,10)
        #
        #connect the first neuron from the neg and pos subsets in input pops1 to multpos pop and inputpops2 to multpos pop
        if((In1totalNum-In1negNum)>0):
            ExcConnector+=[(In1negNum, 0,Weight,nealParameters.DELAY)] #0=+ (++), 1=+ (--),2=-(+-), 3=(-+)  ##we are not using a minweight/2 to make the action faster, i.e. set this before before cos and sin have reached mult so that posorneg reaches mult at the same time
            ExcConnector+=[(In1negNum, 2,Weight,nealParameters.DELAY)]
        if(In1negNum>0):
            ExcConnector+=[(0, 1,Weight,nealParameters.DELAY)]
            ExcConnector+=[(0, 3,Weight,nealParameters.DELAY)]        

        if((In2totalNum-In2negNum)>0):
            ExcConnector2+=[(In2negNum, 0,Weight,nealParameters.DELAY)]
            ExcConnector2+=[(In2negNum, 3,Weight,nealParameters.DELAY)]
        if(In2negNum>0):            
            ExcConnector2+=[(0, 1,Weight,nealParameters.DELAY)]
            ExcConnector2+=[(0, 2,Weight,nealParameters.DELAY)]
       

        connList = self.sim.FromListConnector(ExcConnector)
        exc_connections=self.sim.Projection(inputPops1,PosOrNegPop, connList, receptor_type='excitatory')

        connList = self.sim.FromListConnector(ExcConnector2)
        exc_connections=self.sim.Projection(inputPops2,PosOrNegPop, connList, receptor_type='excitatory')

        ExcConnector=[]
        #connect inputpops to input buffers
        for eachCell in range(0,In1totalNum):
            ExcConnector+=[(eachCell, eachCell,minWeight,nealParameters.DELAY)]

        connList = self.sim.FromListConnector(ExcConnector)
        exc_connections=self.sim.Projection(inputPops1,inputPops1Buf, connList, receptor_type='excitatory')

        ExcConnector=[]
        #connect inputpops to input buffers
        for eachCell in range(0,In2totalNum):
            ExcConnector+=[(eachCell, eachCell,minWeight,nealParameters.DELAY)]

        #connList = self.sim.FromListConnector(ExcConnector)
        #exc_connections=self.sim.Projection(inputPops2,inputPops2Buf, connList, receptor_type='excitatory')
    """

    def RoundValues(self, RoundOutPopNum , RoundOutPopNegNum, RoundOutIncrements, IntotalNum, InnegNum, InPopIncr, minWeight):
        #print "CALCULATE ROUNDED"
        ##ROUND THE RESULTS BY MERGING (ADDING) THE SMALLER VALUES OF THE INPUT  NETWORK INTO LARGER VALUES OF THE ROUND NETWORK, i.e. WE NEED 20*0.0025 NEURONS TO FIRE A SINGLE  0.05 NEURON
        ##as many results are near a single rounded value, these rounded values will fire faster compared
        #to one output that only receives one input, i.e. an output value which is massive and rare.
        #Weve already done the * of pos and neg so we just want to marry up the pos with pos etc    
        EXConnections=[]
        INHconnections=[]
        EXConnections2=[]     #excitatory connections            
        INHconnections2=[]    #inhibitory connections    
    #numNegNeurons=0
        toNeuronTotalValue=0
        PosOrNeg=-1                                      #set the value that each neuron represents as positive or negative
        #minWeight=0.346
        for eachOutNeuron in range(0, RoundOutPopNum):           
            #print "roundconnections"
            #print "toFneuron"
            #print eachOutNeuron
        #PosORNeg=PosOrNegNeurons(minF, outFValueincrements, toFneuron)
        ##calculate which neurons in the population represent positive or negative values (if negative and positive valued neurons, the first neurons will represent
        #negative neurons.
        
        #if((minF>0)or(((minF+(outFValueincrements*(toFneuron+1)))>=0)and(PosOrNeg==-1)and(toFneuron>0))):
       #     numOfNegNeurons=toFneuron
       #     PosOrNeg=1
            if(RoundOutPopNegNum>eachOutNeuron):
                toNeuronTotalValue+=RoundOutIncrements*-1   
            else:
                if(RoundOutPopNegNum==eachOutNeuron):
                    toNeuronTotalValue=RoundOutIncrements
                else:
                    toNeuronTotalValue+=RoundOutIncrements

            for eachinput in range(0, IntotalNum):
                

                ValueDif=(InPopIncr/toNeuronTotalValue)   #the percentage difference between the toValue and the FromValue, if 75% (1.25) of the neurons attached to the rounded neuron, it will fire, i.e. it will slightly overestimate the value
        
                wt=abs(minWeight*ValueDif)
                wt=round(wt,100)


                if((InnegNum>eachinput)and(RoundOutPopNegNum>eachOutNeuron)):
                    EXConnections += [(eachinput,eachOutNeuron,abs(wt),nealParameters.DELAY)]
                elif((InnegNum<=eachinput)and(RoundOutPopNegNum<=eachOutNeuron)):
                    EXConnections += [(eachinput,eachOutNeuron,abs(wt),nealParameters.DELAY)]

        return EXConnections

    

    def Divide2Pops(self, inputPops1, inputPops2, numNeuronsIn1Pop, numNeuronsIn2Pop, in1Increments, in2Increments, DivPops, numDivPops, DivPopIncr, RoundoutputPops, numNeuronsRoundOutPop, RoundOutIncrements, minWeight, RoundCellValues):
        #print "mult2pops"
        ExcConnector=[]
        InhConnector=[]
        ExcConnector2=[]
        In1totalNum=numNeuronsIn1Pop[0]
        In1negNum=numNeuronsIn1Pop[1]
        In2totalNum=numNeuronsIn2Pop[0]
        In2negNum=numNeuronsIn2Pop[1]
        OuttotalNum=numNeuronsRoundOutPop[0]
        OutnegNum=numNeuronsRoundOutPop[1]

        DivtotalNum=numDivPops[0]
        DivnegNum=numDivPops[1]
        copy=minWeight
        printconn2=[]
        printconn=[]
        printconn3=[]

        """
        print in1Increments
        print in2Increments
        print MultPopIncr
        print RoundOutIncrements
        print numNeuronsIn1Pop
        print numNeuronsIn2Pop
        print numMultPops
        print numNeuronsRoundOutPop
        print inputPops1
        print inputPops2
        print MultPops
        print RoundoutputPops
        """
        outdivnum=0
        #AccurateIncrPerOutCell=in1Increments*in2Increments                  #0.0025
        #RoundedIncPerOutCell=RoundOutIncrements                                  #0.05
        #numConnPerOutCell=int(RoundedIncPerOutCell/AccurateIncrPerOutCell)  #20

        #CALCULATE THE ACTUAL MULTIPLICATION
        
        #minWeight=0
        #print "In1negNum"
        #print In1negNum
        #print "outmultnum"
        #print outdivnum
        #print "MultnegNum"
        #print DivnegNum
        #print "outmultnum+MultnegNum"
        #print outmultnum+MultnegNum
        #print "In2negNum"
        #print In2negNum
        #print "In1totalNum"
        #print In1totalNum
        #print "In2totalNum"
        #print In2totalNum
        #print "In2totalNum-In2negNum"
        #print In2totalNum-In2negNum
        #print "MulttotalNum"
        #print DivtotalNum
        ##connect first input population (negative neurons) to output
        #print "negative input1 neurons to output"
        
        outdivnum=0
        connvalues=[0,0]
        
        numneurons=int(round((in1Increments/in2Increments)/DivPopIncr))
        outdivnum2=0
        outdivnum3=0
        outdivnum4=0
        record=0
        record2=0
        record3=0
        record4=0
        Divvalueout=DivPopIncr
        startinhib=0
        input2value=0
        #CONNECT INPUT1 TO DIV POPULATION
        for EachInputin1Cell in range (0,In1totalNum): #numCells[0]==total, numCells[1]==numNegCells
            printconn=[]
            #if(In2negNum>0):
            #only connect input1 negative values to negative outputs if input2 has positive values
            
            if(In1negNum>EachInputin1Cell):
                if((In2totalNum-In2negNum)>0):
                    #neg/pos=neg
                    for i in range(0,numneurons):
                        ExcConnector+=[(EachInputin1Cell, outdivnum,round(minWeight/2.0,10),nealParameters.DELAY)]##connect negative inputs to negative outputs
                        printconn+=[(EachInputin1Cell, outdivnum,round(minWeight/2.0,10),nealParameters.DELAY)]                    
                        outdivnum+=1
                #only connect input1 negative values to positive outputs if input2 has negative values
                if(In2negNum>0):
                    #neg/neg=pos
                    for i in range(0,numneurons):
                        ExcConnector+=[(EachInputin1Cell, DivnegNum+outdivnum2,round(minWeight/2.0,10),nealParameters.DELAY)]##connect negative inputs to negative outputs
                        printconn+=[(EachInputin1Cell, DivnegNum+outdivnum2,round(minWeight/2.0,10),nealParameters.DELAY)]                    
                        outdivnum2+=1                

            else:
                #positive input1
                ##only connnect input1 positive values to negative outputs if input2 has negative values
                if(In2negNum>0):
                    #pos/neg=neg
                    for i in range(0,numneurons):
                        ExcConnector+=[(EachInputin1Cell, outdivnum+outdivnum3,round(minWeight/2.0,10),nealParameters.DELAY)]##connect negative inputs to negative outputs
                        printconn+=[(EachInputin1Cell, outdivnum+outdivnum3,round(minWeight/2.0,10),nealParameters.DELAY)]                    
                        outdivnum3+=1
                if((In2totalNum-In2negNum)>0):
                    #pos/pos=pos
                    ##only connnect input1 positive values to positive output if input 2 has positive values
                    for i in range(0,numneurons):
                        ExcConnector+=[(EachInputin1Cell, DivnegNum+outdivnum2+outdivnum4,round(minWeight/2.0,10),nealParameters.DELAY)]##connect negative inputs to negative outputs
                        printconn+=[(EachInputin1Cell, DivnegNum+outdivnum2+outdivnum4,round(minWeight/2.0,10),nealParameters.DELAY)]                    
                        outdivnum4+=1
                     

        #CONNECT INPUT2 TO DIV POPULATION
        for EachInputin2Cell in range (0,In2totalNum): #numCells[0]==total, numCells[1]==numNegCells
            #if(EachInputin2Cell!=0):

            
            if((EachInputin2Cell==0)and(In1totalNum>0)and(In2negNum>0)):
                input2value=in2Increments
                     #only connect input2 negative values to negative outputs if input1 has positive values
                    #neg/pos=neg
              #  if((In1totalNum-In1negNum)>0):
                for i in range(0,numneurons*(In1totalNum-In1negNum)): #the outdivnum tells us whether there are pos and neg neurons associated with input1 population
                    ExcConnector2+=[(EachInputin2Cell, (numneurons*(In1totalNum-In1negNum))+i,round(minWeight/2.0,10),nealParameters.DELAY)]##connect negative inputs to negative outputs
                    printconn2+=[(EachInputin2Cell, (numneurons*(In1totalNum-In1negNum))+i,round(minWeight/2.0,10),nealParameters.DELAY)]                            
                    #only connect input2 negative values to positive outputs if input1 has negative values
                    #neg/neg=pos
                #if(In1negNum>0):
                for i in range(0,numneurons*In1negNum):
                    ExcConnector2+=[(EachInputin2Cell, DivnegNum+i,round(minWeight/2.0,10),nealParameters.DELAY)]##connect negative inputs to negative outputs
                    printconn2+=[(EachInputin2Cell, DivnegNum+i,round(minWeight/2.0,10),nealParameters.DELAY)]
            elif((EachInputin2Cell==In2negNum)and((In2totalNum-In2negNum)>0)):
                input2value=in2Increments
                startinhib=0
                    #only connect input2 positive values to negative outputs if input1 has negative values
                    #neg/pos=neg
                #if(In1negNum>0):
                for i in range(0,numneurons*In1negNum):
                    ExcConnector2+=[(EachInputin2Cell, i,round(minWeight/2.0,10),nealParameters.DELAY)]##connect negative inputs to negative outputs
                    printconn2+=[(EachInputin2Cell, i,round(minWeight/2.0,10),nealParameters.DELAY)]                            
                    #only connect input2 positive values to positive outputs if input1 has positive values
                    #neg/neg=pos
                #if((In1totalNum-In1negNum)>0):
                for i in range(0,numneurons*(In1totalNum-In1negNum)):
                    ExcConnector2+=[(EachInputin2Cell, DivnegNum+(numneurons*In1negNum)+i,round(minWeight/2.0,10),nealParameters.DELAY)]##connect negative inputs to negative outputs
                    printconn2+=[(EachInputin2Cell, DivnegNum+(numneurons*In1negNum)+i,round(minWeight/2.0,10),nealParameters.DELAY)]                   
            elif(In2negNum>EachInputin2Cell):
                #negativ
                input2value+=round(in2Increments,10)
                
                howmanyon=int(round((in1Increments/input2value)/DivPopIncr))
                if((numneurons-howmanyon)>startinhib):
                    numneuronsinhib=(numneurons-howmanyon)-startinhib
                else:
                    numneuronsinhib=0
                
                #only connect input2 negative values to negative outputs if input1 has positive values
                #neg/pos=neg                
                #if((In1totalNum-In1negNum)>0):
                for eachCell in range(0,(In1totalNum-In1negNum)): #dont need above if statement as if In1totalNum-In1negNum==0 there will be no loop
                        
                    for i in range(0,numneuronsinhib):
                        InhConnector+=[(EachInputin2Cell, (In1negNum*numneurons)+(eachCell*numneurons)+startinhib+i,round(minWeight/2.0,10),nealParameters.DELAY)]##connect negative inputs to negative outputs
                        printconn3+=[(EachInputin2Cell, (In1negNum*numneurons)+(eachCell*numneurons)+startinhib+i,round(minWeight/2.0,10),nealParameters.DELAY)]                           
                            #record+=1
                #if(In1negNum>0):                          
                    #only connect input2 negative values to positive outputs if input1 has negative values
                    #neg/neg=pos
                for eachCell in range(0,In1negNum):
                        
                    for i in range(0,numneuronsinhib):
                        InhConnector+=[(EachInputin2Cell, DivnegNum+(eachCell*numneurons)+startinhib+i,round(minWeight/2.0,10),nealParameters.DELAY)]##connect negative inputs to negative outputs
                        printconn3+=[(EachInputin2Cell, DivnegNum+(eachCell*numneurons)+startinhib+i,round(minWeight/2.0,10),nealParameters.DELAY)]                           
                            #record2+=1
                startinhib+=numneuronsinhib
            else:
                input2value+=round(in2Increments,10)
                howmanyon=int(round((in1Increments/input2value)/DivPopIncr))
                if((numneurons-howmanyon)>startinhib):
                    numneuronsinhib=(numneurons-howmanyon)-startinhib
                else:
                    numneuronsinhib=0
                #if(input2value==0.55):
                #print input2value
                #print howmanyon
                #print in1Increments
                #print DivPopIncr
                #print numneurons
                #print startinhib
                #print numneuronsinhib
                #print In1negNum
                #print ((In1totalNum-In1negNum)*numneurons)+(eachCell*numneurons)+startinhib
                #print In1totalNum-In1negNum
                #print (In1totalNum-In1negNum)*numneurons
                ###self.pause()
                    
                #only connect input2 positive values to negative outputs if input1 has negative values
                #pos/neg=neg                
                #if(In1negNum>0):
                for eachCell in range(0,In1negNum):
                        
                    for i in range(0,numneuronsinhib):
                        InhConnector+=[(EachInputin2Cell,(eachCell*numneurons)+startinhib+i,round(minWeight/2.0,10),nealParameters.DELAY)]##connect negative inputs to negative outputs
                        printconn3+=[(EachInputin2Cell, (eachCell*numneurons)+startinhib+i,round(minWeight/2.0,10),nealParameters.DELAY)]                           
                            #record+=1
                #if((In1totalNum-In1negNum)>0):                          
                    #only connect input2 positive values to positive outputs if input1 has positive values
                    #pos/pos=pos
                for eachCell in range(0,(In1totalNum-In1negNum)):
                        
                    for i in range(0,numneuronsinhib):
                        InhConnector+=[(EachInputin2Cell, DivnegNum+(eachCell*numneurons)+(In1negNum*numneurons)+startinhib+i,round(minWeight/2.0,10),nealParameters.DELAY)]##connect negative inputs to negative outputs
                        printconn3+=[(EachInputin2Cell, DivnegNum+(eachCell*numneurons)+(In1negNum*numneurons)+startinhib+i,round(minWeight/2.0,10),nealParameters.DELAY)]                           
                            #record2+=1               
                startinhib+=numneuronsinhib
            

        #print inputPops1
        #print inputPops2
        #print DivPops
        #print ExcConnector
        #print ExcConnector2
        #print InhConnector
        
        #akj

        connList = self.sim.FromListConnector(ExcConnector)
        connList2 = self.sim.FromListConnector(ExcConnector2)
        connList3 = self.sim.FromListConnector(InhConnector)
        if(RoundCellValues==1):
        
            exc_connections=self.sim.Projection(inputPops1, DivPops, connList, receptor_type='excitatory')
            exc_connections=self.sim.Projection(inputPops2, DivPops, connList2, receptor_type='excitatory')
            exc_connections=self.sim.Projection(inputPops2, DivPops, connList3, receptor_type='inhibitory')

            EXConnections=self.RoundValues(OuttotalNum, OutnegNum, RoundOutIncrements, DivtotalNum, DivnegNum, DivPopIncr, minWeight)

            connList = self.sim.FromListConnector(EXConnections)
            exc_connections=self.sim.Projection(DivPops,RoundoutputPops, connList, receptor_type='excitatory')
        else:
            exc_connections=self.sim.Projection(inputPops1, RoundoutputPops, connList, receptor_type='excitatory')   #in this case roundoutputpops does not contain the rounded values, it contains the value from the division network
            exc_connections=self.sim.Projection(inputPops2, RoundoutputPops, connList2, receptor_type='excitatory')  #in this case roundoutputpops does not contain the rounded values, it contains the value from the division network
            exc_connections=self.sim.Projection(inputPops2, RoundoutputPops, connList3, receptor_type='inhibitory')  #in this case roundoutputpops does not contain the rounded values, it contains the value from the division network
        #print ExcConnector
        #print ExcConnector2
        ####self.pause()
        
        #minWeight=copy
        ##connect up population which decides whether the output of the multiplication should be pos or neg
        """
        ExcConnector=[]
        for eachCellInMult in range(0,MulttotalNum):
            if(MultnegNum>eachCellInMult):
                ExcConnector+=[(2,eachCellInMult, round(minWeight/3.0,10),nealParameters.DELAY)]
                ExcConnector+=[(3,eachCellInMult, round(minWeight/3.0,10),nealParameters.DELAY)]
            else:
                ExcConnector+=[(0,eachCellInMult, round(minWeight/3.0,10),nealParameters.DELAY)]
                ExcConnector+=[(1,eachCellInMult, round(minWeight/3.0,10),nealParameters.DELAY)]                

        
        #print ExcConnector
        #kjkjh
        connList = self.sim.FromListConnector(ExcConnector)
        exc_connections=self.sim.Projection(posOrNegPop,MultPops, connList, receptor_type='excitatory')
        """

        
        #hgjhg

        #ExcConnector=[]
        #OutValue=0.0
        #inputneuron=0
        #flag=1






    def Multiplication2Pops(self, inputPops1, inputPops2, numNeuronsIn1Pop, numNeuronsIn2Pop, in1Increments, in2Increments, MultPops, numMultPops, MultPopIncr, RoundoutputPops, numNeuronsRoundOutPop, RoundOutIncrements, minWeight, RoundCellValues, squared, connectionnum):
        #print "mult2pops
        ###connectionnum=1 if we want to connect every cell in pop2 to the output cells
        ###connectionnum=2 if we want to connect every 2 cells in pop2 to one output cell
        ExcConnector=[]
        ExcConnector2=[]

        In1totalNum=numNeuronsIn1Pop[0]
        In1negNum=numNeuronsIn1Pop[1]
        In2totalNum=numNeuronsIn2Pop[0]
        In2negNum=numNeuronsIn2Pop[1]
        OuttotalNum=numNeuronsRoundOutPop[0]
        OutnegNum=numNeuronsRoundOutPop[1]

        MulttotalNum=numMultPops[0]
        MultnegNum=numMultPops[1]
        copy=minWeight


        """
        print in1Increments
        print in2Increments
        print MultPopIncr
        print RoundOutIncrements
        print numNeuronsIn1Pop
        print numNeuronsIn2Pop
        print numMultPops
        print numNeuronsRoundOutPop
        print inputPops1
        print inputPops2
        print MultPops
        print RoundoutputPops
        """
        outmultnum=0
        #AccurateIncrPerOutCell=in1Increments*in2Increments                  #0.0025
        #RoundedIncPerOutCell=RoundOutIncrements                                  #0.05
        #numConnPerOutCell=int(RoundedIncPerOutCell/AccurateIncrPerOutCell)  #20

        #CALCULATE THE ACTUAL MULTIPLICATION
        
        #minWeight=0
        print "In1negNum"
        print In1negNum
        print "outmultnum"
        print outmultnum
        print "MultnegNum"
        print MultnegNum
        print "outmultnum+MultnegNum"
        print outmultnum+MultnegNum
        print "In2negNum"
        print In2negNum
        print "In1totalNum"
        print In1totalNum
        print "In2totalNum"
        print In2totalNum
        print "In2totalNum-In2negNum"
        print In2totalNum-In2negNum
        print "MulttotalNum"
        print MulttotalNum
        ##connect first input population (negative neurons) to output
        print "negative input1 neurons to output"
        outmultnum2=0
        connvalues=[0,0]
        totalin2neg=(In2negNum)/connectionnum
        totalin2pos=(In2totalNum-In2negNum)/connectionnum
        divisor=(connectionnum*1.0)+1.0       
        for EachInputin1Cell in range (0, In1negNum): #numCells[0]==total, numCells[1]==numNegCells
            printconn=[]
            #if(In2negNum>0):
            #only connect input1 negative values to negative outputs if input2 has positive values
            if(squared==0):
                for i in range(0,totalin2pos):
                    ExcConnector+=[(EachInputin1Cell, outmultnum,round(minWeight/divisor,100),nealParameters.DELAY)]##connect negative inputs to negative outputs
                
                    printconn+=[(EachInputin1Cell, outmultnum,round(minWeight/divisor,100),nealParameters.DELAY)]                

                    outmultnum+=1
            #outmultnum=0
            #only connect input1 negative values to positive outputs if input2 has negative values
            for i in range(0, totalin2neg): 
                ExcConnector+=[(EachInputin1Cell, outmultnum2+MultnegNum,round(minWeight/divisor,100),nealParameters.DELAY)]##connect negative inputs to positive outputs
                printconn+=[(EachInputin1Cell, outmultnum2+MultnegNum,round(minWeight/divisor,100),nealParameters.DELAY)]
                
                outmultnum2+=1
            """
            print "CONNECT FIRST POP, CONNECT NEGATIVE NEURONS"
            print "each input cell"
            print EachInputin1Cell
            print "totalnum"
            print In1totalNum
            print "numNeg"
            print In1negNum
            print "numneginputpop2"
            print In2negNum
            print "outmultnum"
            print outmultnum
            print "connections"
            print printconn
            print "number of mult neurons"
            print MulttotalNum
            print "number of neg mult neurons"
            print MultnegNum
            """
            #else:
         ##connect first input population (positive neurons) to output
        #outmultnum=0
        #outmultnum2=0
        connvalues[0]=outmultnum
        connvalues[1]=outmultnum2                                                  
        #print ExcConnector
        #print "positive input1 neurons to output"
        totalin2neg=(In2negNum)/connectionnum
        totalin2pos=(In2totalNum-In2negNum)/connectionnum
        divisor=(connectionnum*1.0)+1.0
        for EachInputin1Cell in range (0, In1totalNum-In1negNum):           
            
            printconn=[]
            
            if(squared==0):
                for i in range(0,totalin2neg):
                    ##only connnect input1 positive values to negative outputs if input2 has negative values
                    ExcConnector+=[(EachInputin1Cell+In1negNum, outmultnum,round(minWeight/divisor,100),nealParameters.DELAY)]##connect positive inputs to negative valued outputs
                    printconn+=[(EachInputin1Cell+In1negNum, outmultnum,round(minWeight/divisor,100),nealParameters.DELAY)]
                    outmultnum+=1
            #outmultnum=0
            for i in range(0, totalin2pos):
                ##only connnect input1 positive values to positive output if input 2 has positive values
                ExcConnector+=[(EachInputin1Cell+In1negNum, outmultnum2+MultnegNum,round(minWeight/divisor,100),nealParameters.DELAY)]##connect positive inputs to positive valued outputs          
                printconn+=[(EachInputin1Cell+In1negNum, outmultnum2+MultnegNum,round(minWeight/divisor,100),nealParameters.DELAY)]##connect positive inputs to positive valued outputs
                                   
                outmultnum2+=1
            """
            print "CONNECT FIRST POP, CONNECT POSITIVE NEURONS"
            print "each input cell"
            print EachInputin1Cell
            print "totalnum"
            print In1totalNum
            print "numNeg"
            print In1negNum
            print "total pos in2 pop"
            print In2totalNum-In2negNum
            print "numneginputpop2"
            print In2negNum
            print "outmultnum"
            print outmultnum
            print "connections"
            print printconn
            print "number of mult neurons"
            print MulttotalNum
            print "number of neg mult neurons"
            print MultnegNum
            """
        ##connect second input population (negative neurons to output)
        #outmultnum=0
        #outmultnum2=0
        #minWeight=copy
        #minWeight=0
        #print ExcConnector
        ####self.pause()
        counter=0
        cellconnect=0
        totalin2neg=(In2negNum)/connectionnum
        divisor=(connectionnum*1.0)+1.0          
        for EachInputin2Cell in range (0, In2negNum): #numCells[0]==total, numCells[1]==numNegCells
            printconn=[]
            if(counter==connectionnum):
                counter=0
                cellconnect+=1            
            #if(In2negNum>EachInputin2Cell):
            #only connect input2 negative values to negative outputs if input1 has positive values
            for i in range(0, In1totalNum-In1negNum):
                ExcConnector2+=[(EachInputin2Cell, connvalues[0]+cellconnect+(i*totalin2neg),round(minWeight/divisor,100),nealParameters.DELAY)]##connect negative inputs to negative outputs
                printconn+=[(EachInputin2Cell, connvalues[0]+cellconnect+(i*totalin2neg),round(minWeight/divisor,100),nealParameters.DELAY)]##connect negative inputs to negative outputs
                outmultnum+=1
            #only connect input2 negative values to positive outputs if input1 has negative values
            if(squared==0):
                for i in range(0, In1negNum): 
                
                    ExcConnector2+=[(EachInputin2Cell, cellconnect+(i*totalin2neg)+MultnegNum,round(minWeight/divisor,100),nealParameters.DELAY)]##connect negative inputs to positive outputs
                
                    printconn+=[(EachInputin2Cell, cellconnect+(i*totalin2neg)+MultnegNum,round(minWeight/divisor,100),nealParameters.DELAY)]##connect negative inputs to positive outputs
                    outmultnum2+=1
                   #outmultnum+=1
            counter+=1
            """
            print "CONNECT SECOD POP, CONNECT NEGATIVE NEURONS"
            print "each input cell"
            print EachInputin2Cell
            print "totalnum"
            print In1totalNum
            print "numNeg"
            print In1negNum
            print "numneginputpop2"
            print In2negNum
            print "EVERY IN2NEGNUM NEURON"
            print i*In1negNum
                #print outmultnum
            print "connections"
            print printconn
            print "number of mult neurons"
            print MulttotalNum
            print "number of neg mult neurons"
            print MultnegNum
            """
            
            #else:
                #outmultnum=0
            ##connect second input population (positive neurons to output)
            #0  0
            #1  0
            #2  1
            
        outmultnum=0
        outmultnum2=0
        counter=0
        cellconnect=0
        totalin2pos=(In2totalNum-In2negNum)/connectionnum
        divisor=(connectionnum*1.0)+1.0
        for EachInputin2Cell in range (0, In2totalNum-In2negNum):
            printconn=[]
            if(counter==connectionnum):
                counter=0
                cellconnect+=1
                
            if(squared==0):
                #only connect input2 positive values to negative outputs if input1 has negative values
                for i in range(0, In1negNum):
                    ExcConnector2+=[(EachInputin2Cell+In2negNum, cellconnect+(i*totalin2pos),round(minWeight/divisor,100),nealParameters.DELAY)]##connect positive inputs to negative valued outputs
                    printconn+=[(EachInputin2Cell+In2negNum, cellconnect+(i*totalin2pos),round(minWeight/divisor,100),nealParameters.DELAY)]##connect positive inputs to negative valued outputs
                #outmultnum+=1
            #only connect input2 positive values to positive outputs if input1 has positive values
            for i in range(0, In1totalNum-In1negNum): 
                ExcConnector2+=[(EachInputin2Cell+In2negNum, connvalues[1]+cellconnect+(i*totalin2pos)+MultnegNum,round(minWeight/divisor,100),nealParameters.DELAY)]##connect positive inputs to positive valued outputs
                
                printconn+=[(EachInputin2Cell+In2negNum, connvalues[1]+cellconnect+(i*totalin2pos)+MultnegNum,round(minWeight/divisor,100),nealParameters.DELAY)]##connect positive inputs to positive valued outputs
                #outmultnum2+=1
                #printconn=
                    #outmultnum+=1


            counter+=1
            """    
            print "CONNECT SECOD POP, CONNECT POSITIVE NEURONS"
            print "each input cell"
            print EachInputin2Cell
            print "totalnum"
            print In1totalNum
            print "numNeg"
            print In1negNum
            print "numneginputpop2"
            print In2negNum
            print "EVERY IN2NEGNUM NEURON"
            print i*In2negNum
                #print "neuron in mult
                #print outmultnum
            print "connections"
            print printconn
            print "number of mult neurons"
            print MulttotalNum
            print "number of neg mult neurons"
            print MultnegNum
            print "positive number of neurons in inp2"
            print In1totalNum-In1negNum
            """
        #print "first pop"
        #print ExcConnector
        #print "second pop"
        #print ExcConnector2
        #self.pause()
        if(ExcConnector!=[]):
            connList = self.sim.FromListConnector(ExcConnector)
        if(ExcConnector2!=[]):
            connList2 = self.sim.FromListConnector(ExcConnector2)

        if(RoundCellValues==1):
            if(ExcConnector!=[]):
                exc_connections=self.sim.Projection(inputPops1, MultPops, connList, receptor_type='excitatory')
            if(ExcConnector2!=[]):
                exc_connections=self.sim.Projection(inputPops2, MultPops, connList2, receptor_type='excitatory')

            EXConnections=self.RoundValues(OuttotalNum, OutnegNum, RoundOutIncrements, MulttotalNum, MultnegNum, MultPopIncr, minWeight)


            #print EXConnections

            if(EXConnections!=[]):
                connList = self.sim.FromListConnector(EXConnections)
                exc_connections=self.sim.Projection(MultPops,RoundoutputPops, connList, receptor_type='excitatory')           
        else:
            if(ExcConnector!=[]):
                exc_connections=self.sim.Projection(inputPops1, RoundoutputPops, connList, receptor_type='excitatory') #in this case roundoutpos does not contain the round result, only the multiplication result
            if(ExcConnector2!=[]):
                exc_connections=self.sim.Projection(inputPops2, RoundoutputPops, connList2, receptor_type='excitatory')  #in this case roundoutpos does not contain the round result, only the multiplication result         

        #print ExcConnector
        #print ExcConnector2
        ####self.pause()
        
        #minWeight=copy
        ##connect up population which decides whether the output of the multiplication should be pos or neg
        """
        ExcConnector=[]
        for eachCellInMult in range(0,MulttotalNum):
            if(MultnegNum>eachCellInMult):
                ExcConnector+=[(2,eachCellInMult, round(minWeight/3.0,10),nealParameters.DELAY)]
                ExcConnector+=[(3,eachCellInMult, round(minWeight/3.0,10),nealParameters.DELAY)]
            else:
                ExcConnector+=[(0,eachCellInMult, round(minWeight/3.0,10),nealParameters.DELAY)]
                ExcConnector+=[(1,eachCellInMult, round(minWeight/3.0,10),nealParameters.DELAY)]                

        
        #print ExcConnector
        #kjkjh
        connList = self.sim.FromListConnector(ExcConnector)
        exc_connections=self.sim.Projection(posOrNegPop,MultPops, connList, receptor_type='excitatory')
        """

        
        #hgjhg

        #ExcConnector=[]
        #OutValue=0.0
        #inputneuron=0
        #flag=1


        



                
            #connections=self.makePlusConnectionsV3(numMultPops, eachOutNeuron, MultPopIncr, minWeight, toNeuronTotalValue)
            #EXConnections+=connections[0]     #excitatory connections            

        #print EXConnections
        print "finished"
        ###self.pause()

#exc_connections=self.sim.Projection(MultPops,RoundoutputPops , connList, receptor_type='excitatory')  





#print "neg pos"
#print "pos neg"
#print "neg neg"
#print "pos pos"


        """
        #minWeight=0.346 #want all cells to fire at exactly 3ms, using 0.26, when only one input of 0.26, will take 2ms after initiation to fire. 0.346 will make sure, even with a single input of 0.346, the cell will fire at exactly 3m and not at 5ms (with 0.26 conductance)
        #print "CALCULATE ROUNDED"
        print connvalues
        #adfasd
        for eachOutNeuron in range(0,OuttotalNum):  #rounded pop, takes 2ms
            if(OutnegNum>eachOutNeuron):
                OutValue+=-RoundOutIncrements
                inputneuron=0 ##INPUT NEURON IS THE NEURONS IN THE MULTPOP
                for eachIn1Neuron in range(0,In1negNum):
                    for eachIn2Neuron in range(0,In2totalNum-In2negNum):
                        #inputneuron=(eachIn1Neuron*(In2totalNum-In2negNum))+eachIn2Neuron
                        inputvalue=round(((eachIn1Neuron+1)*in1Increments)*((eachIn2Neuron+1)*in2Increments)*-1.0,10)
                        #eachset=round(((In2totalNum-In2negNum)*in2Increments)/MultPopIncr,10)
                        #inputneuron=int(round(((eachIn1Neuron)*eachset)+((eachIn2Neuron+1)*in2Increments)/MultPopIncr,10))
                        inputneuron=(int(round(abs(inputvalue)/MultPopIncr,10)))
                        
                        print "neg pos"
                        print "negative"
                        print eachOutNeuron
                        print eachIn1Neuron
                        print eachIn2Neuron                        
                        print inputvalue
                        print OutValue
                        print inputneuron
                        print in1Increments
                        print in2Increments
                        print MultPopIncr
                        ###self.pause()
                        
                        if(inputvalue==round(OutValue,10)):
                        #if(int(round(abs(inputvalue/RoundOutIncrements),1))==(eachOutNeuron)):
                        #if(round(inputvalue,2)==round(OutValue,2)):
                            
                            print "rounded negative values"
                            print "output neuron"
                            print eachOutNeuron
                            print "in1neuron"
                            print eachIn1Neuron
                            print "in2neuron"
                            print eachIn2Neuron
                            print "inputvalue"
                            print inputvalue
                            print "outvalue"
                            print OutValue
                            print "inputneuron"
                            print inputneuron
                            print "eachoutneuron"
                            print eachOutNeuron
                            c=inputneuron-1
                            
                            ExcConnector+=[(inputneuron-1, eachOutNeuron,minWeight,nealParameters.DELAY)] #connect negative input to negative output
                            #print ExcConnector
                            ###self.pause()
                        #inputneuron+=1                                                           
                for eachIn1Neuron in range(0,In1totalNum-In1negNum):
                    for eachIn2Neuron in range(0,In2negNum):
                        #inputneuron=(In1negNum*In2negNum)+(eachIn1Neuron*In2negNum)+eachIn2Neuron
                        inputvalue=round(((eachIn1Neuron+1)*in1Increments)*((eachIn2Neuron+1)*in2Increments)*-1.0,10)
                        #eachset=round((In2negNum*in2Increments)/MultPopIncr,10)
                        #inputneuron=connvalues[0]+int(round(((eachIn1Neuron)*eachset)+((eachIn2Neuron+1)*in2Increments)/MultPopIncr,10))
                        inputneuron=(connvalues[0]+int(round(abs(inputvalue)/MultPopIncr,10)))
                        
                        print "pos neg"
                        
                        print "negative"
                        print eachOutNeuron
                        print eachIn1Neuron
                        print eachIn2Neuron                        
                        print inputvalue
                        print OutValue
                        print inputneuron
                        ##self.pause()
                        
                        if(inputvalue==round(OutValue,10)):
                        #if(int(round(abs(inputvalue/RoundOutIncrements),1))==(eachOutNeuron)):
                        #if(round(inputvalue,2)==round(OutValue,2)):
                            
                            print "rounded negative values"
                            print "output neuron"
                            print eachOutNeuron
                            print "in1neuron"
                            print eachIn1Neuron
                            print "in2neuron"
                            print eachIn2Neuron
                            print "inputvalue"
                            print inputvalue
                            print "outvalue"
                            print OutValue
                            print "inputneuron"
                            print inputneuron
                            print "eachoutneuron"
                            print eachOutNeuron
                            
                            ExcConnector+=[(inputneuron-1, eachOutNeuron,minWeight,nealParameters.DELAY)] #connect negative input to negative output
                        
                        #inputneuron+=1
                       
            else:
                if(flag==1):
                    OutValue=0.0
                    flag=0
                OutValue+=RoundOutIncrements
                #inputneuron=MultnegNum                         
                #inputneuron=MultnegNum                   
                for eachIn1Neuron in range(0,In1negNum):
                    for eachIn2Neuron in range(0,In2negNum):
                        #inputneuron=MultnegNum+((eachIn1Neuron*In2negNum)+eachIn2Neuron)
                        inputvalue=round(((eachIn1Neuron+1)*in1Increments)*((eachIn2Neuron+1)*in2Increments),10)
                        #eachset=round((In2negNum*in2Increments)/MultPopIncr,10)
                        #inputneuron=MultnegNum+int(round(((eachIn1Neuron)*eachset)+((eachIn2Neuron+1)*in2Increments)/MultPopIncr,10))
                        inputneuron=MultnegNum+int(round(inputvalue/MultPopIncr,10))
                        
                        print "neg neg"
                        print"positive"
                        print eachOutNeuron
                        print eachIn1Neuron
                        print eachIn2Neuron
                        print inputvalue
                        print OutValue
                        print inputneuron
                        ##self.pause()
                        
                        if(inputvalue==round(OutValue,10)):
                        #if((int(round(abs(inputvalue/RoundOutIncrements),1))+OutnegNum)==(eachOutNeuron)):
                        #if(round(inputvalue,2)==round(OutValue,2)):
                            
                            
                            
                            print "rounded positive values"
                            print "output neuron"
                            print eachOutNeuron
                            print "in1neuron"
                            print eachIn1Neuron
                            print "in2neuron"
                            print eachIn2Neuron
                            print "inputvalue"
                            print inputvalue
                            print "outvalue"
                            print OutValue
                            print "inputneuron"
                            print inputneuron
                            print "multnegnum"
                            print MultnegNum
                            #print "eachoutneuron"
                            #print eachOutNeuron
                            
                            ExcConnector+=[(inputneuron-1, eachOutNeuron,minWeight,nealParameters.DELAY)] #connect negative input to negative output
                        #inputneuron+=1

                for eachIn1Neuron in range(0,In1totalNum-In1negNum):
                    #eachset=int(round((((In2totalNum-In2negNum))*in2Increments)/MultPopIncr,10))
                    #nextcell=0
                    #if(eachIn1Neuron==0):
                    #    nextstep=0
                    #else:
                    #nextstep=int(round(in2Increments/MultPopIncr))
                    #nextcell=nextstep
                    for eachIn2Neuron in range(0,In2totalNum-In2negNum):
                        #inputneuron=MultnegNum+(In2negNum*In1negNum)+((eachIn1Neuron*(In2totalNum-In2negNum))+eachIn2Neuron)
                        inputvalue=round(((eachIn1Neuron+1)*in1Increments)*((eachIn2Neuron+1)*in2Increments),10)
                        inputneuron=connvalues[1]+MultnegNum+int(round(inputvalue/MultPopIncr,10))

                        #((eachIn1Neuron)*eachset)+int(round(((eachIn2Neuron+1)*in2Increments)/MultPopIncr))
                        #nextcell+=nextstep
                        
                        print "pos pos"
                        print "positive"
                        print eachOutNeuron
                        print eachIn1Neuron
                        print eachIn2Neuron
                        print inputvalue
                        print OutValue
                        print inputneuron
                        ##self.pause()
                        
                        
                        print OutValue
                        if(OutValue==6.0):
                            print"positive"
                            print eachOutNeuron
                            print eachIn1Neuron
                            print eachIn2Neuron
                            print inputvalue
                            print OutValue
                            print inputneuron
                            ###self.pause()
                        )
                        if((((eachIn1Neuron+1)*in1Increments)==1.5)and((((eachIn2Neuron+1)*in2Increments)==4.0))):
                            print "in pos pos, and found the input values"
                            ###self.pause()
                        
                        if(inputvalue==round(OutValue,10)):
                        #if((int(round(abs(inputvalue/RoundOutIncrements),1))+OutnegNum)==(eachOutNeuron)):
                        #    if((((eachIn1Neuron+1)*in1Increments)==1.5)and((((eachIn2Neuron+1)*in2Increments)==4.0))):
                                                                           
                        #if(round(inputvalue,2)==round(OutValue,2)):
                            #if(in
                            
                            print "rounded positive values"
                            print "output neuron"
                            print eachOutNeuron
                            print "in1neuron"
                            print eachIn1Neuron
                            print "in2neuron"
                            print eachIn2Neuron
                            print "inputvalue"
                            print inputvalue
                            print "outvalue"
                            print OutValue
                            print "inputneuron"
                            print inputneuron-1
                            print "multnegnum"
                            print "numNeuronsRoundOutPop"
                            print numNeuronsRoundOutPop
                            print "nummultpops"
                            print numMultPops
                            print "In1totalNum-In1negNum"
                            print In1totalNum-In1negNum
                            print "In2totalNum-In2negNum"
                            print In2totalNum-In2negNum
                            #print "eachset"
                            #print eachset
                            print "connvalues"
                            print connvalues                               
                            ###self.pause()                                                                           
                            
                            #print "eachoutneuron"
                            #print eachOutNeuron
                            
                            ExcConnector+=[(inputneuron-1, eachOutNeuron,minWeight,nealParameters.DELAY)] #connect negative input to negative output
                        #inputneuron+=1
        print "ROUNDED CONNECTIONS"
        #print ExcConnector
        #fssfg
        
        connList = self.sim.FromListConnector(ExcConnector)
        print ExcConnector
        print MultPops
        print RoundoutputPops
        print inputPops1
        print inputPops2
        print numNeuronsIn1Pop
        print numNeuronsIn2Pop
        print in1Increments
        print in2Increments
        print MultPops
        print numMultPops
        print MultPopIncr
        print RoundoutputPops
        print numNeuronsRoundOutPop
        print RoundOutIncrements
        print In1totalNum-In1negNum
        print In2totalNum-In2negNum
        print In1negNum
        print In2negNum
        print MultnegNum
        print OutnegNum
        print OuttotalNum
        print connvalues
        
        print "THIS IS ROUNDED"
        ###self.pause()
        """
        
        #exc_connections=self.sim.Projection(MultPops,RoundoutputPops , connList, receptor_type='excitatory')                        




    def Multiplication(self, inputPops, outputPops, inputIncrements, OutputIncrements, numOutCells, numInCells, minWeight, numSets, kvalue, numOutCellsPerInp):


        



        #print "hello"
        ##first set of neurons is e-x
        ##second set of neurons, which is 1, is K
        #totalnumOutneurons=numOutCells[0]
        #totalNegnumOutneurons=numOutCells[1]
        #totalNegnumFneurons=numFcells[2]
        #print "inconnectfunction"
        ExcOutConn=[[] for k in range(1)]  #set up numSets sets of empty lists in an array
        #InhOutConn=[[] for k in range(numSets)]  #set up numSets sets of empty lists in an array
        #numNegNeurons=0
        #toFneuronTotalValue=0
        #ConnectToOutputNegCell=0  #start connecting the negative input cells to negative output cells
        #ConnectToOutputPosCell=0
        #PosOrNeg=-1                                      #set the value that each neuron represents as positive or negative
        #FneuronIsNeg=1
        #startNeuronOutPop=0
        #print inputIncrements
        #print OutputIncrements
        #E1X1K1cells
        #print numInCells
        #adfadf
        #    connections=[]
        #if(summation==1):
        #    ConnectToPosOutputCell=totalNegnumOutneurons              ##START THE POS COUNTER FROM THE NUM OF NEGATIVE NEURONS
        #    ConnectToNegOutputCell=0
        #else:
        #    ConnectToPosOutputCell=totalNegnumOutneurons              ##START THE POS COUNTER FROM THE NUM OF NEGATIVE NEURONS
       #     ConnectToNegOutputCell=0
        TotalOutNeg=numOutCells[1]
        InNumCells=numInCells[0]
        TotalInCells=InNumCells[0]     #e-x
        TotalInNegCells=InNumCells[1]  #e-x

        #if(kvalue<0):
        ConnectToOutputPosCell=TotalOutNeg
        #else
            
        ConnectToOutputNegCell=0
        """
        print "TotalInCells"
        print TotalInCells
        print "TotalI nNegCells"
        print TotalInNegCells
        print "connecttoputput"
        print ConnectToOutputPosCell
        print "numperneuron"
        print numOutCellsPerInp
        print kvalue
        print self.Karray
        print numOutCells
        print self.KneuronsPerEXneuron
        """
        #flag=0
#        adfasdf
        #for eachPop in range(0, 1):   #loop through e-x neurons and connect to times k neurons


#            secondSetInNumCells=numInCells[1]
#            secondTotalInCells=secondSetInNumCells[0]
#            secondTotalInNegCells=secondSetInNumCells[1]
            
        #if(eachPop>0):
#ConnectToPosOutputCell=totalNegPopCells
            #    startNeuronOutPop+=totalCells
            #if(InputIncr[eachPop]!=OutputIncr):
            #    print "WARNING:Input increments are not the same as output increments. Input: %s, Output: %s" % (str(InputIncr[eachPop]),str(OutputIncr))
            #    ####self.pause()
        #flag=0
        #if(kvalue<0):
        #    ConnectToOutputPosCell=
        #    ConnectToOutputNegCell=
        #else:
        #    ConnectToOutputPosCell=
        #   ConnectToOutputNegCell=
            
        for EachInputCell in range (0, TotalInCells): #numCells[0]==total, numCells[1]==numNegCells
                #if(summation==1):   #do summation, Pop1 + Pop2 + Pop3 + Pop4
            if(((TotalInNegCells>EachInputCell)and(kvalue<0))or((TotalInNegCells<=EachInputCell)and(kvalue>0))):    # inputincrements[1] refers to the value, the only neuron in k represents#if one both input cella are positive or negative, connect to positive output cell else connect to positive cell
                        #neg input and k is neg, or, pos input and k is pos output is pos
           #     print "CONNECTTOPOS"
           #     print TotalInNegCells
           #     print EachInputCell
           #     print kvalue                
                for i in range(0,numOutCellsPerInp):
                    ExcOutConn[0]+=[(EachInputCell, ConnectToOutputPosCell,minWeight,nealParameters.DELAY)] #excitatory connections
                    #ExcOutConn[1]+=[(0, ConnectToOutputPosCell,minWeight,nealParameters.DELAY)]
                    ConnectToOutputPosCell+=1
 
            else:
            #    print "CONNECTTONEG"
             #   print TotalInNegCells
             #   print EachInputCell
             #   print kvalue
                for i in range(0,numOutCellsPerInp):
                #pos input and k is neg, or, neg input and k is pos
                    ExcOutConn[0]+=[(EachInputCell, ConnectToOutputNegCell,minWeight,nealParameters.DELAY)] #e-x #excitatory connections
                #ExcOutConn[1]+=[(0, ConnectToOutputNegCell,minWeight,nealParameters.DELAY)]#only 1 neuron in k, so 0 and 1 in excoutconn as second set of input neurons
                    ConnectToOutputNegCell+=1

#            print "make E %s X %s K %s cells connections" % (eachPop,eachPop,eachPop)

                #else:       #subtraction, Pop1-Pop2-Pop3-Pop4
                #    if(eachPop==0):
                #        if(totalNegPopCells>EachInputCell): #if input cell is negative, connect to negative output cell else connect to positive cell
#ConnectToOutputCell=totalNegnumFneurons+totalNegCells  #start connecting the positive input cells to the positive output cells
                        #flag=1
                #            ExcOutConn[eachPop]+=[(EachInputCell, ConnectToNegOutputCell,minWeight,nealParameters.DELAY)] #excitatory connections
                #            ConnectToNegOutputCell+=1

                #        else:
                #            ExcOutConn[eachPop]+=[(EachInputCell, ConnectToPosOutputCell,minWeight,nealParameters.DELAY)] #excitatory connections
                #            ConnectToPosOutputCell+=1
                #    else:
                #        if(totalInNegCells>EachInputCell): #if input cell is positive, connect to negative output cell else connect to positive cell
#ConnectToOutputCell=totalNegnumFneurons+totalNegCells  #start connecting the positive input cells to the positive output cells
                        #flag=1
               #             ExcOutConn[eachPop]+=[(EachInputCell, ConnectToPosOutputCell,minWeight,nealParameters.DELAY)] #excitatory connections
               #             ConnectToPosOutputCell+=1
               #         else:
              #              ExcOutConn[eachPop]+=[(EachInputCell, ConnectToNegOutputCell,minWeight,nealParameters.DELAY)] #excitatory connections
              #              ConnectToNegOutputCell+=1

            #print "make E %s X %s K %s cells connections" % (eachPop,eachPop,eachPop)

        for i in range(0, 1):

           # print i
    #neal.nealProjection(InputPop[i], OutputPop, EXKPopExcToFConn[i], 'excitatory')  #excitatory
    #neal.nealProjection(EMinusXMultKCells[i], OutputPop, EXKPopInhToFConn[i], 'inhibitory')  #inhibitory
           # print inputPops[i]
           # print outputPops
             
            connList = self.sim.FromListConnector(ExcOutConn[i])
           # print connList
            exc_connections=self.sim.Projection(inputPops[i], outputPops, connList, receptor_type='excitatory')
        #connList = self.sim.FromListConnector(EXKPopInhToFConn[i])
        #inh_connections=self.sim.Projection(InputPop[i], OutputPop, connList, receptor_type='inhibitory')


            #print "MULTIPLICATION exc connections"
            #print exc_connections.get(["weight", "delay"], format="list")
            #####self.pause()

        #print "finished"        

    def Subtraction(self, inputPops, outputPops, inputIncrements, OutputIncrements, numOutCells, numInCells, minWeight, numSets, evalue):
        #print "hello"

        



        EXKPopExcToFConn=[[] for k in range(2)]  #set up numSets sets of empty lists in an array
        #EXKPopInhToFConn=[[] for k in range(2)]  #set up numSets sets of empty lists in an array




        
        ##first set of neurons is e-x
        ##second set of neurons, which is 1, is K
        #totalnumOutneurons=numOutCells[0]
        #totalNegnumOutneurons=numOutCells[1]
        #totalNegnumFneurons=numFcells[2]
        #print "inconnectfunction"
        #ExcOutConn=[[] for k in range(numSets)]  #set up numSets sets of empty lists in an array
        #InhOutConn=[[] for k in range(numSets)]  #set up numSets sets of empty lists in an array
        #numNegNeurons=0
        #toFneuronTotalValue=0
        ConnectToOutputNegCell=0  #start connecting the negative input cells to negative output cells
        ConnectToOutputPosCell=0
        #PosOrNeg=-1                                      #set the value that each neuron represents as positive or negative
        #FneuronIsNeg=1
        startNeuronOutPop=0
        #print inputIncrements
        #print OutputIncrements
        #E1X1K1cells
        #print numInCells
        #adfadf
        #    connections=[]
        #if(summation==1):
        #    ConnectToPosOutputCell=totalNegnumOutneurons              ##START THE POS COUNTER FROM THE NUM OF NEGATIVE NEURONS
        #    ConnectToNegOutputCell=0
        #else:
        #    ConnectToPosOutputCell=totalNegnumOutneurons              ##START THE POS COUNTER FROM THE NUM OF NEGATIVE NEURONS
       #     ConnectToNegOutputCell=0
        TotalInCells=[0,0]
        NegInCells=[0,0]
        flag=0
       # eValIncr=inputIncrements[0]#e
       # XValIncr=inputIncrements[1]#x

        fistSetInNumCells=numInCells[0]

        firstTotalInCells=fistSetInNumCells[0]     #e
        firstTotalInNegCells=fistSetInNumCells[1]  #e

        secondSetInNumCells=numInCells[1]
        secondTotalInCells=secondSetInNumCells[0]#x
        secondTotalInNegCells=secondSetInNumCells[1]#x
        
        TotalInCells[0]=firstTotalInCells  #e
        TotalInCells[1]=secondTotalInCells #x

        NegInCells[0]=firstTotalInNegCells #e
        NegInCells[1]=secondTotalInNegCells #x
        

        ConnectToOutputCell=0
        outNumCells=numOutCells[0]
        outNumCellsNeg=numOutCells[1]
        """
        print "XnumCells"
        print self.numNeuronsInEachXPop
        print "outnumcells"
        print outNumCells
        print "outnumcellsneg"
        print outNumCellsNeg
        print "totalincells"
        print TotalInCells
        print "negcells"
        print NegInCells
        """
        #adfadf
        
        for eachPop in range(0, 2):   #loop through e-x neurons and compare the sign with k, eachpop in this case is only 0, which refers to the set of neurons in e-x
            #if(evalue!=0.0):
        #eachpop =0 for e
        #eachpop =1 for x
            if(eachPop==0):     #eachpop=0=e pop
                if(evalue>0):
                        #connect to pos values
                    ConnectToOutputCell=outNumCellsNeg              ##START THE POS COUNTER FROM THE NUM OF NEGATIVE NEURONS
                        #ConnectToNegOutputCell=0
                        #ConnOutCell=
                else:
                        #connect to neg neurons (neg values)
                    ConnectToOutputCell=0
                    
            for EachInputCell in range(0,TotalInCells[eachPop]):  #connect the E populatoin to e-x first

                if((eachPop==0)):
                    #connect e pop to e-x
                    EXKPopExcToFConn[eachPop]+=[(EachInputCell, ConnectToOutputCell,minWeight,nealParameters.DELAY)]
                    ConnectToOutputCell+=1
                else:
                    #connect x pop to e-x
                    if(flag==0):
                        if(evalue>0):
                            ConnectToNegOutputCell=0
                            ConnectToPosOutputCell=ConnectToOutputCell #put x values after e values
                            flag=1
                        else:
                            ConnectToPosOutputCell=outNumCellsNeg
                            ConnectToNegOutputCell=ConnectToOutputCell #put x values after e values
                            flag=1
                    

                    if(NegInCells[eachPop]>EachInputCell):    #if input cell is negative, connect to positive output 
                        #ConnectToOutputCell=totalNegnumFneurons+totalNegCells  #start connecting the negative input cells to the positive output cells
                        #flag=1
                        EXKPopExcToFConn[eachPop]+=[(EachInputCell, ConnectToPosOutputCell,minWeight,nealParameters.DELAY)]     #excitatory connections
                        ConnectToPosOutputCell+=1
                    
                    else:   #if input cell is positive, connect to negative output
                        EXKPopExcToFConn[eachPop]+=[(EachInputCell, ConnectToNegOutputCell,minWeight,nealParameters.DELAY)]     #excitatory connections
                        ConnectToNegOutputCell+=1
                #else:
                #    if(totalNegPopCells>EachInputCell):    #if input cell is positive, connect to negative output cell else connect to positive cell
                        #ConnectToOutputCell=totalNegnumFneurons+totalNegCells  #start connecting the positive input cells to the positive output cells
                        #flag=1
                #        EXKPopExcToFConn[eachPop]+=[(EachInputCell, ConnectToPosOutputCell,minWeight,nealParameters.DELAY)]     #excitatory connections
                #        ConnectToPosOutputCell+=1
                    
                #    else:
                #        EXKPopExcToFConn[eachPop]+=[(EachInputCell, ConnectToNegOutputCell,minWeight,nealParameters.DELAY)]     #excitatory connections
                #        ConnectToNegOutputCell+=1                   
                
        #        print "make E %s X %s K %s cells connections" % (eachPop,eachPop,eachPop)               
        #print "connnections"
        #print EXKPopExcToFConn
        for i in range(0, 2):  #if i==0, e pop
            
        
    #neal.nealProjection(EMinusXMultKCells[i], FOutputCells, EXKPopExcToFConn[i], 'excitatory')  #excitatory
    #neal.nealProjection(EMinusXMultKCells[i], FOutputCells, EXKPopInhToFConn[i], 'inhibitory')  #inhibitory
            if((i>0)or(evalue!=0.0)):
                connList = self.sim.FromListConnector(EXKPopExcToFConn[i])
                exc_connections=self.sim.Projection(inputPops[i], outputPops, connList, receptor_type='excitatory')
        #connList = self.sim.FromListConnector(EXKPopInhToFConn[i])
        #inh_connections=self.sim.Projection(EMinusXMultKCells[i], FOutputCells, connList, receptor_type='inhibitory')

           #     print "E=i=0"
           #     print i
           #     print "X=i=1"
           #     print i
           #     print "exc connections"
           #     print exc_connections.get(["weight", "delay"], format="list")
           #     ####self.pause()                    



        """  
        #if(eachPop>0):
#ConnectToPosOutputCell=totalNegPopCells
            #    startNeuronOutPop+=totalCells
            #if(InputIncr[eachPop]!=OutputIncr):
            #    print "WARNING:Input increments are not the same as output increments. Input: %s, Output: %s" % (str(InputIncr[eachPop]),str(OutputIncr))
            #    ####self.pause()
        #flag=0
            for EachInputCell in range (0, firstTotalInCells): #numCells[0]==total, numCells[1]==numNegCells
                #if(summation==1):   #do summation, Pop1 + Pop2 + Pop3 + Pop4
                if((eValIncr-(XValIncr*(EachInputCell+1)))>0):
                    #if(((firstTotalInNegCells>EachInputCell)and(inputIncrements[1]<0))or((firstTotalInNegCells<EachInputCell)and(inputIncrements[1]>0))):    # inputincrements[1] refers to the value, the only neuron in k represents#if one both input cella are positive or negative, connect to positive output cell else connect to positive cell
#ConnectToOutputCell=totalNegnumFneurons+totalNegCells  #start connecting the positive input cells to the positive output cells
                    #flag=1
                        ExcOutConn[eachPop]+=[(EachInputCell, ConnectToOutputPosCell,minWeight/2,nealParameters.DELAY)] #excitatory connections
                        ExcOutConn[1]+=[(0, ConnectToOutputPosCell,minWeight/2,nealParameters.DELAY)]
                        ConnectToOutputPosCell+=1
 
                    else:
                        ExcOutConn[eachPop]+=[(EachInputCell, ConnectToOutputNegCell,minWeight/2,nealParameters.DELAY)] #e-x #excitatory connections
                        ExcOutConn[1]+=[(0, ConnectToOutputNegCell,minWeight/2,nealParameters.DELAY)]#only 1 neuron in k, so 0 and 1 in excoutconn as second set of input neurons
                        ConnectToOutputNegCell+=1

                    print "make E %s X %s K %s cells connections" % (eachPop,eachPop,eachPop)

                #else:       #subtraction, Pop1-Pop2-Pop3-Pop4
                #    if(eachPop==0):
                #        if(totalNegPopCells>EachInputCell): #if input cell is negative, connect to negative output cell else connect to positive cell
#ConnectToOutputCell=totalNegnumFneurons+totalNegCells  #start connecting the positive input cells to the positive output cells
                        #flag=1
                #            ExcOutConn[eachPop]+=[(EachInputCell, ConnectToNegOutputCell,minWeight,nealParameters.DELAY)] #excitatory connections
                #            ConnectToNegOutputCell+=1

                #        else:
                #            ExcOutConn[eachPop]+=[(EachInputCell, ConnectToPosOutputCell,minWeight,nealParameters.DELAY)] #excitatory connections
                #            ConnectToPosOutputCell+=1
                #    else:
                #        if(totalInNegCells>EachInputCell): #if input cell is positive, connect to negative output cell else connect to positive cell
#ConnectToOutputCell=totalNegnumFneurons+totalNegCells  #start connecting the positive input cells to the positive output cells
                        #flag=1
               #             ExcOutConn[eachPop]+=[(EachInputCell, ConnectToPosOutputCell,minWeight,nealParameters.DELAY)] #excitatory connections
               #             ConnectToPosOutputCell+=1
               #         else:
              #              ExcOutConn[eachPop]+=[(EachInputCell, ConnectToNegOutputCell,minWeight,nealParameters.DELAY)] #excitatory connections
              #              ConnectToNegOutputCell+=1

                    print "make E %s X %s K %s cells connections" % (eachPop,eachPop,eachPop)

        for i in range(0, numSets):

            print i
    #neal.nealProjection(InputPop[i], OutputPop, EXKPopExcToFConn[i], 'excitatory')  #excitatory
    #neal.nealProjection(EMinusXMultKCells[i], OutputPop, EXKPopInhToFConn[i], 'inhibitory')  #inhibitory
            print inputPops[i]
            print outputPops
             
            connList = self.sim.FromListConnector(ExcOutConn[i])
            print connList
            exc_connections=self.sim.Projection(inputPops[i], outputPops, connList, receptor_type='excitatory')
        #connList = self.sim.FromListConnector(EXKPopInhToFConn[i])
        #inh_connections=self.sim.Projection(InputPop[i], OutputPop, connList, receptor_type='inhibitory')


            print "exc connections"
            print exc_connections.get(["weight", "delay"], format="list")
            ####self.pause()

        print "finished"
        """
    def PrintOutPopulationSets(self, population, increments, populationNum, whichNeuronsFired, runDur, runs):
        for j in range(0,self.numSets):
            d=str(increments[j])
            title= "Value Increment Per Spiking Neuron: %s" % d
            print "RESULTS"
            print title
            #print "min value of E %s... pop:" %j
            #print minEminusXMultKarray[j]
    
            print "FIREDNEURONS LAJFLKASDJKFLJSADLKFJSALAKDJF"
            firedneurons=whichNeuronsFired[j]
            if(firedneurons!=[]):
                numFired=len(firedneurons)
                numNeurons=populationNum[j]
                total=numNeurons[0]
                totalneg=numNeurons[1]
                #for i in range(0,numFired)
                if(totalneg==0):
                    numposvalues=numFired
                    numnegvalues=0
                else:
                    numnegvalues=len([1 for i in firedneurons if i < totalneg])
                    numposvalues=len([1 for i in firedneurons if i >= totalneg])
        #numnegvalues=sum(firedneurons < totalneg)
        #numposvalues=sum(firedneurons>totalneg)
                print "neurons fired"
                print firedneurons
                print "num of negative neurons fired"
                print numnegvalues
                print "num of positive neurons fired"
                print numposvalues        
        #if(min(firedneurons)<totalneg):   #lowest cell in population that fired
        #    PosOrNeg=-1
        #else:
        #    PosOrNeg=1

                print "min"
                print min(firedneurons)
                print "numfired"
                print numFired
                print "totalneg"
                print totalneg
                print "firedneurons"
                print firedneurons
                print "output value of E %s... pop:" %j
        #print numFired*EXKincrements[j]*PosOrNeg
                print (numnegvalues*increments[j]*-1)+(numposvalues*increments[j])
            else:
                print "output value of E %s... pop:" %j
                print str(0)
            #print "Expected Value:"
            #print InputValue[j]
            self.PlotMembraneVoltageAndSpikes(population[j],j+1,runDur*runs-1, title)

    def ConnectCos(self, X1Cells, X1CellSize, X1incr, CosCells, CosCellSize, COSincr, minWeight, PulseCell, WhichPulseCell, X1InterCells, PulseCell2, WhichPulseCell2):
        #print "cos"
        #print "sin"
        #extra x1intercells pop is to split the input into cycles, so we only allow one part of the input to be used to calculate the cos value 
        #as cos(0)=1, we need several single neurons in a line so that when is it time for the cos population to fire something, the single neuron fires a spike to make all of the positivie subset of the cos population fire, unless other spikes came through and therefore inhibition may need to take place
        ExcConnector=[]
        ExcConnector2=[]
        InhConnector=[]
        ExcConnector3=[]
        InhConnector3=[]
        #print CosCells
        #print CosCellSize
        #print COSincr

        X1totalNum=X1CellSize[0]
        X1negNum=X1CellSize[1]

        COStotal=CosCellSize[0]
        COSneg=CosCellSize[1]
        #####
        #connect pulse neuron into cosine population so if no input to cosine pop, all pos neurons fire, i.e. cos(0)=1.  Thus, to make other numbers we need to inhibit the appropriate neurons
        for eachPosCosCell in range(0, COStotal-COSneg):
            ExcConnector2+=[(WhichPulseCell, COSneg+eachPosCosCell,minWeight,nealParameters.DELAY)]


        connList = self.sim.FromListConnector(ExcConnector2)
        exc_connections=self.sim.Projection(PulseCell, CosCells, connList, receptor_type='excitatory')
        ##########

        #print ExcConnector2
        #adfasdf
        
        X1MinValue=self.minXarray[1]
        X1MaxValue=self.maxXarray[1]
        FromX1cell=0
        prevcosvalue=2
        once=0
        flag1=1
        flag2=1
        flag3=1
        flag4=1
        InhConnector4=[]
        adddec=0.0
        activate=0
        #alreadyconnected=ones(COStotal-COSneg)
        #alreadyconnected[COStotal-COSneg-1]=0
        #alreadyconnected3=alreadyconnected
        StartDeCell=COStotal-1
        PopSize=COStotal-COSneg
        StartDeCell2=COStotal-COSneg-1
        startcell=57656
        prevCy=0
        print "X1"
        print X1negNum
        print X1totalNum
        #if(X1MinValue<0):
        #    X1Value=-X1incr
        #    alreadyconnected=zeros(COSneg)
        #else:
        #    X1Value=X1incr
        #    alreadyconnected=zeros(COStotal)
        if(X1negNum>0):
            X1Value=-6.27       #start it as -2*pi
        else:
            X1Value=X1incr
        numCells=0
        numCells2=0
        flag2=1
        firstsection=[]
        lastsection=[]
        numcells2=1
        cenum=0
        alreadyconnectednegINH=zeros(COSneg)
        alreadyconnectedposINH=zeros(COStotal-COSneg)
        alreadyconnectednegEXC=zeros(COSneg)
        alreadyconnectedposEXC=zeros(COStotal-COSneg)

        alreadyconnectednegINH2=zeros(COStotal)
        alreadyconnectedposINH2=zeros(COStotal)
        alreadyconnectednegEXC2=zeros(COStotal)
        alreadyconnectedposEXC2=zeros(COStotal)

        ###FOR THE SIN CONNECTION TO WORK WE NEED TO EXCHANGE THE LOWER NEG NUMBERS FOR THE HIGH NUMBERS AND VICE VERSA, SO -0.01 WILL EQUAL -6.27
        #connect pulse neuron into cosine population so if no input to cosine pop, all pos neurons fire, i.e. cos(0)=1.  Thus, to make other numbers we need to inhibit the appropriate neurons
        ExcConnector6=[]
        InhConnector6=[]
        for eachNegX1Cell in range(0, X1negNum):
            ExcConnector6+=[(WhichPulseCell2, eachNegX1Cell, minWeight,nealParameters.DELAY)]


        if(ExcConnector6!=[]):
            connList = self.sim.FromListConnector(ExcConnector6)
            exc_connections=self.sim.Projection(PulseCell2, X1InterCells, connList, receptor_type='excitatory')

        cell=X1negNum-1
        for eachNegX1Cell in range(0, X1negNum):
            InhConnector6+=[(eachNegX1Cell, cell,minWeight,nealParameters.DELAY)]
            cell=cell-1

        if(InhConnector6!=[]):
            connList = self.sim.FromListConnector(InhConnector6)
            exc_connections=self.sim.Projection(X1Cells, X1InterCells, connList, receptor_type='inhibitory')



        for eachPosX1Cell in range(0, X1totalNum-X1negNum):
            ExcConnector3+=[(eachPosX1Cell+X1negNum, eachPosX1Cell+X1negNum,minWeight,nealParameters.DELAY)]
        ##################
        
        for eachX1cell in range(0,X1totalNum):
            cosvalue=cos(X1Value)
            #ExcConnector3+=[(eachX1cell, eachX1cell,minWeight,nealParameters.DELAY)]
            if((cosvalue<prevcosvalue)and(cosvalue>0)and(prevcosvalue>0)and(flag1==1)):
                #numCells=numCells-1 ###numCells-1 as we are interested in the prevcosvalue as the start of the cycle

                
                if (eachX1cell>0):
                    for i in range(0, numCells-numCells2):
                        InhConnector3+=[(numCells, i+numCells2,minWeight,nealParameters.DELAY)]  #inhibit all of the previous cycles neurons
          #          prevCy=numCells
                    """
                    print "adfjsalkfdfjsdlkfj"
                    print numCells
                    print numCells2
                    print numCells-numCells2
                    print cosvalue
                    print prevcosvalue
                    """
                    #self.pause()
                    numCells2=numCells
                    alreadyconnectednegINH=zeros(COSneg)
                    alreadyconnectedposINH=zeros(COStotal-COSneg)
                    alreadyconnectednegEXC=zeros(COSneg)
                    alreadyconnectedposEXC=zeros(COStotal-COSneg)                   
                ###any still in the pos pop (above section) need to be deactivated
                    #print alreadyconnected
                    #wrtwr
                    """
                    for i in range(0, COStotal-COSneg):
                        if (alreadyconnected[i]==1):
                            InhConnector+=[(eachX1cell, COStotal-1-i,minWeight,nealParameters.DELAY)]
                    """
                    #cenum=numcells2        
                ###self.pause()
                #prevSinValue=0
                activate=0
                #startcell=COSneg
                StartDeCell=COStotal-1
                PopSize=COStotal-COSneg
                StartDeCell2=COStotal-COSneg-1
                #alreadyconnected=zeros(COStotal-COSneg)
                #if (eachX1cell>0):
                #    alreadyconnected3[COStotal-COSneg-1]=0
                
                #alreadyconnected=alreadyconnected3
                flag1=0
                flag4=1
                numc=0
                
           #     numcells2=1
           #     if(numCells2>0):
           #         firstsection+=[eachX1cell]                
            #elif((cosvalue<prevcosvalue)and(cosvalue>0)and(prevcosvalue>0)):
             #   numcells2+=1
            elif((cosvalue<0)and(prevcosvalue>0)and(flag3==1)):
                #recordX=eachX1cell-1 #-1 for previous x value before intersection
                ###any still in the pos pop (above section) need to be deactivated
                
                for i in range(0, COStotal-COSneg):
                    if (alreadyconnectedposINH[i]==0):
                        InhConnector+=[(eachX1cell, COSneg+i,minWeight,nealParameters.DELAY)]
                
                ##########
                activate=1
                startcell=0
                #StartDeCell=COStotal-1
                PopSize=COSneg
                #alreadyconnected=zeros(PopSize)
                #alreadyconnected=alreadyconnected2
                flag1=1
                flag3=0
            elif((cosvalue<0)and(prevcosvalue<0)and(cosvalue>prevcosvalue)and(flag2==1)):
                ###any still in the pos pop (above section) need to be deactivated
                #for i in range(0, COSneg):
                #    if (alreadyconnected[i]==1):
                #        InhConnector+=[(eachX1cell, COSneg-1-i,minWeight,nealParameters.DELAY)]                
                activate=2
                StartDeCell=COSneg-1
                StartDeCell2=COSneg-1
                PopSize=COSneg
                flag2=0
                flag3=1
                
                #alreadyconnected=zeros(PopSize)
            elif((cosvalue>0)and(prevcosvalue<0)and(flag4==1)):
                ###any still in the pos pop (above section) need to be deactivated
                
                for i in range(0, COSneg):
                    if (alreadyconnectednegINH[i]==0):
                        InhConnector+=[(eachX1cell, i,minWeight,nealParameters.DELAY)]
                        

                #print alreadyconnected
                ###self.pause()
                activate=3
                flag2=1
                flag4=0

                #COSneuronsToActivate=int(np.fix((abs(cosvalue/COSincr)+adddec)))
                
                startcell=COSneg
                PopSize=COStotal-COSneg                
                #alreadyconnected=zeros(PopSize)
                
                #numc=numcells2-2  ##-1 as we are intereseted in the neuron representing the prev value and another -1 to take 1 off for the array values
            if((cosvalue)<0):
                adddec=-0.00001
            elif((cosvalue)>0):
                adddec=0.00001
            else:
                adddec=0.0


            #if((cosvalue>0)and(cosvalue>prevcosalue)):
            #    activate=1
           # elif((cosvalue>0)and(cosvalue<prevcosalue)):
          #      activate=0
         #   elif((cosvalue<0)and(cosvalue<prevcosalue)):
        #        activate=1
        #    elif((cosvalue<0)and(cosvalue>prevcosalue)):
          #      activate=0
        #alreadyconnectednegINH=zeros(COSneg)
        #alreadyconnectedposINH=zeros(COStotal-COSneg)
        #alreadyconnectednegEXC=zeros(COSneg)
        #alreadyconnectedposEXC=zeros(COStotal-COSneg)  
        
            COSneuronsToActivate=int(np.fix((abs(cosvalue/COSincr)+adddec)))
            COSneuronsToDeActivate=int(PopSize-COSneuronsToActivate)
            #print "##################"
            
            if(activate==1):
                
                for eachCosCell in range(0,COSneuronsToActivate):
                    #print "activateeachSinCell"
                    #print eachSinCell
                    ToCell=eachCosCell
                        #print "sin>prev"
                        #print sinvalue
                        #print prevSinValue
                    
                    
                        #print SINneuronsActivate
                        #print ToCell
                        #print alreadyconnected
                        #print X1Value                        
                    if (alreadyconnectednegEXC[eachCosCell]==0):
                        #print "EXCITE"
                        #print eachX1cell
                        #print ToCell
                        ExcConnector+=[(eachX1cell, ToCell,minWeight,nealParameters.DELAY)]
                        alreadyconnectednegEXC[eachCosCell]=1
                        alreadyconnectednegEXC2[eachCosCell]+=1
            elif(activate==0):
                #SINneuronsActivate=int(np.fix(abs((sinvalue/SINincr)+adddec)))


                
                for eachCosCell in range(0,COSneuronsToDeActivate):
                    #print "deactivateeachSinCell"
                    #print eachSinCell                    
                    ToCell=COStotal-1-eachCosCell
                        #print "sin<prev"
                        #print sinvalue
                        #print prevSinValue
                        #print SINneuronsActivate
                        #print ToCell
                    
                        #print alreadyconnected
                        #print X1Value                        
                    #if (eachSinCell>=SINneuronsToActivate):
                    if (alreadyconnectedposINH[(COStotal-COSneg)-1-eachCosCell]==0):
                        #print "INHIBIT"
                        #print eachX1cell
                        #print ToCell                        
                        InhConnector+=[(eachX1cell, ToCell,minWeight,nealParameters.DELAY)]
                        alreadyconnectedposINH[(COStotal-COSneg)-1-eachCosCell]=-1
                        alreadyconnectedposINH2[(COStotal-COSneg)-1-eachCosCell]+=-1
            elif(activate==2):
                #SINneuronsActivate=int(np.fix(abs((sinvalue/SINincr)+adddec)))


                
                for eachCosCell in range(0,COSneuronsToDeActivate):
                    #print "deactivateeachSinCell"
                    #print eachSinCell                    
                    ToCell=COSneg-1-eachCosCell
                        #print "sin<prev"
                        #print sinvalue
                        #print prevSinValue
                        #print SINneuronsActivate
                        #print ToCell
                        #print alreadyconnected
                        #print X1Value                        
                    #if (eachSinCell>=SINneuronsToActivate):
                    if (alreadyconnectednegINH[COSneg-1-eachCosCell]==0):
                        #print "INHIBIT"
                        #print eachX1cell
                        #print ToCell                        
                        InhConnector+=[(eachX1cell, ToCell,minWeight,nealParameters.DELAY)]
                        alreadyconnectednegINH[COSneg-1-eachCosCell]=-1
                        alreadyconnectednegINH2[COSneg-1-eachCosCell]+=-1
        
        
                              
            elif(activate==3):
                #SINneuronsActivate=int(np.fix(abs((sinvalue/SINincr)+adddec)))
                #SINneuronsActivate=int(np.fix(abs((sinvalue/SINincr)+adddec)))
                #inhibit the input neurons so that the pulse cell allows fires all and we inhibit the correct ones
                #print "EXCITE"
                for eachCosCell in range(0,COSneuronsToActivate):
                    #print "activateeachSinCell"
                    #print eachSinCell
                    ToCell=COSneg+eachCosCell
                        #print "sin>prev"
                        #print sinvalue
                        #print prevSinValue
                        #print SINneuronsActivate
                        #print ToCell
                        #print alreadyconnected
                        #print X1Value                        
                    if (alreadyconnectedposEXC[eachCosCell]==0):
                        #print "EXCITE"
                        #print eachX1cell
                        #print ToCell
                        ExcConnector+=[(eachX1cell, ToCell,minWeight+0.2,nealParameters.DELAY)]  #need to add 0.2 as the cells already have excitatory and inhibition going into it, so we need to add another excitatory input plus a bit more to make it fire
                        alreadyconnectedposEXC[eachCosCell]=1
                        alreadyconnectedposEXC2[eachCosCell]+=1
                
               # if(recordX>=numCells2):
               #     InhConnector4+=[(eachX1cell, recordX,minWeight,nealParameters.DELAY)]  #numcells2 and numCells2 are 2 diff variables
               # 
               #     recordX=recordX-1
                """
                for eachCell in range(0,COSneuronsToActivate):
                    #print "activateeachSinCell"
                    #print eachSinCell
                    ToCell=StartDeCell-eachCosCell
                        #print "sin>prev"
                        #print sinvalue
                        #print prevSinValue
                        #print SINneuronsActivate
                        #print ToCell
                        #print alreadyconnected
                        #print X1Value                        
                    if (alreadyconnected[eachCosCell]==0):
                        
                        print eachX1cell
                        print ToCell
                       
                        alreadyconnected[eachCosCell]=1
                """
            """
            print "increment"
            print X1incr
            print "COSneuronsToActivate"
            print COSneuronsToActivate            
            print "eachX1cell"
            print eachX1cell
            print "X1Value"
            print X1Value
            print "cosvalue"
            print cosvalue
            print "activate"
            print activate
            print "prevCosValue"
            print prevcosvalue
            print "startcell"
            print startcell
            print "alreadyconnected"
            print alreadyconnected
            print "startdecell"
            print StartDeCell2
            print "StartDeCell2-eachCosCell"
            print StartDeCell2-eachCosCell
            print "COSneuronsToDeActivate"
            print COSneuronsToDeActivate
            """



            prevcosvalue=cosvalue
            numCells+=1
            X1Value+=X1incr
        """
        print firstsection
        print lastsection
        ##self.pause()

        print "INHIB"
        print InhConnector
        print "EXCITE"
        print ExcConnector

        print "inh4"
        print InhConnector4

        print alreadyconnectednegINH2
        print alreadyconnectedposINH2
        print alreadyconnectednegEXC2
        print alreadyconnectedposEXC2
        """
        #self.pause()
        #adfadf

        if(ExcConnector3!=[]):
            connList = self.sim.FromListConnector(ExcConnector3)
            exc_connections=self.sim.Projection(X1Cells, X1InterCells, connList, receptor_type='excitatory')

        if(InhConnector3!=[]):
            connList = self.sim.FromListConnector(InhConnector3)
            exc_connections=self.sim.Projection(X1Cells, X1InterCells, connList, receptor_type='inhibitory')

#        connList = self.sim.FromListConnector(InhConnector4)
#        exc_connections=self.sim.Projection(X1Cells, X1InterCells, connList, receptor_type='inhibitory')

        if(ExcConnector!=[]):
            connList = self.sim.FromListConnector(ExcConnector)
            exc_connections=self.sim.Projection(X1InterCells, CosCells, connList, receptor_type='excitatory')

        if(InhConnector!=[]):
            connList = self.sim.FromListConnector(InhConnector)
            exc_connections=self.sim.Projection(X1InterCells, CosCells, connList, receptor_type='inhibitory')       

    def ConnectSin(self, X1Cells, X1CellSize, X1incr, SinCells, SinCellSize, SINincr, minWeight, X1CellCopy, PulseCell, WhichPulseCell):
        print "CONNECTSIN"
        ExcConnector=[]
        InhConnector=[]
        ExcConnector2=[]
        InhConnector2=[]        
        print SinCells
        print SinCellSize
        print SINincr

        X1totalNum=X1CellSize[0]
        X1negNum=X1CellSize[1]

        SINtotal=SinCellSize[0]
        SINneg=SinCellSize[1]

        ####need to offset x1incr, otherwise each cycle of neurons will be offset and therefore produce wrong answers
        #
        #pi2=pi*2
        #off=pi2/X1incr
        #offsetnum=round(off)
        #X1incr=pi2/offsetnum
        
        #adddec=0.0000001
        adddec=0.0
        X1MinValue=self.minXarray[1]
        X1MaxValue=self.maxXarray[1]
        FromX1cell=0
        prevSinValue=0
        once=0
         
        print "X1"
        print X1negNum
        print X1totalNum
        #if(X1MinValue<0):
        #    X1Value=-X1incr
        #    alreadyconnected=zeros(SINneg)
        #else:
        #X1Value=X1incr
        #alreadyconnected=zeros(SINtotal)
        if(X1negNum>0):
            X1Value=-6.27   #start at -2*pi
        else:
            X1Value=X1incr
        ####X1 TO X1 COPY -- AS X1 COULD HAVE MANY SIN CYCLES, WE WANT TO MAKE SURE ONLY ONE CYCLE GETS FORWARDED TO THE SIN POP, THEREFORE, IF THE VALUES ENTERS THE SECOND CYCLE, THIRD CYCLE, WE WANT TO INHIBIT THE PREVIOUS ONES
        numCells=0
        numCells2=0

        #####
        ExcConnector6=[]
        InhConnector6=[]
        ###FOR THE SIN CONNECTION TO WORK WE NEED TO EXCHANGE THE LOWER NEG NUMBERS FOR THE HIGH NUMBERS AND VICE VERSA, SO -0.01 WILL EQUAL -6.27
        #connect pulse neuron into cosine population so if no input to cosine pop, all pos neurons fire, i.e. cos(0)=1.  Thus, to make other numbers we need to inhibit the appropriate neurons
        for eachNegX1Cell in range(0, X1negNum):
            ExcConnector6+=[(WhichPulseCell, eachNegX1Cell,minWeight,nealParameters.DELAY)]


        if(ExcConnector6!=[]):
            connList = self.sim.FromListConnector(ExcConnector6)
            exc_connections=self.sim.Projection(PulseCell, X1CellCopy, connList, receptor_type='excitatory')

        cell=X1negNum-1
        for eachNegX1Cell in range(0, X1negNum):
            InhConnector6+=[(eachNegX1Cell, cell,minWeight,nealParameters.DELAY)]
            cell=cell-1

        if(InhConnector6!=[]):
            connList = self.sim.FromListConnector(InhConnector6)
            exc_connections=self.sim.Projection(X1Cells, X1CellCopy, connList, receptor_type='inhibitory')



        for eachPosX1Cell in range(0, X1totalNum-X1negNum):
            ExcConnector2+=[(eachPosX1Cell+X1negNum, eachPosX1Cell+X1negNum,minWeight,nealParameters.DELAY)]
        
        ##########

        
        for eachX1cell in range(0,X1totalNum):
            
            sinvalue=sin(X1Value)
            ##connect x1 to x1 copy
            
                
            
            if((prevSinValue<=0)and(sinvalue>0)):
                if(eachX1cell>0):
                    ##inhibit any residual neurons that should be off
                    for i in range(0, SINneg):
                        if (alreadyconnected2[i]==1):
                            InhConnector+=[(eachX1cell, i,minWeight,nealParameters.DELAY)]
                
                startcell=SINneg
                StartDeCell=SINtotal-1
                alreadyconnected2=zeros(SINtotal-SINneg)
                StartDeCell2=SINtotal-SINneg-1
                PopSize=SINtotal-SINneg
                

                if(eachX1cell>0):
                    """
                    print "inhibadjasldkfjflskdjfflskajdf"
                    print sinvalue
                    print prevSinValue
                    print eachX1cell
                    print numCells
                    print numCells2
                    """
                    for i in range(0, numCells-numCells2):
                        InhConnector2+=[(numCells, i+numCells2,minWeight,nealParameters.DELAY)]  #inhibit all of the previous cycles neurons
                    numCells2=numCells
                        
                    
                    ###self.pause()
                ###################
                #prevSinValue=0
                ###################
                #if(X1negNum>eachX1cell):
                #    X1Value=-X1incr
               # else:
               #     X1Value=X1incr
               #takevalue=SINtotal-SINneg
            elif((prevSinValue>=0)and(sinvalue<0)):
                ##inhibit any residual neurons that should be off
                for i in range(0, SINtotal-SINneg):
                    if (alreadyconnected2[i]==1):
                        InhConnector+=[(eachX1cell, SINneg+i,minWeight,nealParameters.DELAY)]
                
                startcell=0
                StartDeCell=SINneg-1
                StartDeCell2=SINneg-1
                alreadyconnected2=zeros(SINneg)
                PopSize=SINneg
                ##############
                #prevSinValue=0
                ##############
                #if(X1negNum>eachX1cell):
                #    X1Value=-X1incr
                #else:
                #    X1Value=X1incr                
                #takevalue=-1.0
                
            if((sinvalue)<0):
                adddec=-0.00001
                
            elif((sinvalue)>0):
                adddec=0.00001
            else:
                adddec=0.0
                
            """
            if(X1negNum>eachX1cell):               
                if(sinvalue<prevSinValue):                     
                    SINneuronsToActivate=int(np.fix(abs((sinvalue/SINincr)+adddec)))
                    for eachSinCell in range(0,SINneuronsToActivate):
                    
                        if (alreadyconnected[eachSinCell]==0):
                            ExcConnector+=[(eachX1cell, eachSinCell,minWeight,nealParameters.DELAY)]
                            alreadyconnected[eachSinCell]=1
                else:
                    SINneuronsActivate=int(np.fix(abs((sinvalue/SINincr)+adddec)))
                    
                    for eachSinCell in range(0,SINneg):
                        #print "sin>prev"
                        #print sinvalue
                        #print prevSinValue
                        #print SINneuronsActivate
                        #print eachSinCell
                        #print alreadyconnected
                        #print X1Value
                        if (eachSinCell>=SINneuronsActivate):
                            if (alreadyconnected[eachSinCell]==1):
                                InhConnector+=[(eachX1cell, eachSinCell,minWeight,nealParameters.DELAY)]
                                alreadyconnected[eachSinCell]=-1
                        
                X1Value+=-X1incr
            else:
            """
            """
                if(once==0):
                    once=1
                    X1Value=X1incr
                    
                    
                    prevSinValue=0
                    startcell=SINneg
                    sinvalue=sin(X1Value)
                    #fromCell=X1negNum
            """
            if((sinvalue>0)and(sinvalue>prevSinValue)):
                activate=1
            elif((sinvalue>0)and(sinvalue<prevSinValue)):
                activate=0
            elif((sinvalue<0)and(sinvalue<prevSinValue)):
                activate=1
            elif((sinvalue<0)and(sinvalue>prevSinValue)):
                activate=0


            
            SINneuronsToActivate=int(np.fix((abs(sinvalue/SINincr)+adddec)))
            SINneuronsToDeActivate=int(PopSize-SINneuronsToActivate)
            #print "##################"
            if(activate==1):
                
                for eachSinCell in range(0,SINneuronsToActivate):
                    #print "activateeachSinCell"
                    #print eachSinCell
                    ToCell=startcell+eachSinCell
                        #print "sin>prev"
                        #print sinvalue
                        #print prevSinValue
                        #print SINneuronsActivate
                        #print ToCell
                        #print alreadyconnected
                        #print X1Value                        
                    if (alreadyconnected2[eachSinCell]==0):
                        #print "EXCITE"
                        #print eachX1cell
                        #print ToCell
                        ExcConnector+=[(eachX1cell, ToCell,minWeight,nealParameters.DELAY)]
                        alreadyconnected2[eachSinCell]=1
            else:
                #SINneuronsActivate=int(np.fix(abs((sinvalue/SINincr)+adddec)))
                
                for eachSinCell in range(0,SINneuronsToDeActivate):
                    #print "deactivateeachSinCell"
                    #print eachSinCell                    
                    ToCell=StartDeCell-eachSinCell
                        #print "sin<prev"
                        #print sinvalue
                        #print prevSinValue
                        #print SINneuronsActivate
                        #print ToCell
                        #print alreadyconnected
                        #print X1Value                        
                    #if (eachSinCell>=SINneuronsToActivate):
                    if (alreadyconnected2[StartDeCell2-eachSinCell]==1):
                        #print "INHIBIT"
                        #print eachX1cell
                        #print ToCell                        
                        InhConnector+=[(eachX1cell, ToCell,minWeight,nealParameters.DELAY)]
                        alreadyconnected2[StartDeCell2-eachSinCell]=-1
            """
            print "increment"
            print X1incr
            print "SINneuronsToActivate"
            print SINneuronsToActivate            
            print "eachX1cell"
            print eachX1cell
            print "X1Value"
            print X1Value
            print "sinvalue"
            print sinvalue
            print "activate"
            print activate
            print "prevSinValue"
            print prevSinValue
            print "startcell"
            print startcell
            print "alreadyconnected"
            print alreadyconnected2
            print "startdecell"
            print StartDeCell2
            print "StartDeCell2-eachSinCell"
            print StartDeCell2-eachSinCell
            print "SINneuronsToDeActivate"
            print SINneuronsToDeActivate
            """    
            #if(X1negNum>eachX1cell):
            #    X1Value+=-X1incr
            #else:
            X1Value+=X1incr  
               # X1Value+=X1incr

            prevSinValue=sinvalue
            numCells+=1

        """    
        print "EXC inter to sin"
        print ExcConnector
        print "INH inter to sin"
        print InhConnector
        print "EXC x1 to interx1"
        print ExcConnector2
        print "INH x1 to interx1"
        print InhConnector2        
        jhjhg
        """

        if(ExcConnector2!=[]):
            connList = self.sim.FromListConnector(ExcConnector2)
            exc_connections=self.sim.Projection(X1Cells, X1CellCopy, connList, receptor_type='excitatory')

        if(InhConnector2!=[]):
            connList = self.sim.FromListConnector(InhConnector2)
            exc_connections=self.sim.Projection(X1Cells, X1CellCopy, connList, receptor_type='inhibitory')

        if(ExcConnector!=[]):
            connList = self.sim.FromListConnector(ExcConnector)
            exc_connections=self.sim.Projection(X1CellCopy, SinCells, connList, receptor_type='excitatory')

        if(InhConnector!=[]):
            connList = self.sim.FromListConnector(InhConnector)
            exc_connections=self.sim.Projection(X1CellCopy, SinCells, connList, receptor_type='inhibitory')

    def ConnectPulseToEOrKCells(self, inputPop, InputPopNum, WhichPulseCell, PulseCellPop, minWeight, value):
        ExcConnector=[]
        NumCells=InputPopNum[0]

        if(value!=0.0):
            for eachCell in range(0,NumCells):
                ExcConnector+=[(WhichPulseCell, eachCell,minWeight,nealParameters.DELAY)]

            connList = self.sim.FromListConnector(ExcConnector)
            exc_connections=self.sim.Projection(PulseCellPop, inputPop, connList, receptor_type='excitatory')  

    def setuprecordings(self):
        self.setupRecording(self.FOutCells)
        
        self.setupRecording(self.CosPopCells)
        #self.SinPopCells[[3]].record(['spikes','v','gsyn_exc','gsyn_inh'])
        self.setupRecording(self.SinPopCells)
        self.setupRecording(self.CosSinPopCells)
        self.setupRecording(self.MultCosSinPopCells)
        """
        self.setupRecording(self.PosOrNegCosSinPop)
        self.setupRecording(self.CosSinSumCells)
        self.setupRecording(self.CosSinSubCells)    
        self.setupRecording(self.CosSinDivCells)
        """
        self.setupRecording(self.testoutputcells)
        self.setupRecording(self.testinputcells)
        
        """
        self.setupRecording(self.CosPopInterSumCells)
        self.setupRecording(self.SinPopInterSumCells)
        """
        #self.setupRecording(self.CosSinPopInterOutSumCells)
        #self.setupRecording(self.CosSinPopInterOutSubCells)
#        self.d[[0]].record(['spikes','v','gsyn_exc','gsyn_inh'])
        
        #self.copycell=self.CosSinSumCells
        #self.CosSinPopInterOutSumCells[[40]].record(['spikes','v','gsyn_exc','gsyn_inh'])
        #self.CosSinSumCells[[48]].record(['spikes','v','gsyn_exc','gsyn_inh'])
        #self.CosSinSubCells[[3]].record(['spikes','v','gsyn_exc','gsyn_inh'])
#self.MultCosSinPopsCells, self.numNeuronsInMultCosSinPops, self.MultCosSinPopIncr
        
        #self.setupMultipleRecordngs(self.EMinusXMultKPops, self.numSets)
        #self.EMinusXMultKPops
        #self.d=self.EMinusXMultKPops[0]
        #self.d[[0]].record(['spikes','v','gsyn_exc','gsyn_inh'])
        #self.setupMultipleRecordngs(self.EMinusXPops, self.numSets)
        #self.setupMultipleRecordngs(self.EPopsInpCells, self.numSets)# dont use this one as we only want one pop
        #self.setupRecording(self.EPopsInpCells[1]) #only pop in the E pops to have an e value
        
        #self.setupMultipleRecordngs(self.EXInterOutSubCells, self.numSets)
        #self.setupMultipleRecordngs(self.PosOrNegEXKPop, self.numSets)
        #self.setupMultipleRecordngs(self.RoundEXKPopCells, self.numSets)
        self.setupRecording(self.PulseCellPop)
        #self.setupRecording(self.EXKSum01Cells)
        #self.setupRecording(self.EXKSum23Cells)
        #self.setupRecording(self.EXKPopInterOutSum01Cells)
        #self.setupRecording(self.EXKPopInterOutSum23Cells)
        #self.setupRecording(self.FInterSumCells)
        self.setupRecording(self.sinsqpop)
        self.setupRecording(self.RoundSinSqPopCells)

        self.setupRecording(self.M1Pop)
        
        #self.setupMultipleRecordngs(self.KPopsInpCells, self.numSets)
        #self.setupMultipleRecordngs(self.EMinusXBufPops, self.numSets)
        #self.setupMultipleRecordngs(self.KPopsInpCellsBuf, self.numSets)
        #self.setupRecording(self.CosPopBufCells)
        
        #self.setupRecording(self.SinPopBufCells)
#        self.setupRecording(self.DivPops)
#        self.setupRecording(self.DivRoundoutputPops)

   
        self.setupRecording(self.onedivpop)
        self.setupRecording(self.dtcell)
        #self.setupRecording(self.dtresultpopCos)
        #self.setupRecording(self.rounddtcospop)
        
        self.setupRecording(self.sinM1pop)
        self.setupRecording(self.RoundSinM1PopCells)

        self.setupRecording(self.SinM1M0SumCells)
        self.setupRecording(self.SinM1M0PopInterOutSumCells)
        self.setupRecording(self.M0Pop)

        self.setupRecording(self.onedivSinsqM1M0Pops)
        self.setupRecording(self.onedivSinsqM1M0RoundPops)
        self.setupRecording(self.X3sqpop)
        self.setupRecording(self.RoundX3SqPopCells)
        self.setupRecording(self.X3sqM1Lpop)
        self.setupRecording(self.RoundX3sqM1LPopCells)

        self.setupRecording(self.MmultLPop)
        self.setupRecording(self.SinPopCells3)
        self.setupRecording(self.SinPopCells1)
        self.setupRecording(self.SinX3sqM1Lpop)
        self.setupRecording(self.RoundSinX3sqM1LPopCells)
        self.setupRecording(self.M1gCosSinpop)
        self.setupRecording(self.RoundM1gCosSinPopCells)
        self.setupRecording(self.MmultGPop)


        self.setupRecording(self.RoundM1gCosSinPopCells2)
        self.setupRecording(self.M1gCosSinMinusSinX3sqM1LPops)
        self.setupRecording(self.M1gCosSinMinusSinX3sqM1LInterCells)
        #self.setupRecording(self.Force2Cells)
        self.setupRecording(self.M1gCosSinMinusSinX3sqM1LPlusFCells)

        #self.setupRecording(self.onedivSinsqM1M0RoundPops2)
        self.setupRecording(self.DX2Pop)
        self.setupRecording(self.RoundDX2PopCells)

        #self.setupRecording(self.CosPopCells11)
        self.setupRecording(self.CosPopCells1)
        self.setupRecording(self.DX2Cospop)
        self.setupRecording(self.RoundDX2CosPopCells)

        self.setupRecording(self.gPop)
        self.setupRecording(self.SinGpop)
        self.setupRecording(self.RoundSinGPopCells)

        #self.setupRecording(self.RoundSinGPopCells11)
        self.setupRecording(self.RoundSinGPopCells1)
        self.setupRecording(self.DX2CosPlusSingGInterSumCells)
        self.setupRecording(self.DX2CosPlusSingGPop)

        self.setupRecording(self.DX3Pop)
        self.setupRecording(self.RoundDX3PopCells)
        self.setupRecording(self.oneDivLPop)
##############
        self.setupRecording(self.DX3dtPop)
        
        self.setupRecording(self.dt3cell)
        self.setupRecording(self.RoundDX3dtPopCells)

        self.setupRecording(self.X3PlusDX3dt3InterSumCells)
        self.setupRecording(self.X3PopsInpCells1)
        #self.setupRecording(self.X3PopsInpCells20)
##############
        self.setupRecording(self.DX2dtPop)
        
        self.setupRecording(self.dt2cell)
        self.setupRecording(self.RoundDX2dtPopCells)

        self.setupRecording(self.X2PlusDX2dt2InterSumCells)


        #self.X2PlusDX2dt2InterSumCells[[47]].record(['spikes','v','gsyn_exc','gsyn_inh'])

        #self.setupRecording(self.X2PopsInpCells14)
        self.setupRecording(self.X2PopsInpCells1)       
        #self.setupRecording(self.X2NextStateCells5)

#####
        #self.setupRecording(self.X0NextStateCells)
        #self.setupRecording(self.X0NextStateCells17)
        self.setupRecording(self.DX0dtPop)
        self.setupRecording(self.RoundDX0dtPopCells)
        self.setupRecording(self.X0PlusDX0dt0InterSumCells)
        self.setupRecording(self.dt0cell)
        self.setupRecording(self.X0PopsInpCells1)  

        #self.setupRecording(self.X1NextStateCells)
        #self.setupRecording(self.X1NextStateCells17)
        self.setupRecording(self.DX1dtPop)
        self.setupRecording(self.RoundDX1dtPopCells)
        self.setupRecording(self.X1PlusDX1dt1InterSumCells)
        self.setupRecording(self.dt1cell)
        self.setupRecording(self.X1PopsInpCells1)             
        self.setupRecording(self.M1gCosSinMinusSinX3sqM1LPlusFInterCells)
        
        self.setupRecording(self.X1CopyPop)
        self.setupRecording(self.X1CopyCosPop)
        #self.setupRecording(self.X2NextStateCells)
       
    def CreateNetwork(self):
        #global FOutCells


        #from nealCoverClass import NealCoverFunctions
        #we are using a tau_refrac of 6.0 ms to stop the output neurons firing more than one spike, i.e. prevent bursting
        # tau_syn_E'= how long the post spike has an effect for. E.g. 0.065 with 5.0ms causes a spike, but 0.065 with 3.0ms does not (i.e. there is not enough time with the conductance strenghth of 0.065 for the neuron to spike


        #####CREATE MIN AND MAX VALUES THAT EACH POPULATION NEED TO REPRESENT

        #numNeurons=CalculateNeuronNumEachPop(minF, maxF, varRes)

        #numNeurons=[Totatnum, posnum, negnum]

        #numNeuronsInEachPop=int(1/varRes)
        #numNeuronsInEachPop=10

        #numNeuronsInEachPop=10
        #print "numNeuronsInEachPop"
        #print numNeuronsInEachPop
        #pops = createNeurons(numNeuronsInEachPop, 10)
        #inputCells = pops[0]
        #outputCells = pops[1]
        #setupRecording(inputCells)
        ####calculate the number of neurons used in each population with a resolution of varRes, and also the number of positive and negative numbers used within the population
        #print "createdneurons"
        #print "XInputCells"
        #print self.XPopsInpCells[0]
        #print "FOutputCells"
        #print self.FOutCells




        ##calculate min and max from adding all EXK values
        #minF=np.sum(minEminusXMultKarray)
        #maxF=np.sum(maxEminusXMultKarray)


        #print "outside function"
        #print self.minF
        #print self.maxF
        #print self.maxXarray
        #adfadfs
        #initialise the network

        starttime=0
        #varRes = 0.01    #value resoluation within each population
        #minWeight=0.0606
        #minWeight=0.0667
        #minWeight=0.26
        #minWeight=0.73  #0.713  ---0.73 and refrac of 4ms worked, refrac was 10
        ###########
        #minWeight=0.713
        minWeight=0.712464
        ###########
        #minWeight=0.75  ##could use this one
        #minWeight=0.26
        #minWeight=0.0667#0.073#0.0756 #was0.2 #0.0667  #0.0667 = 11ms first spike time #min total weight across connections to activate post synaptic neuron
        #we firstly used 0.0665 a the conductance to genreate a spike in the post synaptic neuron.  However, the membrane rest voltage never reached the rest of -65mV after a spike, i.e. it reached a rest of -65.0793 mV at 92.7ms and -65.0475 at 103ms, therefore when using 0.0665 reaching a rest of -65 could take a long time in terms of ms, and thus, a second spike on a second run at 100ms could not be reached as it could not reach the -53mV threshold with the above parameters.  Therefore, we now use 0.0667 so that a neuron could generate spikes on different consecutive runs
        neal = NealCoverFunctions(nealParameters.simulator)
        
        ############






        ###
        #print self.numNeuronsInFPop
        #print self.numNeuronsInEachEMinusXMultKPop
        #print self.numNeuronsInFPop

        #JHGJH


        #numNeuronsInFPop=CalculateNeuronNumEachPop(minF, maxF, varResF) # make num array for createneurons
        #print numNeuronsInFPop
        #adfadf
        #print "numneuronsineachxpop"

        #print numNeuronsInEachXPop
        #print numNeuronsInEachXPop[1]
        #d=numNeuronsInEachXPop[1]
        #print d[1]

        #pause()

        #adfadfad

        """
numNeuronsInEachX1Pop=numNeuronsInEachPop
numNeuronsInEachX2Pop=numNeuronsInEachPop
numNeuronsInEachX3Pop=numNeuronsInEachPop
numNeuronsInEachX4Pop=numNeuronsInEachPop
numNeuronsInEachE1Pop=numNeuronsInEachPop
numNeuronsInEachE2Pop=numNeuronsInEachPop
numNeuronsInEachE3Pop=numNeuronsInEachPop
numNeuronsInEachE4Pop=numNeuronsInEachPop
numNeuronsInEachK1Pop=numNeuronsInEachPop
numNeuronsInEachK2Pop=numNeuronsInEachPop
numNeuronsInEachK3Pop=numNeuronsInEachPop
numNeuronsInEachK4Pop=numNeuronsInEachPop
numNeuronsInEachE1MinusX1Pop=numNeuronsInEachPop
numNeuronsInEachE2MinusX2Pop=numNeuronsInEachPop
numNeuronsInEachE3MinusX3Pop=numNeuronsInEachPop
numNeuronsInEachE4MinusX4Pop=numNeuronsInEachPop
numNeuronsInEachE1MinusX1MultK1Pop=numNeuronsInEachPop
numNeuronsInEachE2MinusX2MultK2Pop=numNeuronsInEachPop
numNeuronsInEachE3MinusX3MultK3Pop=numNeuronsInEachPop
numNeuronsInEachE4MinusX4MultK4Pop=numNeuronsInEachPop
        """

#numNeurons==[row[4] for row in varValues]



#numNeuronsInFPop=numNeuronsInEachPop #change the array to a number
        """
X1InputCells=Xpops[0]
X2InputCells=Xpops[1]
X3InputCells=Xpops[2]
X4InputCells=Xpops[3]
E1InputCells=Epops[0]
E2InputCells=Epops[1]
E3InputCells=Epops[2]
E4InputCells=Epops[3]
K1InputCells=Kpops[0]
K2InputCells=Kpops[1]
K3InputCells=Kpops[2]
K4InputCells=Kpops[3]
E1MinusX1Cells=EMinusXpops[0]
E2MinusX2Cells=EMinusXpops[1]
E3MinusX3Cells=EMinusXpops[2]
E4MinusX4Cells=EMinusXpops[3]
E1MinusX1MultK1Cells=EMinusXMultKpops[0]
E2MinusX2MultK2Cells=EMinusXMultKpops[1]
E3MinusX3MultK3Cells=EMinusXMultKpops[2]
E4MinusX4MultK4Cells=EMinusXMultKpops[3]
FOutputCells=Fpops[0]
        """


###########
        self.setupMultipleRecordngs(self.XPopsInpCells, self.numSets)
        self.setupRecording(self.testoutputcells)
        self.setupRecording(self.testinputcells)        
        #self.setupRecording(self.FOutCells)
        #self.setupRecording(self.M1gCosSinMinusSinX3sqM1LPops)
        #self.setupRecording(self.M1gCosSinMinusSinX3sqM1LPlusFInterCells)
        #self.setupRecording(self.M1gCosSinMinusSinX3sqM1LPlusFCells)
        
        #self.setuprecordings()
        if((self.test==1)and(self.recording==1)):
            self.setuprecordings()
            print "selftest"

        #self.ClearData()
        #adfa


              
        
########
        
        #setupRecording(E4MinusX4MultK4Cells)
        #setupRecording(E3MinusX3MultK3Cells)
        #setupRecording(E2MinusX2MultK2Cells)
        #setupRecording(E1MinusX1MultK1Cells)
        #print self.FOutCells
        #setupRecording(FOutputCells)


        #numInps = 10  #numInps (number of input neurons the stimneuron is connected to) cannot be larger than the number of input neurons
        ###############
        #create connections between populations

        #connectInputPopToFOutput(EMinusXMultKPops, FOutCells, EXKincrements, Fincrement, numNeuronsInFPop, numNeuronsInEachEMinusXMultKPop, minWeight, varValues, numSets)
        #############TEST
        """
        print "doing test"
        print "testNeuron"
        self.testNeuron(self.testinputcells, self.testoutputcells)
        print "testCells"
        self.testCells()
        adfadf
        """
        #######################INTERNAL MODEL

        ##connect pulse cells throughout network

        ExConnector=[]
        ###PULSE CELL CONNECTIONS
        for eachdepth in range(0, self.numdepths):
            if(eachdepth==self.numdepths-1):
                ExConnector=[(eachdepth, 0,minWeight,nealParameters.DELAY)]
            else:
                ExConnector=[(eachdepth, eachdepth+1,minWeight,nealParameters.DELAY)]
            connList = self.sim.FromListConnector(ExConnector)
            exc_connections=self.sim.Projection(self.PulseCellPop, self.PulseCellPop, connList, receptor_type='excitatory')

        ########
        synDelay=1.0
        print "x3 sqaured"
        self.Multiplication2Pops(self.XPopsInpCells[3], self.XPopsInpCells[3], self.numNeuronsInEachXPop[3], self.numNeuronsInEachXPop[3], self.Xincrements[3], self.Xincrements[3], self.X3sqpop, self.numNeuronsInMultX3X3Pop, self.MultX3X3increments, self.RoundX3SqPopCells, self.numNeuronsInRoundX3Sq, self.RoundX3X3increments, minWeight,1,1, self.connectionnum2)


        self.connectsinpops(minWeight) #connect the sin populations
        #self.connectRoundM1gCosSinPopCellspops(minWeight)
        self.ConnectM1gCosSinMinusSinX3sqM1LPops(minWeight)
        #self.connectonedivSinsqM1M0RoundPops(minWeight)
        self.ConnectCosPops(minWeight)                      ##done, must hit 25ms
        self.ConvertConnectionsForForcePop(minWeight)
        self.ConnectSinGPops(minWeight)                     ##done, must hit 29ms

        self.ConnectX3(minWeight)                           ##done, 39 delay, needs to hit 41ms
        self.ConnectX2(minWeight)                           ##done, 27 delay, needs to hit 29
        #self.ConnectNextStateX2Cells(minWeight)
        #self.ConnectNextStateX0Cells(minWeight)
        self.ConnectX0(minWeight)                           ##DONE
        #self.ConnectNextStateX1Cells(minWeight)
        self.ConnectX1(minWeight)                           ##DONE

        print "num X0"
        print self.numNeuronsInEachXPop[0]
        print "num X1"
        print self.numNeuronsInEachXPop[1]
        print "num X2"
        print self.numNeuronsInEachXPop[2]
        print "num X3"
        print self.numNeuronsInEachXPop[3]        

        
        print "sum of ....plus F"
        self.summationTwoPopsV3(self.M1gCosSinMinusSinX3sqM1LPops, self.FOutCells, self.M1gCosSinMinusSinX3sqM1LPlusFCells, self.M1gCosSinMinusSinX3sqM1Lincrements, self.Force2increments, self.M1gCosSinMinusSinX3sqM1LPlusFincrements, self.numneuron, self.numNeuronsM1gCosSinMinusSinX3sqM1L, self.numNeuronsInFPop, minWeight, self.M1gCosSinMinusSinX3sqM1LPlusFInterCells,1, 1,self.numNeuronsInM1gCosSinMinusSinX3sqM1LPlusF, synDelay)
        print self.numneuron
        
        self.ConnectCos(self.XPopsInpCells[1], self.numNeuronsInEachXPop[1], self.Xincrements[1], self.CosPopCells, self.numNeuronsInCosPop, self.COSincrements, minWeight, self.PulseCellPop, self.addtime+1,self.X1CopyCosPop, self.PulseCellPop, self.addtime)
        self.ConnectSin(self.XPopsInpCells[1], self.numNeuronsInEachXPop[1], self.Xincrements[1], self.SinPopCells, self.numNeuronsInSinPop, self.SINincrements, minWeight, self.X1CopyPop, self.PulseCellPop, self.addtime)


        #self.MultPosOrNeg(self.CosPopCells, self.SinPopCells, self.numNeuronsInCosPop, self.numNeuronsInSinPop, self.PosOrNegCosSinPop, minWeight, self.CosPopBufCells, self.SinPopBufCells)
        "multiple in force 0"
        print "COS*SIN"
        self.Multiplication2Pops(self.CosPopCells, self.SinPopCells, self.numNeuronsInCosPop, self.numNeuronsInSinPop, self.SINincrements, self.COSincrements, self.MultCosSinPopCells, self.numNeuronsInMultCosSinPop, self.MultCosSinincrements, self.CosSinPopCells, self.numNeuronsInSinCosPop, self.CosSinincrements, minWeight,1,0, self.connectionnum)

        print self.numNeuronsInCosPop
        print self.numNeuronsDtPop
        #print self.numNeuronsDtPopCos
        #print self.numNeuronsRoundDtCos
        #print self.CosPopCells
        #print self.dtcell
        #print self.dtresultpopCos
        #adfda
        print "multiple in force 1"
#        self.Multiplication2Pops(self.CosPopCells, self.dtcell, self.numNeuronsInCosPop, self.numNeuronsDtPop, self.dtincrement, self.COSincrements, self.dtresultpopCos, self.numNeuronsDtPopCos, self.dtcosincrement, self.rounddtcospop, self.numNeuronsRoundDtCos, self.RoundOutDtIncrements, minWeight,1,0)

        #sinsquared
        print "multiple in force 2"
        print "SIN SQUARED"
        self.Multiplication2Pops(self.SinPopCells, self.SinPopCells, self.numNeuronsInSinPop, self.numNeuronsInSinPop, self.SINincrements, self.SINincrements, self.sinsqpop, self.numNeuronsInMultSinSinPop, self.MultSinSinincrements, self.RoundSinSqPopCells, self.numNeuronsInRoundSinSq, self.RoundSinSinincrements, minWeight,1,1, self.connectionnum)

        print self.SinPopCells
        print self.SinPopCells
        print self.numNeuronsInSinPop
        print self.numNeuronsInSinPop
        print self.SINincrements
        print self.SINincrements
        print self.sinsqpop
        print self.numNeuronsInMultSinSinPop
        print self.MultSinSinincrements
#        adfad

        self.ConnectPulseToEOrKCells(self.M1Pop, self.numNeuronsM1Pop, self.addtime+3,self.PulseCellPop, minWeight, self.M1increments)

        self.ConnectPulseToEOrKCells(self.M0Pop, self.numNeuronsM0Pop, self.addtime+5,self.PulseCellPop, minWeight, self.M0increments)

        print "multiple in force 3"
        print "M1*SIN SQ"
        self.Multiplication2Pops(self.M1Pop, self.RoundSinSqPopCells, self.numNeuronsM1Pop, self.numNeuronsInRoundSinSq, self.RoundSinSinincrements, self.M1increments, self.sinM1pop, self.numNeuronsInMultSinM1Pop, self.MultSinM1increments, self.RoundSinM1PopCells, self.numNeuronsInRoundSinM1, self.RoundSinM1increments, minWeight,1,1, self.connectionnum)

        print "sum M0 and SinM1"

        self.summationTwoPopsV3(self.M0Pop, self.RoundSinM1PopCells, self.SinM1M0SumCells, self.M0increments, self.RoundSinM1increments, self.SinM1M0increments, self.numNeuronsInSinsqM1M0Pop, self.numNeuronsM0Pop, self.numNeuronsInRoundSinM1, minWeight, self.SinM1M0PopInterOutSumCells,1, 0, [], synDelay)

        print self.numNeuronsInSinsqM1M0Pop

        self.ConnectPulseToEOrKCells(self.onedivpop, self.numNeuronsIn1DivPop, self.addtime+7,self.PulseCellPop, minWeight, self.in1DivIncrements)

        print "one divide by sinM1M0sum"

        self.Divide2Pops(self.onedivpop, self.SinM1M0SumCells, self.numNeuronsIn1DivPop, self.numNeuronsInSinsqM1M0Pop, self.in1DivIncrements, self.SinM1M0increments, self.onedivSinsqM1M0Pops, self.numonedivSinsqM1M0Pops, self.onedivSinsqM1M0Incr, self.onedivSinsqM1M0RoundPops, self.numNeuronsonedivSinsqM1M0RoundPop, self.RoundonedivSinsqM1M0Increments, minWeight,1)

        print self.numonedivSinsqM1M0Pops

        #self.OneDivideByPop(self.SinM1M0SumCells, self.numNeuronsInSinsqM1M0Pop,  self.SinM1M0increments, self.onedivSinsqM1M0Pops, self.onedivSinsqM1M0Incr, self.numonedivSinsqM1M0Pops, minWeight)                             

        ###X3 SQUARED WAS HERE
        print "m*l * round x3sq"
        self.Multiplication2Pops(self.MmultLPop, self.RoundX3SqPopCells, self.numNeuronsMmultLPop, self.numNeuronsInRoundX3Sq, self.RoundX3X3increments, self.MmultLincrements, self.X3sqM1Lpop, self.numNeuronsInMultX3sqM1LPop, self.MultX3sqM1Lincrements, self.RoundX3sqM1LPopCells, self.numNeuronsInRoundX3sqM1L, self.RoundX3sqM1Lincrements, minWeight,1,1, self.connectionnum)

        self.ConnectPulseToEOrKCells(self.MmultLPop, self.numNeuronsMmultLPop, self.addtime+1,self.PulseCellPop, minWeight, self.MmultLincrements)

        print "sin * x3squared*m*l"
        self.Multiplication2Pops(self.SinPopCells3, self.RoundX3sqM1LPopCells, self.numNeuronsInSinPop, self.numNeuronsInRoundX3sqM1L, self.RoundX3sqM1Lincrements, self.SINincrements, self.SinX3sqM1Lpop, self.numNeuronsInMultSinX3sqM1LPop, self.MultSinX3sqM1Lincrements, self.RoundSinX3sqM1LPopCells, self.numNeuronsInRoundSinX3sqM1L, self.RoundSinX3sqM1Lincrements, minWeight,1,0, self.connectionnum8)

        self.ConnectPulseToEOrKCells(self.MmultGPop, self.numNeuronsMmultGPop, self.addtime+3,self.PulseCellPop, minWeight, self.MmultGincrements)  


        print "m*g*cos*sin"
        self.Multiplication2Pops(self.MmultGPop, self.CosSinPopCells, self.numNeuronsMmultGPop, self.numNeuronsInSinCosPop, self.CosSinincrements, self.MmultGincrements, self.M1gCosSinpop, self.numNeuronsInMultM1gCosSinPop, self.MultM1gCosSinincrements, self.RoundM1gCosSinPopCells, self.numNeuronsInRoundM1gCosSin, self.RoundM1gCosSinincrements, minWeight,1,0, self.connectionnum3)

        print "subtract round m1gcossin and singx3sqm1l"

        self.subtractTwoPopsV2(self.RoundM1gCosSinPopCells, self.RoundSinX3sqM1LPopCells, self.M1gCosSinMinusSinX3sqM1LPops, self.RoundM1gCosSinincrements, self.RoundSinX3sqM1Lincrements, self.M1gCosSinMinusSinX3sqM1Lincrements, self.numNeuronsM1gCosSinMinusSinX3sqM1L, self.numNeuronsInRoundM1gCosSin, self.numNeuronsInRoundSinX3sqM1L, minWeight, self.M1gCosSinMinusSinX3sqM1LInterCells,1, synDelay)

        print self.numNeuronsM1gCosSinMinusSinX3sqM1L


        print "dx2"
        self.Multiplication2Pops(self.onedivSinsqM1M0RoundPops, self.M1gCosSinMinusSinX3sqM1LPlusFCells, self.numNeuronsonedivSinsqM1M0RoundPop, self.numneuron, self.M1gCosSinMinusSinX3sqM1LPlusFincrements, self.RoundonedivSinsqM1M0Increments, self.DX2Pop, self.numNeuronsInDX2, self.DX2increments, self.RoundDX2PopCells, self.numNeuronsInRoundDX2Pop, self.RoundDX2increments, minWeight,1,0, self.connectionnum7)


        print "round dx2* cos"
        self.Multiplication2Pops(self.RoundDX2PopCells, self.CosPopCells1, self.numNeuronsInRoundDX2Pop, self.numNeuronsInCosPop, self.COSincrements, self.RoundDX2increments, self.DX2Cospop, self.numNeuronsInMultDX2CosPop, self.MultDX2Cosinincrements, self.RoundDX2CosPopCells, self.numNeuronsInRoundDX2Cos, self.RoundDX2Cosincrements, minWeight,1,0, self.connectionnum6)



        self.ConnectPulseToEOrKCells(self.gPop, self.numNeuronsgPop, self.addtime+1,self.PulseCellPop, minWeight, self.gincrements)


        print "g * sin"
        self.Multiplication2Pops(self.gPop, self.SinPopCells, self.numNeuronsgPop, self.numNeuronsInSinPop, self.SINincrements, self.gincrements, self.SinGpop, self.numNeuronsInMultSinGPop, self.MultSinGincrements, self.RoundSinGPopCells, self.numNeuronsInRoundSinG, self.RoundSinGincrements, minWeight,1,0, self.connectionnum)


        print "sum roundDX2Cos and sing"
        self.summationTwoPopsV3(self.RoundDX2CosPopCells, self.RoundSinGPopCells1, self.DX2CosPlusSingGPop, self.RoundDX2Cosincrements, self.RoundSinGincrements, self.DX2CosPlusSingGincrements, self.numNeuronsDX2CosPlusSingGPop, self.numNeuronsInRoundDX2Cos, self.numNeuronsInRoundSinG, minWeight, self.DX2CosPlusSingGInterSumCells,1, 0, [], synDelay)
        print self.numNeuronsDX2CosPlusSingGPop


        self.ConnectPulseToEOrKCells(self.oneDivLPop, self.numNeuronsoneDivLPop, self.addtime+15,self.PulseCellPop, minWeight, self.onedivlincrements)
        
        print "DX2*cos*1/l"
        self.Multiplication2Pops(self.DX2CosPlusSingGPop, self.oneDivLPop, self.numNeuronsDX2CosPlusSingGPop, self.numNeuronsoneDivLPop, self.onedivlincrements, self.DX2CosPlusSingGincrements, self.DX3Pop, self.numNeuronsInDX3, self.DX3increments, self.RoundDX3PopCells, self.numNeuronsInRoundDX3Pop, self.RoundDX3increments, minWeight,1,0, self.connectionnum4)


        self.ConnectPulseToEOrKCells(self.dt3cell, self.numNeuronsDt3Pop, self.addtime+17,self.PulseCellPop, minWeight, self.dt3increment)
        
        print "dx3*dt"
        self.Multiplication2Pops(self.dt3cell, self.RoundDX3PopCells, self.numNeuronsDt3Pop, self.numNeuronsInRoundDX3Pop, self.RoundDX3increments, self.dt3increment, self.DX3dtPop, self.numNeuronsInDX3dt, self.DX3dtincrements, self.RoundDX3dtPopCells, self.numNeuronsInRoundDX3dtPop, self.RoundDX3dtincrements, minWeight,1,0, self.connectionnum)




        #self.summationTwoPopsV3(self.RoundDX2CosPopCells, self.RoundSinGPopCells11, self.DX2CosPlusSingGPop, self.RoundDX2Cosincrements, self.RoundSinGincrements, self.DX2CosPlusSingGincrements, self.numNeuronsDX2CosPlusSingGPop, self.numNeuronsInRoundDX2Cos, self.numNeuronsInRoundSinG, minWeight, self.DX2CosPlusSingGInterSumCells,1)




        #self.summationTwoPopsV3(self.X3PopsInpCells20, self.RoundDX3dtPopCells, self.XPopsInpCells[3], self.Xincrements[3], self.RoundDX3dtincrements, self.Xincrements[3], self.numNeuronsInEachXPop[3], self.numNeuronsInEachXPop[3], self.numNeuronsInRoundDX3dtPop, minWeight, self.X3PlusDX3dt3InterSumCells,1)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     



        #self.summationTwoPopsV3(self.X3PopsInpCells20, self.RoundDX3dtPopCells, self.XPopsInpCells[3], self.Xincrements[3], self.RoundDX3dtincrements, self.Xincrements[3], self.numNeuronsInEachXPop[3], self.numNeuronsInEachXPop[3], self.numNeuronsInRoundDX3dtPop, minWeight, self.X3PlusDX3dt3InterSumCells,1,1,self.numNeuronsX3PlusDX3dt3InterPop)

##########
        self.ConnectPulseToEOrKCells(self.dt2cell, self.numNeuronsDt2Pop, self.addtime+11,self.PulseCellPop, minWeight, self.dt2increment)
        
        print "dx2*dt"
        self.Multiplication2Pops(self.dt2cell, self.RoundDX2PopCells, self.numNeuronsDt2Pop, self.numNeuronsInRoundDX2Pop, self.RoundDX2increments, self.dt2increment, self.DX2dtPop, self.numNeuronsInDX2dt, self.DX2dtincrements, self.RoundDX2dtPopCells, self.numNeuronsInRoundDX2dtPop, self.RoundDX2dtincrements, minWeight,1,0, self.connectionnum)


        print "X2+DX2DT"
        ####CHANGED
        #self.summationTwoPopsV3(self.X2PopsInpCells14, self.RoundDX2dtPopCells, self.X2NextStateCells, self.Xincrements[2], self.RoundDX2dtincrements, self.Xincrements[2], self.numNeuronsInEachXPop[2], self.numNeuronsInEachXPop[2], self.numNeuronsInRoundDX2dtPop, minWeight, self.X2PlusDX2dt2InterSumCells,1,1,self.numNeuronsX2PlusDX2dt2InterPop, synDelay)
        ###
########
        if(self.network==1):
            self.ConnectPulseToEOrKCells(self.dt0cell, self.numNeuronsDt0Pop, self.numdepths-1,self.PulseCellPop, minWeight, self.dt0increment)
        else:
            self.ConnectPulseToEOrKCells(self.dt0cell, self.numNeuronsDt0Pop, self.addtime-1,self.PulseCellPop, minWeight, self.dt0increment)
                                                                                                                                                                                                                                                                                                                                                                                               
        print "dx0*dt"
        self.Multiplication2Pops(self.dt0cell, self.XPopsInpCells[2], self.numNeuronsDt0Pop, self.numNeuronsInEachXPop[2], self.Xincrements[2], self.dt0increment, self.DX0dtPop, self.numNeuronsInDX0dt, self.DX0dtincrements, self.RoundDX0dtPopCells, self.numNeuronsInRoundDX0dtPop, self.RoundDX0dtincrements, minWeight,1,0, self.connectionnum)

#InputPops1, InputPops2, OutputPops, Input1Incr, Input2Incr, OutputIncr, numOutcells, numIn1Cells, numIn2Cells, minWeight, sumInterPop, Reorder, useintervalues, numintercells):
        print "X0+DX0DT"
        ####CHANGED
        #self.summationTwoPopsV3(self.X0PopsInpCells2, self.RoundDX0dtPopCells, self.X0NextStateCells, self.Xincrements[0], self.RoundDX0dtincrements, self.Xincrements[0], self.numNeuronsInEachXPop[0], self.numNeuronsInEachXPop[0], self.numNeuronsInRoundDX0dtPop, minWeight, self.X0PlusDX0dt0InterSumCells,1,1,self.numNeuronsX0PlusDX0dt0InterPop)
        ####
########
        if(self.network==1):
            self.ConnectPulseToEOrKCells(self.dt1cell, self.numNeuronsDt1Pop, self.numdepths-1,self.PulseCellPop, minWeight, self.dt1increment)
        else:
            self.ConnectPulseToEOrKCells(self.dt1cell, self.numNeuronsDt1Pop, self.addtime-1,self.PulseCellPop, minWeight, self.dt1increment) 
                                                                                                                                                                                                                                                                                                                                                                                               
        print "dx1*dt"
        self.Multiplication2Pops(self.dt1cell, self.XPopsInpCells[3], self.numNeuronsDt1Pop, self.numNeuronsInEachXPop[3], self.Xincrements[3], self.dt1increment, self.DX1dtPop, self.numNeuronsInDX1dt, self.DX1dtincrements, self.RoundDX1dtPopCells, self.numNeuronsInRoundDX1dtPop, self.RoundDX1dtincrements, minWeight,1,0, self.connectionnum)

#InputPops1, InputPops2, OutputPops, Input1Incr, Input2Incr, OutputIncr, numOutcells, numIn1Cells, numIn2Cells, minWeight, sumInterPop, Reorder, useintervalues, numintercells):
        print "X1+DX1DT"
        ####CHANGED
#        self.summationTwoPopsV3(self.X1PopsInpCells2, self.RoundDX1dtPopCells, self.X1NextStateCells, self.Xincrements[1], self.RoundDX1dtincrements, self.Xincrements[1], self.numNeuronsInEachXPop[1], self.numNeuronsInEachXPop[1], self.numNeuronsInRoundDX1dtPop, minWeight, self.X1PlusDX1dt1InterSumCells,1,1,self.numNeuronsX1PlusDX1dt1InterPop, synDelay)
        ####





        
        #self.summationTwoPopsV2(self.CosPopCells, self.SinPopCells, self.CosSinSumCells, self.COSincrements, self.SINincrements, self.CosSinSumincrements, self.numNeuronsInCosSinSumPop, self.numNeuronsInCosPop, self.numNeuronsInSinPop, minWeight, self.CosPopInterSumCells, self.SinPopInterSumCells, self.CosSinPopInterOutSumCells)

        #self.summationTwoPops(self.CosPopCells, self.SinPopCells, self.CosSinSumCells, self.COSincrements, self.SINincrements, self.CosSinSumincrements, self.numNeuronsInCosSinSumPop, self.numNeuronsInCosPop, self.numNeuronsInSinPop, minWeight)


        """
        self.summationTwoPopsV3(self.CosPopCells, self.SinPopCells, self.CosSinSumCells, self.COSincrements, self.SINincrements, self.CosSinSumincrements, self.numNeuronsInCosSinSumPop, self.numNeuronsInCosPop, self.numNeuronsInSinPop, minWeight, self.CosSinPopInterOutSumCells,1,0,[], synDelay)


        self.subtractTwoPopsV2(self.CosPopCells, self.SinPopCells, self.CosSinSubCells, self.COSincrements, self.SINincrements, self.CosSinSubincrements, self.numNeuronsInCosSinSubPop, self.numNeuronsInCosPop, self.numNeuronsInSinPop, minWeight, self.CosSinPopInterOutSubCells,1, synDelay)
        """
        #print self.COSincrements
        #adfadf


        #self.ConnectPulseToEOrKCells(self.onedivpop, self.numNeuronsIn1DivPop, 0,self.PulseCellPop, minWeight, [1])

        #self.Divide2Pops(self.onedivpop, self.CosPopCells, self.numNeuronsIn1DivPop, self.numNeuronsInCosPop, self.in1DivIncrements, self.COSincrements, self.DivPops, self.numDivPops, self.DivPopIncr, self.DivRoundoutputPops, self.numNeuronsDivRoundOutPop, self.RoundOutDivIncrements, minWeight)
                                       
        #self.Divide2Pops(self.SinPopCells, self.CosPopCells, self.numNeuronsInSinPop, self.numNeuronsInCosPop, self.SINincrements, self.COSincrements, self.DivPops, self.numDivPops, self.DivPopIncr, self.DivRoundoutputPops, self.numNeuronsDivRoundOutPop, self.RoundOutDivIncrements, minWeight,1)


        """
        self.OneDivideByPop(self.CosPopCells, self.numNeuronsInCosPop,  self.COSincrements, self.CosSinDivCells, self.CosSinDivincrements, self.numNeuronsInCosSinDivPop, minWeight)                             
        """


        #######################FORCE CALCULATION
        """
        #OLD VERSION
        numConnections=self.numSets
        for popConnections in range(0,numConnections):
            ###connect the E and X to EminusX
            #subtraction
         #   print "popConnections"
         #   print popConnections
         #   print "inputpops"
         #   print self.EPopsInpCells

            if(self.Earray[popConnections]!=0.0):
                inputnumpops=[self.numNeuronsInEachEPop[popConnections], self.numNeuronsInEachXPop[popConnections]]
                inputincrements=[self.Eincrements[popConnections], self.Xincrements[popConnections]]
                inputpops=[self.EPopsInpCells[popConnections], self.XPopsInpCells[popConnections]]
            else:
                inputnumpops=[self.numNeuronsInEachEPop[popConnections],self.numNeuronsInEachXPop[popConnections]]
                inputincrements=[self.Eincrements[popConnections],self.Xincrements[popConnections]]
                inputpops=[[], self.XPopsInpCells[popConnections]]
                          
            ###SUBTRACTS A FIXED CONSTANT FROM A POPULATION, THEREFORE, THE NUMBER 
            self.Subtraction(inputpops, self.EMinusXPops[popConnections], inputincrements, self.EXincrements[popConnections], self.numNeuronsInEachEMinusXPop[popConnections], inputnumpops, minWeight, 2, self.Earray[popConnections])
            #####
            ###connect the E-X and K to (EminusX)*K
            #multiplication
            inputnumpops=[self.numNeuronsInEachEMinusXPop[popConnections]]
            inputincrements=[self.EXincrements[popConnections]]
            inputpops=[self.EMinusXPops[popConnections]]

            #print "hello"
            #print inputnumpops
            #print inputincrements
            #print inputpops
            
            ##MULTINEUIES A FIXED CONSTANT WITH A POPULATION, I.E. THE NUMBER OF CONNECTIONS FIXED TO EACH NEURON IN A POPULATION IS EQUAL TO THE CONSTANT K
            self.Multiplication(inputpops, self.EMinusXMultKPops[popConnections], inputincrements, self.EXKincrements[popConnections], self.numNeuronsInEachEMinusXMultKPop[popConnections], inputnumpops, minWeight, 2, self.Karray[popConnections], self.KneuronsPerEXneuron[popConnections])
            

            #print "previous"
            #print self.EMinusXMultKPops
            #print self.FOutCells
            #print self.EXKincrements
            #print self.Fincrements
           # print self.numNeuronsInFPop
           # print self.numNeuronsInEachEMinusXMultKPop
           # vzcvzcv
            #EMinusXPops[popConnections]
            
                
            ##subtraction
            #summation=0 ##subtraction =1 for summation
            #h=self.makePlusConnections(self, 0, 1, 0.065)
#SumOrSub(self, InputPop, OutputPop, InputIncr, OutputIncr, numOutCells, numInCells, minWeight, numSets, summation)            


        ###connect the (E-X)*k pops to F
           #addition
        self.SumOrSub(self.EMinusXMultKPops, self.FOutCells, self.EXKincrements, self.Fincrements, self.numNeuronsInFPop, self.numNeuronsInEachEMinusXMultKPop, minWeight, self.numSets,1)
        """
        #NEW VERSION OF FORCE
        ##NEURAL CONTROLLER
        if(self.useNeuralController==1):
            print "Neural Control"
            #print "....................................................."
            #print self.KPopsInpCells
            #print self.numNeuronsInEachKPop
            #print self.numNeuronsInEachEPop     #when no value for e we have given it a cell (just to satisfy the subtraction, multiplication function etc) that never fires
            #print self.numNeuronsInEachEMinusXPop
            #print self.numNeuronsInEachXPop
            #jkhkjh
            #print self.EPopsInpCells
            #print self.Eincrements
            #print self.Kincrements
            #print self.Earray
            #print self.Karray
        
            #fadf
        

        
            numConnections=self.numSets
            for popConnections in range(0,numConnections):

                self.ConnectPulseToEOrKCells(self.EPopsInpCells[popConnections], self.numNeuronsInEachEPop[popConnections], self.addtime+0,self.PulseCellPop, minWeight, self.Earray[popConnections])
                self.ConnectPulseToEOrKCells(self.KPopsInpCells[popConnections], self.numNeuronsInEachKPop[popConnections], self.addtime+1,self.PulseCellPop, minWeight, self.Karray[popConnections])
            #print "POP COMMECTIONS"
            #print popConnections
                self.subtractTwoPopsV2(self.EPopsInpCells[popConnections], self.XPopsInpCells[popConnections], self.EMinusXPops[popConnections], self.Eincrements[popConnections], self.Xincrements[popConnections], self.EXincrements[popConnections], self.numNeuronsInEachEMinusXPop[popConnections], self.numNeuronsInEachEPop[popConnections], self.numNeuronsInEachXPop[popConnections], minWeight, self.EXInterOutSubCells[popConnections], 1)
            #print popConnections
            #print self.EMinusXPops[popConnections]
            #print self.KPopsInpCells[popConnections]
            #print self.numNeuronsInEachEMinusXPop[popConnections]
            #print self.numNeuronsInEachKPop[popConnections]
            #print self.PosOrNegEXKPop[popConnections]
            #print self.numNeuronsInRoundEXKPopCells[popConnections]
            #print self.RoundEXKincrements[popConnections]
            #print self.EMinusXMultKPops
            #print self.numNeuronsInEachEMinusXMultKPop
            #adfad


            
            #self.MultPosOrNeg(self.EMinusXPops[popConnections], self.KPopsInpCells[popConnections], self.numNeuronsInEachEMinusXPop[popConnections], self.numNeuronsInEachKPop[popConnections] , self.PosOrNegEXKPop[popConnections], minWeight, self.EMinusXBufPops[popConnections], self.KPopsInpCellsBuf[popConnections])

#(self, inputPops1, inputPops2, numNeuronsIn1Pop, numNeuronsIn2Pop, in1Increments, in2Increments, MultPops, numMultPops, MultPopIncr, RoundoutputPops, numNeuronsRoundOutPop, RoundOutIncrements, minWeight, posOrNegPop)
            #dont forget the increments of mult is the input increment*input2increment
            #print "multiple in force"
            #print popConnections
                self.Multiplication2Pops(self.EMinusXPops[popConnections], self.KPopsInpCells[popConnections], self.numNeuronsInEachEMinusXPop[popConnections], self.numNeuronsInEachKPop[popConnections], self.EXincrements[popConnections], self.Kincrements[popConnections], self.EMinusXMultKPops[popConnections], self.numNeuronsInEachEMinusXMultKPop[popConnections], self.EXKincrements[popConnections], self.RoundEXKPopCells[popConnections], self.numNeuronsInRoundEXKPopCells[popConnections], self.RoundEXKincrements[popConnections], minWeight, 1,0)



            #self.subtractTwoPopsV2(self.CosPopCells, self.SinPopCells, self.CosSinSubCells, self.COSincrements, self.SINincrements, self.CosSinSubincrements, self.numNeuronsInCosSinSubPop, self.numNeuronsInCosPop, self.numNeuronsInSinPop, minWeight, self.CosSinPopInterOutSubCells)

        
            #maxF, numFcells, numE1X1K1cells, numE2X2K2cells, numE3X3K3cells, numE4X4K4cells

        ##these are now 0.25 increments due to the multiplication

        #the round po

        #print self.numNeuronsInEachEMinusXPop
        #print self.numNeuronsInEachEMinusXMultKPop
        #print self.EMinusXMultKPops
        #print self.numNeuronsInRoundEXKPopCells
        #print self.RoundEXKPopCells
        #print self.RoundEXKincrements
        #print self.EXKincrements
        #print self.EXKSum01Cells
        #print self.EXKSum23Cells
        #print self.EXKSum01increments
        #print self.EXKSum23increments

        
        #print self.EXKPopInterOutSum01Cells
        #print self.EXKPopInterOutSum23Cells
        #print self.numNeuronsInEXKSum01Pop
        #print self.numNeuronsInEXKSum23Pop
        #jkhkjh

            self.summationTwoPopsV3(self.RoundEXKPopCells[0], self.RoundEXKPopCells[1], self.EXKSum01Cells, self.RoundEXKincrements[0], self.RoundEXKincrements[1], self.EXKSum01increments, self.numNeuronsInEXKSum01Pop, self.numNeuronsInRoundEXKPopCells[0], self.numNeuronsInRoundEXKPopCells[1], minWeight, self.EXKPopInterOutSum01Cells,1,0,[])
            self.summationTwoPopsV3(self.RoundEXKPopCells[2], self.RoundEXKPopCells[3], self.EXKSum23Cells, self.RoundEXKincrements[2], self.RoundEXKincrements[3], self.EXKSum23increments, self.numNeuronsInEXKSum23Pop, self.numNeuronsInRoundEXKPopCells[2], self.numNeuronsInRoundEXKPopCells[3], minWeight, self.EXKPopInterOutSum23Cells,1,0,[])
        
        #(self, InputPops1, InputPops2, OutputPops, Input1Incr, Input2Incr, OutputIncr, numOutcells, numIn1Cells, numIn2Cells, minWeight, sumInterPop):
        ##DISCONNECT THE FORCE POP FROM THE REST FOR THE MOMENT
            self.summationTwoPopsV3(self.EXKSum01Cells, self.EXKSum23Cells, self.FOutCells2, self.EXKSum01increments, self.EXKSum23increments, self.Fincrements, self.numNeuronsInFPop, self.numNeuronsInEXKSum01Pop, self.numNeuronsInEXKSum23Pop, minWeight, self.FInterSumCells,1)
        ######################
        ##EXKSumCells[2]=F

    def printPklSpikes(self, fileName, InputOrOutput):
        fileHandle = open(fileName)
        neoObj = pickle.load(fileHandle)
        segments = neoObj.segments
        segment = segments[0]
        spikeTrains = segment.spiketrains
        neurons = len(spikeTrains)
        numNeuronsfired=0
        for neuronNum in range (0,neurons):
            if (len(spikeTrains[neuronNum])>0):
                spikes = spikeTrains[neuronNum]
                for spike in range (0,len(spikes)):
                    if (InputOrOutput==0):
                        neurons
                        #print "Input Neuron:",neuronNum, spikes[spike]
                    else:
                        neurons
                        #print "Output Neuron:",neuronNum, spikes[spike]
                numNeuronsfired+=1    
        fileHandle.close()
        return numNeuronsfired


    def countPklSpikes(self,fileName):
        spikeCount = 0
        fileHandle = open(fileName)
        neoObj = pickle.load(fileHandle)
        segments = neoObj.segments
        segment = segments[0]
        spikeTrains = segment.spiketrains
        neurons = len(spikeTrains)
        WhichNeurons=[]
        for neuronNum in range (0,neurons):
            if (len(spikeTrains[neuronNum])>0):
                spikes = spikeTrains[neuronNum]
                WhichNeurons.append(neuronNum)
                for spike in range (0,len(spikes)):
                    spikeCount = spikeCount + 1
        fileHandle.close()
        return [spikeCount, WhichNeurons]

    def PlotMembraneVoltageAndSpikes(self,cellpopulation, fignum, simtime, titlefig):
        data = cellpopulation.get_data().segments[0]
        vm = data.filter(name="v")[0]
        gsynExc = data.filter(name="gsyn_exc")[0]
        gsynInh = data.filter(name="gsyn_inh")[0]
        if(fignum==1):
            figurename="E1X1K1input.png"
        elif(fignum==2):
            figurename="E2X2K2input.png"
        elif(fignum==3):
            figurename="E3X3K3input.png"
        elif (fignum==4):
            figurename="E4X4K4input.png"
        else:
            figurename="Foutputneurons.png"
    #print "vm"
    #print vm
    #print len(vm)
#    fig=plt.figure(fignum)
    #ax1 = fig.add_subplot(211)
    #ax2 = fig.add_subplot(212)
#    plt.subplot(2, 1, 1)
#    plt.plot(vm)
#    plt.subplot(2, 1, 2)
#    plot_spiketrains(data)
    
 #   times=np.arange(0,simtime,nealParameters.DELAY)  # array holding a set of times starting at 0, incrementing by dt and ending at simtime
 #   fig=plt.figure(fignum)
  #  ax1 = fig.add_subplot(211)
 #   ax2 = fig.add_subplot(212)
#    ax1.plot(vm)
#    ax2.plot(data.spiketrains)
#    ax1.set_ylabel('Membrane potential (mV)')
#    ax2.set_ylabel('Spikes')
  
#    ax2.set_xlabel('Time (ms)')
        Figure(
        Panel(vm, ylabel="Membrane potential (mV)", xticks=True, yticks=True),
 #   Panel(gsyn, ylabel="Synaptic conductance (uS)"),
        Panel(gsynExc, ylabel="Exc Synaptic conductance (uS)", xticks=True,yticks=True),
        Panel(gsynInh, ylabel="Inh Synaptic conductance (uS)", xticks=True,yticks=True),
        Panel(data.spiketrains, xlabel="Time (ms)", xticks=True, yticks=True),
        title=titlefig,
    #Panel(vm2, ylabel="Membrane potential (mV)", xticks=True,yticks=True),
    #Panel(data2.spiketrains, xlabel="Time (ms)", xticks=True),
    #Panel([inputtimes,output_firing_rates], xlabel="Time (ms)", xticks=True, yticks=True)
    ).save(figurename)

    def actualforward(self,x2):
        dx=[0,0,0,0]
        F=0
        m0=0.01
        m1=0.01
        l=1
        dt=0.01
        g=9.75        
        #dt=0.1

        x=[0,0,0,0]
        x[0]=x2[0]
        x[1]=x2[1]
        x[2]=x2[2]
        x[3]=x2[3]
        
        theta = x[1]
        dtheta = x[3]

        dx[0] = x[2]
        dx[1] = x[3]
        dx[2] = 1/(m0+m1*(sin(theta)**2.))*(m1*g*sin(theta)*cos(theta)-m1*l*(dtheta**2.)*sin(theta)+F)
        dx[3] = 1/l*(g*sin(theta)+dx[2]*cos(theta))

        x[0]+=dx[0]*dt
        x[1]+=dx[1]*dt
        x[2]+=dx[2]*dt
        x[3]+=dx[3]*dt
        return x

    def testforward(self, x2, F2, dt, itest):
        #F=0.0
        print "#####################"
        print "input"
        print x2

        F=F2
        if(round(F,5)<0):
            adddec=-0.00001
        elif(round(F,5)>0):
            adddec=0.00001
        else:
            adddec=0.0

        Fincrement=0.01

        #print "dtheta"
        F = Fincrement*(np.fix((round(F,5)/Fincrement)+adddec))
        #print round(x[3],5)
        #print '{0:.16f}'.format(dtheta)
        F=round(F,5)       
    
        m0=0.01
        m1=0.01
        l=1
    #dt=0.1
        g=9.75
        gincrement=0.25

        #test=1
        x=[0,0,0,0]
        x[0]=x2[0]
        x[1]=x2[1]
        x[2]=x2[2]
        x[3]=x2[3]

        numb=1
        numb10=150 #250
        res=0.01
        
        x1increment=res
        x3increment=res
        cosincrement=0.05
        sinincrement=0.05
        ###
        x3sqincrement=x3increment*(x3increment*numb10) #0.01 
        Rx3sqincrement=0.05
        m1MlMRx3sqincrement=m1*(Rx3sqincrement*numb) #0.001 (0.0005*2)
        Rm1MlMRx3sqincrement=0.01
        numb6=10
        SinRm1lRx3sqincrement=sinincrement*(Rm1MlMRx3sqincrement*numb6) #0.0001 (0.00005*2)
        RSinRm1lRx3sqincrement=0.01
        ####
        CosSinincrement=cosincrement*(numb*sinincrement)        #0.005 (0.0025*2)
        RCosSinincrement=0.01
        M1GRCosSinincrement=(m1*g)*(RCosSinincrement)         #0.004875
        RM1GRCosSinincrement=0.01
        ####
        SinGincrement=gincrement*(sinincrement*numb)                        # 0.025    (0.0125*2)
        RSinGincrement=0.05
        ####
        sinsqincrement=sinincrement*(sinincrement*numb)             #0.005 (0.0025*2)
        Rsinsqincrement=0.05    
        M1Rsinsqincrement=m1*(Rsinsqincrement*numb)          #0.001 (0.0005*2)
        RM1Rsinsqincrement=0.01
        M0RM1Rsinsqincrement=0.01
        oneDivM0RM1Rsinsqincrement=0.05
        RoneDivM0RM1Rsinsqincrement=0.75    
        ####4
        x2increment=res
        x3increment=res
        #####
        RM1GRCosSinMinusRSinRm1lRx3sqincrement=0.01
        RM1GRCosSinMinusRSinRm1lRx3sqPlusFincrement=0.01
        #####
        numb3=2
        DX2increment=RoneDivM0RM1Rsinsqincrement*(RM1GRCosSinMinusRSinRm1lRx3sqPlusFincrement*numb3) #0.03 (0.015*2)
        RDX2increment=0.5
        #####
        numb2=1
        CosRDX2increment=RDX2increment*(cosincrement*numb2)     #0.05 (0.025*2)
        
        #CosRDX2increment=RDX2increment*(cosincrement*numb)     #0.05 (0.025*2)
        RCosRDX2increment=0.05
        DX3increment=RCosRDX2increment # RCosRDX2increment has to be the same as SinG as we add them together #0.05
        RDX3increment=0.1
        ####
        DX0dt0increment=dt*(x2increment*numb)          #0.0002 (0.0001*2)
        RDX0dt0increment=res
        X0PRDX0dt0increment=res
        ####
        DX1dt1increment=dt*(x3increment*numb)          #0.0002 (0.0001*2)
        RDX1dt1increment=res
        X1PRDX1dt1increment=res
        ####
        DX2dt2increment=dt*(RDX2increment*numb)            #0.01 (0.005*2)
        RDX2dt2increment=res
        X2PRDX2dt2increment=res
        ####
        DX3dt3increment=dt*(RDX3increment*numb)            #0.002 (0.001*2)
        RDX3dt3increment=res
        X3PRDX3dt3increment=res    
        """
        print "###############"
        print "inside testforward"
        print '{0:.16f}'.format(x[0])
        print '{0:.16f}'.format(x[1])
        print '{0:.16f}'.format(x[2])
        print '{0:.16f}'.format(x[3])
        print "##################"
        """
        #angincr=0.05
        theta=x[1]
        dtheta=x[3]
        #sintheta=angincr*(round(sin(theta)/angincr,5))
        #costheta=angincr*(round(cos(theta)/angincr,5))
        #incr=M1*g*angincr
        

        #adddec=0.00000001
        adddec=0.0

        if(round(x[1],5)<0):
            adddec=-0.00001
        elif(round(x[1],5)>0):
            adddec=0.00001
        else:
            adddec=0.0
        
        theta = x1increment*(np.fix((round(x[1],5)/x1increment)+adddec))     ###np.fix rounds towards 0
        theta=round(theta,5)
        adddec=0.0

        
        if(round(x[3],5)<0):
            adddec=-0.00001
        elif(round(x[3],5)>0):
            adddec=0.00001
        else:
            adddec=0.0

        #print "dtheta"
        dtheta = x3increment*(np.fix((round(x[3],5)/x3increment)+adddec))
        #print round(x[3],5)
        #print '{0:.16f}'.format(dtheta)
        dtheta=round(dtheta,5)
        #print round(dtheta,5)
        #adddec=0.0

        if(round(cos(theta),5)<0):
            adddec=-0.00001
        elif(round(cos(theta),5)>0):
            adddec=0.00001
        else:
            adddec=0.0

            
        costheta=cosincrement*(np.fix((round(cos(theta),5)/cosincrement)+adddec))
        costheta=round(costheta,5)

        #adddec=0.0

        if(sin(theta)<0):
            adddec=-0.00001
        elif(sin(theta)>0):
            adddec=0.00001
        else:
            adddec=0.0
            
        sintheta=sinincrement*(np.fix((round(sin(theta),5)/sinincrement)+adddec))
        sintheta=round(sintheta,5)

    
        if((dtheta)<0):
            adddec=-0.00001
        elif((dtheta)>0):
            adddec=0.00001
        else:
            adddec=0.0
        
        dtheta2=np.fix((round(dtheta/x3increment,5)/numb10)+adddec)*(x3increment*numb10)

        adddec=0.00001         
        #print dtheta
        #print '{0:.16f}'.format(dtheta)
        dthetasq=x3sqincrement*(np.fix((round(dtheta*dtheta2,5)/x3sqincrement)+adddec))

        #print dthetasq
        #print '{0:.16f}'.format(dthetasq)
#        adfa
        dthetasq=round(dthetasq,5)
        Rdthetasq=Rx3sqincrement*(np.fix((round(dthetasq,5)/Rx3sqincrement)+adddec))
        Rdthetasq=round(Rdthetasq,5)

        if((Rdthetasq)<0):
            adddec=-0.00001
        elif((Rdthetasq)>0):
            adddec=0.00001
        else:
            adddec=0.0
        
        Rdthetasq=np.fix((round(Rdthetasq/Rx3sqincrement,5)/numb)+adddec)*(Rx3sqincrement*numb)



        i=m1MlMRx3sqincrement*(np.fix((round(m1*l*Rdthetasq,5)/m1MlMRx3sqincrement)+adddec))
        i=round(i,5)
        Ri= Rm1MlMRx3sqincrement*(np.fix((round(i,5)/Rm1MlMRx3sqincrement)+adddec))
        Ri=round(Ri,5)

        #adddec=0.0

        if((Ri)<0):
            adddec=-0.00001
        elif((Ri)>0):
            adddec=0.00001
        else:
            adddec=0.0
        
        Ri=np.fix((round(Ri/Rm1MlMRx3sqincrement,5)/numb6)+adddec)*(Rm1MlMRx3sqincrement*numb6)


        if((Ri*sintheta)<0):
            adddec=-0.00001
        elif ((Ri*sintheta)>0):
            adddec=0.00001
        else:
            adddec=0.0


        z=SinRm1lRx3sqincrement*(np.fix((round(Ri*sintheta,5)/SinRm1lRx3sqincrement)+adddec))
        z=round(z,5)
        Rz=RSinRm1lRx3sqincrement*(np.fix((round(z,5)/RSinRm1lRx3sqincrement)+adddec))
        Rz=round(Rz,5)

        adddec=0.0

        if((sintheta)<0):
            adddec=-0.00001
        elif((sintheta)>0):
            adddec=0.00001
        else:
            adddec=0.0
        
        sintheta4=np.fix((round(sintheta/sinincrement,5)/numb)+adddec)*(sinincrement*numb)


        if((sintheta4*costheta)<0):
            adddec=-0.00001
        elif((sintheta4*costheta)>0):
            adddec=0.00001
        else:
            adddec=0.0


        s= CosSinincrement*(np.fix((round(sintheta4*costheta,5)/CosSinincrement)+adddec))
        s=round(s,5)
        Rs=RCosSinincrement*(np.fix((round(s,5)/RCosSinincrement)+adddec))
        Rs=round(Rs,5)
        
       #t=0.004905*(round(((m1*g*Rs)/0.004905)+adddec))
        
        if((m1*g*Rs)<0):
            adddec=-0.00001
        elif((m1*g*Rs)>0):
            adddec=0.00001
        else:
            adddec=0.0
    #print "################"
    #print m1*g*Rs
    #print m1*g
    #print Rs
    #print round(m1*g*Rs,6)
    #print adddec
    #print round(m1*g*Rs,6)/0.004875
    #print np.fix((round(m1*g*Rs,6)/0.004875)+adddec)
    #print 0.004875*(np.fix((round(m1*g*Rs,6)/0.004875)+adddec))

    
        t=M1GRCosSinincrement*(np.fix((round(m1*g*Rs,6)/M1GRCosSinincrement)+adddec))
        t=round(t,6)
        Rt=RM1GRCosSinincrement*(np.fix((round(t,5)/RM1GRCosSinincrement)+adddec))
        Rt=round(Rt,5)

        if((sintheta)<0):
            adddec=-0.00001
        elif((sintheta)>0):
            adddec=0.00001
        else:
            adddec=0.0
        
        sintheta3=np.fix((round(sintheta/sinincrement,5)/numb)+adddec)*(sinincrement*numb)


        if((g*sintheta3)<0):
            adddec=-0.00001
        elif((g*sintheta3)>0):
            adddec=0.00001
        else:
            adddec=0.0


        f=SinGincrement*(np.fix((round(g*sintheta3,5)/SinGincrement)+adddec))
        f=round(f,5)
        Rf=RSinGincrement*(np.fix((round(f,5)/RSinGincrement)+adddec))
        Rf=round(Rf,5)


        if((sintheta)<0):
            adddec=-0.00001
        elif((sintheta)>0):
            adddec=0.00001
        else:
            adddec=0.0
        
        sintheta2=np.fix((round(sintheta/sinincrement,5)/numb)+adddec)*(sinincrement*numb)


        if((sintheta*sintheta2)<0):
            adddec=-0.00001
        elif((sintheta*sintheta2)>0):
            adddec=0.00001
        else:
            adddec=0.0




        v=sinsqincrement*(np.fix((round(sintheta*sintheta2,5)/sinsqincrement)+adddec))
        v=round(v,5)
        Rv=Rsinsqincrement*(np.fix((round(v,5)/Rsinsqincrement)+adddec))
        Rv=round(Rv,5)

        if((Rv)<0):
            adddec=-0.00001
        elif((Rv)>0):
            adddec=0.00001
        else:
            adddec=0.0
        
        Rv=np.fix((round(Rv/Rsinsqincrement,5)/numb)+adddec)*(Rsinsqincrement*numb)



        if((m1*Rv)<0):
            adddec=-0.00001
        elif((m1*Rv)>0):
            adddec=0.00001
        else:
            adddec=0.0


        vm=M1Rsinsqincrement*(np.fix((round(m1*Rv,5)/M1Rsinsqincrement)+adddec))
        vm=round(vm,5)
        Rvm=RM1Rsinsqincrement*(np.fix((round(vm,5)/RM1Rsinsqincrement)+adddec))
        Rvm=round(Rvm,5)



        if((m0+Rvm)<0):
            adddec=-0.00001
        elif((m0+Rvm)>0):
            adddec=0.00001
        else:
            adddec=0.0

    
            
        oneRvmM=M0RM1Rsinsqincrement*(np.fix((round(m0+Rvm,5)/M0RM1Rsinsqincrement)+adddec))
        oneRvmM=round(oneRvmM,5)
        dx=[0,0,0,0]


        if((x[2])<0):
            adddec=-0.00001
        elif((x[2])>0):
            adddec=0.00001
        else:
            adddec=0.0
        
        #print x[2]
        #print adddec
        #print round(x[2],5)
        #print (round(x[2],5)/0.1)
        #print (np.fix((round(x[2],5)/0.1)+adddec))
        #print 0.1*(np.fix((round(x[2],5)/0.1)+adddec))
    
    
        dx[0] = x2increment*(np.fix((round(x[2],5)/x2increment)+adddec))
        #print dx[0]
        #print round(dx[0],5)
        dx[0]=round(dx[0],5)
        
        if((x[3])<0):
            adddec=-0.00001
        elif((x[3])>0):
            adddec=0.00001
        else:
            adddec=0.0

    
        dx[1] = x3increment*(np.fix((round(x[3],5)/x3increment)+adddec))
        dx[1]=round(dx[1],5)
        #dx[2] = 1/(m0+m1*(sin(theta)**2.))*(m1*g*sin(theta)*cos(theta)-m1*l*(dtheta**2.)*sin(theta)+F)
        #dx[3] = 1/l*(g*sin(theta)+dx[2]*cos(theta))

        #dx[0] = incr*(math.floorx[2]/incr,5))
        #dx[1] = incr*(math.floorx[3]/incr,5))
        a=oneRvmM
        if((1.0/a)<0):
            adddec=-0.00001
        elif((1.0/a)>0):
            adddec=0.00001
        else:
            adddec=0.0


        aa=oneDivM0RM1Rsinsqincrement*(np.fix((round(1.0/a,5)/oneDivM0RM1Rsinsqincrement)+adddec))
        aa=round(aa,5)
        Raa=RoneDivM0RM1Rsinsqincrement*(np.fix((round(aa,5)/RoneDivM0RM1Rsinsqincrement)+adddec))
        Raa=round(Raa,5)

    
        b=Raa   
        c=Rt
        d=Rz
        e=Rf

        if((c-d)<0):
            adddec=-0.00001
        elif((c-d)>0):
            adddec=0.00001
        else:
            adddec=0.0

            
        bb=RM1GRCosSinMinusRSinRm1lRx3sqincrement*(np.fix((round(c-d,5)/RM1GRCosSinMinusRSinRm1lRx3sqincrement)+adddec))
        bb=round(bb,5)

        if((bb+F)<0):
            adddec=-0.00001
        elif((bb+F)>0):
            adddec=0.00001
        else:
            adddec=0.0

    
            
        ko=RM1GRCosSinMinusRSinRm1lRx3sqPlusFincrement*(np.fix((round(bb+F,5)/RM1GRCosSinMinusRSinRm1lRx3sqPlusFincrement)+adddec))
        ko=round(ko,5)



        if((ko)<0):
            adddec=-0.00001
        elif((ko)>0):
            adddec=0.00001
        else:
            adddec=0.0
        
        ko2=np.fix((round(ko/RM1GRCosSinMinusRSinRm1lRx3sqPlusFincrement,5)/numb3)+adddec)*(RM1GRCosSinMinusRSinRm1lRx3sqPlusFincrement*numb3)

        if((b*ko2)<0):
            adddec=-0.00001
        elif((b*ko2)>0):
            adddec=0.00001
        else:
            adddec=0.0
    
        cc=DX2increment*(np.fix((round(b*ko2,5)/DX2increment)+adddec))
        cc=round(cc,5)
        if((cc)<0):
            adddec=-0.00001
        elif((cc)>0):
            adddec=0.00001
        else:
            adddec=0.0
            
        Rcc=RDX2increment*(np.fix((round(cc,5)/RDX2increment)+adddec))
        Rcc=round(Rcc,5)
                                 
        dx[2] = Rcc
        #dx[2]=1.0

        if((costheta)<0):
            adddec=-0.00001
        elif((costheta)>0):
            adddec=0.00001
        else:
            adddec=0.0
        
        costheta2=np.fix((round(costheta/cosincrement,5)/numb2)+adddec)*(cosincrement*numb2)


        if((dx[2]*costheta2)<0):
            adddec=-0.00001
        elif((dx[2]*costheta2)>0):
            adddec=0.00001
        else:
            adddec=0.0



        dd=CosRDX2increment*(np.fix((round(dx[2]*costheta2,5)/CosRDX2increment)+adddec))
        dd=round(dd,5)
        Rdd=RCosRDX2increment*(np.fix((round(dd,5)/RCosRDX2increment)+adddec))
        Rdd=round(Rdd,5)

        ff=Rdd
        if((e+ff)<0):
            adddec=-0.00001
        elif((e+ff)>0):
            adddec=0.00001
        else:
            adddec=0.0


            
        ee=DX3increment*(np.fix((round(e+ff,5)/DX3increment)+adddec))
        ee=round(ee,5)

        if((ee)<0):
            adddec=-0.00001
        elif((ee)>0):
            adddec=0.00001
        else:
            adddec=0.0

        Ree=RDX3increment*(np.fix((round(ee,5)/RDX3increment)+adddec))
        Ree=round(ee,5)    

    
        dx[3] = Ree


    
        DX0dt0increment=round(DX0dt0increment,5)


        #print '{0:.16f}'.format(((dx[0]*dt)/incr)+adddec)
        #print '{0:.16f}'.format(np.fix(((dx[0]*dt)/incr)+adddec))
        #print np.fix(10.0)
        #print incr*(np.fix(((dx[0]*dt)/incr)+adddec))

        if((dx[0])<0):
            adddec=-0.00001
        elif((dx[0])>0):
            adddec=0.00001
        else:
            adddec=0.0
        
        dx02=np.fix((round(dx[0]/x2increment,5)/numb)+adddec)*(x2increment*numb)
        


        if((dx02*dt)<0):
            adddec=-0.00001
        elif((dx02*dt)>0):
            adddec=0.00001
        else:
            adddec=0.0



        gg=DX0dt0increment*(np.fix((round(dx02*dt,5)/DX0dt0increment)+adddec))

        print dx[0]
        print x2increment
        print dt
        print numb
        print DX0dt0increment
        print gg
   # adfaf
    
        gg=round(gg,5)
        Rgg=RDX0dt0increment*(np.fix((round(gg,5)/RDX0dt0increment)+adddec))
        Rgg=round(Rgg,5)

        
        if((x[0]+Rgg)<0):
            adddec=-0.00001
        elif((x[0]+Rgg)>0):
            adddec=0.00001
        else:
            adddec=0.0
            
        ii=X0PRDX0dt0increment*(np.fix((round(x[0]+Rgg,5)/X0PRDX0dt0increment)+adddec))
        ii=round(ii,5)
        #print dx[0]
        #print dt
        #print incr

        #print gg
        #print Rgg
        #print ii

        x[0]=ii
        #print x[0]
        #zgdfg

        DX1dt1increment=round(DX1dt1increment,5)

        if((dx[1])<0):
            adddec=-0.00001
        elif((dx[1])>0):
            adddec=0.00001
        else:
            adddec=0.0

        dx12=np.fix((round(dx[1]/x3increment,5)/numb)+adddec)*(x3increment*numb)
        



    
        if((dx12*dt)<0):
            adddec=-0.00001
        elif((dx12*dt)>0):
            adddec=0.00001
        else:
            adddec=0.0


            
        jj=DX1dt1increment*(np.fix((round(dx12*dt,5)/DX1dt1increment)+adddec))
        jj=round(jj,5)
        Rjj=RDX1dt1increment*(np.fix(((round(jj,5))/RDX1dt1increment)+adddec))
        Rjj=round(Rjj,5)

        if((x[1]+Rjj)<0):
            adddec=-0.00001
        elif((x[1]+Rjj)>0):
            adddec=0.00001
        else:
            adddec=0.0
        kk=X1PRDX1dt1increment*(np.fix((round(x[1]+Rjj,5)/X1PRDX1dt1increment)+adddec))
        kk=round(kk,5)
                  
        x[1]=kk



        DX2dt2increment=round(DX2dt2increment,5)

        if((dx[2])<0):
            adddec=-0.00001
        elif((dx[2])>0):
            adddec=0.00001
        else:
            adddec=0.0

        dx22=np.fix((round(dx[2]/RDX2increment,5)/numb)+adddec)*(RDX2increment*numb)
        


        if((dx22*dt)<0):
            adddec=-0.00001
        elif((dx22*dt)>0):
            adddec=0.00001
        else:
            adddec=0.0


            
        ll=DX2dt2increment*(np.fix((round(dx22*dt,5)/DX2dt2increment)+adddec))
        ll=round(ll,5)
        Rll=RDX2dt2increment*(np.fix(((round(ll,5))/RDX2dt2increment)+adddec))
        Rll=round(Rll,5)

        if((x[2]+Rll)<0):
            adddec=-0.00001
        elif((x[2]+Rll)>0):
            adddec=0.00001
        else:
            adddec=0.0
            
        mm=X2PRDX2dt2increment*(np.fix((round(x[2]+Rll,5)/X2PRDX2dt2increment)+adddec))
        mm=round(mm,5)
                 
        x[2]=mm

        DX3dt3increment=round(DX3dt3increment,5)

        if((dx[3])<0):
            adddec=-0.00001
        elif((dx[3])>0):
            adddec=0.00001
        else:
            adddec=0.0

        dx32=np.fix((round(dx[3]/RDX3increment,5)/numb)+adddec)*(RDX3increment*numb)


        if((dx32*dt)<0):
            adddec=-0.00001
        elif((dx32*dt)>0):
            adddec=0.00001
        else:
            adddec=0.0

        nn=DX3dt3increment*(np.fix((round(dx32*dt,5)/DX3dt3increment)+adddec))
        nn=round(nn,5)

        #print '{0:.16f}'.format((nn)+adddec)
        #print '{0:.16f}'.format((nn/0.1)+adddec)

        Rnn=RDX3dt3increment*(np.fix(((round(nn,5))/RDX3dt3increment)+adddec))
        Rnn=round(Rnn,5)

        if((x[3]+Rnn)<0):
            adddec=-0.00001
        elif((x[3]+Rnn)>0):
            adddec=0.00001
        else:
            adddec=0.0
            
        oo=X3PRDX3dt3increment*(np.fix((round(x[3]+Rnn,5)/X3PRDX3dt3increment)+adddec))
        oo=round(oo,5)
        x[3]=oo
        if(self.test==1):
            print "---------dx[0]-----------"
            print dx[0]
            print "dx[0] rounded"
            print dx02        
            print "dx[0]*dt"
            print gg
            print Rgg
            print "x[0]"
            print x[0]


            print "-----------dx[1]--------"
            print dx[1]
            print "dx[1] rounded"
            print dx12        
            print "dx[1]*dt"
            print jj
            print Rjj
            print "x[1]"
            print x[1]        

 
              
            print "-----------------dx[2]--------"
            print "sintheta*sintheta"
            print "rounded sin"
            print sintheta2
            print v
            print Rv
            print "sintheta*sintheta*m1+m0"
            print oneRvmM
            print "1/sintheta*singhteta*m1+m0"
            print aa
            print Raa
            print "dtheta*dtheta"
            print "dtheta1"
            print dtheta
            print "dtheta2"
            print dtheta2
            print dthetasq
            print Rdthetasq
            print "dtheta*dtheta*m1*l"
            print i
            print Ri
            print "dtheta*dtheta*m1*l*sin"
            print z
            print Rz
            print "costheta*sintheta"
            print "rounded sintheta"
            print sintheta4
            print s
            print Rs
            print "costheta*sintheta*M1*g"
            print t
            print Rt
            print "costheta*sintheta*M1*g-dtheta*dtheta*m1*l*sin"
            print bb
            print "F"
            print F
            print "(costheta*sintheta*M1*g-dtheta*dtheta*m1*l*sin)+F"
            print ko
            print "(1/sintheta*singhteta*m1+m0)*(costheta*sintheta*M1*g-dtheta*dtheta*m1*l*sin+F)"
            print "rounded (costheta*sintheta*M1*g-dtheta*dtheta*m1*l*sin)+F"
            print ko2
            print cc
            print "Rcc (below)=round(dx[2])"
            print Rcc
            print "dx[2]"
            print dx[2]
            print "dx[2] rounded"
            print dx22        
            print "dx[2]*dt"
            print ll
            print Rll
            print "x[2]"
            print x[2]
            print "------------------dx[3]--------"

            print "costheta"
            print costheta
            print "sintheta"
            print sintheta
            print "g*sintheta"
            print "rounded sin"
            print sintheta3
            print f
            print Rf
            print "costtheta*dx[2]"
            print "rounded cos"
            print costheta2
            print dd
            print Rdd
            print "1*(g*sintheta)+(costtheta*dx[2])"
            print dx[3]
            print "dx[3]"
            print ee
            print dx[3]
            print "dx[3] rounded"
            print dx22
            print "dx[3]*dt"
            print nn
            print Rnn
            print "x[3]"
            print oo          
        #kjhkj

    #if(itest==14):
    #    print '{0:.16f}'.format(Rv)
   #     print round(m1*Rv,5)
    #    print vm
    #    print Rvm
    #    pause()

        print "output"
        print x
        print "#####################"
    #adfa
        return x
    

    def PlotMembraneVoltageAndSpikesOneCell(self,cellpopulation, fignum):
        data_out = cellpopulation.get_data()
        #vm = data.filter(name="v")[0]
        #gsynExc = data.filter(name="gsyn_exc")[0]
        #gsynInh = data.filter(name="gsyn_inh")[0]

        fig_settings = {
        'lines.linewidth': 0.5,
        'axes.linewidth': 0.5,
        'axes.labelsize': 'small',
        'legend.fontsize': 'small',
        'font.size': 8
        }
        plt.rcParams.update(fig_settings)
        plt.figure(1, figsize=(6, 8))


        def plot_spiketrains(segment):
            for spiketrain in segment.spiketrains:
                y = np.ones_like(spiketrain) * spiketrain.annotations['source_id']
                plt.plot(spiketrain, y, '.')
                plt.ylabel(segment.name)
                plt.setp(plt.gca().get_xticklabels(), visible=False)


        def plot_signal(signal, index, colour='b'):
            label = "Neuron %d" % signal.annotations['source_ids'][index]
            plt.plot(signal.times, signal[:, index], colour, label=label)
            plt.ylabel("%s (%s)" % (signal.name, signal.units._dimensionality.string))
            plt.setp(plt.gca().get_xticklabels(), visible=False)
            plt.legend()

        n_panels = sum(a.shape[1] for a in data_out.segments[0].analogsignals) + 2
        plt.subplot(n_panels, 1, 1)
        #plot_spiketrains(spikes_in.segments[0])
        #plt.subplot(n_panels, 1, 2)
        plot_spiketrains(data_out.segments[0])
        panel = 2
        num2=0
        num=0
        for array in data_out.segments[0].analogsignals:
            if(num==0):
                for i in range(array.shape[1]):
                    plt.subplot(n_panels, 1, panel)
                    plot_signal(array, i, colour='bg'[panel % 2])
                    panel += 1
                plt.xlabel("time (%s)" % array.times.units._dimensionality.string)
                plt.setp(plt.gca().get_xticklabels(), visible=True)
            num2+=1
            print num2
        plt.show()


    def CalculateAndPrintForcePop(self, population, increment, populationNum, summation, InputValues,  whichNeuronsFired, runDur, runs, counter):

        test=0

        h=str(increment)
        title5 = "Value Increment Per Spiking Neuron: %s" % h
        #print title5


        firedneurons=whichNeuronsFired
        if(firedneurons!=[]):
            numFired=len(firedneurons)
            #if(summation==1):
            numNeurons=populationNum
            #else:
            #    numNeurons=self.numNeuronsInFPopNeg
            total=numNeurons[0]
            totalneg=numNeurons[1]
            if(totalneg==0):
                numposvalues=numFired
                numnegvalues=0
            else:
                numnegvalues=len([1 for i in firedneurons if i < totalneg])
                numposvalues=len([1 for i in firedneurons if i >= totalneg])
    #numnegvalues=sum(firedneurons < totalneg)
    #numposvalues=sum(firedneurons >totalneg)
            if(self.test==1):
                print "neurons fired"
                print firedneurons
                print "num of negative neurons fired"
                print numnegvalues
                print "num of positive neurons fired"
                print numposvalues
    #print "min"
    #print min(firedneurons)
                print "numfired"
                print numFired
                print "totalneg"
                print totalneg
                print "firedneurons"
                print firedneurons
                print "number of neurons"
                print total
            
    #for i in range(0,numFired)
    #if(min(firedneurons)<totalneg):   #lowest cell in population that fired
    #    PosOrNeg=-1
    #else:
    #    PosOrNeg=1

    #print "min value of F pop:"
    #print minF
            
    #print Fincrement*numFired*PosOrNeg
    ###SUMMATION
            if(summation==1):
               # print "output value of F pop:"
                Forcesum=(numnegvalues*increment*-1)+(numposvalues*increment)
                #print Forcesum
                #print "Expected Value:"
                #print "summation"
                #print np.sum(InputValues)                
                #print Forcesum
                #eturn Forcesum
                Force=Forcesum
            else:
               # print "output value of F pop:"
                Forceneg=(numnegvalues*increment*-1)+(numposvalues*increment)                
               # print Forceneg
               # print "subtraction"
               # print "expected Value:"
                exp=InputValues[0]-InputValues[1]-InputValues[2]-InputValues[3]
               # print exp
                Force=Forceneg

            ###print figures
            #print "t1"
            #print counter
            #if(counter==500):
            #    print "inside"
            if((self.test==1)or(test==1)):
                self.PlotMembraneVoltageAndSpikes(population,5,runDur*runs-1,title5)
            
                plt.show()
        
            #Force=Forceneg #or forcepos
            #Force=np.sum(x)
            
    ###SUBTRACTION
    
        else:
            #print "output value of F pop:"
            #print str(0)
            if((self.test==1)or(test==1)):
                self.PlotMembraneVoltageAndSpikes(population,5,runDur*runs-1,title5)
            
                plt.show()            
            Force=0

        return Force



    def ClearData(self, Population, numSets):
        for j in range(0,numSets):
            if(numSets==1):
                Pop=Population
            else:
                Pop=Population[j]
            data=Pop.get_data(clear=True).segments[0]
            

    def DetermineWhichFired(self,Population, numSets, segment):
        WhichNeuronsFired=[[] for k in range(numSets)]
        numNeuronsFired=np.zeros((numSets), dtype=np.int)
        test=0
        for j in range(0, numSets):
            if(numSets==1):
                Pop=Population
            else:
                Pop=Population[j]
            spikeCount=0
            #print "start5"
            ###THIS LINE IS SLOW WHEN MANY NEURONS, EVEN WITHOUT THE CLEAR=TRUE 
            #data=Pop.get_data(clear=True).segments[0] # clear the data after each run using clear=true, which is also the voltage and spikes, otherwise the spikes considered after each run will include the previous runs which will cause incorrect results
            #print "end5"
            #data=Pop.get_data().segments[segment]
            #p=Pop.get_data('spikes',clear=True).segments[0]
            #data=Pop.get_data().segments[segment]
            #spikeTrains = data.spiketrains
            if((self.test==1)or(test==1)):
                spikeTrains=Pop.get_data().segments[0].spiketrains   
            else:
                spikeTrains=Pop.get_data('spikes',clear=True).segments[0].spiketrains
                         
            #spikedata=Pop.get_data('spikes',clear=True).segments[0]
            #spikeTrains=data
            neurons = len(spikeTrains)
            WhichNeurons=[]
            #print "start4"
            for neuronNum in range (0,neurons):
                if (len(spikeTrains[neuronNum])>0):
                    spikes = spikeTrains[neuronNum]
                    WhichNeurons.append(neuronNum)
                    #for spike in range (0,len(spikes)):
                    #    spikeCount = spikeCount + 1
            #print "end4"
            WhichNeuronsFired[j]=WhichNeurons
        #fileHandle.close()
        """
        print "whichneurons"
        print WhichNeurons
        print "numneurons"
        print len(WhichNeurons)
        """
        return WhichNeuronsFired
    
    def DetermineWhichInpOutFired(self,InPop, OutPop):
        WhichInNeuronsFired=[[] for k in range(self.numSets)]
        numInNeuronsFired=np.zeros((self.numSets), dtype=np.int)        
        for j in range(0, self.numSets):
            self.printResults(InPop[j],OutPop)
            spikingstats= self.countPklSpikes ('tempOut.pkl')
            count=spikingstats[0]
            WhichOutNeuronsFired=spikingstats[1]
       #     print "output spikes for:", 
       #     print count
       #     print "OutneuronsFired"
       #     print WhichOutNeuronsFired
            spikingstats = self.countPklSpikes ('tempInp.pkl')
            count=spikingstats[0]
            WhichInNeuronsFired[j]=spikingstats[1]
       #     print "input spikes"
       #     print count
       #     print "InneuronsFired"
       #     print WhichInNeuronsFired
        
            numInNeuronsFired[j]=self.printPklSpikes('tempInp.pkl',0)  #0 == input neurons
       #     print spikingstats
        
        

       #     print "Inneuronsfired"
       #     print WhichInNeuronsFired[j]
        
            numOutNeuronsFired=self.printPklSpikes('tempOut.pkl',1)  #1 == output neurons
            #spikingstats[0]
            #whichFNeuronsFired=spikingstats[1]
       #     print "numOutneuronsFired"
       #     print numOutNeuronsFired



        #    print "numIn %s neuronsFired" % j
        #    print numInNeuronsFired[j]
        

        return(WhichInNeuronsFired,WhichOutNeuronsFired)

    def testNeuron(self, testinputcells, testoutputcells):
        #wt=0.0167
        ##the larger inhibition gets, it gets closer (over time) to the excitation level (when the inhibition reversal potential is equal to the excitation reversal potential)
        #ExcConnector=[(0, 0,0.109,nealParameters.DELAY)]
        #InhConnector=[(1, 0,0.0485,nealParameters.DELAY)]
        """
        ExcConnector=[(0, 0,0.34,nealParameters.DELAY)] #fires a cell in 3ms
        InhConnector=[(1, 0,0.071,nealParameters.DELAY)]   #0.07 just lets the cell fire, 0.071 doesnt (when the excitatory weight is 0.34)
        ExcConnector=[(0, 0,0.26,nealParameters.DELAY)]  #0.251 doesnt let the cell fire, 0.252 does (fires a cell in 5ms)
        """
        #0.713
        minWeight=0.712464
        #ExcConnector=[(0, 0,0.377,nealParameters.DELAY)] #0.377 is the point where there is a linear increase in excitatory connection from 2ms to 3ms, and fires at 3ms.  Therefore, when we have an exact value of 0.26 made from inhib and excit it will fire.  Other values we make from inhib and excit may take time to make the cell fire and larger values of excite and inhib, even though the difference the minweight value to make the cell fire, will not make the cell fire due to larger decreases in connection strength due to the inhib and excite differences overtime
        #ExcConnector=[(0, 0,1.2,nealParameters.DELAY)]     #0.346
        ExcConnector=[(0, 0,minWeight, 1.0)]        #0.0713 will make the cell fire
        #ExcConnector=[(0, 0,0.377,nealParameters.DELAY)] #0.0667 conductance, 0.0 refrac, 3ms oscillations
        #InhConnector=[(0, 0,minWeight, nealParameters.DELAY)]
        #InhConnector=[(0, 0,round(0.55*0.7905,2),nealParameters.DELAY)]
        #InhConnector=[(1, 1,0.55,nealParameters.DELAY)]
        #InhConnector=[(0, 0,2,nealParameters.DELAY)]
        #InhConnector+=[(1, 1,0.41,nealParameters.DELAY)]        
        connList = self.sim.FromListConnector(ExcConnector)
        exc_connections=self.sim.Projection(testinputcells, testoutputcells, connList, receptor_type='excitatory')
        #exc_connections=self.sim.Projection(testinputcells, testinputcells, connList, receptor_type='excitatory')
        #connList = self.sim.FromListConnector(InhConnector)
        #exc_connections=self.sim.Projection(testinputcells, testoutputcells, connList, receptor_type='inhibitory')

    def testCells(self):
        voltage=-51.0
        rest=-65.0
        runDur = 10.0
        runs=2
        
        #testoutputcells
        #testinputcells
        self.initializeCellsUsingValue(self.testinputcells,0.1, 0.05, voltage, [2,0],rest) #this calculates which cells to initialise when given a value

        self.sim.run(runDur)
        self.sim.end()


        [WhichInNeuronsFired]=self.DetermineWhichFired(self.testoutputcells, 1, 0)
        divvalue=self.CalculateAndPrintForcePop(self.testoutputcells, 0.05, [2,0], 1, 0.05, WhichInNeuronsFired, runDur, runs, 0)

        #[WhichInNeuronsFired]=self.DetermineWhichFired(self.testinputcells, 1, 0)
        #divvalue=self.CalculateAndPrintForcePop(self.testinputcells, 0.05, [2,0], 1, 0.05, WhichInNeuronsFired, runDur, runs, 0)

    def testDX0(self):
        rad=0
        runDur=0
        runs=0
        """
        print "X1PopsInpCells1"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.X1PopsInpCells1, 1, 0)
        X1PopsInpCells1value=self.CalculateAndPrintForcePop(self.X1PopsInpCells1, self.Xincrements[1], self.numNeuronsInEachXPop[1], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[1]
        print "X1PopsInpCells1value"
        print X1PopsInpCells1value
        """
        print "X0PopsInpCells1"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.X0PopsInpCells1, 1, 0)
        X0PopsInpCells1value=self.CalculateAndPrintForcePop(self.X0PopsInpCells1, self.Xincrements[0], self.numNeuronsInEachXPop[0], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[0]
        print "X0PopsInpCells1value"
        print X0PopsInpCells1value
        
        """
        print "X2"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.XPopsInpCells[2], 1, 0)
        x2=self.CalculateAndPrintForcePop(self.XPopsInpCells[2], self.Xincrements[2], self.numNeuronsInEachXPop[2], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[2]
        print "x2"
        print x2 
        """
        print "dt0cell"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.dt0cell, 1, 0)
        dt0cellvalue=self.CalculateAndPrintForcePop(self.dt0cell, self.dt0increment, self.numNeuronsDt0Pop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.dt0increment
        print "dt2cellvalue"
        print dt0cellvalue

        print "DX0dtPop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.DX0dtPop, 1, 0)
        DX0dtPopvalue=self.CalculateAndPrintForcePop(self.DX0dtPop, self.DX0dtincrements, self.numNeuronsInDX0dt, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.DX0dtincrements
        print "DX0dtPopvalue"
        print DX0dtPopvalue
        
        print "RoundDX0dtPopCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundDX0dtPopCells, 1, 0)
        RoundDX0dtPopCellsvalue=self.CalculateAndPrintForcePop(self.RoundDX0dtPopCells, self.RoundDX0dtincrements, self.numNeuronsInRoundDX0dtPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.RoundDX0dtincrements
        print "RoundDX0dtPopCellsvalue"
        print RoundDX0dtPopCellsvalue




        print "X0PlusDX0dt0InterSumCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.X0PlusDX0dt0InterSumCells, 1, 0)
        X0PlusDX0dt0InterSumCellsvalue=self.CalculateAndPrintForcePop(self.X0PlusDX0dt0InterSumCells, self.Xincrements[0], self.numNeuronsX0PlusDX0dt0InterPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[2]
        print "X0PlusDX0dt0InterSumCellsvalue"
        print X0PlusDX0dt0InterSumCellsvalue


        print "X0NextStateCells17"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.X0NextStateCells17, 1, 0)
        X0NextStateCells17value=self.CalculateAndPrintForcePop(self.X0NextStateCells17, self.Xincrements[0], self.numNeuronsInEachXPop[0], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[0]
        print "X0NextStateCells17value"
        print X0NextStateCells17value

        print "X0"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.XPopsInpCells[0], 1, 0)
        x0=self.CalculateAndPrintForcePop(self.XPopsInpCells[0], self.Xincrements[0], self.numNeuronsInEachXPop[0], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[0]
        print "x0"
        print x0        

    def testDX1(self):
        rad=0
        runDur=0
        runs=0        
        print "X3"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.XPopsInpCells[3], 1, 0)
        x3=self.CalculateAndPrintForcePop(self.XPopsInpCells[3], self.Xincrements[3], self.numNeuronsInEachXPop[3], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[3]
        print "x3"
        print x3
         

        print "dt1cell"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.dt1cell, 1, 0)
        dt1cellvalue=self.CalculateAndPrintForcePop(self.dt1cell, self.dt1increment, self.numNeuronsDt1Pop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.dt1increment
        print "dt2cellvalue"
        print dt1cellvalue

        print "DX1dtPop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.DX1dtPop, 1, 0)
        DX1dtPopvalue=self.CalculateAndPrintForcePop(self.DX1dtPop, self.DX1dtincrements, self.numNeuronsInDX1dt, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.DX1dtincrements
        print "DX1dtPopvalue"
        print DX1dtPopvalue
        
        print "RoundDX1dtPopCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundDX1dtPopCells, 1, 0)
        RoundDX1dtPopCellsvalue=self.CalculateAndPrintForcePop(self.RoundDX1dtPopCells, self.RoundDX1dtincrements, self.numNeuronsInRoundDX1dtPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.RoundDX1dtincrements
        print "RoundDX1dtPopCellsvalue"
        print RoundDX1dtPopCellsvalue

        print "X1PopsInpCells2"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.X1PopsInpCells2, 1, 0)
        X1PopsInpCells2value=self.CalculateAndPrintForcePop(self.X1PopsInpCells2, self.Xincrements[1], self.numNeuronsInEachXPop[1], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[1]
        print "X1PopsInpCells2value"
        print X1PopsInpCells2value


        print "X1PlusDX1dt1InterSumCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.X1PlusDX1dt1InterSumCells, 1, 0)
        X1PlusDX1dt1InterSumCellsvalue=self.CalculateAndPrintForcePop(self.X1PlusDX1dt1InterSumCells, self.Xincrements[1], self.numNeuronsX1PlusDX1dt1InterPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[1]
        print "X1PlusDX1dt1InterSumCellsvalue"
        print X1PlusDX1dt1InterSumCellsvalue

        print "X1NextStateCells17"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.X1NextStateCells17, 1, 0)
        X1NextStateCells17value=self.CalculateAndPrintForcePop(self.X1NextStateCells17, self.Xincrements[1], self.numNeuronsInEachXPop[1], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[1]
        print "X1NextStateCells17value"
        print X1NextStateCells17value

        print "X1"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.XPopsInpCells[1], 1, 0)
        x1=self.CalculateAndPrintForcePop(self.XPopsInpCells[1], self.Xincrements[1], self.numNeuronsInEachXPop[1], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[1]
        print "x1"
        print x1           

    def testF(self):
        rad=0
        runDur=0
        runs=0
        print "FOutCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.FOutCells, 1, 0)
        FOutCellsvalue=self.CalculateAndPrintForcePop(self.FOutCells, self.Fincrements, self.numNeuronsInFPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Fincrements
        print "FOutCellsvalue"
        print FOutCellsvalue

        print "M1gCosSinMinusSinX3sqM1LPops"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.M1gCosSinMinusSinX3sqM1LPops, 1, 0)
        M1gCosSinMinusSinX3sqM1LPopsvalue=self.CalculateAndPrintForcePop(self.M1gCosSinMinusSinX3sqM1LPops, self.M1gCosSinMinusSinX3sqM1Lincrements, self.numNeuronsM1gCosSinMinusSinX3sqM1L, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.M1gCosSinMinusSinX3sqM1Lincrements
        print "M1gCosSinMinusSinX3sqM1LPopsvalue"
        print M1gCosSinMinusSinX3sqM1LPopsvalue

        print "M1gCosSinMinusSinX3sqM1LPlusFInterCells"  
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.M1gCosSinMinusSinX3sqM1LPlusFInterCells, 1, 0)
        M1gCosSinMinusSinX3sqM1LPlusFInterCellsvalue=self.CalculateAndPrintForcePop(self.M1gCosSinMinusSinX3sqM1LPlusFInterCells, self.Force2increments, self.numNeuronsInM1gCosSinMinusSinX3sqM1LPlusF, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Force2increments
        print "M1gCosSinMinusSinX3sqM1LPlusFInterCellsvalue"
        print M1gCosSinMinusSinX3sqM1LPlusFInterCellsvalue

        print "M1gCosSinMinusSinX3sqM1LPlusFCells"  
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.M1gCosSinMinusSinX3sqM1LPlusFCells, 1, 0)
        M1gCosSinMinusSinX3sqM1LPlusFCellsvalue=self.CalculateAndPrintForcePop(self.M1gCosSinMinusSinX3sqM1LPlusFCells, self.M1gCosSinMinusSinX3sqM1LPlusFincrements, self.numneuron, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.M1gCosSinMinusSinX3sqM1LPlusFincrements
        print "M1gCosSinMinusSinX3sqM1LPlusFCellsvalue"
        print M1gCosSinMinusSinX3sqM1LPlusFCellsvalue


    def testSINCOS(self):
        rad=0
        runDur=0
        runs=0

        print "X1"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.XPopsInpCells[1], 1, 0)
        x1=self.CalculateAndPrintForcePop(self.XPopsInpCells[1], self.Xincrements[1], self.numNeuronsInEachXPop[1], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[1]
        print "x1"
        print x1

        print "X1COPYINTER"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.X1CopyPop, 1, 0)
        x1=self.CalculateAndPrintForcePop(self.X1CopyPop, self.Xincrements[1], self.numNeuronsInEachXPop[1], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[1]
        print "x1"
        print x1

        print "X1CopyCosPopINTER"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.X1CopyCosPop, 1, 0)
        x1=self.CalculateAndPrintForcePop(self.X1CopyCosPop, self.Xincrements[1], self.numNeuronsInEachXPop[1], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[1]
        print "x1"
        print x1

        
        print "COS"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.CosPopCells, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        cosvalue=self.CalculateAndPrintForcePop(self.CosPopCells, self.COSincrements, self.numNeuronsInCosPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.COSincrements
        print "value"
        print cosvalue

        print "SIN"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.SinPopCells, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        sinvalue=self.CalculateAndPrintForcePop(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.SINincrements
        print "sinvalue"
        print sinvalue
        
    def testDX3(self):
        rad=0
        runDur=0
        runs=0

        print "RoundSinGPopCells1"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundSinGPopCells1, 1, 0)
        RoundSinGPopCells1value=self.CalculateAndPrintForcePop(self.RoundSinGPopCells1, self.RoundSinGincrements  , self.numNeuronsInRoundSinG, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.RoundSinGincrements  
        print "RoundSinGPopCells1value"
        print RoundSinGPopCells1value

        print "COSPOPCELLS1"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.CosPopCells1, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)
        cosvalue=self.CalculateAndPrintForcePop(self.CosPopCells1, self.COSincrements, self.numNeuronsInCosPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.COSincrements
        print "value"
        print cosvalue

#self.CosPopCells11
#self.RoundSinGPopCells11

        #print "X3PopsInpCells20"
        #[WhichInNeuronsFired]=self.DetermineWhichFired(self.X3PopsInpCells20, 1, 0)
        #X3PopsInpCells20value=self.CalculateAndPrintForcePop(self.X3PopsInpCells20, self.Xincrements[3], self.numNeuronsInEachXPop[3], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        #print "increment"
        #print self.Xincrements[3]
        #print "X3PopsInpCells20value"
        #print X3PopsInpCells20value        

        print "X3PopsInpCells1"         #39 DELAY, NEEDS TO HIT 41MS
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.X3PopsInpCells1, 1, 0)
        X3PopsInpCells1value=self.CalculateAndPrintForcePop(self.X3PopsInpCells1, self.Xincrements[1], self.numNeuronsInEachXPop[1], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[1]
        print "X3PopsInpCells1value"
        print X3PopsInpCells1value 
        
        print "X1"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.XPopsInpCells[1], 1, 0)
        x1=self.CalculateAndPrintForcePop(self.XPopsInpCells[1], self.Xincrements[1], self.numNeuronsInEachXPop[1], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[1]
        print "x1"
        print x1
                
        print "COS"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.CosPopCells, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        cosvalue=self.CalculateAndPrintForcePop(self.CosPopCells, self.COSincrements, self.numNeuronsInCosPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.COSincrements
        print "value"
        print cosvalue

        print "SIN"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.SinPopCells, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        sinvalue=self.CalculateAndPrintForcePop(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.SINincrements
        print "sinvalue"
        print sinvalue

        print "gPop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.gPop, 1, 0)
        gPopvalue=self.CalculateAndPrintForcePop(self.gPop, self.gincrements, self.numNeuronsgPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.gincrements
        print "gPopvalue"
        print gPopvalue
        
        print "SinGpop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.SinGpop, 1, 0)
        SinGpopvalue=self.CalculateAndPrintForcePop(self.SinGpop, self.MultSinGincrements, self.numNeuronsInMultSinGPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.MultSinGincrements
        print "SinGpopvalue"
        print SinGpopvalue

        print "RoundSinGPopCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundSinGPopCells, 1, 0)
        RoundSinGPopCellsvalue=self.CalculateAndPrintForcePop(self.RoundSinGPopCells, self.RoundSinGincrements, self.numNeuronsInRoundSinG, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.RoundSinGincrements
        print "RoundSinGPopCellsvalue"
        print RoundSinGPopCellsvalue        



        print "DX2Pop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.DX2Pop, 1, 0)
        DX2Popvalue=self.CalculateAndPrintForcePop(self.DX2Pop, self.DX2increments, self.numNeuronsInDX2, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.DX2increments
        print "DX2Popvalue"
        print DX2Popvalue

        print "RoundDX2PopCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundDX2PopCells, 1, 0)
        RoundDX2PopCellsvalue=self.CalculateAndPrintForcePop(self.RoundDX2PopCells, self.RoundDX2increments, self.numNeuronsInRoundDX2Pop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.RoundDX2increments
        print "RoundDX2PopCellsvalue"
        print RoundDX2PopCellsvalue            

        print "DX2Cospop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.DX2Cospop, 1, 0)
        DX2Cospopvalue=self.CalculateAndPrintForcePop(self.DX2Cospop, self.MultDX2Cosinincrements, self.numNeuronsInMultDX2CosPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.MultDX2Cosinincrements
        print "CosPopCells11value"
        print DX2Cospopvalue
        

        print "RoundDX2CosPopCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundDX2CosPopCells, 1, 0)
        RoundDX2CosPopCellsvalue=self.CalculateAndPrintForcePop(self.RoundDX2CosPopCells, self.RoundDX2Cosincrements, self.numNeuronsInRoundDX2Cos, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.RoundDX2Cosincrements
        print "RoundDX2CosPopCellsvalue"
        print RoundDX2CosPopCellsvalue


        print "DX2CosPlusSingGPop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.DX2CosPlusSingGPop, 1, 0)
        DX2CosPlusSingGPopvalue=self.CalculateAndPrintForcePop(self.DX2CosPlusSingGPop, self.DX2CosPlusSingGincrements  , self.numNeuronsDX2CosPlusSingGPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.DX2CosPlusSingGincrements 
        print "DX2CosPlusSingGPopvalue"
        print DX2CosPlusSingGPopvalue

        print "dt3cell"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.dt3cell, 1, 0)
        dt3cellvalue=self.CalculateAndPrintForcePop(self.dt3cell, self.dt3increment, self.numNeuronsDt3Pop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.dt3increment
        print "dt3cellvalue"
        print dt3cellvalue


        print "DX3dtPop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.DX3dtPop, 1, 0)
        DX3dtPopvalue=self.CalculateAndPrintForcePop(self.DX3dtPop, self.DX3dtincrements, self.numNeuronsInDX3dt, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.DX3dtincrements
        print "DX3dtPopvalue"
        print DX3dtPopvalue
        
        print "RoundDX3dtPopCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundDX3dtPopCells, 1, 0)
        RoundDX3dtPopCellsvalue=self.CalculateAndPrintForcePop(self.RoundDX3dtPopCells, self.RoundDX3dtincrements, self.numNeuronsInRoundDX3dtPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.RoundDX3dtincrements
        print "RoundDX3dtPopCellsvalue"
        print RoundDX3dtPopCellsvalue

        print "X3PlusDX3dt3InterSumCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.X3PlusDX3dt3InterSumCells, 1, 0)
        X3PlusDX3dt3InterSumCellsvalue=self.CalculateAndPrintForcePop(self.X3PlusDX3dt3InterSumCells, self.Xincrements[3], self.numNeuronsX3PlusDX3dt3InterPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[3]
        print "X3PlusDX3dt3InterSumCellsvalue"
        print X3PlusDX3dt3InterSumCellsvalue


        print "X3"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.XPopsInpCells[3], 1, 0)
        x3=self.CalculateAndPrintForcePop(self.XPopsInpCells[3], self.Xincrements[3], self.numNeuronsInEachXPop[3], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[3]
        print "x3"
        print x3            

                   

    def ClearData(self):
        spikeTrains=self.SinPopCells.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.sinsqpop.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.RoundSinSqPopCells.get_data('spikes',clear=True).segments[0].spiketrains


        spikeTrains=self.RoundSinM1PopCells.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.SinM1M0SumCells.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.SinM1M0PopInterOutSumCells.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.onedivSinsqM1M0Pops.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.onedivSinsqM1M0RoundPops.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.X3sqpop.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.RoundX3SqPopCells.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.X3sqM1Lpop.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.RoundX3sqM1LPopCells.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.SinPopCells3.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.SinX3sqM1Lpop.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.RoundSinX3sqM1LPopCells.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.MultCosSinPopCells.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.CosSinPopCells.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.MmultGPop.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.M1gCosSinpop.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.RoundM1gCosSinPopCells.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.RoundM1gCosSinPopCells2.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.M1gCosSinMinusSinX3sqM1LPops.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.M1gCosSinMinusSinX3sqM1LInterCells.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.M1gCosSinMinusSinX3sqM1LPlusFInterCells.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.M1gCosSinMinusSinX3sqM1LPlusFCells.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.DX2Pop.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.RoundDX2PopCells.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.X2PopsInpCells14.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.dt2cell.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.DX2dtPop.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.RoundDX2dtPopCells.get_data('spikes',clear=True).segments[0].spiketrains
        spikeTrains=self.X2PlusDX2dt2InterSumCells.get_data('spikes',clear=True).segments[0].spiketrains

    def testDX2(self):
        rad=0
        runDur=0
        runs=0
        ##CHANGE X MIN AND XMAX VALUES WHEN TESTING THE COS SIN
        print "TESTDX2FUNCTION"
        """
        print "X2PopsInpCells14"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.X2PopsInpCells14, 1, 0)
        X2PopsInpCells14value=self.CalculateAndPrintForcePop(self.X2PopsInpCells14, self.Xincrements[2], self.numNeuronsInEachXPop[2], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[2]
        print "X2PopsInpCells20value"
        print X2PopsInpCells14value        
        """
        print "X2PopsInpCells1"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.X2PopsInpCells1, 1, 0)
        X2PopsInpCells1value=self.CalculateAndPrintForcePop(self.X2PopsInpCells1, self.Xincrements[2], self.numNeuronsInEachXPop[2], 1, rad, WhichInNeuronsFired, runDur, runs, 0) #to hit 29ms
        print "increment"
        print self.Xincrements[2]
        print "X2PopsInpCells1value"
        print X2PopsInpCells1value 
        
        print "X1"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.XPopsInpCells[1], 1, 0)
        x1=self.CalculateAndPrintForcePop(self.XPopsInpCells[1], self.Xincrements[1], self.numNeuronsInEachXPop[1], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[1]
        print "x1"
        print x1
        
        print "X2"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.XPopsInpCells[2], 1, 0)
        x2=self.CalculateAndPrintForcePop(self.XPopsInpCells[2], self.Xincrements[2], self.numNeuronsInEachXPop[2], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[2]
        print "x2"
        print x2

        print "SIN"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.SinPopCells, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        sinvalue=self.CalculateAndPrintForcePop(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.SINincrements
        print "sinvalue"
        print sinvalue

        print "COS"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.CosPopCells, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        cosvalue=self.CalculateAndPrintForcePop(self.CosPopCells, self.COSincrements, self.numNeuronsInCosPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.COSincrements
        print "value"
        print cosvalue

        print "SINSQ"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.sinsqpop, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        sinsqvalue=self.CalculateAndPrintForcePop(self.sinsqpop, self.MultSinSinincrements, self.numNeuronsInMultSinSinPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.MultSinSinincrements
        print "sinsqvalue"
        print sinsqvalue

        print "SINSQROUND"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundSinSqPopCells, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        sinsqroundvalue=self.CalculateAndPrintForcePop(self.RoundSinSqPopCells, self.RoundSinSinincrements, self.numNeuronsInRoundSinSq, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.RoundSinSinincrements
        print "sinsqroundvalue"
        print sinsqroundvalue

        print "M1Pop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.M1Pop, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        M0value=self.CalculateAndPrintForcePop(self.M1Pop, self.M1increments, self.numNeuronsM1Pop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)


        print "sinM1pop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.sinM1pop, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        sinM1value=self.CalculateAndPrintForcePop(self.sinM1pop, self.MultSinM1increments, self.numNeuronsInMultSinM1Pop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.MultSinM1increments
        print " sinM1value"
        print  sinM1value

        print "RoundSinM1PopCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundSinM1PopCells, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        RoundsinM1value=self.CalculateAndPrintForcePop(self.RoundSinM1PopCells, self.RoundSinM1increments, self.numNeuronsInRoundSinM1, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print  self.RoundSinM1increments
        print " RoundsinM1value"
        print  RoundsinM1value        

        print "M0Pop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.M0Pop, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)
        
        M0value=self.CalculateAndPrintForcePop(self.M0Pop, self.M0increments, self.numNeuronsM0Pop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)



        print "SinM1M0SumCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.SinM1M0SumCells, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        SinM1M0SumCellsValue=self.CalculateAndPrintForcePop(self.SinM1M0SumCells, self.SinM1M0increments, self.numNeuronsInSinsqM1M0Pop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.SinM1M0increments
        print "SinM1M0SumCellsValue"
        print  SinM1M0SumCellsValue


        print "SinM1M0PopInterOutSumCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.SinM1M0PopInterOutSumCells, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        SinM1M0PopInterOutSumCellsValue=self.CalculateAndPrintForcePop(self.SinM1M0PopInterOutSumCells, self.SinM1M0increments, self.numNeuronsInSinsqM1M0Pop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.SinM1M0increments
        print "SinM1M0PopInterOutSumCellsValue"
        print  SinM1M0PopInterOutSumCellsValue

        print "onedivSinsqM1M0Pops"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.onedivSinsqM1M0Pops, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        onedivSinsqM1M0Popsvalue=self.CalculateAndPrintForcePop(self.onedivSinsqM1M0Pops, self.onedivSinsqM1M0Incr, self.numonedivSinsqM1M0Pops, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.onedivSinsqM1M0Incr
        print "onedivSinsqM1M0Popsvalue"
        print onedivSinsqM1M0Popsvalue

        print "onedivSinsqM1M0RoundPops"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.onedivSinsqM1M0RoundPops, 1, 0)
        #print self.onedivSinsqM1M0RoundPops
        #print self.RoundonedivSinsqM1M0Increments
        #print self.numNeuronsonedivSinsqM1M0RoundPop        
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        onedivSinsqM1M0RoundPopsvalue=self.CalculateAndPrintForcePop(self.onedivSinsqM1M0RoundPops, self.RoundonedivSinsqM1M0Increments, self.numNeuronsonedivSinsqM1M0RoundPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)

        print "increment"
        print self.RoundonedivSinsqM1M0Increments
        print "onedivSinsqM1M0RoundPopsvalue"
        print onedivSinsqM1M0RoundPopsvalue

        print "onedivSinsqM1M0RoundPops2"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.onedivSinsqM1M0RoundPops2, 1, 0)
        onedivSinsqM1M0RoundPops2value=self.CalculateAndPrintForcePop(self.onedivSinsqM1M0RoundPops2, self.RoundonedivSinsqM1M0Increments, self.numNeuronsonedivSinsqM1M0RoundPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.RoundonedivSinsqM1M0Increments
        print "onedivSinsqM1M0RoundPops2value"
        print onedivSinsqM1M0RoundPops2value
        
        print "X3sq"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.X3sqpop, 1, 0)
        x3sq=self.CalculateAndPrintForcePop(self.X3sqpop, self.MultX3X3increments, self.numNeuronsInMultX3X3Pop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.MultX3X3increments
        print "x3sq"
        print x3sq

        print "RoundX3sq"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundX3SqPopCells, 1, 0)
        roundx3sq=self.CalculateAndPrintForcePop(self.RoundX3SqPopCells, self.RoundX3X3increments, self.numNeuronsInRoundX3Sq, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.RoundX3X3increments
        print "roundx3sq"
        print roundx3sq



        print "X3sqM1Lpop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.X3sqM1Lpop, 1, 0)
        roundx3sq=self.CalculateAndPrintForcePop(self.X3sqM1Lpop, self.MultX3sqM1Lincrements, self.numNeuronsInMultX3sqM1LPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.MultX3sqM1Lincrements
        print "X3sqM1Lpop"
        print roundx3sq

        print "RoundX3sqM1LPopCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundX3sqM1LPopCells, 1, 0)
        roundx3sq=self.CalculateAndPrintForcePop(self.RoundX3sqM1LPopCells, self.RoundX3sqM1Lincrements, self.numNeuronsInRoundX3sqM1L, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.RoundX3sqM1Lincrements
        print "roundX3sqM1LPopCells"
        print roundx3sq

        

        print "SinPopCells3"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.SinPopCells3, 1, 0)
        sin3value=self.CalculateAndPrintForcePop(self.SinPopCells3, self.SINincrements, self.numNeuronsInSinPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "sin3value"
        print sin3value
        
        print "SinX3sqM1Lpop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.SinX3sqM1Lpop, 1, 0)
        SinX3sqM1Lpopvalue=self.CalculateAndPrintForcePop(self.SinX3sqM1Lpop, self.MultSinX3sqM1Lincrements, self.numNeuronsInMultSinX3sqM1LPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.MultSinX3sqM1Lincrements
        print "SinX3sqM1Lpopvalue"
        print SinX3sqM1Lpopvalue       
        
        print "RoundSinX3sqM1LPopCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundSinX3sqM1LPopCells, 1, 0)
        RoundSinX3sqM1LPopCellsvalue=self.CalculateAndPrintForcePop(self.RoundSinX3sqM1LPopCells, self.RoundSinX3sqM1Lincrements, self.numNeuronsInRoundSinX3sqM1L, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.RoundSinX3sqM1Lincrements
        print "RoundSinX3sqM1LPopCellsvalue"
        print RoundSinX3sqM1LPopCellsvalue        
        
        print "MULTCOSSIN"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.MultCosSinPopCells, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)
#self.MultCosSinPopCells, self.numNeuronsInMultCosSin, self.MultCosSinPopIncr

        multvalueactual=self.CalculateAndPrintForcePop(self.MultCosSinPopCells, self.MultCosSinincrements, self.numNeuronsInMultCosSinPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.MultCosSinincrements
        print "multvalueactual"
        print multvalueactual
        
        print "ROUNDMULTCOSSIN"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.CosSinPopCells, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        multvalueround=self.CalculateAndPrintForcePop(self.CosSinPopCells, self.CosSinincrements, self.numNeuronsInSinCosPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.CosSinincrements
        print "multvalueround"
        print multvalueround

        print "MmultGPop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.MmultGPop, 1, 0)
        MmultGPopvalue=self.CalculateAndPrintForcePop(self.MmultGPop, self.MmultGincrements, self.numNeuronsMmultGPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.MmultGincrements
        print "MmultGPopvalue"
        print MmultGPopvalue
        
        print "MmultGPop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.MmultGPop, 1, 0)
        MmultGPopvalue=self.CalculateAndPrintForcePop(self.MmultGPop, self.MmultGincrements, self.numNeuronsMmultGPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.MmultGincrements
        print "MmultGPopvalue"
        print MmultGPopvalue        
        #k=InputXValues
        

        print "M1gCosSinpop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.M1gCosSinpop, 1, 0)
        M1gCosSinpopvalue=self.CalculateAndPrintForcePop(self.M1gCosSinpop, self.MultM1gCosSinincrements, self.numNeuronsInMultM1gCosSinPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.MultM1gCosSinincrements
        print "M1gCosSinpopvalue"
        print M1gCosSinpopvalue

        print "RoundM1gCosSinPopCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundM1gCosSinPopCells, 1, 0)
        RoundM1gCosSinPopCellsvalue=self.CalculateAndPrintForcePop(self.RoundM1gCosSinPopCells, self.RoundM1gCosSinincrements, self.numNeuronsInRoundM1gCosSin, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.RoundM1gCosSinincrements
        print "RoundM1gCosSinPopCellsvalue"
        print RoundM1gCosSinPopCellsvalue        

        print "RoundM1gCosSinPopCells2"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundM1gCosSinPopCells2, 1, 0)
        RoundM1gCosSinPopCells2value=self.CalculateAndPrintForcePop(self.RoundM1gCosSinPopCells2, self.RoundM1gCosSinincrements, self.numNeuronsInRoundM1gCosSin, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.RoundM1gCosSinincrements
        print "RoundM1gCosSinPopCells2value"
        print RoundM1gCosSinPopCells2value         

        
        print "M1gCosSinMinusSinX3sqM1LPops"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.M1gCosSinMinusSinX3sqM1LPops, 1, 0)
        M1gCosSinMinusSinX3sqM1LPopsvalue=self.CalculateAndPrintForcePop(self.M1gCosSinMinusSinX3sqM1LPops, self.M1gCosSinMinusSinX3sqM1Lincrements, self.numNeuronsM1gCosSinMinusSinX3sqM1L, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.M1gCosSinMinusSinX3sqM1Lincrements
        print "M1gCosSinMinusSinX3sqM1LPopsvalue"
        print M1gCosSinMinusSinX3sqM1LPopsvalue 

        print "M1gCosSinMinusSinX3sqM1LInterCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.M1gCosSinMinusSinX3sqM1LInterCells, 1, 0)
        M1gCosSinMinusSinX3sqM1LInterCellsvalue=self.CalculateAndPrintForcePop(self.M1gCosSinMinusSinX3sqM1LInterCells, self.M1gCosSinMinusSinX3sqM1Lincrements, self.numNeuronsM1gCosSinMinusSinX3sqM1L, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.M1gCosSinMinusSinX3sqM1Lincrements
        print "M1gCosSinMinusSinX3sqM1LInterCellsvalue"
        print M1gCosSinMinusSinX3sqM1LInterCellsvalue



        print "M1gCosSinMinusSinX3sqM1LPlusFInterCells"  
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.M1gCosSinMinusSinX3sqM1LPlusFInterCells, 1, 0)
        M1gCosSinMinusSinX3sqM1LPlusFInterCellsvalue=self.CalculateAndPrintForcePop(self.M1gCosSinMinusSinX3sqM1LPlusFInterCells, self.Force2increments, self.numNeuronsInM1gCosSinMinusSinX3sqM1LPlusF, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Force2increments
        print "M1gCosSinMinusSinX3sqM1LPlusFInterCellsvalue"
        print M1gCosSinMinusSinX3sqM1LPlusFInterCellsvalue

        print "M1gCosSinMinusSinX3sqM1LPlusFCells"  
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.M1gCosSinMinusSinX3sqM1LPlusFCells, 1, 0)
        M1gCosSinMinusSinX3sqM1LPlusFCellsvalue=self.CalculateAndPrintForcePop(self.M1gCosSinMinusSinX3sqM1LPlusFCells, self.M1gCosSinMinusSinX3sqM1LPlusFincrements, self.numneuron, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.M1gCosSinMinusSinX3sqM1LPlusFincrements
        print "M1gCosSinMinusSinX3sqM1LPlusFCellsvalue"
        print M1gCosSinMinusSinX3sqM1LPlusFCellsvalue
        
        #every 45ms its calculating a 100ms section of the simulation



        print "DX2Pop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.DX2Pop, 1, 0)
        DX2Popvalue=self.CalculateAndPrintForcePop(self.DX2Pop, self.DX2increments, self.numNeuronsInDX2, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.DX2increments
        print "DX2Popvalue"
        print DX2Popvalue
        

        print "RoundDX2PopCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundDX2PopCells, 1, 0)
        RoundDX2PopCellsvalue=self.CalculateAndPrintForcePop(self.RoundDX2PopCells, self.RoundDX2increments, self.numNeuronsInRoundDX2Pop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.RoundDX2increments
        print "RoundDX2PopCellsvalue"
        print RoundDX2PopCellsvalue        




        print "dt2cell"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.dt2cell, 1, 0)
        dt2cellvalue=self.CalculateAndPrintForcePop(self.dt2cell, self.dt2increment, self.numNeuronsDt2Pop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.dt2increment
        print "dt2cellvalue"
        print dt2cellvalue


        print "DX2dtPop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.DX2dtPop, 1, 0)
        DX2dtPopvalue=self.CalculateAndPrintForcePop(self.DX2dtPop, self.DX2dtincrements, self.numNeuronsInDX2dt, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.DX2dtincrements
        print "DX2dtPopvalue"
        print DX2dtPopvalue
        
        print "X2PopsInpCells14"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.X2PopsInpCells14, 1, 0)
        X2PopsInpCells14value=self.CalculateAndPrintForcePop(self.X2PopsInpCells14, self.Xincrements[2], self.numNeuronsInEachXPop[2], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[2]
        print "X2PopsInpCells20value"
        print X2PopsInpCells14value
        
        print "RoundDX2dtPopCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundDX2dtPopCells, 1, 0)                                   ###was numNeuronsInRoundDX3dtPop
        RoundDX2dtPopCellsvalue=self.CalculateAndPrintForcePop(self.RoundDX2dtPopCells, self.RoundDX2dtincrements, self.numNeuronsInRoundDX2dtPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.RoundDX2dtincrements
        print "RoundDX2dtPopCellsvalue"
        print RoundDX2dtPopCellsvalue

        print "X2PlusDX2dt2InterSumCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.X2PlusDX2dt2InterSumCells, 1, 0)
        X2PlusDX2dt2InterSumCellsvalue=self.CalculateAndPrintForcePop(self.X2PlusDX2dt2InterSumCells, self.Xincrements[2], self.numNeuronsX2PlusDX2dt2InterPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[2]
        print "X2PlusDX2dt2InterSumCellsvalue"
        print X2PlusDX2dt2InterSumCellsvalue



        print "X2NextStateCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.X2NextStateCells, 1, 0)
        X2NextStateCellsValue=self.CalculateAndPrintForcePop(self.X2NextStateCells, self.Xincrements[2], self.numNeuronsInEachXPop[2], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[3]
        print "X2NextStateCells"
        print X2NextStateCellsValue

        print "X2"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.XPopsInpCells[2], 1, 0)
        x2=self.CalculateAndPrintForcePop(self.XPopsInpCells[2], self.Xincrements[2], self.numNeuronsInEachXPop[2], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[3]
        print "x2"
        print x2

        """
            if(i==0):
                print "X3"
                [WhichInNeuronsFired]=self.DetermineWhichFired(self.XPopsInpCells[3], 1, 0)
                x3=self.CalculateAndPrintForcePop(self.XPopsInpCells[3], self.Xincrements[3], self.numNeuronsInEachXPop[3], 1, rad, WhichInNeuronsFired, runDur, runs, 0)

                x3states+=[x3]

                print"X1"
                [WhichInNeuronsFired]=self.DetermineWhichFired(self.XPopsInpCells[1], 1, 0)
                x1=self.CalculateAndPrintForcePop(self.XPopsInpCells[1], self.Xincrements[1], self.numNeuronsInEachXPop[1], 1, rad, WhichInNeuronsFired, runDur, runs, 0)

                x1states+=[x1]
                
           
            
                print "x1"
                print x1states

                print "x3"
                print x3states

                print "dt1cell"
                [WhichInNeuronsFired]=self.DetermineWhichFired(self.dt1cell, 1, 0)
                dt1cellvalue=self.CalculateAndPrintForcePop(self.dt1cell, self.dt1increment, self.numNeuronsDt1Pop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
                print "increment"
                print self.dt1increment
                print "dt1cellvalue"
                print dt1cellvalue

                print "DX1dtPop"
                [WhichInNeuronsFired]=self.DetermineWhichFired(self.DX1dtPop, 1, 0)
                DX1dtPopvalue=self.CalculateAndPrintForcePop(self.DX1dtPop, self.DX1dtincrements, self.numNeuronsInDX1dt, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
                print "increment"
                print self.DX1dtincrements
                print "DX0dtPopvalue"
                print DX1dtPopvalue

                print "PULSE CELLS"
                [WhichInNeuronsFired]=self.DetermineWhichFired(self.PulseCellPop, 1, 0)
                pulvalue=self.CalculateAndPrintForcePop(self.PulseCellPop, 0.5, [self.numdepths,0], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
                print "pulvalue"
                print pulvalue
        
                print "RoundDX1dtPopCells"
                [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundDX1dtPopCells, 1, 0)
                RoundDX1dtPopCellsvalue=self.CalculateAndPrintForcePop(self.RoundDX1dtPopCells, self.RoundDX1dtincrements, self.numNeuronsInRoundDX1dtPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
                print "increment"
                print self.RoundDX1dtincrements
                print "RoundDX1dtPopCellsvalue"
                print RoundDX1dtPopCellsvalue

                print "X1PopsInpCells2"
                [WhichInNeuronsFired]=self.DetermineWhichFired(self.X1PopsInpCells2, 1, 0)
                X1PopsInpCells2value=self.CalculateAndPrintForcePop(self.X1PopsInpCells2, self.Xincrements[1], self.numNeuronsInEachXPop[1], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
                print "increment"
                print self.Xincrements[1]
                print "X1PopsInpCells2value"
                print X1PopsInpCells2value

                print "X1PlusDX1dt1InterSumCells"
                [WhichInNeuronsFired]=self.DetermineWhichFired(self.X1PlusDX1dt1InterSumCells, 1, 0)
                X1PlusDX1dt1InterSumCellsvalue=self.CalculateAndPrintForcePop(self.X1PlusDX1dt1InterSumCells, self.Xincrements[1], self.numNeuronsX1PlusDX1dt1InterPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
                print "increment"
                print self.Xincrements[1]
                print "X1PlusDX1dt1InterSumCellsvalue"
                print X1PlusDX1dt1InterSumCellsvalue

                print "X1NextStateCells"
                [WhichInNeuronsFired]=self.DetermineWhichFired(self.X1NextStateCells, 1, 0)
                X1NextStateCellsvalue=self.CalculateAndPrintForcePop(self.X1NextStateCells, self.Xincrements[1], self.numNeuronsInEachXPop[1], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
                print "increment"
                print self.Xincrements[1]
                print "X0NextStateCellsvalue"
                print X1NextStateCellsvalue




                print "X1NextStateCells17"
                [WhichInNeuronsFired]=self.DetermineWhichFired(self.X1NextStateCells17, 1, 0)
                X1NextStateCells17value=self.CalculateAndPrintForcePop(self.X1NextStateCells17, self.Xincrements[1], self.numNeuronsInEachXPop[1], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
                print "increment"
                print self.Xincrements[1]
                print "X0NextStateCells17value"
                print X1NextStateCells17value

               
                [WhichInNeuronsFired]=self.DetermineWhichFired(self.XPopsInpCells[0], 1, 0)
                x0=self.CalculateAndPrintForcePop(self.XPopsInpCells[0], self.Xincrements[0], self.numNeuronsInEachXPop[0], 1, rad, WhichInNeuronsFired, runDur, runs, 0)

                x0states+=[x0]

            #print "x0"
            #print x0states

                [WhichInNeuronsFired]=self.DetermineWhichFired(self.XPopsInpCells[2], 1, 0)
                x2=self.CalculateAndPrintForcePop(self.XPopsInpCells[2], self.Xincrements[2], self.numNeuronsInEachXPop[2], 1, rad, WhichInNeuronsFired, runDur, runs, 0)

                x2states+=[x2] 

        """






        #self.sim.end()


#self.X2NextStateCells5
        print "X0"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.XPopsInpCells[0], 1, 0)
        x0=self.CalculateAndPrintForcePop(self.XPopsInpCells[0], self.Xincrements[0], self.numNeuronsInEachXPop[0], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[0]
        print "x0"
        print x0

        print "X1"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.XPopsInpCells[1], 1, 0)
        x1=self.CalculateAndPrintForcePop(self.XPopsInpCells[1], self.Xincrements[1], self.numNeuronsInEachXPop[1], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[1]
        print "x1"
        print x1





        
######################################
        

###################



        print "X2NextStateCells5"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.X2NextStateCells5, 1, 0)
        X2NextStateCells5value=self.CalculateAndPrintForcePop(self.X2NextStateCells5, self.Xincrements[2], self.numNeuronsInEachXPop[2], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[3]
        print "X2NextStateCells5value"
        print X2NextStateCells5value

        #print "X2NextStateCells"
        #[WhichInNeuronsFired]=self.DetermineWhichFired(self.X2NextStateCells, 1, 0)
        #X2NextStateCellsvalue=self.CalculateAndPrintForcePop(self.X2NextStateCells, self.Xincrements[2], self.numNeuronsInEachXPop[2], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        #print "increment"
        #print self.Xincrements[3]
        #print "X2NextStateCellsvalue"
        #print X2NextStateCellsvalue

        print "X3"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.XPopsInpCells[3], 1, 0)
        x3=self.CalculateAndPrintForcePop(self.XPopsInpCells[3], self.Xincrements[3], self.numNeuronsInEachXPop[3], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[3]
        print "x3"
        print x3

      

        #self.PlotMembraneVoltageAndSpikesOneCell(self.SinPopCells, 5)
        #plt.show()
        #adfa



####        
        print "X3PopsInpCells20"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.X3PopsInpCells20, 1, 0)
        X3PopsInpCells20value=self.CalculateAndPrintForcePop(self.X3PopsInpCells20, self.Xincrements[3], self.numNeuronsInEachXPop[3], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[3]
        print "X3PopsInpCells20value"
        print X3PopsInpCells20value


        print "dt3cell"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.dt3cell, 1, 0)
        dt3cellvalue=self.CalculateAndPrintForcePop(self.dt3cell, self.dt3increment, self.numNeuronsDt3Pop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.dt3increment
        print "dt3cellvalue"
        print dt3cellvalue


        print "DX3dtPop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.DX3dtPop, 1, 0)
        DX3dtPopvalue=self.CalculateAndPrintForcePop(self.DX3dtPop, self.DX3dtincrements, self.numNeuronsInDX3dt, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.DX3dtincrements
        print "DX3dtPopvalue"
        print DX3dtPopvalue
        
        print "RoundDX3dtPopCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundDX3dtPopCells, 1, 0)
        RoundDX3dtPopCellsvalue=self.CalculateAndPrintForcePop(self.RoundDX3dtPopCells, self.RoundDX3dtincrements, self.numNeuronsInRoundDX3dtPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.RoundDX3dtincrements
        print "RoundDX3dtPopCellsvalue"
        print RoundDX3dtPopCellsvalue

        print "X3PlusDX3dt3InterSumCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.X3PlusDX3dt3InterSumCells, 1, 0)
        X3PlusDX3dt3InterSumCellsvalue=self.CalculateAndPrintForcePop(self.X3PlusDX3dt3InterSumCells, self.Xincrements[3], self.numNeuronsX3PlusDX3dt3InterPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[3]
        print "X3PlusDX3dt3InterSumCellsvalue"
        print X3PlusDX3dt3InterSumCellsvalue


        print "X3"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.XPopsInpCells[3], 1, 0)
        x3=self.CalculateAndPrintForcePop(self.XPopsInpCells[3], self.Xincrements[3], self.numNeuronsInEachXPop[3], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[3]
        print "x3"
        print x3


##########


        print "DX3Pop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.DX3Pop, 1, 0)
        DX3Popvalue=self.CalculateAndPrintForcePop(self.DX3Pop, self.DX3increments, self.numNeuronsInDX3, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.DX3increments
        print "DX3Popvalue"
        print DX3Popvalue

        print "RoundDX3PopCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundDX3PopCells, 1, 0)
        RoundDX3PopCellsvalue=self.CalculateAndPrintForcePop(self.RoundDX3PopCells, self.RoundDX3increments, self.numNeuronsInRoundDX3Pop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.RoundDX3increments
        print "RoundDX3PopCellsvalue"
        print RoundDX3PopCellsvalue


        print "gPop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.gPop, 1, 0)
        gPopvalue=self.CalculateAndPrintForcePop(self.gPop, self.gincrements, self.numNeuronsgPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.gincrements
        print "gPopvalue"
        print gPopvalue
        
        print "SinGpop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.SinGpop, 1, 0)
        SinGpopvalue=self.CalculateAndPrintForcePop(self.SinGpop, self.MultSinGincrements, self.numNeuronsInMultSinGPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.MultSinGincrements
        print "SinGpopvalue"
        print SinGpopvalue

        print "RoundSinGPopCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundSinGPopCells, 1, 0)
        RoundSinGPopCellsvalue=self.CalculateAndPrintForcePop(self.RoundSinGPopCells, self.RoundSinGincrements, self.numNeuronsInRoundSinG, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.RoundSinGincrements
        print "RoundSinGPopCellsvalue"
        print RoundSinGPopCellsvalue        

        print "RoundSinGPopCells11"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundSinGPopCells11, 1, 0)
        RoundSinGPopCells11value=self.CalculateAndPrintForcePop(self.RoundSinGPopCells11, self.RoundSinGincrements  , self.numNeuronsInRoundSinG, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.RoundSinGincrements  
        print "RoundSinGPopCells11value"
        print RoundSinGPopCells11value



        print "DX2Cospop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.DX2Cospop, 1, 0)
        DX2Cospopvalue=self.CalculateAndPrintForcePop(self.DX2Cospop, self.MultDX2Cosinincrements, self.numNeuronsInMultDX2CosPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.MultDX2Cosinincrements
        print "CosPopCells11value"
        print DX2Cospopvalue

        print "RoundDX2CosPopCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundDX2CosPopCells, 1, 0)
        RoundDX2CosPopCellsvalue=self.CalculateAndPrintForcePop(self.RoundDX2CosPopCells, self.RoundDX2Cosincrements, self.numNeuronsInRoundDX2Cos, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.RoundDX2Cosincrements
        print "RoundDX2CosPopCellsvalue"
        print RoundDX2CosPopCellsvalue


        print "DX2CosPlusSingGPop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.DX2CosPlusSingGPop, 1, 0)
        DX2CosPlusSingGPopvalue=self.CalculateAndPrintForcePop(self.DX2CosPlusSingGPop, self.DX2CosPlusSingGincrements  , self.numNeuronsDX2CosPlusSingGPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.DX2CosPlusSingGincrements 
        print "DX2CosPlusSingGPopvalue"
        print DX2CosPlusSingGPopvalue










        print "X"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.XPopsInpCells[3], 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        xvalue3=self.CalculateAndPrintForcePop(self.XPopsInpCells[3], self.Xincrements[3], self.numNeuronsInEachXPop[3], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[3]
        print "xvalue"
        print xvalue3
        





























        print "oneDivLPop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.oneDivLPop, 1, 0)
        oneDivLPopvalue=self.CalculateAndPrintForcePop(self.oneDivLPop, self.onedivlincrements, self.numNeuronsoneDivLPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.onedivlincrements
        print "oneDivLPopvalue"
        print oneDivLPopvalue



        print "RAD"
        print rad
        print "PULSE CELLS"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.PulseCellPop, 1, 0)
        pulvalue=self.CalculateAndPrintForcePop(self.PulseCellPop, 0.5, [self.numdepths,0], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "pulvalue"
        print pulvalue






        print "DX2CosPlusSingGInterSumCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.DX2CosPlusSingGInterSumCells, 1, 0)
        DX2CosPlusSingGInterSumCellsvalue=self.CalculateAndPrintForcePop(self.DX2CosPlusSingGInterSumCells, self.DX2CosPlusSingGincrements, self.numNeuronsDX2CosPlusSingGPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.DX2CosPlusSingGincrements 
        print "DX2CosPlusSingGInterSumCellsvalue"
        print self.DX2CosPlusSingGInterSumCells

       









        
        
        #print "FORCE2"
        #[WhichOutNeuronsFired]=self.DetermineWhichFired(self.Force2Cells,1,0)
        #Force2=self.CalculateAndPrintForcePop(self.Force2Cells, self.Force2increments,self.numNeuronsForce2, 1, InputXValues, WhichOutNeuronsFired, runDur, runs, 0)
        #print "Force2"
        #print Force2
        
#        print "FORCE"
#        [WhichOutNeuronsFired]=self.DetermineWhichFired(self.FOutCells,1,0)
#        Force=self.CalculateAndPrintForcePop(self.FOutCells, self.Fincrements, self.numNeuronsInFPop, 1, InputXValues, WhichOutNeuronsFired, runDur, runs, 0)
#        print "Force"
#        print Force

        print "CosPopCells11"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.CosPopCells11, 1, 0)
        CosPopCells11value=self.CalculateAndPrintForcePop(self.CosPopCells11, self.COSincrements, self.numNeuronsInCosPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.COSincrements
        print "CosPopCells11value"
        print CosPopCells11value

       

        


        print "COS"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.CosPopCells, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        cosvalue=self.CalculateAndPrintForcePop(self.CosPopCells, self.COSincrements, self.numNeuronsInCosPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.COSincrements
        print "value"
        print cosvalue



      



        


        print "MmultLPop"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.MmultLPop, 1, 0)
        MmultLPopvalue=self.CalculateAndPrintForcePop(self.MmultLPop, self.MmultLincrements, self.numNeuronsMmultLPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.MmultLincrements
        print "MmultLPopvalue"
        print MmultLPopvalue

        







       




        print "1D"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.onedivpop, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        onedvalue=self.CalculateAndPrintForcePop(self.onedivpop, self.in1DivIncrements, self.numNeuronsIn1DivPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.in1DivIncrements
        print "1dvalue"
        print onedvalue










        print "DTCELL"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.dtcell, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)
        print "increment"
        print self.dtincrement
        print "value"
        dtvalue=self.CalculateAndPrintForcePop(self.dtcell, self.dtincrement, self.numNeuronsDtPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)

        print "COSMULTDT"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.dtresultpopCos, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        dtcosvalue=self.CalculateAndPrintForcePop(self.dtresultpopCos, self.dtcosincrement, self.numNeuronsDtPopCos, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.dtcosincrement
        print "dtcosvalue"
        print dtcosvalue
        
        print "ROUNDCOSMULTDT"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.rounddtcospop, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        roundtcosvalue=self.CalculateAndPrintForcePop(self.rounddtcospop, self.RoundOutDtIncrements, self.numNeuronsRoundDtCos, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.RoundOutDtIncrements
        print "roundtcosvalue"
        print roundtcosvalue



        print "X"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.XPopsInpCells[1], 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        xvalue=self.CalculateAndPrintForcePop(self.XPopsInpCells[1], self.Xincrements[1], self.numNeuronsInEachXPop[1], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "increment"
        print self.Xincrements[1]
        print "xvalue"
        print xvalue

        



        





        
#        print "COSSINDIV"
#        [WhichInNeuronsFired]=self.DetermineWhichFired(self.CosSinDivCells, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

#        divvalue=self.CalculateAndPrintForcePop(self.CosSinDivCells, self.CosSinDivincrements, self.numNeuronsInCosSinDivPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)

#        print "COSSINDIVPROPERROUND (SIN/COS)"
#        [WhichInNeuronsFired]=self.DetermineWhichFired(self.DivRoundoutputPops, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

#        rounddivvalue=self.CalculateAndPrintForcePop(self.DivRoundoutputPops, self.RoundOutDivIncrements, self.numNeuronsDivRoundOutPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)

#        print "COSSINDIVPROPERINTER (SIN/COS)"
#        [WhichInNeuronsFired]=self.DetermineWhichFired(self.DivPops, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

#        properdivvalue=self.CalculateAndPrintForcePop(self.DivPops, self.DivPopIncr, self.numDivPops, 1, rad, WhichInNeuronsFired, runDur, runs, 0)









#        print "SINBUF"
#        [WhichInNeuronsFired]=self.DetermineWhichFired(self.SinPopBufCells, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

#        sinvaluebuf=self.CalculateAndPrintForcePop(self.SinPopBufCells, self.SINincrements, self.numNeuronsInSinPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)


        print "SININTER"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.SinPopInterSumCells, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        sininter=self.CalculateAndPrintForcePop(self.SinPopInterSumCells, self.SINincrements, self.numNeuronsInSinPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)





#        print "COSBUF"
#        [WhichInNeuronsFired]=self.DetermineWhichFired(self.CosPopBufCells, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

#        cosvaluebuf=self.CalculateAndPrintForcePop(self.CosPopBufCells, self.COSincrements, self.numNeuronsInCosPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)

        print "COSINTER"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.CosPopInterSumCells, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        cosinter=self.CalculateAndPrintForcePop(self.CosPopInterSumCells, self.COSincrements, self.numNeuronsInCosPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)





       #(inputPops1, inputPops2, numNeuronsIn1Pop, numNeuronsIn2Pop, in1Increments, in2Increments, MultPops, numMultPops, MultPopIncr, RoundoutputPops, numNeuronsRoundOutPop, RoundOutIncrements, minWeight):






        print "POSORNEG"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.PosOrNegCosSinPop, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)
#self.MultCosSinPopCells, self.numNeuronsInMultCosSin, self.MultCosSinPopIncr
        posorneg=self.CalculateAndPrintForcePop(self.PosOrNegCosSinPop, 1, [4,0], 1, rad, WhichInNeuronsFired, runDur, runs, 0)



        #self.EMinusXMultKPops[popConnections], inputincrements, self.EXKincrements[popConnections], self.numNeuronsInEachEMinusXMultKPop[popConnections], inputnumpops, minWeight, 2, self.Karray[popConnections], self.KneuronsPerEXneuron[popConnections])


        print "COSINTERSINSUM"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.CosSinPopInterOutSumCells, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        suminter=self.CalculateAndPrintForcePop(self.CosSinPopInterOutSumCells, self.CosSinSumincrements, self.numNeuronsInCosSinSumPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        
        print "COSSINSUM"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.CosSinSumCells, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        sumvalue=self.CalculateAndPrintForcePop(self.CosSinSumCells, self.CosSinSumincrements, self.numNeuronsInCosSinSumPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)

        print "COSINTERSINSUB"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.CosSinPopInterOutSubCells, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)

        suminter=self.CalculateAndPrintForcePop(self.CosSinPopInterOutSubCells, self.CosSinSumincrements, self.numNeuronsInCosSinSubPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)




        print "COSSINSUBT"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.CosSinSubCells, 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)


        subvalue=self.CalculateAndPrintForcePop(self.CosSinSubCells, self.CosSinSubincrements, self.numNeuronsInCosSinSubPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)



        return [sinvalue, cosvalue, multvalueround, multvalueactual, sumvalue, subvalue, divvalue, rounddivvalue, properdivvalue]
        
        
    def ForceOutput(self, InputXValues, counter, segment):
         ##CHANGE X MIN AND XMAX VALUES WHEN TESTING THE COS SIN 
        #numSets=4
        #print "inforce"
        #print InputXValues
        numConnections=self.numSets
        runs=2  #how many input runs to generate
        runDur = 50.0 #we are using 11 as we are resetting the network every 11ms rather than have a continuous real time run#40.0 #takes this time to reset the membrane potential to initial values   #how long to activate an input neuron for (was 100.0)
        voltage=-51.0
        rest=-65.0
        summation=0
        rad=0
        #self.testCells()
        #sdfafd        
        #Fvalue=FValues[statenum]
        #InputXValues=list(InputXValues)
        #print "inforce"
        #print InputXValues
        voltlist=ones(self.numdepths)*rest
        voltlist[1]=voltage
        self.PulseCellPop.initialize(v=voltlist)
        for j in range(0,self.numSets):
            #print value
         #   print self.EMinusXMultKPops[j]
         #   print self.minEminusXMultKarray[j]
         #   print self.maxEminusXMultKarray[j]
         #   print self.numNeuronsInEachEMinusXMultKPop[j]   
            #whichcells=CalculateCells(value[j], minEminusXMultKarray[j], EXKincrements[j])
            #whichcells=Result[0]
            #Eincrement[j]=Result[1]
            #whichcells=2
            #initializeCells(EMinusXMultKPops[j],whichcells[j], voltage, numNeuronsInEachEMinusXMultKPop[j],rest, PosOrNeg)  # this initialises a particular set of cells
         #   print "x"
            #print "HELLO DAVE"
            #print "input x values"
            #print InputXValues[j]
            self.initializeCellsUsingValue(self.XPopsInpCells[j],InputXValues[j], self.Xincrements[j], voltage, self.numNeuronsInEachXPop[j],rest) #this calculates which cells to initialise when given a value
         #   print "E"
         #   print self.Earray
            if(self.Earray[j]!=0.0):
                self.initializeCellsUsingValue(self.EPopsInpCells[j],self.Earray[j], self.Eincrements[j], voltage, self.numNeuronsInEachEPop[j],rest)
            #print "K"
            #print self.Karray            
            #self.initializeCellsUsingValue(self.KPopsInpCells[j],self.Karray[j], self.Kincrements[j], voltage, self.numNeuronsInEachKPop[j],rest)
            #sdfasdf

            #print "whichE %s..cells" % str(j)
            #print whichcells
        #print self.numNeuronsInEachKPop
        
        #adfadsf
        #InputXValues=[]
        #for i in range(0,1000):
        #    print "i"
        #    print i
        #print "start"
        self.sim.run(runDur)
        self.sim.end()

        #self.PlotMembraneVoltageAndSpikesOneCell(self.d,5)
        #plt.show()
        #adfa        
        #if(self.sim.get_time_step()==2.0):
        #   print self.sim.get_time_step()
        #    print "in time step"
        
        print "PULSE CELLS"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.PulseCellPop, 1, 0)
        pulvalue=self.CalculateAndPrintForcePop(self.PulseCellPop, 0.5, [self.numdepths,0], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "pulKvalue"
        print pulvalue
        
        for popConnections in range(0,numConnections):
            print "popconnections"
            print popConnections
            print "ECELLS"
            [WhichInNeuronsFired]=self.DetermineWhichFired(self.EPopsInpCells[popConnections], 1, 0)
            evalue=self.CalculateAndPrintForcePop(self.EPopsInpCells[popConnections], self.Eincrements[popConnections], self.numNeuronsInEachEPop[popConnections], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
            print "evalue"
            print evalue

            print "KCELLS"
            [WhichInNeuronsFired]=self.DetermineWhichFired(self.KPopsInpCells[popConnections], 1, 0)
            kvalue=self.CalculateAndPrintForcePop(self.KPopsInpCells[popConnections], self.Kincrements[popConnections], self.numNeuronsInEachKPop[popConnections], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
            print "kvalue"
            print kvalue

#            print "KCELLSBUF"
#            [WhichInNeuronsFired]=self.DetermineWhichFired(self.KPopsInpCellsBuf[popConnections], 1, 0)
#            kvaluebuf=self.CalculateAndPrintForcePop(self.KPopsInpCellsBuf[popConnections], self.Kincrements[popConnections], self.numNeuronsInEachKPop[popConnections], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
#            print "kvaluebuf"
#            print kvaluebuf





            print "XCELLS"
            [WhichInNeuronsFired]=self.DetermineWhichFired(self.XPopsInpCells[popConnections], 1, 0)
            xvalue=self.CalculateAndPrintForcePop(self.XPopsInpCells[popConnections], self.Xincrements[popConnections], self.numNeuronsInEachXPop[popConnections], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
            print "xvalue"
            print xvalue

            print "EXInter"
            [WhichInNeuronsFired]=self.DetermineWhichFired(self.EXInterOutSubCells[popConnections], 1, 0)
            xvalue=self.CalculateAndPrintForcePop(self.EXInterOutSubCells[popConnections], self.EXincrements[popConnections], self.numNeuronsInEachEMinusXPop[popConnections], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
            print "xvalue"
            print xvalue          

            print "E-XCELLS"
            [WhichInNeuronsFired]=self.DetermineWhichFired(self.EMinusXPops[popConnections], 1, 0)
            exvalue=self.CalculateAndPrintForcePop(self.EMinusXPops[popConnections], self.EXincrements[popConnections], self.numNeuronsInEachEMinusXPop[popConnections], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
            print "e-xvalue"
            print exvalue

#            print "E-XCELLSBUF"
#            [WhichInNeuronsFired]=self.DetermineWhichFired(self.EMinusXBufPops[popConnections], 1, 0)
#            exvaluebuf=self.CalculateAndPrintForcePop(self.EMinusXBufPops[popConnections], self.EXincrements[popConnections], self.numNeuronsInEachEMinusXPop[popConnections], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
#            print "e-xvaluebuf"
#            print exvaluebuf            



            print "MULTPOSORNEG"
            [WhichInNeuronsFired]=self.DetermineWhichFired(self.PosOrNegEXKPop[popConnections], 1, 0)
        #self.PrintOutPopulationSets(self.SinPopCells, self.SINincrements, self.numNeuronsInSinPop[0], WhichInNeuronsFired, runDur, runs)
#self.MultCosSinPopCells, self.numNeuronsInMultCosSin, self.MultCosSinPopIncr
            posorneg=self.CalculateAndPrintForcePop(self.PosOrNegEXKPop[popConnections], 1, [4,0], 1, rad, WhichInNeuronsFired, runDur, runs, 0)

            print "E-X*KCELLS"
            [WhichInNeuronsFired]=self.DetermineWhichFired(self.EMinusXMultKPops[popConnections], 1, 0)
            exkvalue=self.CalculateAndPrintForcePop(self.EMinusXMultKPops[popConnections], self.EXKincrements[popConnections], self.numNeuronsInEachEMinusXMultKPop[popConnections], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
            print "e-xKvalue"
            print exkvalue

            print "ROUND E-X*KCELLS"
            [WhichInNeuronsFired]=self.DetermineWhichFired(self.RoundEXKPopCells[popConnections], 1, 0)
            exkvalue=self.CalculateAndPrintForcePop(self.RoundEXKPopCells[popConnections], self.RoundEXKincrements[popConnections], self.numNeuronsInRoundEXKPopCells[popConnections], 1, rad, WhichInNeuronsFired, runDur, runs, 0)
            print "round e-xKvalue"
            print exkvalue
        
        
    

        print "EXKSum01Cells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.EXKSum01Cells, 1, 0)
        exk01sumval=self.CalculateAndPrintForcePop(self.EXKSum01Cells, self.EXKSum01increments, self.numNeuronsInEXKSum01Pop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "exk01sumval"
        print exk01sumval           
            
        print "EXKSum23Cells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.EXKSum23Cells, 1, 0)
        exk01sumval=self.CalculateAndPrintForcePop(self.EXKSum23Cells, self.EXKSum23increments, self.numNeuronsInEXKSum23Pop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "exk01sumval"
        print exk01sumval       
        
        print "EXKSum01InterCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.EXKPopInterOutSum01Cells, 1, 0)
        exk01intersumval=self.CalculateAndPrintForcePop(self.EXKPopInterOutSum01Cells, self.EXKSum01increments, self.numNeuronsInEXKSum01Pop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "exk01intersumval"
        print exk01intersumval

        print "EXKSum23InterCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.EXKPopInterOutSum23Cells, 1, 0)
        exk01intersumval=self.CalculateAndPrintForcePop(self.EXKPopInterOutSum23Cells, self.EXKSum23increments, self.numNeuronsInEXKSum23Pop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "exk01intersumval"
        print exk01intersumval

        print "FintersumCells"
        [WhichInNeuronsFired]=self.DetermineWhichFired(self.FInterSumCells, 1, 0)
        finter=self.CalculateAndPrintForcePop(self.FInterSumCells, self.Fincrements, self.numNeuronsInFPop, 1, rad, WhichInNeuronsFired, runDur, runs, 0)
        print "finter"
        print finter
        






#EMinusXPops
#FOutCells
#EMinusXPops
#EPopsInpCells
#XPopsInpCells
    #numNeuronsInEachXPop
    #numNeuronsInEachEPop
    #numNeuronsInEachKPop
    #numNeuronsInEachEMinusXPop        
        
        #print "end1"  
        #[WhichInNeuronsFired,WhichOutNeuronsFired]=self.DetermineWhichInpOutFired(self.EMinusXMultKPops, self.FOutCells)
        #[WhichInNeuronsFired,WhichOutNeuronsFired]=self.DetermineWhichInpOutFired(self.EMinusXMultKPops, self.EMinusXMultKPops[0])        
        #[WhichInNeuronsFired,WhichOutNeuronsFired]=self.DetermineWhichInpOutFired(self.EMinusXPops, self.EMinusXPops[0])
        #[WhichInNeuronsFired,WhichOutNeuronsFired]=self.DetermineWhichInpOutFired(self.XPopsInpCells, self.XPopsInpCells[0])
        #[WhichInNeuronsFired,WhichOutNeuronsFired]=self.DetermineWhichInpOutFired(self.EPopsInpCells, self.EPopsInpCells[0])
        #print self.EPopsInpCells
        #[WhichInNeuronsFired,WhichOutNeuronsFired]=self.DetermineWhichInpOutFired(self.EPopsInpCells, self.EPopsInpCells[0])

        #WhichInNeuronsFired=self.DetermineWhichFired(self.XPopsInpCells, self.numSets, segment)
        #print "which"
        #print WhichInNeuronsFired
        #self.PrintOutPopulationSets(self.XPopsInpCells, self.Xincrements, self.numNeuronsInEachXPop, WhichInNeuronsFired, runDur, runs)

        
        #print "start2"
        
        [WhichOutNeuronsFired]=self.DetermineWhichFired(self.FOutCells,1,segment)
        #print "FORCEOUTPUT"
        #print "which"
        #print WhichOutNeuronsFired        
        #print "end2"
        #print "start3"
        Force=self.CalculateAndPrintForcePop(self.FOutCells, self.Fincrements, self.numNeuronsInFPop, 1, InputXValues, WhichOutNeuronsFired, runDur, runs, counter)
        #print Force

        
        #kjhkjh

        
        #WhichInNeuronsFired=self.DetermineWhichFired(self.EPopsInpCells[1], 1)
        #WhichInNeuronsFired=self.DetermineWhichFired(self.EMinusXPops, self.numSets, segment)
        #WhichInNeuronsFired=self.DetermineWhichFired(self.EMinusXMultKPops, self.numSets, segment)

        #print WhichInNeuronsFired
        #adfad
        #Force=self.CalculateAndPrintForcePop(self.EPopsInpCells[1], self.Fincrements, self.numNeuronsInEachEPop, 1, InputXValues, WhichInNeuronsFired, runDur, runs)

        #self.PrintOutPopulationSets(self.EMinusXMultKPops, self.EXKincrements, self.numNeuronsInEachEMinusXMultKPop, WhichInNeuronsFired, runDur, runs)
        #self.PrintOutPopulationSets(self.EMinusXPops, self.Xincrements, self.numNeuronsInEachEMinusXPop, WhichInNeuronsFired, runDur, runs)

        #self.PrintOutPopulationSets(self.EPopsInpCells, self.Xincrements, self.numNeuronsInEachEPop, WhichInNeuronsFired, runDur, runs)        
        #subtraction
        #print self.KneuronsPerEXneuron
        #kjhkj

        #clear data from run, if we dont the spikes from previous runs will be considered for future force
        """
        for j in range(0,self.numSets):
            Pop=self.XPopsInpCells[j]
            data=Pop.get_data(clear=True).segments[0]
            Pop=self.EMinusXPops[j]
            data=Pop.get_data(clear=True).segments[0]
            Pop=self.EMinusXMultKPops[j]
            data=Pop.get_data(clear=True).segments[0]

        Pop=self.EPopsInpCells[1]       
        data=Pop.get_data(clear=True).segments[0]
        #Pop=self.FOutCells
        #data=Pop.get_data(clear=True).segments[0]
        """
        

#############
                                  
        #Force=0
        self.sim.reset()  #we reset it to make sure that the membrate potential etc return to their
                     #initial state, or we could wait 40ms to enter the next set of inputs as this
                    #is the time it takes for the membrane potential to reach the initial values with the above parameters
                    #at the moment the simulation could stop just after 10ms (when the output neurons spike)
                    # however these are recorded, therefore,when we input the values again from the cart and pole the simulation will start
                    #just after 10ms, the recorded values, i.e. the values when we ended the simulation, will be used, which
                    #could cause the spikes to generated quicker as there will still be residul conductance from the
                    #previous set of spikes, which could also cause burst firing, i.e. firing every 10ms due to the
                    #large conduction, i.e. previous+now.  we also at the moment have the problem of not running this
                    #in real time, i.e. we are using x which is generated every e.g 0.00001ms time step, but we are allowing
                    #the simulation to run for 40ms after each time step used from the cart and pole integration.  Therefore, we would
                    #need larger time steps in the cart and pole which match the time we input the x data to the next allowed set of data at t+40ms
                    #everytime we reset a new segment of get_data appears
        ###reset function doesnt work as when we try to initialise the network
        ###on second run after reset the initialiation spikes are missing
        ###reset to vreset--how to reset the connection strength?
        #    print "end"
        """            
        for j in range(0,self.numSets):
            self.initializeCellsUsingValue(self.EMinusXPops[j],0, self.EXKincrements[j], voltage, self.numNeuronsInEachEMinusXPop[j],rest) #this calculates which cells to initialise when given a value
            self.initializeCellsUsingValue(self.EMinusXMultKPops[j],0, self.EXKincrements[j], voltage, self.numNeuronsInEachEMinusXMultKPop[j],rest)

        self.initializeCellsUsingValue(self.FOutCells,0, self.Fincrements, voltage, self.numNeuronsInFPop,rest)
        """
        #print "Xnum"
        #print self.numNeuronsInEachXPop
        #Force=20.0
        #print Force
        return Force

